indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_notebook.e,v 1.7 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_NOTEBOOK
inherit
   SIMPLE_TEST
      redefine
         destroy_window
      end
   GTK_CONSTANTS
   VEGTK_CALLBACK_HANDLER

creation
   make

feature -- Creation

   make is
      local
         box1, box2 : GTK_BOX
         button : GTK_BUTTON
         separator : GTK_HSEPARATOR
      do
         !!menu_pixwids.make(1,5)
         !!label_pixwids.make(1,5)

         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)

         window.set_title("notebook")
         window.set_border_width(10)

         !GTK_VBOX!box1.make(False, 0)
         window.add(box1)

         !!notebook.make
         signal_connect(notebook,"switch_page",$switch_page_command)
         notebook.set_tab_pos(Gtk_pos_top)
         box1.pack_start(notebook, True, True, 0)
         notebook.set_border_width(10)

         notebook.realize

         create_pages(1,5)
         !!separator.make

         box1.pack_start(separator, False, True, 10)
         !GTK_HBOX!box2.make(True, 5)
         box1.pack_start(box2, False, True, 0)

--       omenu := build_option_menu (items, 3, 0, notebook)
--       box2.pack_start(omenu, False, False, 0)

         !!popup_button.make_with_label("enable popup menu")
         box2.pack_start(popup_button, False, False, 0)
         signal_connect_with_data(popup_button,"clicked",$clicked,notebook_popup)

         !GTK_HBOX!box2.make(True, 0)
         box2.set_border_width(10)
         box1.pack_start(box2, False, True, 0)

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(button, True, True, 0)
--       button.set_flags(Gtk_can_default)
--       button.grab_default

         !!button.make_with_label("next")
         signal_connect_with_data(button,"clicked",$clicked,next_page)
         box2.pack_start(button, True, True, 0)
--       button.set_flags(Gtk_can_default)

         !!button.make_with_label("prev")
         signal_connect_with_data(button,"clicked",$clicked,prev_page)
         box2.pack_start(button, True, True, 0)
--       button.set_flags(Gtk_can_default)

         !!button.make_with_label("rotate")
         signal_connect_with_data(button,"clicked",$clicked,rotate_notebook)
         box2.pack_start(button, True, True, 0)
--       button.set_flags(Gtk_can_default)

         window.show_all
      end -- make

feature {NONE} -- Implementations

   notebook_popup, next_page, prev_page, rotate_notebook : INTEGER is unique
   popup_button : GTK_CHECK_BUTTON
   menu_pixwids, label_pixwids : ARRAY[GTK_PIXMAP]

   destroy_window is
      do
         destroying := true
         Precursor
      end -- destroy_window

   clicked ( data : ANY ) is
      local
         i : INTEGER_REF
         j: INTEGER
         positions : ARRAY[GTK_POSITION_TYPE]
         rotated : BOOLEAN
      do
         i ?= data
         inspect i.item
         when notebook_popup then
            if popup_button.get_active then
               notebook.popup_enable
            else
               notebook.popup_disable
            end
         when next_page then
            notebook.next_page
         when prev_page then
            notebook.prev_page
         when rotate_notebook then
            positions := << Gtk_pos_top,
                            Gtk_pos_right,
                            Gtk_pos_bottom,
                            Gtk_pos_left >>
            from
               j := positions.lower
            until
               rotated or j > positions.upper
            loop
               if notebook.tab_pos = positions.item(j).get_value then
                  notebook.set_tab_pos(positions.item((j \\ 4) +1))
                  rotated := True
               end -- if
               j := j+1
            end -- loop
            else
         end -- inspect
      end -- clicked

   create_pages ( start, end_ : INTEGER ) is
      local
         i : INTEGER
         buffer : STRING
         button : GTK_BUTTON
         frame : GTK_FRAME
         box : GTK_VBOX
         menu_box, label_box, hbox : GTK_HBOX
         label : GTK_LABEL
         entry : GTK_ENTRY
         child : GTK_WIDGET
         pixwid : GTK_PIXMAP
      do
         !!buffer.make(32)
         from
            i := start
         until
            i >  end_
         loop
            buffer.copy("Page ")
            buffer.append_string(i.out)

            inspect i \\ 4
            when 3 then
               button.make_with_label(buffer)
               button.set_border_width(10)
               child := button
            when 2 then
               !!label.make(buffer)
               child := label
            when 1 then
               !!frame.make(buffer)
               frame.set_border_width(10)

               !!box.make(True, 0)
               box.set_border_width(10)
               frame.add(box)

               !!label.make(buffer)
               box.pack_start(label, True, True, 5)
               !!entry.make
               box.pack_start(entry, True, True, 5)
               !!hbox.make(True, 0)
               box.pack_start(hbox, True, True, 5)
               !!button.make_with_label("Ok")
               hbox.pack_start(button, True, True, 5)
               !!button.make_with_label("Cancel")
               hbox.pack_start(button, True, True, 5)

               child := frame
            when 0 then
               !!frame.make(buffer)
               frame.set_border_width(10)

               !!label.make(buffer)
               frame.add(label)

               child := frame
            else
            end -- inspect

            child.show_all

            !!label_box.make(False, 0)
            !!pixwid.make(book_closed_pixmap(window),book_closed_pixmap(window).mask)
            label_box.pack_start(pixwid, False, True, 0)
            pixwid.set_padding(3,1)
            label_pixwids.put(pixwid, i)
            !!label.make(buffer)
            label_box.pack_start(label, False, True, 0)
            label_box.show_all

            !!menu_box.make(False,0)
            !!pixwid.make(book_closed_pixmap(window),book_closed_pixmap(window).mask)
            menu_box.pack_start(pixwid, False, True, 0)
            pixwid.set_padding(3,1)
            menu_pixwids.put(pixwid, i)
            !!label.make(buffer)
            menu_box.pack_start(label, False, True, 0)
            menu_box.show_all

            notebook.append_page_menu(child, label_box, menu_box)
            i := i+1
         end -- loop
      end -- create_pages

   set_is_destroying is
      do
         destroying := true
      end

   destroying : BOOLEAN
   notebook : GTK_NOTEBOOK

   update_icons ( new_page : INTEGER ) is
      local
         last_page : INTEGER
      do
         if new_page >= 0 then
            last_page := notebook.get_current_page
            label_pixwids.item(new_page+1).set(book_open_pixmap(window),book_open_pixmap(window).mask)
            menu_pixwids.item(new_page+1).set(book_open_pixmap(window),book_open_pixmap(window).mask)
            if (last_page >= 0) then
               label_pixwids.item(last_page+1).set(book_closed_pixmap(window),book_closed_pixmap(window).mask)
               menu_pixwids.item(last_page+1).set(book_closed_pixmap(window),book_closed_pixmap(window).mask)
            end -- if
         end -- if
      end -- update_icons

   switch_page_command (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         args : GTK_NOTEBOOK_SWITCH_PAGE_CALLBACK_ARGS;
      do
         !!args.make(cb_data);
         if destroying then
         else
            update_icons(args.page_num)
         end -- if
      end -- switch_page_command

end -- class CREATE_NOTEBOOK
