indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_list.e,v 1.8 2000/11/13 14:55:20 eugenem Exp $";

class CREATE_LIST
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         cbox : GTK_HBOX
         vbox : GTK_VBOX
         hbox : GTK_HBOX
         label : GTK_LABEL
         scrolled_win : GTK_SCROLLED_WINDOW
         item : GTK_LIST_ITEM
         button : GTK_BUTTON
         separator : GTK_HSEPARATOR
         infile : FILE
      do
         !!window.make(Gtk_window_toplevel)

         signal_connect(window,"destroy",$destroy_window)

         window.set_title("list")
         window.set_border_width(0)

         !!vbox.make(false, 0)
         window.add(vbox)

         !!scrolled_win.make(Void, Void)
         scrolled_win.set_border_width(5)
         scrolled_win.set_usize(-1, 300)
         vbox.pack_start(scrolled_win, true, true, 0)
         scrolled_win.set_policy(Gtk_policy_automatic,Gtk_policy_automatic)

         !!list.make
         list.set_selection_mode(Gtk_selection_extended)
         scrolled_win.add_with_viewport(list)
         list.set_focus_vadjustment(scrolled_win.get_vadjustment)
         list.set_focus_hadjustment(scrolled_win.get_hadjustment)

         !!infile.make_open_read("create_tooltips.e")
         if infile.is_open_read then
            from
               infile.read_line
            until
               infile.end_of_file
            loop
               !!item.make_with_label (infile.last_string)
               list.add (item);
               infile.read_line
            end -- loop
            infile.close
         end -- if

         !!hbox.make(true, 5);
         hbox.set_border_width(5)
         vbox.pack_start(hbox, false, true, 0)

         !!button.make_with_label("Insert Row")
         hbox.pack_start(button, true, true, 0)
         signal_connect(button,"clicked",$list_add)

         !!button.make_with_label("Clear List")
         hbox.pack_start(button, true, true, 0)
         signal_connect(button,"clicked",$list_clear)

         !!button.make_with_label("Remove Selection")
         hbox.pack_start(button, true, true, 0)
         signal_connect(button,"clicked",$list_remove)

         !!cbox.make(false, 0)
         vbox.pack_start(cbox, false, true, 0)

         !!hbox.make(false, 5)
         hbox.set_border_width(5)
         cbox.pack_start(hbox, true, false, 0)

         !!label.make("Selection Mode :")
         hbox.pack_start(label, false, true, 0)

         list_omenu := build_option_menu (items, 4, 3, Void)
         hbox.pack_start(list_omenu, false, true, 0)

         !!separator.make
         vbox.pack_start(separator, false, true, 0)

         !!cbox.make(false, 0)
         vbox.pack_start(cbox, false, true, 0)

         !!button.make_with_label("close")
         button.set_border_width(10)
         cbox.pack_start(button, true, true, 0)
         signal_connect(button,"clicked", $close_window)

         button.set_flags(Gtk_can_default)
         button.grab_default

         window.show_all

         list_add_i := 1 -- in C this is "static int" in "list_add" routine
      end -- make

feature {NONE} -- Impelmentations

   list : GTK_LIST
   list_omenu : GTK_OPTION_MENU

   items : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      do
         !!Result.make(0,3)
         !!item.make("Single",   $list_toggle_sel_mode)
         Result.put(item,0)
                 !!item.make("Browse",   $list_toggle_sel_mode)
         Result.put(item,1)
         !!item.make("Multiple", $list_toggle_sel_mode)
         Result.put(item,2)
         !!item.make("Extended", $list_toggle_sel_mode)
         Result.put(item,3)
      end -- items

   list_add_i : INTEGER

   list_add is
      local
         buffer : STRING
         list_item : GTK_LIST_ITEM
      do
         !!buffer.make(64)
         buffer.copy("added item ")
         buffer.append_string(list_add_i.out)
         list_add_i := list_add_i+1

         !!list_item.make_with_label(buffer)
         list_item.show

         list.add(list_item)
      end -- list_add

   list_remove is
      local
         clear_list, sel_row, work : G_LIST[GTK_LIST_ITEM];
         item : GTK_LIST_ITEM;
         done : BOOLEAN;
      do
         if (list.selection_mode).is_equal (Gtk_selection_extended) then
            item ?= list.focus_child;
            if item = Void and not list.selection_list.empty then
               item := list.selection_list.item;
            end
           if item /= Void then
               work := list.children_list.find (item);
               from
                  sel_row := work
                  done := False;
               until
                  sel_row.empty or done
               loop
                  if not sel_row.item.state.is_equal(Gtk_state_selected) then
                     done := True;
                  else
                     sel_row := sel_row.next;
                  end; -- if
               end; -- loop

               if sel_row.empty then
                  from
                     sel_row := work
                     done := False;
                  until
                     sel_row.empty or done
                  loop
                     if not sel_row.item.state.is_equal(Gtk_state_selected) then
                        done := True;
                     else
                        sel_row := sel_row.prev;
                     end; -- if
                  end; -- loop
               end -- if
            end -- if
         end -- if

         from
            !G_LIST_OF_GTK_OBJECT [GTK_LIST_ITEM]!clear_list.make;
            work := list.selection_list;
         until
            work.empty
         loop
            clear_list := clear_list.prepend (work.item);
            work := work.next;
         end; -- loop
         clear_list := clear_list.reverse;
         list.remove_items_list (clear_list);
         clear_list.free;
         if list.selection_mode.is_equal (Gtk_selection_extended)
            and then sel_row /= Void and then not sel_row.empty then
            list.select_child (sel_row.item);
         end -- if
      end -- list_remove

   list_clear is
      do
         list.clear_items(0, -1)
      end -- list_clear

   list_toggle_sel_mode(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         i : INTEGER
         widget : GTK_WIDGET
         mode : GTK_SELECTION_MODE
      do
         widget ?= cb_data.get_widget

         if widget.mapped then
            i := radio_menu_toggled(list_omenu.menu_item.group)
            !!mode.make(3-i)
            list.set_selection_mode(mode)
         end -- if
      end -- list_toggle_sel_mode

end -- class CREATE_LIST
