indexing

   title:       "An example how LIST_ITERATOR_ might be used";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:34:22 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class LIST_ITERATOR_DEMO

inherit

   LIST_ITERATOR_[SAMPLE]
      redefine
         action, test
      end;

   INPUT_OUTPUT
      end

creation

   make

feature -- Operations

   action is
         -- ...
      do
         number := number + 1;

         io.put_string
            (get_concatenated (2, <<'%T', item.base, " - No. ", number>>));
         io.put_string ("%N")
      end;

   make is
         -- ...
      local
         index:    INTEGER;
         samples:  ARRAY [SAMPLE];
         the_list: SORTED_LIST_[SAMPLE];
         supplier: SAMPLE_SUPPLIER

      do
         !!supplier.make;
         samples := supplier.sample_set_a;
         !!the_list.make (false);

         from index := 1 until index > samples.count loop
            the_list.put (samples.item (index));
            index := index + 1
         end;

         io.put_string ("%NAll items starting with %'F%' ...%N%N");

         -- the following is what you need to go through all the list ...
         attach (the_list);
         do_if;
         get_a_string ("%NPress any letter to stop ...")
      end


feature -- Queries

   test: BOOLEAN is
         -- ...
      do
         if item.base.item (1) = 'F' then
            Result := true
         end
      end


feature {NONE} -- Implementation

   number: INTEGER

end -- class LIST_ITERATOR_DEMO