indexing

   title:       "An example of how TABLE_ITERATOR_ might be used";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:34:24 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TABLE_ITERATOR_DEMO

inherit
   INPUT_OUTPUT
      end

creation
   make


feature -- Operations

   make is
         -- ...
      local
         template:   CONTRACT;
         the_table:  SORTED_TABLE_[CONTRACT, STRING];
         val_report: REPORT

      do
         !!the_table.make (true);

         !!template.make                                              -- 1
            ("14-95/ABC", "QWERTY Inc.", "14-Dec-96", 10, 17, 9000);
         the_table.put (template, "AB");

         !!template.make                                              -- 2
            ("15-95/QWE", "ALPHA", "26-Jan-96", 21, 19, 11300);
         the_table.put (template, "AZ");

         !!template.make                                              -- 3
            ("33-95/AQC", "QWERTY Inc.", "27-Mar-96", 5, 21, 10000);
         the_table.put (template, "AC");

         !!template.make                                              -- 4
            ("34-95/WEC", "Z-123 GmbH", "28-Mar-96", 100, 31, 10000);
         the_table.put (template, "AA");

         !!template.make                                              -- 5
            ("41-95/YTE", "SUDS AG", "05-Jun-97", 210, 44, 10000);
         the_table.put (template, "WA");

         !!template.make                                              -- 6
            ("42-95/YTE", "ULTER", "01-Dec-99", 10, 52, 30000);
         the_table.put (template, "QA");

         !!template.make                                              -- 7
            ("44-95/OPW", "VPERJED Ltd.", "17-Dec-95", 10, 61, 10500);
         the_table.put (template, "RB");

         !!template.make                                              -- 8
            ("51-95/EER", "Mo & SHe", "07-Nov-96", 30, 71, 9000);
         the_table.put (template, "RA");

         !!template.make                                              -- 9
            ("64-95/TYQ", "Number 1", "31-Aug-97", 10, 83, 20000);
         the_table.put (template, "RC");

         !!template.make                                              -- 10
            ("67-95/PQT", "Twins Plus", "11-Feb-96", 20, 91, 10000);
         the_table.put (template, "IA");

         !!template.make                                              -- 11
            ("68-95/ZXD", "QWERTY Inc.", "21-Apr-97", 40, 101, 10000);
         the_table.put (template, "AX");

         !!template.make                                              -- 12
            ("69-95/RET", "BETA Inc.", "14-Dec-96", 10, 117, 10000);
         the_table.put (template, "ZW");

         --
         -- the following is what you need to prepare the report ...
         --

         !!val_report.make ("All non-Q-contracts, SOV > 9500", 9500, 'Q');
         val_report.attach (the_table);
         val_report.do_if;
         get_a_string ("%NPress any letter to stop ...")
      end

end -- class TABLE_ITERATOR_DEMO