#ifdef WIN32
#include <windows.h>
#else
#include <stdio.h>
#define wsprintf sprintf
#endif
#include <cecil.h>

/* Structure of expanded class EXP_TST */
typedef struct _EIFFEL_EXPANDED {
    int i;
    int j;
    int k;
} EIFFEL_EXPANDED;

/* Function to output string via Eiffel routines */
void eiffel_put_string (const char *buf);

/* Function which is called from Eiffel code */
void print_from_c (EIFFEL_EXPANDED Exp)
{
    char buf[64];

    wsprintf(
        buf,
        "\n\nPrint the expanded class from C:\n i = %d\n j = %d\n k = %d",
        Exp.i,
        Exp.j,
        Exp.k
    );

    eiffel_put_string (buf);
}

/* Function to output string via Eiffel routines */
void eiffel_put_string (const char *buf)
{
    EIF_TYPE_ID     bio_id;
    EIF_TYPE_ID     str_id;
    EIF_REFERENCE   bio_ref;
    EIF_REFERENCE   str_ref;
    EIF_PROC        bio_put_string;
    EIF_PROC        str_from_c;
    EIF_PROC        str_make;

/* ----------- create eiffel string --------------*/
    str_id  = eif_type_id ("STRING");
    str_ref = eif_create (str_id);
    eif_adopt (str_ref);
    str_make    = eif_proc ("make",   str_id);
    str_from_c  = eif_proc ("from_c", str_id);

    str_make (str_ref, 0);
    str_from_c (str_ref, buf);

/*----------- output eiffel string --------------*/
    bio_id  = eif_type_id ("BASIC_IO");
    bio_ref = eif_create (bio_id);
    eif_adopt (bio_ref);
    bio_put_string = eif_proc ("put_string", bio_id);
    bio_put_string (bio_ref, str_ref);
}
