indexing
   title       : "The test which shows how Eiffel objects may be accessed",
                 "from external C routine                                ";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/14 11:56:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST

creation
   make

feature

   make is
      do
         -- Let's initialize expanded object
         a1.set_i (3);
         a1.set_j (7);
         a1.set_k (11);

         -- Display expanded object contents from Eiffel
         bio.put_string ("%NPrint the expanded class from Eiffel:");
         a1.print_exp;

         -- Display expanded object contents from C
         print_from_c (a1);
      end

feature {NONE} -- Implementation

   bio : BASIC_IO is
      once
         !!Result
      end

   print_from_c (a : EXP_TST) is
      external "C"
      end

   a1: EXP_TST

end -- class TEST

expanded class EXP_TST

feature {TEST} -- Status setting

   set_i (ii : INTEGER) is
      do
         i := ii;
      end

   set_j (jj : INTEGER) is
      do
         j := jj;
      end

   set_k (kk : INTEGER) is
      do
         k := kk;
      end

feature {TEST} -- Status printing

   print_exp is
      do
         io.put_string ("%N i = ")
         io.put_integer (i)
         io.put_string ("%N j = ")
         io.put_integer (j)
         io.put_string ("%N k = ")
         io.put_integer (k)
      end

feature {NONE} -- Implementation

   i : INTEGER;
   j : INTEGER;
   k : INTEGER;

end -- class EXP_TST