indexing

   title      : "COMMERCIAL_FORMAT usage example";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:34:29 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";


class PIC
      -- Class illustrate COMMERCIAL_FORMAT usage.

inherit

   G_COMMERCIAL_FORMAT
      rename
         make as cformat_make
      end


creation
   make

feature

   make is
      do
         cformat_make

         -- You may mix-up several types in format string
         -- argument must conform to corresponding typechar
         -- If picture character repeats more that once you
         -- can use brief form e.g. 99999999 is the same as 9(8)

         printf ( "!9999 !9.999 !XXXX %N", << 123, 1.23, "abc">> );
         printf ( "!9(4) !9.9(3) !X(2)X(2) %N", << 123, 1.23, "abc" >> );
         printf ( "!9(10)%N", <<1>> ) -- !9999999999
         printf ( "!9(1)%N", <<1>> );   -- same as "!9"


         -- You may use formatting options in square brackets
         -- such as [BLANK WHEN ZERO] or its shortform [BZ]

         printf ( "%N !9(10)[BZ] %N", << 1 >> ); -- !9999999999
         printf ( "!9999[BLANK WHEN ZERO]%N", <<123>> );
         printf ( "!9[BZ]999 %N", <<123>> );


         -- You can enclose picture in brackets to sepatate it from
         -- other characters in format string

         printf ( "!(99(9))999", <<1>> ); -- 9999999999+999
         printf ( "(!9)", <<1>> );
         printf ( "!(9)995%N", <<1>> ); -- print 1995


         -- You can mix COMMERCIAL and SCIENTIFIC format specification

         printf ( "Mixed !9(1) !d%N", <<1,1>> );
         printf ( "Mixed !9(1) !s%N", <<1,"">> );

         -- You can set picture format as default for all objects
         -- with conformad type.

         set_default_format ( "!99999" );
         print ( 123 );
         set_default_format ( "!-d" );
         print ( 123 );

         set_default_format ( "!99999.9" );
         print ( 0.123 );
         set_default_format ( "!f" );
         print ( 0.123 );
         printf ( "Is it [!99999.9]%N" , << 0.123 >> );

--       ----------------------------------------------------------------------
--       -- Hints
--       ----------------------------------------------------------------------
--          printf ( "%N******** Now some bugs *********%N" , << >> );
--       ----------------------------------------------------------------------
--       -- Errors (remarks show symbols caused error)
--       ----------------------------------------------------------------------
--       try_printf ( "! 999", <<123>> );        -- ' '
--       try_printf ( "!()...",  <<1>> );        -- '()'
--       try_printf ( "!)...",   <<1>> );        -- ')'
--       try_printf ( "!9[]...", <<1>> );        -- '[]'
--       try_printf ( "!]",      <<1>> );        -- ']'
--       try_printf ( "!(91)",   <<1>> );        -- '1'
--       try_printf ( "!(99",   <<1>> );         -- ')'
--       try_printf ( "!9[[",   <<1>> );         -- '['
--       try_printf ( "!(9) !9", <<1>> );      -- number of arguments
--       try_printf ( "!(9)",    <<"abc">> );  -- type of argument
--       try_printf ( "!99",     <<123>> );    -- number not fit
--       try_printf ( "!9.9string",   <<3.14>> ); -- error !9.9s & 3.14
--       printf ( "!(9.9)string", <<3.14>> );    -- ok !9.9
--       -- repeatance counter must be a positive number
--       try_printf ( "!9999(-1)", <<123>> );   -- '(-1)'
--       -- empty picture before repeatance
--       try_printf ( "!(1)", <<1>> );          -- (1)
--       -- bad repeatance number
--       try_printf ( "!9(3(3))", <<1>> );          -- (3(3))
--       try_printf ( "!(9(3(3))9)9", <<1>> );
--       try_printf ( "!9(3(3", <<1>> );
--       try_printf ( "!(9(3(3", <<1>> );
--       -- twice repeatance (unsupported)
--       try_printf ( "!9(1)(2)", <<1>> );      -- (1)(2)
--       -- twice repeatance (unsupported)
--       try_printf ( "!9(1)[BZ](2)", <<1>> );  -- (1)(2)
--       io.put_string("Press any key ...")
--       io.read_character
      end


   try_printf ( format: STRING ; para: ARRAY [ ANY ] ) is
         -- ignore exceptions
      local
         failed: BOOLEAN
      do
         if not failed then printf ( format, para ) end
      rescue
         io.put_string ("PRINTF execution failed (Training exception).%N");
         failed := true
         retry
      end


   try_print ( para: ANY ) is
         -- ignore exceptions
      local
         failed: BOOLEAN
      do
         if not failed then print ( para ) end
      rescue
         io.put_string ("PRINT execution failed (Training exception).%N");
         failed := true
         retry
      end

end -- class PIC
