indexing

   title      : "VECTOR_FORMATTER";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:34:31 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VECTOR_FORMATTER

inherit

   G_ABSTRACT_JUSTIFY_FORMATTER
      redefine
         make, set_sign, set_align_char
      end

creation

   make

feature

   joker: G_FIXED_POINT_FORMATTER
   vect: ARRAY [ REAL ]
   signs, align_chars: STRING
   i_real: REAL is 3.1415

   make (v : ARRAY [ REAL ]) is
      require else
         v /= Void
      do
         vect := v
         Precursor (v)
         !!joker.make_real (i_real) -- forgot it
         !!signs.make_empty
         !!align_chars.make_empty
      end

   set_sign (c : CHARACTER) is
      do
         --signs.extend (c)
         str_tools.x_extend (signs, c)
      end

   set_align_char (c : CHARACTER) is
      do
         --align_chars.extend (c)
         str_tools.x_extend (align_chars, c)
      end

   output : STRING is
      local
         i, j : INTEGER
      do
         !!Result.make_empty
         str_tools.x_extend (Result,'{')
         from i := vect.lower until i > vect.upper loop
            if i > vect.lower then str_tools.x_append (Result,", ") end
            joker.make_real (vect @ i)
            from j := 1 until j > signs.count loop
               joker.set_sign (signs @ j)
               j := j + 1
            end
            from j := 1 until j > align_chars.count loop
               joker.set_align_char (align_chars @ j)
               j := j + 1
            end
            joker.set_width (width)
            joker.set_precision (prec)
            str_tools.x_append (Result, joker.output)
            i := i + 1
         end
         str_tools.x_extend (Result,'}')
      end

   str_tools : G_STRING_TOOLS is
      once
         !!Result
      end

end -- class VECTOR_FORMATTER
