indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_bbox_window.e,v 1.5 2000/03/13 18:19:59 eugenem Exp $";

class CREATE_BBOX_WINDOW
inherit
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS
   MEMORY
      redefine
         dispose
      end

creation
   make

feature -- Creation

   make(horizontal : BOOLEAN; title : STRING; pos, spacing, child_w, child_h : INTEGER ;
      layout : GTK_BUTTON_BOX_STYLE) is
      -- Creation and initialization
      local
         box1 : GTK_BOX
         bbox : GTK_BUTTON_BOX
         button : GTK_BUTTON
      do
         !!window.make(Gtk_window_toplevel)
         window.set_title(title)
         signal_connect(window,"destroy",$destroy_window)

         if horizontal then
            window.set_usize(550,60)
            window.set_uposition(150, pos)
            !GTK_VBOX!box1.make(False, 0)
         else
            window.set_usize(150, 400)
            window.set_uposition(pos, 200)
            !GTK_VBOX!box1.make(False, 0)
         end -- if
         window.add(box1)
         box1.show

         if horizontal then
            !GTK_HBUTTON_BOX!bbox.make
         else
            !GTK_VBUTTON_BOX!bbox.make
         end -- if
         bbox.set_layout(layout)
         bbox.set_spacing(spacing)
         bbox.set_child_size(child_w, child_h)
         bbox.show

         box1.set_border_width(25)
         box1.pack_start(bbox, True, True, 0)

         !!button.make_with_label("OK")
         bbox.add(button)

         signal_connect(button,"clicked", $close_window)
         button.show

         !!button.make_with_label("Cancel")
         bbox.add(button)
         button.show

         !!button.make_with_label("Help")
         bbox.add(button)
         button.show

         window.show
      end -- make

feature {NONE} -- Implementations

   window : GTK_WINDOW

   close_window is
      do
         window.destroy
      end

   destroy_window is
      do
         window := Void
      end -- destroy_window

   dispose is
      do
         if window /= Void then
            window.destroy
            window := Void
         end
      end

end -- class CREATE_BBOX_WINDOW
