indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_buttons.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_BUTTONS
inherit
   GTK_CONSTANTS
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER

creation
   make

feature -- Creation

   make is
      -- Creation and initialization
      local
         box1, box2 : GTK_BOX
         table : GTK_TABLE
         buttons : ARRAY[GTK_BUTTON]
         button : GTK_BUTTON
         button_string : STRING
         expfill : GTK_ATTACH_OPTIONS
         i : INTEGER
         separator : GTK_HSEPARATOR
      do
         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)
         window.set_title("buttons")
         window.set_border_width(0)

         !GTK_VBOX!box1.make(False, 0)
         window.add(box1)
         box1.show

         !!table.make(3, 3, False)
         table.set_row_spacings(5)
         table.set_col_spacings(5)
         table.set_border_width(10)
         box1.pack_start(table, True, True, 0)
         table.show

         !!buttons.make(0,8)
         !!button_string.make(0)
         from i := 0 until i > 8
         loop
            button_string.copy("button ")
            button_string.append_string(i.out)
            !!button.make_with_label(button_string)
            buttons.force(button, i)
            if i>0 then
               signal_connect_with_data(button,"clicked",
               $button_clicked,buttons.item(i-1))
            end
            i := i + 1
         end -- loop

         signal_connect_with_data(buttons.item(0),"clicked",
         $button_clicked,buttons.item(8))

         expfill := Gtk_expand and Gtk_fill

         table.attach(buttons.item(0), 0, 1, 0, 1, expfill, expfill, 0, 0)
         buttons.item(0).show

         table.attach(buttons.item(1), 1, 2, 1, 2, expfill, expfill, 0, 0)
         buttons.item(1).show

         table.attach(buttons.item(2), 2, 3, 2, 3, expfill, expfill, 0, 0)
         buttons.item(2).show

         table.attach(buttons.item(3), 0, 1, 2, 3, expfill, expfill, 0, 0)
         buttons.item(3).show

         table.attach(buttons.item(4), 2, 3, 0, 1, expfill, expfill, 0, 0)
         buttons.item(4).show

         table.attach(buttons.item(5), 1, 2, 2, 3, expfill, expfill, 0, 0)
         buttons.item(5).show

         table.attach(buttons.item(6), 1, 2, 0, 1, expfill, expfill, 0, 0)
         buttons.item(6).show

         table.attach(buttons.item(7), 2, 3, 1, 2, expfill, expfill, 0, 0)
         buttons.item(7).show

         table.attach(buttons.item(8), 0, 1, 1, 2, expfill, expfill, 0, 0)
         buttons.item(8).show

         !!separator.make
         box1.pack_start(separator, False, True, 0)
         separator.show

         !GTK_VBOX!box2.make(False, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, False, True, 0)
         box2.show

         !!button.make_with_label("close")
         buttons.force(button, 9)
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(buttons.item(9), True, True, 0)
         buttons.item(9).set_flags(Gtk_can_default)
         buttons.item(9).grab_default
         buttons.item(9).show

         window.show
      end -- make

feature {NONE} -- Implementations

   button_clicked(data : ANY) is
      local
         button : GTK_BUTTON
      do
         button ?= data
         if button.visible = True then
            button.hide
         else
            button.show
         end
      end -- button_clicked

end -- class CREATE_BUTTONS
