indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_clist.e,v 1.7 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_CLIST
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature

   make is
      local
        i : INTEGER
        text : ARRAY[STRING]
        buf : STRING
        vbox : GTK_VBOX
        hbox : GTK_HBOX
        clist : GTK_CLIST
        button : GTK_BUTTON
        separator : GTK_HSEPARATOR
        scrolled_win : GTK_SCROLLED_WINDOW

        undo_button : GTK_BUTTON
        label : GTK_LABEL

        style : GTK_STYLE
        col1 : GDK_COLOR
        col2 : GDK_COLOR

        row : INTEGER
     do
        clist_rows := 0
        !!text.make(0,testgtk_clist_columns-1)

        !!window.make(Gtk_window_toplevel)

        signal_connect(window,"destroy",$destroy_window)

        window.set_title("clist")
        window.set_border_width(0)

        !!vbox.make(false, 0)
        window.add(vbox)

        !!scrolled_win.make(Void, Void)
        scrolled_win.set_border_width(5)
        scrolled_win.set_policy(Gtk_policy_automatic, Gtk_policy_automatic)

--        create GtkCList here so we have a pointer to throw at the
--        button callbacks -- more is done with it later

        !!clist.make_with_titles(testgtk_clist_columns, titles)
        scrolled_win.add(clist)
        signal_connect_with_data(clist,"click_column",$clist_click_column,clist)

--      control buttons

        !!hbox.make(false, 5)
        hbox.set_border_width(5)
        vbox.pack_start(hbox, false, false, 0)

        !!button.make_with_label("Insert Row")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$insert_row_clist,clist)

        !!button.make_with_label("Add 1,000 Rows With Pixmaps")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$add1000_clist,clist)

        !!button.make_with_label("Add 10,000 Rows")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$add10000_clist,clist)

--      second layer of buttons

        !!hbox.make(false, 5)
        hbox.set_border_width(5)
        vbox.pack_start(hbox, false, false, 0)

        !!button.make_with_label("Clear List")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$clear_clist,clist)

        !!button.make_with_label("Remove Selection")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$clist_remove_selection,clist)

        !!undo_button.make_with_label("Undo Selection")
        hbox.pack_start(undo_button, true, true, 0)
        signal_connect_with_data(undo_button,"clicked",$undo_selection,clist)

        !!button.make_with_label("Warning Test")
        hbox.pack_start(button, true, true, 0)
        signal_connect_with_data(button,"clicked",$clist_warning_test,clist)

--      third layer of buttons

        !!hbox.make(false, 5)
        hbox.set_border_width(5)
        vbox.pack_start(hbox, false, false, 0)

        !!titles_toggle.make_with_label("Show Title Buttons")
        hbox.pack_start(titles_toggle, false, true, 0)
        signal_connect_with_data(titles_toggle,"clicked",$toggle_title_buttons,clist)
        titles_toggle.set_active(true)

        !!reorder_toggle.make_with_label("Reorderable")
        hbox.pack_start(reorder_toggle, false, true, 0)
        signal_connect_with_data(reorder_toggle,"clicked",$toggle_reorderable,clist)
        reorder_toggle.set_active(true)

        !!label.make("Selection Mode :")
        hbox.pack_start(label, false, true, 0)

        clist_omenu := build_option_menu (items, 4, 3, clist)
        hbox.pack_start(clist_omenu, false, true, 0)

--       the rest of the clist configuration

        vbox.pack_start(scrolled_win, true, true, 0)
        clist.set_row_height(18)
        clist.set_usize(-1, 300)

        from
           i := 1
        until
           i = testgtk_clist_columns
        loop
           clist.set_column_width(i, 80)
           i := i+1
        end -- loop

        clist.set_column_auto_resize(0, true)
        clist.set_column_resizeable(1, false)
        clist.set_column_max_width(2, 100)
        clist.set_column_min_width(3, 50)
        clist.set_selection_mode(Gtk_selection_extended)
        clist.set_column_justification(1,Gtk_justify_right)
        clist.set_column_justification(2,Gtk_justify_center)

        !!buf.make(50)
        from
           i := 0
        until
           i = testgtk_clist_columns
        loop
          buf := "Column "
          buf.append_string(i.out)
          text.put(buf,i)
          i := i+1
        end -- loop

        text.put("Right",1)
        text.put("Center",2)

        !!col1.make_with_values(56000,0,0)
        !!col2.make_with_values(0,56000,32000)

        !!style.make
        style.set_fg(Gtk_state_normal,col1)
        style.set_base(Gtk_state_normal,col2)

--        style.font.unref
--        style.font =
--      gdk_font_load ("-adobe-helvetica-bold-r-*-*-*-140-*-*-*-*-*-*");

        from
           i := 0
        until
           i = 10
        loop
          buf.copy("CListRow ")
          buf.append_string(clist_rows.out)
          clist_rows := clist_rows+1
          text.put(buf,0)
          row := clist.append(text)

          inspect (i \\ 4)
             when 2 then
                clist.set_row_style(i, style)
             else
                clist.set_cell_style(i, i \\ 4, style)
          end -- inspect

          i := i+1
        end -- loop

        !!separator.make
        vbox.pack_start(separator, false, true, 0)

        !!hbox.make(false, 0)
        vbox.pack_start(hbox, false, true, 0)

        !!button.make_with_label("close")
        button.set_border_width(10)
        hbox.pack_start(button, true, true, 0)
        signal_connect(button,"clicked", $close_window)

        button.set_flags(Gtk_can_default)
        button.grab_default

        if not window.visible then
           window.show_all
        else
           clist_rows := 0
           window.destroy
        end -- if
     end -- make

feature {NONE} -- Implementations

   testgtk_clist_columns : INTEGER is 12
   clist_rows : INTEGER
   titles_toggle : GTK_CHECK_BUTTON
   reorder_toggle : GTK_CHECK_BUTTON
   clist_omenu : GTK_OPTION_MENU

   titles : ARRAY[STRING] is
      once
         Result :=<<"auto resize", "not resizeable", "max width 100", "min width 50",
         "hide column", "Title 5", "Title 6", "Title 7",
         "Title 8",  "Title 9",  "Title 10", "Title 11">>
      end -- titles

  items : ARRAY[OPTION_MENU_ITEM] is
     local
        item : OPTION_MENU_ITEM
        res : ARRAY[OPTION_MENU_ITEM]
     once
        !!res.make(0,3)
        !!item.make("Single", $clist_toggle_sel_mode)
        res.put(item,0)
        !!item.make("Browse", $clist_toggle_sel_mode)
        res.put(item,1)
        !!item.make("Multiple", $clist_toggle_sel_mode)
        res.put(item,2)
        !!item.make("Extended", $clist_toggle_sel_mode)
        res.put(item,3)
        Result:=res
     end -- items

   add1000_clist(data : ANY) is
      local
         i,row : INTEGER
         text : ARRAY[STRING]
         buf : STRING
         pixmap : GDK_PIXMAP
         clist : GTK_CLIST
      do
         !!buf.make(50)
         !!text.make(0,testgtk_clist_columns-1)
         clist ?= data

         !!pixmap.make_from_xpm_d(clist.clist_window,
                                         clist.get_style.white,
                                         gtk_mini_xpm)

         from
            i := 0
         until
            i = testgtk_clist_columns
         loop
            buf.copy("Column ");
            buf.append_string(i.out);
            text.put(buf, i)
            i := i+1
         end -- loop

-- ???         texts[3] = NULL;
         text.put("",3)
         text.put("Right",1)
         text.put("Center",2)

         clist.freeze
         from
            i := 0
         until
            i = 1000
         loop
            buf.copy("CListRow ")
            buf.append_string("random 10000")
            text.put(buf, 0)
            row := clist.append(text)
            clist.set_pixtext(row, 3, "gtk+", 5, pixmap, pixmap.mask)
            i := i+1
         end -- loop

         clist.thaw

         pixmap.mask.unref
         pixmap.unref
      end -- add1000_clist

   add10000_clist(data : ANY) is
      local
         clist : GTK_CLIST
         i : INTEGER
         text : ARRAY[STRING]
         buf : STRING
         row : INTEGER
      do
         clist ?= data
         !!buf.make(50)
         !!text.make(0,testgtk_clist_columns-1)
         from
            i := 0
         until
            i = testgtk_clist_columns
         loop
            buf.copy("Column ")
            buf.append_string(i.out)
            text.put(buf, i)
            i := i+1
         end -- loop

         text.put("Right", 1)
         text.put("Center", 2)

         clist.freeze
         from
            i := 0
         until
            i = 10000
         loop
            buf.copy("CListRow ");
            buf.append_string("random 10000")
            text.put(buf, 0)
            row := clist.append(text)
            i := i+1
         end -- loop
         clist.thaw
      end -- add10000_clist

   clear_clist(data : ANY) is
      local
         clist : GTK_CLIST
      do
         clist ?= data
         clist.clear
         clist_rows := 0
      end -- clear_clist

   pointer_to_int ( p : POINTER ) : INTEGER is
         -- dirty C type conversion, temporary solution
      external "C"
      alias "pointer_to_int"
      end

   clist_remove_selection(data : ANY) is
      local
         done : BOOLEAN
         clist : GTK_CLIST
      do
         clist ?= data
         clist.freeze
         from
            done := False;
         until
            clist.selected_rows_list.empty or done
         loop
            clist_rows := clist_rows-1
            clist.remove(clist.selected_rows_list.item);
            if clist.selection_mode.is_equal(Gtk_selection_browse) then
               done := True;
            end
         end -- loop

         if clist.selection_mode.is_equal (Gtk_selection_extended) and
            clist.selected_rows_list.empty and clist.focus_row >= 0 then
            clist.select_row(clist.focus_row, -1)
         end -- if

         clist.thaw
      end -- clist_remove_selection

   toggle_title_buttons (data : ANY) is
      local
         clist : GTK_CLIST
      do
         clist ?= data

         if titles_toggle.get_active then
            clist.column_titles_show
         else
            clist.column_titles_hide
         end -- if
      end -- toggle_title_buttons

   toggle_reorderable(data : ANY) is
      local
         clist : GTK_CLIST
      do
         clist ?= data
         clist.set_reorderable(reorder_toggle.get_active)
      end -- toggle_reorderable

   insert_row_clist(data : ANY) is
      local
         text : ARRAY[STRING]
         style1, style2, style3 : GTK_STYLE
         row : INTEGER
         clist : GTK_CLIST
         col1, col2 : GDK_COLOR
      do
         clist ?= data

         text := <<"This", "is an", "inserted", "row.",
            "This", "is an", "inserted", "row.",
            "This", "is an", "inserted", "row.">>

         if clist.focus_row >= 0 then
            row := clist.insert(clist.focus_row,text)
         else
            row := clist.prepend(text)
         end -- if

         !!col1.make_with_values(0,56000,0)
         !!col2.make_with_values(32000,0,56000)

         style1 := clist.get_style.make_copy
         style1.set_base(Gtk_state_normal,col1)
         style1.set_base(Gtk_state_selected,col2)

         style2 := clist.get_style.make_copy
         style2.set_fg(Gtk_state_normal,col1)
         style2.set_fg(Gtk_state_selected,col2)

         style3 := clist.get_style.make_copy
         style3.set_fg(Gtk_state_normal,col1)
         style3.set_base(Gtk_state_normal,col2)
--      gdk_font_unref (style3->font);
--      style3->font =
--      gdk_font_load ("-*-courier-medium-*-*-*-*-120-*-*-*-*-*-*");

         clist.set_cell_style(row, 3, style1)
         clist.set_cell_style(row, 4, style2)
         clist.set_cell_style(row, 0, style3)

         clist_rows := clist_rows+1
      end -- insert_row_clist

   add_remove : BOOLEAN

   clist_warning_test(data : ANY) is
      local
         clist : GTK_CLIST
         child : GTK_LABEL
      do
         clist ?= data
         add_remove := not add_remove

         !!child.make("Test")
         child.ref
         child.sink

         if add_remove then
            clist.add(child)
         else
            child.set_parent(clist)
            clist.remove_container(child)
            child.unparent
         end -- if

         child.destroy
         child.unref
      end -- clist_warning_test

   undo_selection(data : ANY) is
      local
         clist : GTK_CLIST
      do
         clist ?= data
         clist.undo_selection
      end -- undo_selection

   clist_toggle_sel_mode(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         clist : GTK_CLIST
         i : INTEGER
         sel_mode : GTK_SELECTION_MODE
         widget : GTK_WIDGET
      do
         clist ?= data
         widget ?= cb_data.get_widget

         if widget.mapped then
            i := radio_menu_toggled(clist_omenu.menu_item.group)
            !!sel_mode.make(3-i)
            clist.set_selection_mode(sel_mode)
         end -- if
      end -- clist_toggle_sel_mode

   clist_click_column(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         args : GTK_CLIST_CLICK_COLUMN_CALLBACK_ARGS;
         clist : GTK_CLIST
      do
         !!args.make(cb_data);
         clist ?= args.get_user_data

         if args.column = 4 then
            clist.set_column_visibility(args.column, false)
         else
            if args.column = clist.sort_column then
               if clist.sort_type.is_equal (Gtk_sort_ascending) then
                  clist.set_sort_type (Gtk_sort_descending)
               else
                  clist.set_sort_type (Gtk_sort_ascending)
               end -- if
            else
               clist.set_sort_column (args.column)
            end -- if
         end -- if

         clist.sort
      end -- clist_click_column

end -- class CREATE_CLIST

