indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_cursors.e,v 1.5 2000/03/13 18:20:00 eugenem Exp $";

class CREATE_CURSORS
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         frame : GTK_FRAME
         hbox : GTK_HBOX
         main_vbox, vbox : GTK_VBOX
         label : GTK_LABEL
         adj : GTK_ADJUSTMENT
         separator : GTK_HSEPARATOR
         button : GTK_BUTTON
      do
         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)

         !!main_vbox.make(False, 5)
         main_vbox.set_border_width(0)
         window.add(main_vbox)

         !!vbox.make(False, 5)
         vbox.set_border_width(10)
         main_vbox.add(vbox)
         vbox.show

         !!hbox.make(False, 0)
         hbox.set_border_width(5)
         vbox.pack_start(hbox, False, True, 0)

         !!label.make("Cursor Value:")
         label.set_alignment(0.0, 0.5)
         hbox.pack_start(label, False, True, 0)

         !!adj.make(0.0, 0.0, 152.0, 2.0, 10.0, 0.0)
         !!spinner.make(adj, 0.0, 0)
         hbox.pack_start(spinner, True, True, 0)

         !!frame.make("Cursor Area")
         frame.set_label_align(0.5, 0.0)
         frame.set_border_width(10)
         vbox.add(frame)
         frame.show

         !!darea.make
         darea.size(80,80)
         frame.add(darea)
         signal_connect(darea,"button_press_event",$darea_clicked)
      --     darea.add_action("button_press_event", clicked_command, current)
         signal_connect(darea,"expose_event",$cursor_expose_event)
      --     darea.add_action("expose_event", current, "exposed")
         darea.set_events(Gdk_exposure_mask and Gdk_button_press_mask)
         darea.show

      --     spinner.add_action("changed", current, "spun")
         signal_connect(spinner,"changed",$set_cursor)

         !!separator.make
         main_vbox.pack_start(separator, False, True, 0)

         !!hbox.make(False, 0)
         hbox.set_border_width(10)
         main_vbox.pack_start(hbox, False, True, 0)

         !!button.make_with_label("Close")
         signal_connect(button,"clicked", $close_window)
         hbox.pack_start(button, True, True, 5)
         button.show
         button.set_flags(Gtk_can_default)
         button.grab_default
         window.show_all
      end -- make

feature {NONE} -- Implementations

   darea : GTK_DRAWING_AREA
   spinner : GTK_SPIN_BUTTON

   cursor_event ( button : INTEGER ) is
      do
         if button = 1 then
            spinner.spin(Gtk_spin_step_forward, spinner.get_adjustment.step_increment)
            elseif button = 3 then
            spinner.spin(Gtk_spin_step_backward, spinner.get_adjustment.step_increment)
         end -- if
      end -- cursor_event

   darea_clicked(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         button_event : GDK_EVENT_BUTTON
      do
         button_event ?= cb_data.get_event
         cursor_event(button_event.button)
      end -- darea_clicked

   cursor_expose_event is
      local
         drawable : GDK_DRAWABLE
         white_gc, gray_gc, black_gc : GDK_GC
         width, height : INTEGER
      do
         !!drawable.from_external(darea.window.to_external)
         white_gc := darea.get_style.white_gc
         gray_gc := darea.get_style.bg_gc(Gtk_state_normal)
         black_gc := darea.get_style.black_gc

         width := darea.allocation.width.item
         height := darea.allocation.height.item

         drawable.draw_rectangle(white_gc, 1, 0, 0, width, height//2)
         drawable.draw_rectangle(black_gc, 1,
                  0, height//2, width, height//2)
         drawable.draw_rectangle(gray_gc, 1,
                  width//3, height//3, width//3, height//3)

      end -- cursor_expose_event

   set_cursor is
      local
        c : INTEGER
        cursor : GDK_CURSOR
        type : GDK_CURSOR_TYPE
      do
         c := spinner.get_value_as_int
	 !!type.make(c)
         !!cursor.make(type)
         darea.window.set_cursor(cursor)
         cursor.destroy
      end -- set_cursor

end -- class CREATE_CURSORS
