indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_entry.e,v 1.5 2000/03/13 18:20:00 eugenem Exp $";

class CREATE_ENTRY
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         box1 : GTK_VBOX
         box2 : GTK_VBOX
         editable_check : GTK_CHECK_BUTTON
         sensitive_check : GTK_CHECK_BUTTON
         entry : GTK_ENTRY
         cb : GTK_COMBO
         button : GTK_BUTTON
         separator : GTK_HSEPARATOR
      do
         !!window.make(Gtk_window_toplevel)

         signal_connect(window,"destroy",$destroy_window)

         window.set_title("entry")
         window.set_border_width(0)

         !!box1.make(false, 0)
         window.add(box1)
         box1.show

         !!box2.make(false, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, true, true, 0)
         box2.show

         !!entry.make
         entry.set_text("hello world")
         entry.select_region(0, 5)
         box2.pack_start(entry, true, true, 0)
         entry.show

         !!cb.make
         cb.set_popdown_strings(<<"item0"
            ,"item1 item1"
            ,"item2 item2 item2"
            ,"item3 item3 item3 item3"
            ,"item4 item4 item4 item4 item4"
            ,"item5 item5 item5 item5 item5 item5"
            ,"item6 item6 item6 item6 item6"
            ,"item7 item7 item7 item7"
            ,"item8 item8 item8"
            ,"item9 item9">>)
         cb.entry.set_text("hello world")
         cb.entry.select_region(0, -1)
         box2.pack_start(cb, true, true, 0)
         cb.show

         !!editable_check.make_with_label("Editable")
         box2.pack_start(editable_check, false, true, 0)
         signal_connect_with_data(editable_check,"toggled",
            $entry_toggle_editable,entry)
         editable_check.set_active(true)
         editable_check.show

         !!editable_check.make_with_label("Visible")
         box2.pack_start(editable_check, false, true, 0)
         signal_connect_with_data(editable_check,"toggled",
               $entry_toggle_visibility,entry)
         editable_check.set_active(true)
         editable_check.show

         !!sensitive_check.make_with_label("Sensitive")
         box2.pack_start(sensitive_check, false, true, 0)
         signal_connect_with_data(sensitive_check,"toggled",
               $entry_toggle_sensitive, entry)
         sensitive_check.set_active(true)
         sensitive_check.show

         !!separator.make
         box1.pack_start(separator, false, true, 0)
         separator.show


         !!box2.make(false, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, false, true, 0)
         box2.show


         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(button, true, true, 0)
         button.set_flags(Gtk_can_default)
         button.grab_default
         button.show

         window.show
      end -- make

feature {NONE} -- Implementations

   entry_toggle_editable(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         entry : GTK_ENTRY
         button : GTK_TOGGLE_BUTTON
      do
         entry ?= data
         button ?= cb_data.get_widget

         entry.set_editable(button.get_active)
      end -- entry_toggle_editable

   entry_toggle_sensitive(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         entry : GTK_ENTRY
         button : GTK_TOGGLE_BUTTON
      do
         entry ?= data
         button ?= cb_data.get_widget

         entry.set_sensitive(button.get_active)
      end -- entry_toggle_sensitive

   entry_toggle_visibility(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         entry : GTK_ENTRY
         button : GTK_TOGGLE_BUTTON
      do
         entry ?= data
         button ?= cb_data.get_widget

         entry.set_visibility(button.get_active)
      end -- entry_toggle_visibility

end -- class CREATE_ENTRY
