indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_idle.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_IDLE
inherit
   SIMPLE_TEST
      redefine
         destroy_window
      end
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         radio : GTK_RADIO_BUTTON
         button : GTK_BUTTON
         frame : GTK_FRAME
         box : GTK_VBOX
         dialog : GTK_DIALOG
      do
         !!dialog.make

         window := dialog

         signal_connect(dialog,"destroy",$destroy_window)

         dialog.set_title("Idle Test")
         dialog.set_border_width(0)

         !!label.make("count: 0")
         label.set_padding(10, 10)

         !!container.make(true,0)
         container.pack_start(label,true,true,0)
         dialog.vbox.pack_start(container, true, true, 0)

         !!frame.make("Label Container")
         dialog.vbox.pack_start(frame,true,true,5)

         !!box.make(true,0)
         frame.add(box)

         !!radio.make_with_label(Void,"Resize parent")
         box.pack_start(radio,false,true,0)
         signal_connect_with_data(radio,"clicked",$toggle_idle_container,
         Gtk_resize_parent.get_value)

         !!radio.make_with_label(radio.group,"Resize queue")
         box.pack_start(radio,false,true,0)
         signal_connect_with_data(radio,"clicked",$toggle_idle_container,
         Gtk_resize_queue.get_value)

         !!radio.make_with_label(radio.group,"Resize-Immediate")
         box.pack_start(radio,false,true,0)
         signal_connect_with_data(radio,"clicked",$toggle_idle_container,
         Gtk_resize_immediate.get_value)

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)
         button.grab_default

         !!button.make_with_label("start")
         signal_connect(button,"clicked",$start_idle_test)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)

         !!button.make_with_label("stop")
         signal_connect(button,"clicked",$stop_idle_test)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)

         dialog.show_all
      end -- make

feature {NONE} -- Implementations

   container : GTK_HBOX
   label : GTK_LABEL
   count : INTEGER

   idle : GTK_IDLE

   idle_test : INTEGER is
      local
         buffer : STRING
      do
         !!buffer.make(32)
         count := count+1
         buffer.copy("count: ")
         buffer.append_string(count.out)
         label.set_text(buffer)
         Result := 1;
      end -- idle_test

   start_idle_test is
      do
         if idle = Void then
            !!idle.make(current, $idle_test, label)
         end
      end -- start_idle_test

   stop_idle_test is
      do
         if idle /= Void then
            idle.remove
            idle := Void
         end
      end -- stop_idle_test

   toggle_idle_container(data : ANY) is
      local
         mode : GTK_RESIZE_MODE
         i : INTEGER_REF
      do
         i ?= data
         !!mode.make(i.item)
         container.set_resize_mode(mode)
      end -- toggle_idle_container

   destroy_window is
      do
         stop_idle_test
         Precursor
      end -- destroy_window

end -- class CREATE_IDLE
