indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_menus.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_MENUS
inherit
   SIMPLE_TEST
   GTK_CONSTANTS
   VEGTK_CALLBACK_HANDLER

creation
   make

feature -- Creation

   make is
      -- Creation and initialization
      local
         box1, box2 : GTK_BOX
         button : GTK_BUTTON
         menu : GTK_MENU
         menubar : GTK_MENU_BAR
         menuitem : GTK_MENU_ITEM
         optionmenu : GTK_OPTION_MENU
         separator : GTK_HSEPARATOR
         accel_group : GTK_ACCEL_GROUP
         keys : GDK_KEYS
      do
         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)

         !!accel_group.make
         accel_group.attach(window)

         window.set_title("menus")
         window.set_border_width(0)

         !GTK_VBOX!box1.make(False, 0)
         window.add(box1)
         box1.show

         !!menubar.make
         box1.pack_start(menubar, False, True, 0)
         menubar.show

         !!menuitem.make_with_label("test%Nline2")
         menu := create_menu(2)
         menuitem.set_submenu(menu)
         menubar.append(menuitem)
         menuitem.show

         !!menuitem.make_with_label("foo")
         menu := create_menu(1)
         menuitem.set_submenu(menu)
         menubar.append(menuitem)
         menuitem.show

         !!menuitem.make_with_label("bar")
         menu := create_menu(4)
         menuitem.set_submenu(menu)
         menuitem.right_justify
         menubar.append(menuitem)
         menuitem.show

         !GTK_VBOX!box2.make(False, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, True, True, 0)
         box2.show

         menu := create_menu (1)
         menu.set_accel_group(accel_group)
         !GTK_CHECK_MENU_ITEM!menuitem.make_with_label("Accelerate Me")
         menu.append(menuitem)
         menuitem.show
         !!keys
         menuitem.add_accelerator("activate", accel_group, keys.gdk_f1,Gdk_modifier_type_zero,Gtk_accel_visible and Gtk_accel_signal_visible )

         !GTK_CHECK_MENU_ITEM!menuitem.make_with_label("Accelerator Locked")
         menu.append(menuitem)
         menuitem.show
         menuitem.add_accelerator("activate", accel_group, keys.gdk_f1,Gdk_modifier_type_zero, Gtk_accel_visible and Gtk_accel_locked)
         !!optionmenu.make
         optionmenu.set_menu(menu)
         optionmenu.set_history(4)
         box2.pack_start(optionmenu, True, True, 0)
         optionmenu.show

         !!separator.make
         box1.pack_start(separator, False, True, 0)
         separator.show

         !GTK_VBOX!box2.make(False, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, False, True, 0)
         box2.show

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(button, True, True, 0)
         button.set_flags(Gtk_can_default)
         button.grab_default
         button.show

         window.show
      end -- make

feature {NONE} -- Implementations

   create_menu(depth : INTEGER) : GTK_MENU is
      local
         menu : GTK_MENU
         submenu : GTK_MENU
         menuitem : GTK_RADIO_MENU_ITEM
         buf : STRING
         i, j : INTEGER
         group : G_SLIST
      do
         if depth < 1 then
            Result := Void
         else
            !!menu.make
            from
               i := 0
               j := 1
            until i >= 5
            loop
               !!buf.make(10)
               buf.copy("item ")
               buf.append_string(depth.out)
               buf.append_string(" ")
               buf.append_string(j.out)

               if menuitem = Void then
                  !!menuitem.make_alone_with_label(buf)
               else
                  group := menuitem.group
                  !!menuitem.make_with_label(group, buf)
               end -- if
               menu.append(menuitem)
               menuitem.show
               menuitem.configure(False, False)
               if depth > 1 then
                  submenu := create_menu(depth - 1)
                  menuitem.set_submenu(submenu)
               end -- if
               i := i + 1; j := j + 1
            end -- loop
            Result := menu
         end -- if
      end -- create_menu

end -- class CREATE_MENUS

