indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_paned.e,v 1.5 2000/03/13 18:20:00 eugenem Exp $";

class CREATE_PANED
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature {ANY} -- creation

   make is
      local
         frame : GTK_FRAME
         hpaned : GTK_HPANED
         vpaned : GTK_VPANED
         button : GTK_BUTTON
         vbox : GTK_VBOX
      do
         !!window.make(Gtk_window_toplevel)

         signal_connect(window,"destroy",$destroy_window)

         window.set_title("Panes")
         window.set_border_width(0)

         !!vbox.make(false, 0)
         window.add(vbox)

         !!vpaned.make
         vbox.pack_start(vpaned, true, true, 0)
         vpaned.set_border_width(5)

         !!hpaned.make
         vpaned.add1(hpaned)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         frame.set_usize(60, 60)
         hpaned.add1(frame)

         !!button.make_with_label("Hi there")
         frame.add(button)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         frame.set_usize(80, 60)
         hpaned.add2(frame)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         frame.set_usize(60, 80)
         vpaned.add2(frame)

         -- Now create toggle buttons to control sizing

         vbox.pack_start(create_pane_options (hpaned,
                        "Horizontal",
                        "Left",
                        "Right"),
            false, false, 0)

         vbox.pack_start(create_pane_options (vpaned,
                        "Vertical",
                        "Top",
                        "Bottom"),
            false, false, 0);

         vbox.show_all

         window.show
      end -- make

feature {NONE} -- implementations

   create_pane_options(paned : GTK_PANED; frame_label : STRING;
           label1 : STRING; label2 : STRING) : GTK_WIDGET is
      local
         frame : GTK_FRAME
         table : GTK_TABLE
         label : GTK_LABEL
         check_button : GTK_CHECK_BUTTON
      do
         !!frame.make(frame_label)
         frame.set_border_width(4)

         !!table.make(3, 2, true)
         frame.add(table)

         !!label.make(label1)
         table.attach_defaults(label, 0, 1, 0, 1)

         !!check_button.make_with_label("Resize")
         table.attach_defaults(check_button, 0, 1, 1, 2)
         signal_connect_with_data(check_button,"toggled",$toggle_resize,
                     paned.child1)

         !!check_button.make_with_label("Shrink")
         table.attach_defaults(check_button, 0, 1, 2, 3)
         check_button.set_active(true)
         signal_connect_with_data(check_button,"toggled",$toggle_shrink,
                     paned.child1)

         !!label.make(label2)
         table.attach_defaults(label, 1, 2, 0, 1)

         !!check_button.make_with_label("Resize")
         table.attach_defaults(check_button, 1, 2, 1, 2)
         check_button.set_active(true)
         signal_connect_with_data(check_button,"toggled",$toggle_resize,
                     paned.child2)

         !!check_button.make_with_label("Shrink")
         table.attach_defaults(check_button, 1, 2, 2, 3)
         check_button.set_active(true)
         signal_connect_with_data(check_button,"toggled",$toggle_shrink,paned.child2)

         Result := frame
      end -- create_pane_options

   toggle_resize (data : ANY) is
      local
         child : GTK_WIDGET
         paned : GTK_PANED
         is_child1, resize, shrink : BOOLEAN
      do
         child ?= data
         !!paned.from_external( child.parent.to_external )
         is_child1 := child.to_external = paned.child1.to_external

         if is_child1 then
            resize := paned.child1_resize
            shrink := paned.child1_shrink
         else
            resize := paned.child2_resize
            shrink := paned.child2_shrink
         end -- if

         child.ref
         child.parent.remove(child)
         if is_child1 then
            paned.pack1(child,not resize, shrink)
         else
            paned.pack2(child,not resize, shrink)
         end -- if
         child.unref
      end -- toggle_resize

   toggle_shrink ( data : ANY ) is
      local
         child : GTK_WIDGET
         paned : GTK_PANED
         is_child1, resize, shrink : BOOLEAN
      do
         child ?= data
         !!paned.from_external( child.parent.to_external )
         is_child1 := child.to_external = paned.child1.to_external

         if is_child1 then
            resize := paned.child1_resize
            shrink := paned.child1_shrink
         else
            resize := paned.child2_resize
            shrink := paned.child2_shrink
         end -- if

         child.ref
         child.parent.remove(child)
         if is_child1 then
            paned.pack1(child, resize, not shrink)
         else
            paned.pack2(child, resize, not shrink)
         end -- if
         child.unref
      end -- toggle_shrink

end -- class CREATE_PANED
