indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_scribble.e,v 1.5 2000/03/13 18:20:00 eugenem Exp $";

class CREATE_SCRIBBLE
inherit
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS
   SIMPLE_TEST

creation
   make

feature -- Creation

   make is
      local
         vbox : GTK_VBOX
         button : GTK_BUTTON
      do
         !!window.make(Gtk_window_toplevel)
         window.set_name("Test Input")

         !!vbox.make(false, 0)
         window.add(vbox)
         vbox.show

         signal_connect(window,"destroy",$destroy_window)

         !!drawing_area.make
         drawing_area.size(200,200)
         vbox.pack_start(drawing_area, true, true, 0)

         drawing_area.show

         signal_connect(drawing_area,"expose_event",$expose_event)
         signal_connect(drawing_area,"configure_event",$configure_event)

         signal_connect(drawing_area,"motion_notify_event",$motion_notify_event)
         signal_connect(drawing_area,"button_press_event",$button_press_event)

         drawing_area.set_events(Gdk_exposure_mask and Gdk_leave_notify_mask and
                                 Gdk_button_press_mask and Gdk_pointer_motion_mask and
                                 Gdk_pointer_motion_hint_mask)

         !!button.make_with_label("Quit")
         vbox.pack_start(button, false, false, 0)

         signal_connect(button,"clicked", $close_window)
         button.show

         window.show
      end -- make

feature {NONE} -- Implementations

   drawing_area : GTK_DRAWING_AREA

   pixmap : GDK_PIXMAP

   configure_event is
      do
         if pixmap /= Void then
           pixmap.unref
         end -- if

         !!pixmap.make(drawing_area.window,drawing_area.allocation.width,
                       drawing_area.allocation.height,-1)
         pixmap.draw_rectangle(
                      drawing_area.get_style.white_gc,
                      1, 0, 0,
                      drawing_area.allocation.width,
                      drawing_area.allocation.height)
      end -- configure_event

   expose_event(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         event : GDK_EVENT_EXPOSE
      do
         event ?= cb_data.get_event
         drawing_area.window.draw_pixmap(
                  drawing_area.get_style.fg_gc(drawing_area.state),
                  pixmap,
                  event.area.x, event.area.y,
                  event.area.x, event.area.y,
                  event.area.width, event.area.height)
      end -- expose_event

   draw_brush(arg_x : REAL; arg_y : REAL) is
      local
         update_rect : GDK_RECTANGLE
      do
         !!update_rect.make_with_values((arg_x - 5).rounded , (arg_y - 5).rounded, 10, 10 )
         pixmap.draw_rectangle(
                      drawing_area.get_style.black_gc,
                      1,
                      update_rect.x, update_rect.y,
                      update_rect.width, update_rect.height)
         drawing_area.draw(update_rect)
      end -- draw_brush

   button_press_event(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         event : GDK_EVENT_BUTTON
      do
         event ?= cb_data.get_event
         if event.button = 1 and pixmap /= void then
            draw_brush(event.x, event.y)
         end -- if
      end -- button_press_event

   x : INTEGER
   y : INTEGER
   state_value : INTEGER

   motion_notify_event(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         event : GDK_EVENT_MOTION
         wnd : GDK_WINDOW
         state : GDK_MODIFIER_TYPE
      do
         event ?= cb_data.get_event

         if event.is_hint=1 then
            wnd := event.window.get_pointer($x,$y,$state_value)
            !!state.make(state_value)
         else
            x := event.x.rounded
            y := event.y.rounded
            !!state.make( event.state )
         end -- if

         if state.is_equal(state and Gdk_button1_mask) and (pixmap /= void) then
           draw_brush(x,y)
         end -- if
      end -- motion_notify_event

end -- class CREATE_SCRIBBLE
