indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_statusbar.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_STATUSBAR
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         box1, box2 : GTK_VBOX
         button : GTK_BUTTON
         separator : GTK_HSEPARATOR
      do
         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)
         window.set_title("statusbar")
         window.set_border_width(0)

         !!box1.make(False, 0)
         window.add(box1)

         !!box2.make(False, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, True, True, 0)

         !!statusbar.make
         box1.pack_end(statusbar, True, True, 0)

         !!button.make_with_label("push something")
         box2.add(button)
         signal_connect_with_data(button,"clicked",$execute,statusbar_push)

         !!button.make_with_label("pop")
         box2.add(button)
         signal_connect_with_data(button,"clicked",$execute, pop)

         !!button.make_with_label("steal #4")
         box2.add(button)
         signal_connect_with_data(button,"clicked",$execute, steal)

         !!button.make_with_label("dump stack")
         box2.add(button)
         signal_connect_with_data(button,"clicked",$execute, dump_stack)

         !!separator.make
         box1.pack_start(separator, False, True, 0)

         !!box2.make(False, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, False, True, 0)

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(button, True, True, 0)
         button.set_flags(Gtk_can_default)
         button.grab_default

         window.show_all
      end -- make

feature {NONE} -- Implementations

   text_popped, statusbar_push, pop, steal, dump_stack : INTEGER is unique
   statusbar_counter : INTEGER
   statusbar : GTK_STATUSBAR

   execute ( data : ANY ) is
      local
         i : INTEGER_REF
         text : STRING
      do
         i ?= data
         inspect i.item
         when statusbar_push then

            statusbar_counter := statusbar_counter +1

            !!text.make(10)
            text.copy("something ")
            text.append_string(statusbar_counter.out)
            statusbar.push(1, text)

         when pop then
            statusbar.pop(1)
            if statusbar_counter > 0 then
               statusbar_counter := statusbar_counter -1
            end
         when steal then
            statusbar.remove(1, 4)
         else
         end -- inspect
      end -- execute

end -- class CREATE_STATUSBAR
