indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_toolbar.e,v 1.5 2000/03/13 18:20:00 eugenem Exp $";

class CREATE_TOOLBAR
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      do
         !!window.make(Gtk_window_toplevel)
         signal_connect(window,"destroy",$destroy_window)
         window.set_title("Toolbar")
         window.set_policy(False, True, True)
         window.set_border_width(0)
         window.realize

         make_toolbar

         window.add(toolbar)
         window.show_all
      end -- make

feature {NONE} -- Implementations

   horizontal, vertical, icons, text, both, small, big, tooltips_enable,
   tooltips_disable, show_borders, hide_borders: INTEGER is unique

   toolbar : GTK_TOOLBAR

   make_toolbar is
      local
         entry : GTK_ENTRY
      do
         !!toolbar.make(Gtk_orientation_horizontal,
            Gtk_toolbar_both)
         toolbar.append_item("Horizontal",
                        "Horizontal toolbar layout",
                        "Toolbar/Horizontal",
                        testxpm,
                        current,$toolbar_clicked, horizontal)
         toolbar.append_item("Vertical",
                        "Vertical toolbar layout",
                        "Toolbar/Vertical",
                        testxpm,
                        current,$toolbar_clicked, vertical)
         toolbar.append_space
         toolbar.append_item("Icons", "Only show toolbar icons",
                        "Toolbar/IconsOnly",
                        testxpm,
                        current,$toolbar_clicked, icons)
         toolbar.append_item("Text", "Only show toolbar text",
                        "Toolbar/TextOnly",
                        testxpm,
                        current,$toolbar_clicked, text)
         toolbar.append_item("Both",
                        "Show toolbar icons and text",
                        "Toolbar/Both",
                        testxpm,
                        current,$toolbar_clicked, both)
         toolbar.append_space

         !!entry.make
         toolbar.append_widget(entry, "This is an unusable GtkEntry",
                     "Hey don't click me!!!")
         toolbar.append_space

         toolbar.append_item("Small", "Use small spaces",
                        "Toolbar/Small",
                        testxpm,
                        current,$toolbar_clicked, small)
         toolbar.append_item("Big", "Use big spaces",
                     "Toolbar/Big",
                     testxpm,
                     current,$toolbar_clicked, big)
         toolbar.append_space
         toolbar.append_item("Enable", "Enable tooltips", "",
                           testxpm,
                           current,$toolbar_clicked, tooltips_enable)
         toolbar.append_item("Disable",
                           "Disable tooltips", "",
                           testxpm,
                           current,$toolbar_clicked, tooltips_disable)
         toolbar.append_space
         toolbar.append_item("Borders", "Show Borders", "",
                           testxpm, current,$toolbar_clicked, show_borders)
         toolbar.append_item("Borderless", "Hide Borders", "",
                           testxpm, current,$toolbar_clicked, hide_borders)
      end

   toolbar_clicked ( data : ANY ) is
      local
         i : INTEGER_REF
      do
         i ?= data
         inspect i.item
         when horizontal then
            toolbar.set_orientation(Gtk_orientation_horizontal)
         when vertical then
            toolbar.set_orientation(Gtk_orientation_vertical)
         when icons then
            toolbar.set_style(Gtk_toolbar_icons)
         when text then
            toolbar.set_style(Gtk_toolbar_text)
         when both then
            toolbar.set_style(Gtk_toolbar_both)
         when small then
            toolbar.set_space_size(5)
         when big then
            toolbar.set_space_size(10)
         when tooltips_enable then
            toolbar.set_tooltips(True)
         when tooltips_disable then
            toolbar.set_tooltips(False)
         when show_borders then
            toolbar.set_button_relief(Gtk_relief_normal)
         when hide_borders then
            toolbar.set_button_relief(Gtk_relief_none)
         else
         end -- inspect
      end -- toolbar_clicked

   pixmap : GDK_PIXMAP is
      do
         !!Result.make_from_xpm(window.window,
                  window.get_style.bg(Gtk_state_normal),
                  "test.xpm")
      end -- pixmap

   testxpm : GTK_PIXMAP is
      do
         !!Result.make(pixmap,pixmap.mask)
      end -- testxpm

end -- class CREATE_TOOLBAR
