indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_ctree.e,v 1.8 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_CTREE
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         ctree : GTK_CTREE
         scrolled_win : GTK_SCROLLED_WINDOW
         vbox, mbox : GTK_VBOX
         bbox, hbox, hbox2 : GTK_HBOX
         frame : GTK_FRAME
         label : GTK_LABEL
         button : GTK_BUTTON
         check_button : GTK_CHECK_BUTTON
         adj : GTK_ADJUSTMENT
         spinner : GTK_SPIN_BUTTON
      do
         !!window.make(Gtk_window_toplevel)

         signal_connect(window,"destroy",$destroy_window)

         window.set_title("GtkCTree")
         window.set_border_width(0)

         !!tooltips.make
         tooltips.ref
         tooltips.sink

--       gtk_object_set_data_full (GTK_OBJECT (window), "tooltips", tooltips,
--             (GtkDestroyNotify) gtk_object_unref);

         !!vbox.make(false, 0);
         window.add(vbox)

         !!hbox.make(false, 5);
         hbox.set_border_width(5)
         vbox.pack_start(hbox, false, true, 0)

         !!label.make("Depth :")
         hbox.pack_start(label, false, true, 0)

         !!adj.make(4, 1, 10, 1, 5, 0)
         !!spin1.make(adj, 0, 0)
         hbox.pack_start(spin1, false, true, 5)

         !!label.make("Books :")
         hbox.pack_start(label, false, true, 0)

         !!adj.make(3, 1, 20, 1, 5, 0)
         !!spin2.make(adj, 0, 0)
         hbox.pack_start(spin2, false, true, 5)

         !!label.make("Pages :")
         hbox.pack_start(label, false, true, 0)

         !!adj.make(5, 1, 20, 1, 5, 0)
         !!spin3.make(adj, 0, 0)
         hbox.pack_start(spin3, false, true, 5)

         !!button.make_with_label("Close")
         hbox.pack_end(button, true, true, 0)

         signal_connect(button,"clicked", $close_window)

         !!button.make_with_label("Rebuild Tree")
         hbox.pack_start(button, true, true, 0)

         !!scrolled_win.make(Void, Void)
         scrolled_win.set_border_width(5)
         scrolled_win.set_policy(Gtk_policy_automatic,Gtk_policy_always)
         vbox.pack_start(scrolled_win, true, true, 0)

         !!ctree.make_with_titles(2, 0, <<"Tree", "Info">>)
         scrolled_win.add(ctree)

         ctree.set_column_auto_resize(0, true)
         ctree.set_column_width(1, 200)
         ctree.set_selection_mode(Gtk_selection_extended)
         ctree.set_line_style(Gtk_ctree_lines_dotted)
         line_style := Gtk_ctree_lines_dotted

         signal_connect_with_data(button,"clicked",$rebuild_tree,ctree)
         signal_connect_with_data(ctree,"click_column",$ctree_click_column,ctree)

         signal_connect_after(ctree,"button_press_event",$after_press,Void)
         signal_connect_after(ctree,"button_release_event",$after_press,Void)
         signal_connect_after(ctree,"tree_move",$after_move,Void)
         signal_connect_after(ctree,"end_selection",$after_press,Void)
         signal_connect_after(ctree,"toggle_focus_row",$after_press,Void)
         signal_connect_after(ctree,"select_all",$after_press,Void)
         signal_connect_after(ctree,"unselect_all",$after_press,Void)
         signal_connect_after(ctree,"scroll_vertical",$after_press,Void)

         !!bbox.make(false, 5)
         bbox.set_border_width(5)
         vbox.pack_start(bbox, false, true, 0)

         !!mbox.make(true, 5)
         bbox.pack_start(mbox, false, true, 0)

         !!label.make("Row Height :")
         mbox.pack_start(label, false, false, 0)

         !!label.make("Indent :")
         mbox.pack_start(label, false, false, 0)

         !!label.make("Spacing :")
         mbox.pack_start(label, false, false, 0)

         !!mbox.make(true, 5)
         bbox.pack_start(mbox, false, true, 0)

         !!adj.make(20, 12, 100, 1, 10, 0)
         !!spinner.make(adj, 0, 0)
         mbox.pack_start(spinner, false, false, 5)
         tooltips.set_tip(spinner,"Row height of list items","")
         signal_connect_with_data(adj,"value_changed",$change_row_height,ctree)
         ctree.set_row_height(adj.value.rounded)

         !!adj.make(20, 0, 60, 1, 10, 0)
         !!spinner.make(adj, 0, 0)
         mbox.pack_start(spinner, false, false, 5)
         tooltips.set_tip(spinner, "Tree Indentation.", "")
         signal_connect_with_data(adj,"value_changed",$change_indent,ctree)

         !!adj.make(5, 0, 60, 1, 10, 0)
         !!spinner.make(adj, 0, 0)
         mbox.pack_start(spinner, false, false, 5)
         tooltips.set_tip(spinner, "Tree Spacing.","")
         signal_connect_with_data(adj,"value_changed",$change_spacing,ctree)

         !!mbox.make(true, 5)
         bbox.pack_start(mbox, false, true, 0)

         !!hbox.make(false, 5)
         mbox.pack_start(hbox, false, false, 0)

         !!button.make_with_label("Expand All")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$expand_all,ctree)

         !!button.make_with_label("Collapse All")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$collapse_all,ctree)

         !!button.make_with_label("Change Style")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$change_style,ctree)

         !!button.make_with_label ("Export Tree")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$do_export_ctree,ctree)

         !!hbox.make(false, 5)
         mbox.pack_start(hbox, false, false, 0)

         !!button.make_with_label("Select All")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$select_all,ctree)

         !!button.make_with_label("Unselect All")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$unselect_all,ctree)

         !!button.make_with_label("Remove Selection")
         hbox.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$remove_selection,ctree)

         !!check_button.make_with_label("Reorderable")
         hbox.pack_start(check_button, false, true, 0)
         tooltips.set_tip(check_button,"Tree items can be reordered by dragging.","")
         signal_connect_with_data(check_button,"clicked",$toggle_reorderable,ctree)
         check_button.set_active(true)

         !!hbox.make(true, 5)
         mbox.pack_start(hbox, false, false, 0)

         omenu1 := build_option_menu (items1, 4, 2, ctree)
         hbox.pack_start(omenu1, false, true, 0)
         tooltips.set_tip(omenu1, "The tree's line style.", "")

         omenu2 := build_option_menu (items2, 4, 1, ctree)
         hbox.pack_start(omenu2, false, true, 0)
         tooltips.set_tip(omenu2, "The tree's expander style.","")

         omenu3 := build_option_menu (items3, 2, 0, ctree)
         hbox.pack_start(omenu3, false, true, 0)
         tooltips.set_tip(omenu3, "The tree's justification.","")

         omenu4 := build_option_menu (items4, 4, 3, ctree)
         hbox.pack_start(omenu4, false, true, 0)
         tooltips.set_tip(omenu4, "The list's selection mode.","")

         window.realize

         pixmap1 := book_closed_pixmap(window)
         pixmap2 := book_open_pixmap(window)
         pixmap3 := mini_page_pixmap(window)

         ctree.set_usize(0, 300)

         !!frame.make(Void)
         frame.set_border_width(0)
         frame.set_shadow_type(Gtk_shadow_out)
         vbox.pack_start(frame, false, true, 0)

         !!hbox.make(true, 2)
         hbox.set_border_width(2)
         frame.add(hbox)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         hbox.pack_start(frame, false, true, 0)

         !!hbox2.make(false, 0)
         hbox2.set_border_width(2)
         frame.add(hbox2)

         !!label.make("Books :")
         hbox2.pack_start(label, false, true, 0)

         !!book_label.make(books.out)
         hbox2.pack_end(book_label, false, true, 5)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         hbox.pack_start(frame, false, true, 0)

         !!hbox2.make(false, 0)
         hbox2.set_border_width(2)
         frame.add(hbox2)

         !!label.make("Pages :")
         hbox2.pack_start(label, false, true, 0)

         !!page_label.make(pages.out)
         hbox2.pack_end(page_label, false, true, 5)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         hbox.pack_start(frame, false, true, 0)

         !!hbox2.make(false, 0)
         hbox2.set_border_width(2)
         frame.add(hbox2)

         !!label.make("Selected :")
         hbox2.pack_start(label, false, true, 0)

         !!sel_label.make(ctree.selected_nodes_list.length.out)
         hbox2.pack_end(sel_label, false, true, 5)

         !!frame.make(Void)
         frame.set_shadow_type(Gtk_shadow_in)
         hbox.pack_start(frame, false, true, 0)

         !!hbox2.make(false, 0)
         hbox2.set_border_width(2)
         frame.add(hbox2)

         !!label.make("Visible :")
         hbox2.pack_start(label, false, true, 0)

         !!vis_label.make(ctree.row_list.length.out)
         hbox2.pack_end(vis_label, false, true, 5)

         rebuild_tree (ctree)

         window.show_all
      end -- make

feature {NONE} -- Implementations

   tooltips : GTK_TOOLTIPS

   pixmap1, pixmap2, pixmap3 : GDK_PIXMAP
   books, pages : INTEGER
   book_label : GTK_LABEL
   page_label : GTK_LABEL
   sel_label : GTK_LABEL
   vis_label : GTK_LABEL
   omenu1 : GTK_OPTION_MENU
   omenu2 : GTK_OPTION_MENU
   omenu3 : GTK_OPTION_MENU
   omenu4 : GTK_OPTION_MENU
   spin1 : GTK_SPIN_BUTTON
   spin2 : GTK_SPIN_BUTTON
   spin3 : GTK_SPIN_BUTTON
   line_style : GTK_CTREE_LINE_STYLE

   items1 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      once
         !!Result.make(0,3)
         !!item.make("No lines",$ctree_toggle_line_style)
         Result.put(item,0)
         !!item.make("Solid",$ctree_toggle_line_style)
         Result.put(item,1)
         !!item.make("Dotted",$ctree_toggle_line_style)
         Result.put(item,2)
         !!item.make("Tabbed",$ctree_toggle_line_style)
         Result.put(item,3)
      end -- items1

   items2 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      once
         !!Result.make(0,3)
         !!item.make("None",$ctree_toggle_expander_style)
         Result.put(item,0)
         !!item.make("Square",$ctree_toggle_expander_style)
         Result.put(item,1)
         !!item.make("Triangle",$ctree_toggle_expander_style)
         Result.put(item,2)
         !!item.make("Circular",$ctree_toggle_expander_style)
         Result.put(item,3)
      end -- items2

   items3 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      once
         !!Result.make(0,1)
         !!item.make("Left",$ctree_toggle_justify)
         Result.put(item,0)
         !!item.make("Right",$ctree_toggle_justify)
         Result.put(item,1)
      end -- items3

   items4 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      once
         !!Result.make(0,3)
         !!item.make("Single",$ctree_toggle_sel_mode)
         Result.put(item,0)
         !!item.make("Browse",$ctree_toggle_sel_mode)
         Result.put(item,1)
         !!item.make("Multiple",$ctree_toggle_sel_mode)
         Result.put(item,2)
         !!item.make("Extended",$ctree_toggle_sel_mode)
         Result.put(item,3)
      end -- items4

   after_press(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         buf : STRING
      do
         ctree ?= cb_data.get_widget
         !!buf.make(80)

         buf.copy(ctree.selected_nodes_list.length.out)
         sel_label.set_text(buf)

         buf.copy(ctree.row_list.length.out)
         vis_label.set_text(buf)

         buf.copy(books.out)
         book_label.set_text(buf)

         buf.copy(pages.out)
         page_label.set_text(buf)
      end -- after_press

   ptr : POINTER

   after_move(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
-- (GtkCTree *ctree, GtkCTreeNode *child, GtkCTreeNode *parent,
--     GtkCTreeNode *sibling, gpointer data)
      local
         args : GTK_CTREE_TREE_MOVE_CALLBACK_ARGS;
         sh : VEGTK_STRING_HELPER
         ctree : GTK_CTREE
         child : GTK_CTREE_NODE
         parent : GTK_CTREE_NODE
         sibling : GTK_CTREE_NODE
         source : STRING
         target1 : STRING
         target2 : STRING
      do
         !!sh
         !!args.make(cb_data);

         ctree ?= args.get_widget;
         child := args.node;
         parent := args.new_parent;
         sibling := args.new_sibling;

         ctree.get_node_info(child, $ptr, default_pointer, default_pointer,
            default_pointer, default_pointer, default_pointer, default_pointer
            ,default_pointer)
         source:=sh.string_from_external(ptr)
         target1 := ""
         if parent /= Void then
            ctree.get_node_info(parent,$ptr,
                     default_pointer, default_pointer, default_pointer,
                     default_pointer, default_pointer, default_pointer,
                     default_pointer);
            target1:=sh.string_from_external(ptr)
         end -- if
         target2 := ""
         if sibling /= Void then
            ctree.get_node_info(sibling,$ptr,
               default_pointer, default_pointer, default_pointer,
               default_pointer, default_pointer, default_pointer,
               default_pointer)
            target2:=sh.string_from_external(ptr)
         end -- if

         print("Moving %"")
         print(source)
         if target1 /= "" then
            print("%" to %"")
            print(target1)
         end
         if target2 /= "" then
            print("%" with sibling %"")
            print(target2)
         end
         print("%N")
--       g_print("Moving \"%s\" to \"%s\" with sibling \"%s\".\n", source,
--             (parent) ? target1 : "nil", (sibling) ? target2 : "nil");
    end -- after_move

-- this routine is used as callback
   count_items (ctree_ptr : POINTER; list_ptr : POINTER) is
      local
         node : GTK_CTREE_NODE
      do
         !!node.from_external(list_ptr)

         if node.to_row.is_leaf then
            pages := pages-1
         else
            books := books-1
         end -- if
      end -- count_items

   expand_all(data : ANY) is
      local
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
      do
         ctree ?= data
         ctree.expand_recursive(Void)
         !!cb_data.make(ctree, current, $after_press)
         after_press (Void, cb_data)
      end -- expand_all

   collapse_all(data : ANY) is
      local
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
      do
         ctree ?= data
         ctree.collapse_recursive(Void)
         !!cb_data.make(ctree, current, $after_press)
         after_press (Void, cb_data)
      end -- collapse_all

   select_all(data : ANY) is
      local
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
      do
         ctree ?= data
         ctree.select_recursive(Void)
         !!cb_data.make(ctree, current, $after_press)
         after_press (Void, cb_data)
      end -- select_all

   change_style(data : ANY) is
      local
         ctree : GTK_CTREE
         style1, style2 : GTK_STYLE
         node : GTK_CTREE_NODE
         col1, col2 : GDK_COLOR
         font : GDK_FONT;
      do
         ctree ?= data
         if ctree.focus_row >= 0 then
            !!node.from_list (ctree.row_list.nth(ctree.focus_row));
         else
           !!node.from_list (ctree.row_list);
         end -- if

         if node /= Void then

            !!col1.make_with_values(0,56000,0)
            !!col2.make_with_values(32000,0,56000)

            !!style1.make
            style1.set_base(Gtk_state_normal, col1)
            style1.set_fg(Gtk_state_selected, col2)

            !!style2.make
            style2.set_base(Gtk_state_selected, col2)
            style2.set_fg(Gtk_state_normal, col1)
            style2.set_base(Gtk_state_normal, col2)
            style2.font.unref;
            !!font.load("-*-courier-medium-*-*-*-*-300-*-*-*-*-*-*");
            style2.set_font (font);

            ctree.node_set_cell_style(node, 1, style1)
            ctree.node_set_cell_style(node, 0, style2)

            if node.to_row.children /= Void then
               ctree.node_set_row_style(node.to_row.children,style2)
            end -- if
         end -- if
      end -- change_style

   unselect_all(data : ANY) is
      local
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
      do
         ctree ?= data

         ctree.unselect_recursive(Void)
         !!cb_data.make(ctree, current, $after_press)
         after_press (Void, cb_data)
      end -- unselect_all

   remove_selection(data : ANY) is
      local
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
         node : GTK_CTREE_NODE
         item : INTEGER;
         done : BOOLEAN;
      do
         ctree ?= data

         ctree.freeze

         from
            done := False;
         until
            ctree.selected_nodes_list.empty or done
         loop
            node := ctree.selected_nodes_list.item;
            if node.to_row.is_leaf then
               pages := pages-1
            else
               ctree.post_recursive(node,current,$count_items, default_pointer)
            end -- if

            ctree.remove_node(node)
            item := item + 1;
            if ctree.selection_mode.is_equal (Gtk_selection_browse) then
               done := True;
            end
         end -- loop

         if ctree.selection_mode.is_equal (Gtk_selection_extended) and
            ctree.selected_nodes_list.empty and ctree.focus_row >= 0 then
            node := ctree.node_nth(ctree.focus_row)
            if node /= Void then
               ctree.do_select(node)
            end -- if
         end -- if

         ctree.thaw
         !!cb_data.make(ctree, current, $after_press)
         after_press (Void, cb_data)
      end -- remove_selection

-- this routine is used as callback!
   gnode2ctree (ctree_ptr : POINTER; depth : INTEGER; gnode_ptr : POINTER;
        cnode_ptr : POINTER; data : POINTER) : BOOLEAN is
      local
         ctree : GTK_CTREE
         gnode : G_NODE
         cnode : GTK_CTREE_NODE
         es : EXPORT_STRUCT
         pixmap_closed : GDK_PIXMAP
         mask_closed : GDK_BITMAP
         pixmap_opened : GDK_PIXMAP
         mask_opened : GDK_BITMAP
      do
         if cnode_ptr = default_pointer or gnode_ptr = default_pointer then
            Result := false
         else
            !!gnode.from_external(gnode_ptr)
            if gnode.data = Void then -- will this work ?
               Result := false
            else
               !!cnode.from_external(cnode_ptr)
               !!ctree.from_external(ctree_ptr)
               es ?= gnode.data

               if es.is_leaf then
                  pixmap_closed := pixmap3
                  mask_closed := pixmap3.mask
                  pixmap_opened := Void
                  mask_opened := Void
               else
                  pixmap_closed := pixmap1
                  mask_closed := pixmap1.mask
                  pixmap_opened := pixmap2
                  mask_opened := pixmap2.mask
               end -- if

               ctree.set_node_info(cnode, es.tree, 2, pixmap_closed,
                           mask_closed, pixmap_opened, mask_opened,
                           es.is_leaf, (depth < 3))
               ctree.node_set_text(cnode, 1, es.info)
               -- g_free (es);
               gnode.set_data(Void);
               Result := true
            end -- if
         end -- if
      end -- gnode2ctree

-- callback routine!
   ctree2gnode (ctree_ptr : POINTER; depth : INTEGER; gnode_ptr : POINTER;
        cnode_ptr : POINTER; data : POINTER) : BOOLEAN is
      local
         es : EXPORT_STRUCT
         cnode : GTK_CTREE_NODE
         gnode : G_NODE
      do

         if cnode_ptr = default_pointer or gnode_ptr = default_pointer then
            Result := false
         else
            !!cnode.from_external( cnode_ptr )
            !!gnode.from_external( gnode_ptr )

            !!es.make(cnode.to_row.cell(0).text,
               cnode.to_row.cell(1).text,
               cnode.to_row.is_leaf)
            gnode.set_data( es )
            Result := true
         end -- if
      end -- ctree2gnode

   do_export_ctree(data : ANY) is
      local
         ctree : GTK_CTREE
         export_window : GTK_WINDOW
         export_ctree : GTK_CTREE
         vbox : GTK_VBOX
         scrolled_win : GTK_SCROLLED_WINDOW
         button : GTK_BUTTON
         sep : GTK_HSEPARATOR
         gnode : G_NODE
         node, tmp_node : GTK_CTREE_NODE
         mem : expanded MEMORY
      do
         ctree ?= data

         !!export_window.make(Gtk_window_toplevel)

         signal_connect_with_data(export_window,"destroy",$destroy_export_window,
            export_window)

         export_window.set_title("exported ctree")
         export_window.set_border_width(5)

         !!vbox.make(false, 0)
         export_window.add(vbox)

         !!button.make_with_label("Close")
         vbox.pack_end(button, false, true, 0)

         signal_connect_with_data(button,"clicked",$destroy_export_window,
               export_window)

         !!sep.make
         vbox.pack_end(sep, false, true, 10)

         !!export_ctree.make_with_titles(2, 0, <<"Tree", "Info">>)
         export_ctree.set_line_style(Gtk_ctree_lines_dotted)
         export_ctree.set_column_width(0, 200)
         export_ctree.set_column_width(1, 200)
         export_ctree.set_usize(300, 200)
         export_ctree.set_selection_mode(Gtk_selection_extended)

         !!scrolled_win.make(Void, Void)
         scrolled_win.add(export_ctree)
         scrolled_win.set_policy(Gtk_policy_automatic,Gtk_policy_automatic)
         vbox.pack_start(scrolled_win, true, true, 0)

         export_window.show_all

         export_ctree.clear

         !!node.from_list(ctree.row_list.nth(ctree.focus_row));

         mem.collection_off -- don't collect EXPORT_STRUCT instances!

         if node.to_external /=default_pointer then

            gnode := ctree.export_to_gnode(Void, Void, node,
                           current,$ctree2gnode,Void)
            if gnode /= Void then
               tmp_node := export_ctree.insert_gnode(Void, Void, gnode,
                           current,$gnode2ctree,Void)
               gnode.destroy
            end -- if

         mem.collection_on
         end -- if
      end -- do_export_tree

   change_indent (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         adj : GTK_ADJUSTMENT
      do
         ctree ?= data
         adj ?= cb_data.get_widget
         ctree.set_indent(adj.value.rounded)
      end -- change_indent

   change_spacing(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         adj : GTK_ADJUSTMENT
      do
         ctree ?= data
         adj ?= cb_data.get_widget
         ctree.set_spacing(adj.value.rounded)
      end -- change_spacing

   change_row_height(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         adj : GTK_ADJUSTMENT
      do
         ctree ?= data
         adj ?= cb_data.get_widget
         ctree.set_row_height(adj.value.rounded)
      end -- change_row_height

-- callback routine
   set_background(ctree_ptr : POINTER; node_ptr : POINTER) is
      local
         ctree : GTK_CTREE
         node : GTK_CTREE_NODE
         style : GTK_STYLE
      do
         if node_ptr /= default_pointer then
            !!ctree.from_external( ctree_ptr )
            !!node.from_external( node_ptr )
            if not ctree.line_style.is_equal (Gtk_ctree_lines_tabbed) then
               if not node.to_row.is_leaf then
                  style ?= ctree.node_get_row_data(node);
               else
                  if node.to_row.parent /= Void then
                     style ?= ctree.node_get_row_data(node.to_row.parent)
                  end -- if
               end -- if
            end -- if

            ctree.node_set_row_style(node, style)
         end -- if
      end -- set_background

   ctree_toggle_line_style(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         i : INTEGER
         ctree : GTK_CTREE
         widget : GTK_WIDGET
      do
         ctree ?= data

         widget ?= cb_data.get_widget
         if widget.mapped then

            i := radio_menu_toggled(omenu1.menu_item.group)

            if (ctree.line_style.is_equal(Gtk_ctree_lines_tabbed) and
               3 - i /= Gtk_ctree_lines_tabbed.get_value) or
               ((not ctree.line_style.is_equal(Gtk_ctree_lines_tabbed)) and
               3 - i = Gtk_ctree_lines_tabbed.get_value)
            then
               ctree.pre_recursive(Void, current, $set_background, Void)
            end -- if
            !!line_style.make(3 - i)
            ctree.set_line_style(line_style)
         end -- if
      end -- ctree_toggle_line_style

   ctree_toggle_expander_style(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         i : INTEGER
         widget : GTK_WIDGET
         style : GTK_CTREE_EXPANDER_STYLE
      do
         ctree ?= data

         widget ?= cb_data.get_widget
         if widget.mapped then
            i := radio_menu_toggled(omenu2.menu_item.group)

            !!style.make(3 - i)
            ctree.set_expander_style(style)
            end -- if
      end -- ctree_toggle_expander_style

   ctree_toggle_justify(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         i : INTEGER
         widget : GTK_WIDGET
         just : GTK_JUSTIFICATION
      do
         ctree ?= data

         widget ?= cb_data.get_widget
         if widget.mapped then
            i := radio_menu_toggled(omenu3.menu_item.group)

            !!just.make(1 - i)
            ctree.set_column_justification(ctree.tree_column, just)
            end -- if
      end -- ctree_toggle_justify

   ctree_toggle_sel_mode(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         i : INTEGER
         widget : GTK_WIDGET
         sel_mode : GTK_SELECTION_MODE
         cb_data1 : VEGTK_CALLBACK_DATA
      do
         ctree ?= data

         widget ?= cb_data.get_widget
         if widget.mapped then
            i := radio_menu_toggled(omenu4.menu_item.group)

            !!sel_mode.make(3 - i)
            ctree.set_selection_mode(sel_mode)
            !!cb_data1.make(ctree, current, $after_press)
            after_press (Void, cb_data1)
            end -- if
      end -- ctree_toggle_sel_mode

   toggle_reorderable(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         ctree : GTK_CTREE
         button : GTK_TOGGLE_BUTTON
      do
         button ?= cb_data.get_widget
         ctree ?= data
         ctree.set_reorderable(button.get_active)
      end -- toggle_reorderable

   build_recursive(ctree : GTK_CTREE; cur_depth, depth, num_books,
      num_pages : INTEGER; parent : GTK_CTREE_NODE) is
      local
         buf1 : STRING
         buf2 : STRING
         sibling : GTK_CTREE_NODE
         i : INTEGER
         math : MATH
         style : GTK_STYLE
         color : GDK_COLOR
      do
         !!math
         !!buf1.make(60)
         !!buf2.make(60)
         sibling := Void

         from
            i := num_pages + num_books
         until
            i <= num_books
         loop
            pages := pages+1
            buf1.copy("Page ")
            buf1.append_string((math.rand\\100).out) -- must be in (0,100)
            buf2.copy("Item ")
            buf2.append_string(cur_depth.out)
            buf2.append_string("-")
            buf2.append_string(i.out)
            sibling := ctree.insert_node(parent, sibling, <<buf1, buf2>>, 5,
                           pixmap3, pixmap3.mask, Void, Void, true, false)

            if parent /= void and ctree.line_style.is_equal (Gtk_ctree_lines_tabbed) then
               ctree.node_set_row_style(sibling,parent.to_row.style)
            end -- if
            i := i-1
         end -- loop

         if cur_depth /= depth then
            from
               i := num_books
            until
               i<=0
            loop
               books := books+1
               buf1.copy("Book ")
               buf1.append_string((math.rand\\100).out) -- must be in (0,100)
               buf2.copy("Item ")
               buf2.append_string(cur_depth.out)
               buf2.append_string("-")
               buf2.append_string(i.out)
               sibling := ctree.insert_node(parent, sibling, <<buf1, buf2>>, 5,
                              pixmap1, pixmap1.mask, pixmap2, pixmap2.mask,
                              false, false)

               !!style.make
               inspect cur_depth \\ 3
                  when 0 then
                     !!color.make_with_values(10000 * (cur_depth \\ 6),0,
                        65535 - ((i * 10000) \\ 65535))
                     style.set_base(Gtk_state_normal,color)
                  when 1 then
                     !!color.make_with_values(10000 * (cur_depth \\ 6),
                        65535 - ((i * 10000) \\ 65535), 0)
                     style.set_base(Gtk_state_normal,color)
                  else
                     !!color.make_with_values(65535 - ((i * 10000) \\ 65535),0,
                        10000 * (cur_depth \\ 6))
                     style.set_base(Gtk_state_normal,color)
               end -- inspect
               ctree.node_set_row_data_full(sibling, style,current,$destroy_style);

               if ctree.line_style.is_equal (Gtk_ctree_lines_tabbed) then
                  ctree.node_set_row_style(sibling, style)
               end -- if

               build_recursive(ctree, cur_depth + 1, depth, num_books, num_pages,
                        sibling)
               i := i-1
            end -- loop
         end -- if
      end -- build_recursive

   destroy_style(data : ANY) is
      local
         style : GTK_STYLE
      do
         style ?= data
         style.unref
      end -- destroy_style

   rebuild_tree(data : ANY) is
      local
         label1 : STRING
         label2 : STRING
         parent : GTK_CTREE_NODE
         style : GTK_STYLE
         color : GDK_COLOR
         b, d, p : INTEGER
         n : DOUBLE;
         ctree : GTK_CTREE
         cb_data : VEGTK_CALLBACK_DATA
      do
         ctree ?= data

         label1 := "Root"
         label2 := ""

         d := spin1.get_value_as_int
         b := spin2.get_value_as_int
         p := spin3.get_value_as_int

         n := ((b^d - 1) / (b - 1)) * (p + 1);
         if n > 100000 then
            print(n);
            print(" total items? That will take a very long time. Try less%N");
         else
            ctree.freeze
            ctree.clear

            books := 1
            pages := 0

            parent := ctree.insert_node(Void, Void, <<label1, label2>>, 5, pixmap1,

                     pixmap1.mask, pixmap2, pixmap2.mask, false, true)

            !!style.make
            !!color.make_with_values(0,45000,55000)
            style.set_base(Gtk_state_normal,color)

             ctree.node_set_row_data_full (parent, style,current,$destroy_style);

            if ctree.line_style.is_equal (Gtk_ctree_lines_tabbed) then
               ctree.node_set_row_style(parent, style)
            end -- if

            build_recursive (ctree, 1, d, b, p, parent)
            ctree.thaw
            !!cb_data.make(ctree, current, $after_press)
            after_press (Void, cb_data)
         end -- if
      end -- rebuild_tree

   ctree_click_column (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         args : GTK_CLIST_CLICK_COLUMN_CALLBACK_ARGS;
         ctree : GTK_CTREE
      do
         !!args.make(cb_data);
         ctree ?= args.get_user_data;

         if args.column = ctree.sort_column then
            if ctree.sort_type.is_equal (Gtk_sort_ascending) then
               ctree.set_sort_type(Gtk_sort_descending)
            else
               ctree.set_sort_type(Gtk_sort_ascending)
            end -- if
         else
            ctree.set_sort_column (args.column)
         end -- if

         ctree.sort_recursive(Void)
      end -- ctree_click_column

   destroy_export_window(data : ANY) is
      local
         wnd : GTK_WINDOW
      do
         wnd ?= data
         wnd.destroy
      end -- destroy_window

end -- class CREATE_CTREE
