indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_text.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_TEXT
inherit
   SIMPLE_TEST
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature {ANY} -- Creation

   make is
      local
         i, j : INTEGER
         box1 : GTK_VBOX
         box2 : GTK_VBOX
         hbox : GTK_BOX
         button : GTK_BUTTON
         check_button : GTK_CHECK_BUTTON
         separator : GTK_HSEPARATOR
         scrolled_window : GTK_SCROLLED_WINDOW
         font : GDK_FONT
         infile : FILE
      do
         !!window.make(Gtk_window_toplevel)
         window.set_name("text window")
         window.set_usize(500, 500)
         window.set_policy(true, true, false)

         signal_connect(window,"destroy",$destroy_window)

         window.set_title("test")
         window.set_border_width(0)


         !!box1.make(false, 0)
         window.add(box1)
         box1.show

         !!box2.make(false, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, true, true, 0)
         box2.show


         !!scrolled_window.make(Void, Void)
         box2.pack_start(scrolled_window, true, true, 0)
         scrolled_window.set_policy(Gtk_policy_never,Gtk_policy_always)
         scrolled_window.show

         !!text.make(Void, Void)
         text.set_editable(true)
         scrolled_window.add(text)
         text.grab_focus
         text.show


         text.freeze

         !!font.load("-adobe-courier-medium-r-normal--*-120-*-*-*-*-*-*")

         from
            i := 0
         until
            i >=ntext_colors
         loop
               text.insert(font, Void, Void, text_colors.item(i).name)
               text.insert(font, Void, Void, "%T")

            from
               j := 0
            until
               j >= ntext_colors
            loop
               text.insert(font,
                  text_colors.item(j).color,text_colors.item(i).color,"XYZ")
               j := j+1
            end -- loop

               text.insert(Void, Void, Void, "%N")
            i := i+1
         end -- loop

--          /* The Text widget will reference count the font, so we
--          * unreference it here
--          */
         font.unref

         !!infile.make_open_read("create_tooltips.e");

         if infile.is_open_read then
            from
               infile.read_line
            until
               infile.end_of_file
            loop
               text.insert(Void, Void, Void, infile.last_string);
               text.insert(Void, Void, Void, "%N");
               infile.read_line
            end -- loop

            infile.close
         end -- if

         text.thaw

         !GTK_HBUTTON_BOX!hbox.make
         box2.pack_start(hbox, false, false, 0)
         hbox.show

         !!check_button.make_with_label("Editable")
         hbox.pack_start(check_button, false, false, 0)
         signal_connect(check_button,"toggled",$text_toggle_editable)
         check_button.set_active(true)
         check_button.show

         !!check_button.make_with_label("Wrap Words")
         hbox.pack_start(check_button, false, true, 0)
         signal_connect(check_button,"toggled",$text_toggle_word_wrap)
         check_button.set_active(false)
         check_button.show

         !!separator.make
         box1.pack_start(separator, false, true, 0)
         separator.show


         !!box2.make(false, 10)
         box2.set_border_width(10)
         box1.pack_start(box2, false, true, 0)
         box2.show


         !!button.make_with_label("insert random")
         signal_connect(button,"clicked",$text_insert_random)
         box2.pack_start(button, true, true, 0)
         button.show

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         box2.pack_start(button, true, true, 0)
         button.set_flags(Gtk_can_default)
         button.grab_default
         button.show

         window.show
      end -- make

feature {NONE} -- Implementations

   text : GTK_TEXT

   ntext_colors : INTEGER is 8;

   text_colors : ARRAY[TEXT_COLOR] is
      local
         item : TEXT_COLOR
      do
         !!Result.make(0,ntext_colors-1)
         !!item.make(0,0,0,0,"black")
         Result.put(item,0)
         !!item.make(0, 65535, 65535, 65535, "white")
         Result.put(item,1)
         !!item.make(0, 65535, 0, 0, "red")
         Result.put(item,2)
         !!item.make(0, 0, 65535, 0, "green")
         Result.put(item,3)
         !!item.make(0, 0, 0, 65535, "blue")
         Result.put(item,4)
         !!item.make(0, 0, 65535, 65535, "cyan")
         Result.put(item,5)
         !!item.make(0, 65535, 0, 65535, "magenta")
         Result.put(item,6)
         !!item.make(0, 65535, 65535, 0, "yellow")
         Result.put(item,7)
      end -- text_colors

--   text_insert_random is
--      local
--         i : INTEGER
--         c : CHARACTER
--         math : MATH
--         a_int, z_int : INTEGER
--      do
--         !!math
--         from
--            i := 0
--         until
--            i >= 10
--         loop
--            c := 'A'
--            a_int := c.to_integer
--            c := 'Z'
--            z_int := c.to_integer
--            c.from_integer((a_int + math.rand/32767 * (z_int - a_int)).rounded)
--            text.set_point((math.rand/32767 * text.get_length).rounded)
--            text.insert(void, void, void, c.out)
--            i := i+1
--         end -- loop
--      end -- text_insert_random
   text_insert_random is
      local
            i : INTEGER
            c : CHARACTER
         math : MATH
         a_int, z_int : INTEGER
      do
         !!math
         from
            i := 0
         until
            i >= 10
         loop
            c := 'A'
            a_int := c.code
            c := 'Z'
            z_int := c.code
            c.from_integer(a_int +
               (math.rand/32767 * (z_int - a_int)).rounded)
            text.set_point((math.rand/32767 * text.get_length).rounded)
            text.insert(Void, Void, Void, c.out)
            i := i+1
         end -- loop
      end -- text_insert_random

   text_toggle_editable(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         button : GTK_TOGGLE_BUTTON
      do
         button ?= cb_data.get_widget
            text.set_editable(button.get_active)
      end -- text_toggle_editable

   text_toggle_word_wrap(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         button : GTK_TOGGLE_BUTTON
      do
         button ?= cb_data.get_widget
         text.set_word_wrap(button.get_active)
      end -- text_toggle_word_wrap

end -- class CREATE_TEXT
