indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_timeout.e,v 1.6 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_TIMEOUT
inherit
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS
   SIMPLE_TEST
      redefine
         destroy_window
      end

creation
   make

feature

   make is
      local
         button : GTK_BUTTON
         dialog : GTK_DIALOG
      do
         count := 0

         !!dialog.make

         window := dialog

         signal_connect(dialog,"destroy",$destroy_window)

         dialog.set_title("Timeout Test")
         dialog.set_border_width(0)

         !!label.make("count: 0")
         label.set_padding(10, 10)
         dialog.vbox.pack_start(label, true, true, 0)
         label.show

         !!button.make_with_label("close")
         signal_connect(button,"clicked", $close_window)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)
         button.grab_default
         button.show

         !!button.make_with_label("start")
         signal_connect(button,"clicked",$start_timeout_test)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)
         button.show

         !!button.make_with_label("stop")
         signal_connect(button, "clicked",$stop_timeout_test)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)
         button.show

         !!timeout.make(100,current,$timeout_function,void)

         dialog.show
      end -- make

feature {NONE} -- Implementations

   count : INTEGER
   label : GTK_LABEL
   timeout : GTK_TIMEOUT

   timeout_function : INTEGER is
      local
         buf : STRING
      do
         buf := "count: "
         buf.append_string(count.out)
         count := count +1
         label.set_text(buf)
         Result := 1
      end -- timeout_function

   start_timeout_test is
      do
         if not timeout.is_on then
            timeout.start
         end -- if
      end -- start_timeout_test

   stop_timeout_test is
      do
         if timeout.is_on then
            timeout.stop
         end -- if
      end -- stop_timeout_test

   destroy_window is
      do
         stop_timeout_test
         Precursor
      end -- destroy_window

end -- class CREATE_TIMEOUT
