indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: create_tree.e,v 1.7 2000/11/07 11:11:31 eugenem Exp $";

class CREATE_TREE
inherit
   SIMPLE_TEST
      redefine
         destroy_window
      end
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         box1 : GTK_VBOX
         box2 : GTK_VBOX
         box3 : GTK_HBOX
         box4 : GTK_VBOX
         box5 : GTK_HBOX
         button : GTK_BUTTON
         radio_button : GTK_RADIO_BUTTON
         check_button : GTK_CHECK_BUTTON
         frame : GTK_FRAME
         separator : GTK_HSEPARATOR
         label : GTK_LABEL
         spinner : GTK_SPIN_BUTTON
         adj : GTK_ADJUSTMENT
      do
         !!tree_buttons_array.make(false)

         -- create toplevel window
         !!window.make(Gtk_window_toplevel)
         window.set_title("Set Tree Parameters")
         signal_connect(window,"destroy",$destroy_window)
         !!box1.make(false, 0)
         window.add(box1)

         -- create upper box - selection box
         !!box2.make(false, 5)
         box1.pack_start(box2, true, true, 0)
         box2.set_border_width(5)

         !!box3.make(false, 5)
         box2.pack_start(box3, true, true, 0)

         -- create selection mode frame
         !!frame.make("Selection Mode")
         box3.pack_start(frame, true, true, 0)

         !!box4.make(false, 0)
         frame.add(box4)
         box4.set_border_width(5)

         -- create radio button
         !!radio_button.make_with_label(Void, "SINGLE")
         box4.pack_start(radio_button, true, true, 0)
         single_button := radio_button

         !!radio_button.make_with_label(radio_button.group,"BROWSE")
         box4.pack_start(radio_button, true, true, 0)
         browse_button := radio_button

         !!radio_button.make_with_label(radio_button.group,"MULTIPLE")
         box4.pack_start(radio_button, true, true, 0)
         multiple_button := radio_button

         selection_mode_group := radio_button.group

         -- create option mode frame
         !!frame.make("Options")
         box3.pack_start(frame, true, true, 0)

         !!box4.make(false, 0)
         frame.add(box4)
         box4.set_border_width(5)

         -- create check button
         !!check_button.make_with_label("Draw line")
         box4.pack_start(check_button, true, true, 0)
         check_button.set_active(true)
         draw_line_button := check_button

         !!check_button.make_with_label("View Line mode")
         box4.pack_start(check_button, true, true, 0)
         check_button.set_active(true)
         view_line_button := check_button

         !!check_button.make_with_label("Without Root item")
         box4.pack_start(check_button, true, true, 0)
         no_root_item_button := check_button

         -- create recursion parameter
         !!frame.make("Size Parameters")
         box2.pack_start(frame, true, true, 0)

         !!box4.make(false, 5)
         frame.add(box4)
         box4.set_border_width(5)

         -- create number of item spin button
         !!box5.make(false, 5)
         box4.pack_start(box5, false, false, 0)

         !!label.make("Number of items : ")
         label.set_alignment(0, 0.5)
         box5.pack_start(label, false, true, 0)

         !!adj.make(default_number_of_item, 1.0, 255.0, 1.0,5.0, 0.0)
         !!spinner.make(adj, 0, 0)
         box5.pack_start(spinner, false, true, 0)
         nb_item_spinner := spinner

         -- create recursion level spin button
         !!box5.make(false, 5)
         box4.pack_start(box5, false, false, 0)

         !!label.make("Depth : ")
         label.set_alignment(0, 0.5)
         box5.pack_start(label, false, true, 0)

         !!adj.make(default_recursion_level, 0.0, 255.0, 1.0,5.0, 0.0)
         !!spinner.make(adj, 0, 0)
         box5.pack_start(spinner, false, true, 0)
         recursion_spinner := spinner

         -- create horizontal separator
         !!separator.make
         box1.pack_start(separator, false, false, 0)

         -- create bottom button box
         !!box2.make(true, 10)
         box1.pack_start(box2, false, false, 0)
         box2.set_border_width(5)

         !!button.make_with_label("Create Tree")
         box2.pack_start(button, true, true, 0)
         signal_connect(button,"clicked",$cb_create_tree)

         !!button.make_with_label("Close")
         box2.pack_start(button, true, true, 0)
         signal_connect(button,"clicked", $close_window)

         window.show_all
      end -- make

feature {NONE} -- Implementations

   default_number_of_item : REAL is 3.0
   default_recursion_level : REAL is 3.0

   selection_mode_group : G_SLIST
   single_button : GTK_RADIO_BUTTON
   browse_button : GTK_RADIO_BUTTON
   multiple_button : GTK_RADIO_BUTTON
   draw_line_button : GTK_CHECK_BUTTON
   view_line_button : GTK_CHECK_BUTTON
   no_root_item_button : GTK_CHECK_BUTTON
   nb_item_spinner : GTK_SPIN_BUTTON
   recursion_spinner : GTK_SPIN_BUTTON

   tree_buttons_array : LIST_[TREE_BUTTONS]

   create_subtree(item : GTK_TREE_ITEM; arg_level : INTEGER; nb_item_max : INTEGER;
      recursion_level_max : INTEGER) is
      local
         item_subtree : GTK_TREE
         item_new : GTK_TREE_ITEM
         nb_item : INTEGER
         buffer : STRING
         no_root_item : INTEGER
         level : INTEGER
      do
         level := arg_level
         !!buffer.make(255)

         if level /= recursion_level_max then

            if level = -1 then
               -- query with no root item
               level := 0
               !!item_subtree.from_external( item.to_external )
               no_root_item := 1
            else
               -- query with no root item
               -- create subtree and associate it with current item
               !!item_subtree.make
               no_root_item := 0
            end -- if

            from
               nb_item := 0
            until
               nb_item >= nb_item_max
            loop
               buffer.copy("item ")
               buffer.append_string(level.out)
               buffer.append_string("-")
               buffer.append_string(nb_item.out)
               !!item_new.make_with_label(buffer)
               item_subtree.append(item_new)
               create_subtree(item_new, level+1, nb_item_max, recursion_level_max)
               item_new.show
               nb_item := nb_item+1
            end -- loop

            if no_root_item = 0 then
               item.set_subtree(item_subtree)
            end -- if
         end -- if
      end -- create_subtree

   create_tree_sample(selection_mode : GTK_SELECTION_MODE; draw_line : BOOLEAN;
      view_line : BOOLEAN; no_root_item : BOOLEAN; nb_item_max : INTEGER;
      recursion_level_max : INTEGER) is
      local
         wnd : GTK_WINDOW
         box1 : GTK_VBOX
         box2 : GTK_VBOX
         separator : GTK_HSEPARATOR
         button : GTK_BUTTON
         scrolled_win : GTK_SCROLLED_WINDOW
         root_tree : GTK_TREE
         root_item : GTK_TREE_ITEM
         tree_buttons : TREE_BUTTONS
      do

         -- create top level window
         !!wnd.make(Gtk_window_toplevel)
         wnd.set_title("Tree Sample")
         signal_connect_with_data(wnd,"destroy",$cb_tree_destroy_event,wnd)

         -- create tree buttons struct
         !!tree_buttons.make(wnd)
         tree_buttons_array.put(tree_buttons)
         tree_buttons.set_nb_item_add( 0 )

         wnd.set_user_data(tree_buttons)

         !!box1.make(false, 0)
         wnd.add(box1)
         box1.show

         -- create tree box
         !!box2.make(false, 0)
         box1.pack_start(box2, true, true, 0)
         box2.set_border_width(5)
         box2.show

         -- create scrolled window
         !!scrolled_win.make(Void, Void)
         scrolled_win.set_policy(Gtk_policy_automatic, Gtk_policy_automatic)
         box2.pack_start(scrolled_win, true, true, 0)
         scrolled_win.set_usize(200, 200)
         scrolled_win.show

         -- create root tree widget
         !!root_tree.make
         signal_connect(root_tree,"selection_changed",$cb_tree_changed)
         root_tree.set_user_data(tree_buttons)
         scrolled_win.add_with_viewport(root_tree)
         root_tree.set_selection_mode(selection_mode)
         root_tree.set_view_lines(draw_line)
         if view_line then
            root_tree.set_view_mode(Gtk_tree_view_item)
         else
            root_tree.set_view_mode(Gtk_tree_view_line)
         end -- if
         root_tree.show

         if no_root_item then
            -- set root tree to subtree function with root item variable
            !!root_item.from_external(root_tree.to_external)
         else
            -- create root tree item widget
            !!root_item.make_with_label("root item")
            root_tree.append(root_item)
            root_item.show
         end -- if
         if no_root_item then
            create_subtree(root_item, -1, nb_item_max, recursion_level_max)
         else
            create_subtree(root_item, 0, nb_item_max, recursion_level_max)
         end -- if

         !!box2.make(false, 0)
         box1.pack_start(box2, false, false, 0)
         box2.set_border_width(5)
         box2.show

         !!button.make_with_label("Add Item")
         button.set_sensitive(false)
         signal_connect_with_data(button,"clicked",$cb_add_new_item,root_tree)
         box2.pack_start(button, true, true, 0)
         button.show
         tree_buttons.set_add_button( button )

         !!button.make_with_label("Remove Item(s)")
         button.set_sensitive(false)
         signal_connect_with_data(button,"clicked",$cb_remove_item,root_tree)
         box2.pack_start(button, true, true, 0)
         button.show
         tree_buttons.set_remove_button( button )

         !!button.make_with_label("Remove Subtree")
         button.set_sensitive(false)
         signal_connect_with_data(button,"clicked",$cb_remove_subtree,root_tree)
         box2.pack_start(button, true, true, 0)
         button.show
         tree_buttons.set_subtree_button( button )

         -- create separator
         !!separator.make
         box1.pack_start(separator, false, false, 0)
         separator.show

         -- create button box
         !!box2.make(false, 0)
         box1.pack_start(box2, false, false, 0)
         box2.set_border_width(5)
         box2.show

         !!button.make_with_label("Close")
         box2.pack_start(button, true, true, 0)
         signal_connect_with_data(button,"clicked",$cb_tree_close_window,wnd)
         button.show

         wnd.show
      end -- create_tree_sample

   cb_create_tree is
      local
         selection_mode : GTK_SELECTION_MODE
         view_line : BOOLEAN
         draw_line : BOOLEAN
         no_root_item : BOOLEAN
         nb_item : INTEGER
         recursion_level : INTEGER
      do
         -- get selection mode choice
         if single_button.get_active then
            selection_mode := Gtk_selection_single
         else
            if browse_button.get_active then
               selection_mode := Gtk_selection_browse
            else
               selection_mode := Gtk_selection_multiple
            end -- if
         end -- if

         -- get options choice
         draw_line := draw_line_button.get_active
         view_line := view_line_button.get_active
         no_root_item := no_root_item_button.get_active

         -- get levels
         nb_item := nb_item_spinner.get_value_as_int
         recursion_level := recursion_spinner.get_value_as_int

         if nb_item^recursion_level > 10000 then
            print(nb_item^recursion_level);
            print(" total items? That will take a very long time. Try less%N");
         else
           create_tree_sample(selection_mode, draw_line, view_line, no_root_item, nb_item, recursion_level)
         end
      end -- cb_create_tree

   cb_tree_close_window(data : ANY) is
      local
         widget : GTK_WIDGET
      do
         widget ?= data
         widget.destroy
      end

   cb_tree_destroy_event(data : ANY) is
      local
         widget : GTK_WIDGET
         tree_buttons : TREE_BUTTONS
      do
         widget ?= data
         tree_buttons ?= widget.get_user_data

         -- free buttons structure associate at this tree
         if tree_buttons_array.has_item(tree_buttons) then
            tree_buttons_array.remove(tree_buttons)
         end -- if
      end -- cb_tree_destroy_event

   cb_add_new_item(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         subtree, tree : GTK_TREE
         widget : GTK_WIDGET
         buffer : STRING
         selection : G_LIST[GTK_TREE_ITEM]
         item_new, selected_item : GTK_TREE_ITEM
         tree_buttons : TREE_BUTTONS
      do
         tree ?= data
         widget ?= cb_data.get_widget
         !!buffer.make(255)

         tree_buttons ?= tree.get_user_data

         selection := tree.selection_list
         if selection.empty then
            subtree := tree
         else
            selected_item := selection.item
            subtree := selected_item.subtree
            if subtree = Void then
               !!subtree.make
               selected_item.set_subtree( subtree )
            end
         end -- if

         -- at this point, we know which subtree will be used to add new item
         -- create a new item

         buffer.copy("item add ")
         buffer.append_string(tree_buttons.nb_item_add.out)
         !!item_new.make_with_label(buffer)
         subtree.append(item_new)
         item_new.show

         tree_buttons.set_nb_item_add( tree_buttons.nb_item_add+1 )
      end -- cb_add_new_item

   cb_remove_item(data : ANY) is
      local
         tree : GTK_TREE
      do
         tree ?= data
         tree.remove_items_list (tree.selection_list)
      end -- cb_remove_item

   cb_remove_subtree(data : ANY) is
      local
         tree : GTK_TREE
         selection : G_LIST[GTK_TREE_ITEM]
         item : GTK_TREE_ITEM
      do
         tree ?= data
         selection := tree.selection_list
         if not (selection.empty) then
            item := selection.item
            if item.subtree /= Void then
               item.remove_subtree
            end -- if
         end -- if
      end -- cb_remove_subtree

   cb_tree_changed(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         tree : GTK_TREE
         tree_buttons : TREE_BUTTONS
         selection : G_LIST[GTK_TREE_ITEM]
      do
         tree ?= cb_data.get_widget
         tree_buttons ?= tree.get_user_data

         selection := tree.selection_list
         if selection.empty then
            if tree.children_list.empty then
               tree_buttons.add_button.set_sensitive(true)
            else
               tree_buttons.add_button.set_sensitive(false)
            end -- if
            tree_buttons.remove_button.set_sensitive(false)
            tree_buttons.subtree_button.set_sensitive(false)
         else
            tree_buttons.remove_button.set_sensitive(true)
            tree_buttons.add_button.set_sensitive((selection.length = 1))
            tree_buttons.subtree_button.set_sensitive(
               selection.length = 1
               and then (selection.item.subtree /= Void))
         end -- if
      end -- cb_tree_changed

      destroy_window is
         local
            wnd : GTK_WINDOW
            tb : TREE_BUTTONS
            cursor : CURSOR_
         do
            from
            until
               tree_buttons_array.count = 0
            loop
               cursor := tree_buttons_array.cursor
               tb := tree_buttons_array.item_at(cursor)
               wnd := tb.window
               tb.set_window(Void)
               cursor.stop
               tree_buttons_array.remove(tb)
               wnd.destroy
            end

            Precursor
         end -- destroy_window

end -- class CREATE_TREE
