deferred class SIMPLE_TEST
inherit
   VEGTK_CALLBACK_HANDLER

feature -- Creation

   make is
      -- Creation and initialization
      deferred
      end -- make

feature -- data

   window : GTK_WINDOW

feature -- Callbacks

   close_window is
      do
         if window /= Void then
            window.destroy
         end
      end

   destroy_window is
      do
         window := Void
      end -- destroy_window

feature -- Operations

   build_option_menu(arg_items : ARRAY[OPTION_MENU_ITEM];
                   num_items : INTEGER;
                   history : INTEGER;
                   data : ANY) : GTK_OPTION_MENU is
      local
         omenu : GTK_OPTION_MENU
         menu : GTK_MENU
         menu_item : GTK_RADIO_MENU_ITEM
         group : G_SLIST
         i : INTEGER
      do
         !!omenu.make

         !!menu.make
         group := Void -- is this needed in eiffel?

         from
            i := 0
         until
            i = num_items
         loop
            if group=Void then
               !!menu_item.make_alone_with_label(arg_items.item(i).name)
            else
               !!menu_item.make_with_label(group,arg_items.item(i).name)
            end -- if
            signal_connect_with_data(menu_item,"activate",
                          arg_items.item(i).func, data)
            group := menu_item.group
            menu.append(menu_item)
            if i = history then
               menu_item.set_active(true)
            end -- if
            menu_item.show
            i := i+1
         end -- loop

         omenu.set_menu(menu)
         omenu.set_history(history)

         Result := omenu
      end -- build_option_menu

   radio_menu_toggled(group : G_SLIST) : INTEGER is
      local
         item : GTK_RADIO_MENU_ITEM
         i : INTEGER
      do
         from
            i := 0
            !!item.from_external(group.nth_data(i))
         until
            item.active or item.to_external = default_pointer
         loop
            !!item.from_external(group.nth_data(i))
            i := i+1
         end -- loop
         if i>0 then
            i:=i-1
         end -- if
         Result := i
      end

feature {ANY} -- XPMs

   folder_pixmap(wnd : GTK_WINDOW) : GDK_PIXMAP is
      do
         !!Result.make_from_xpm_d(wnd.window,
                                  transparent_color,
                                  folder_xpm)
      end -- folder_pixmap

   book_open_pixmap(wnd : GTK_WINDOW) : GDK_PIXMAP is
      do
         !!Result.make_from_xpm_d(wnd.window,
                                  transparent_color,
                                  book_open_xpm)
      end -- book_open_pixmap

   book_closed_pixmap(wnd : GTK_WINDOW) : GDK_PIXMAP is
      do
         !!Result.make_from_xpm_d(wnd.window,
                                  transparent_color,
                                  book_closed_xpm)
      end -- book_closed_pixmap

   mini_page_pixmap(wnd : GTK_WINDOW) : GDK_PIXMAP is
      do
         !!Result.make_from_xpm_d(wnd.window,
                                  transparent_color,
                                  mini_page_xpm)
      end -- mini_page_pixmap

   gtk_mini_pixmap(wnd : GTK_WINDOW) : GDK_PIXMAP is
      do
         !!Result.make_from_xpm_d(wnd.window,
                                  transparent_color,
                                  gtk_mini_xpm)
      end -- gtk_mini_pixmap

   transparent_color : GDK_COLOR is
      once
         Result := Void
      end -- transparent_color

feature {NONE} -- xpm

   folder_xpm : ARRAY[STRING] is
      once
         Result := <<"20 19 5 1",
                  ". c None",
                  "# c #000000",
                  "a c #ffffff",
                  "b c #7f7f00",
                  "c c #ffff00",

                  "....................",
                  "....................",
                  "....................",
                  "...........###......",
                  "..........#...#.#...",
                  "...............##...",
                  "...###........###...",
                  "..#cac#######.......",
                  "..#acacacaca#.......",
                  "..#cacacacac#.......",
                  "..#acac###########..",
                  "..#cac#bbbbbbbbb#...",
                  "..#ac#bbbbbbbbb#....",
                  "..#c#bbbbbbbbb#.....",
                  "..##bbbbbbbbb#......",
                  "..###########.......",
                  "....................",
                  "....................",
                  "...................." >>
      end -- folder_xpm

   book_open_xpm : ARRAY[STRING] is
      once
         Result := <<
            "16 16 4 1",
            "       c None s None",
            ".      c black",
            "X      c #808080",
            "o      c white",
            "                ",
            "  ..            ",
            " .Xo.    ...    ",
            " .Xoo. ..oo.    ",
            " .Xooo.Xooo...  ",
            " .Xooo.oooo.X.  ",
            " .Xooo.Xooo.X.  ",
            " .Xooo.oooo.X.  ",
            " .Xooo.Xooo.X.  ",
            " .Xooo.oooo.X.  ",
            "  .Xoo.Xoo..X.  ",
            "   .Xo.o..ooX.  ",
            "    .X..XXXXX.  ",
            "    ..X.......  ",
            "     ..         ",
            "                " >>
      end -- book_open_xpm

   book_closed_xpm : ARRAY[STRING] is
      once
         Result := <<
            "16 16 6 1",
            "       c None s None",
            ".      c black",
            "X      c red",
            "o      c yellow",
            "O      c #808080",
            "#      c white",
            "                ",
            "       ..       ",
            "     ..XX.      ",
            "   ..XXXXX.     ",
            " ..XXXXXXXX.    ",
            ".ooXXXXXXXXX.   ",
            "..ooXXXXXXXXX.  ",
            ".X.ooXXXXXXXXX. ",
            ".XX.ooXXXXXX..  ",
            " .XX.ooXXX..#O  ",
            "  .XX.oo..##OO. ",
            "   .XX..##OO..  ",
            "    .X.#OO..    ",
            "     ..O..      ",
            "      ..        ",
            "                ">>
   end -- book_closed_xpm

   mini_page_xpm : ARRAY[STRING] is
      once
         Result := <<
            "16 16 4 1",
            "       c None s None",
            ".      c black",
            "X      c white",
            "o      c #808080",
            "                ",
            "   .......      ",
            "   .XXXXX..     ",
            "   .XoooX.X.    ",
            "   .XXXXX....   ",
            "   .XooooXoo.o  ",
            "   .XXXXXXXX.o  ",
            "   .XooooooX.o  ",
            "   .XXXXXXXX.o  ",
            "   .XooooooX.o  ",
            "   .XXXXXXXX.o  ",
            "   .XooooooX.o  ",
            "   .XXXXXXXX.o  ",
            "   ..........o  ",
            "    oooooooooo  ",
            "                ">>
      end -- mini_page_xpm

   gtk_mini_xpm : ARRAY[STRING] is
      once
         Result := <<"15 20 17 1",
            "       c None",
            ".      c #14121F",
            "+      c #278828",
            "@      c #9B3334",
            "#      c #284C72",
            "$      c #24692A",
            "%%      c #69282E",

        "&      c #37C539",
            "*      c #1D2F4D",
            "=      c #6D7076",
            "-      c #7D8482",
            ";      c #E24A49",
            ">      c #515357",
            ",      c #9B9C9B",
            "'      c #2FA232",
            ")      c #3CE23D",
            "!      c #3B6CCB",
            "               ",
            "      ***>     ",
            "    >.*!!!*    ",
            "   ***....#*=  ",
            "  *!*.!!!**!!# ",
            " .!!#*!#*!!!!# ",
            " @%%#!.##.*!!$& ",
            " @;%%*!*.#!#')) ",
            " @;;@%%!!*$&)'' ",
            " @%%.%%@%%$'&)$+' ",
            " @;...@$'*'*)+ ",
            " @;%%..@$+*.')$ ",
            " @;%%%%;;$+..$)# ",
            " @;%%%%;@$$$'.$# ",
            " %%;@@;;$$+))&* ",
            "  %%;;;@+$&)&*  ",
            "   %%;;@'))+>   ",
            "    %%;@'&#     ",
            "     >%%$$      ",
            "      >=       ">>
      end -- gtk_mini_xpm

end -- class SIMPLE_TEST

