indexing
    title       : "GTK ";
    cluster     : "Testgtk";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: testgtk.e,v 1.2 2000/03/13 18:20:01 eugenem Exp $";

class TESTGTK
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
   GTK_RC

creation
   make

feature -- Creation

    make is
      -- Creation and initialization
      local
         i : INTEGER
         buttons : ARRAY[GTK_BUTTON]
         button : GTK_BUTTON
         names : ARRAY[STRING]
         scrolled_window : GTK_SCROLLED_WINDOW
         box1,box2 : GTK_VBOX
         box3 : GTK_VBOX
         separator : GTK_HSEPARATOR
         tmp : STRING
      do
         tmp := gtk_set_locale

         add_default_file("testgtkrc")

         vegtk_init;

         !!buttons.make(1,0)
         names := << "buttons",
                     "toggle_buttons",
                     "check_buttons",
                     "radio buttons",
                     "button box",
                     "reparent",
                     "pixmap",
                     "tooltips",
                     "menus",
                     "scrolled windows",
                     "drawing areas",
                     "entry",
                     "list",
                     "color selection",
                     "file selection",
                     "dialog",
                     "cursors",
                     "clist",
                     "ctree",
                     "toolbar",
                     "text",
                     "Notebook",
                     "gamma curve",
                     "paned",
                     "progress bar",
                     "handle_box",
                     "rulers",
                     "status_bar",
                     "font selection",
                     "range controls",
--                     "preview color",
--                     "dnd",
                     "tree",
                     "labels",
--                     "WM Hints",
--                     "miscellaneous",
--                     "preview gray",
--                     "test selection",
                     "test timeout",
                     "test idle">>  --,
--                     "test" >>

         !!window.make(Gtk_window_toplevel)
         window.set_name("main window")
         window.set_title("Gtk-Eiffel")
         window.set_usize(200,400)
         window.set_uposition(20, 20)
         signal_connect(window,"destroy",$quit_testgtk)

         !!box1.make(False, 0)
         window.add(box1)

         !!scrolled_window.make(Void, Void)
         scrolled_window.set_border_width(10)
         scrolled_window.set_policy(Gtk_policy_automatic, Gtk_policy_automatic)
         box1.pack_start(scrolled_window, true, true, 0)

         !!box2.make(False, 0)
         box2.set_border_width(10)
         scrolled_window.add_with_viewport(box2)

         !!button_id.make(names.lower,names.upper)
         from i := names.lower
         until i > names.upper
         loop
            !!button.make_with_label(names.item(i))
            button_id.put(i,i)
            signal_connect_with_data(button,"clicked",$button_pressed,button_id.item(i))
            box2.pack_start(button, True, True, 0)

            buttons.force(button, i)
            i := i + 1
         end -- loop

         !!separator.make
         box1.pack_start(separator, False, True, 0)

         !!box3.make(False, 10)
         box3.set_border_width(10)
         box1.pack_start(box3, False, True, 0)

         !!button.make_with_label("close")
         signal_connect(button,"clicked",$destroy_window)

         box3.pack_start(button, True, True, 0)
         button.set_flags(Gtk_can_default)
         button.grab_default

         window.show_all

         gtk_main
      end -- make

feature {NONE} -- Implementations

   button_id : ARRAY[INTEGER]
   window : GTK_WINDOW
   tests : LIST_[SIMPLE_TEST]

   close_tests is
      local
         simple_test : SIMPLE_TEST
         cursor : CURSOR_
      do
         if tests /= Void then
            from
            until
               tests.count = 0
            loop
               cursor := tests.cursor
               simple_test := tests.item_at(cursor)
               cursor.stop
               tests.remove(simple_test)
               if simple_test /= Void then
                  simple_test.close_window
               end
            end
         end -- if
      end

   destroy_window is
      do
         window.destroy
      end

   quit_testgtk is
      do
         close_tests
         gtk_main_quit
      end -- close

   button_pressed(data : ANY) is
      local
         button_num : INTEGER_REF
         simple_test : SIMPLE_TEST
      do
         button_num ?= data

         if data /= Void then
            inspect button_num.item
            when 1 then
               !CREATE_BUTTONS!simple_test.make
            when 2 then
               !CREATE_TOGGLE_BUTTONS!simple_test.make
            when 3 then
               !CREATE_CHECK_BUTTONS!simple_test.make
            when 4 then
               !CREATE_RADIO_BUTTONS!simple_test.make
            when 5 then
               !CREATE_BUTTON_BOX!simple_test.make
            when 6 then
               !CREATE_REPARENT!simple_test.make
            when 7 then
               !CREATE_PIXMAP!simple_test.make
            when 8 then
               !CREATE_TOOLTIPS!simple_test.make
            when 9 then
               !CREATE_MENUS!simple_test.make
            when 10 then
               !CREATE_SCROLLED_WINDOWS!simple_test.make
            when 11 then
               !CREATE_SCRIBBLE!simple_test.make
            when 12 then
               !CREATE_ENTRY!simple_test.make
            when 13 then
               !CREATE_LIST!simple_test.make
            when 14 then
               !CREATE_COLOR_SELECTION!simple_test.make
            when 15 then
               !CREATE_FILESELECTION!simple_test.make
            when 16 then
               !CREATE_DIALOG!simple_test.make
            when 17 then
               !CREATE_CURSORS!simple_test.make
            when 18 then
             !CREATE_CLIST!simple_test.make
            when 19 then
               !CREATE_CTREE!simple_test.make
            when 20 then
               !CREATE_TOOLBAR!simple_test.make
            when 21 then
               !CREATE_TEXT!simple_test.make
            when 22 then
               !CREATE_NOTEBOOK!simple_test.make
            when 23 then
               !CREATE_GAMMA_CURVE!simple_test.make
            when 24 then
               !CREATE_PANED!simple_test.make
            when 25 then
               !CREATE_PROGRESS_BAR!simple_test.make
            when 26 then
               !CREATE_HANDLE_BOX!simple_test.make
            when 27 then
               !CREATE_RULERS!simple_test.make
            when 28 then
               !CREATE_STATUSBAR!simple_test.make
            when 29 then
               !CREATE_FONT_SELECTION!simple_test.make
            when 30 then
               !CREATE_RANGE_CONTROLS!simple_test.make
            when 31 then
               !CREATE_TREE!simple_test.make
            when 32 then
               !CREATE_LABELS!simple_test.make
            when 33 then
               !CREATE_TIMEOUT!simple_test.make
            when 34 then
               !CREATE_IDLE!simple_test.make
            else
            end -- inspect
            if simple_test /= Void then
               if tests = Void then
                  !!tests.make(true)
               end -- if
               tests.put(simple_test)
            end -- if

         end -- if

      end -- button_pressed

end -- class TESTGTK
