-- example-start arrows arrows.e
class ARROWS
inherit
   -- All constants we need are defined in the class below.
   -- eg gtk_window_toplevel etc.
   GTK_CONSTANTS
   -- This class contains common features like vegtk_init and so
   VEGTK_MAIN
   -- If we need to handle callbacks we must inherit from the below
   -- class
   VEGTK_CALLBACK_HANDLER
creation
   make
feature -- Callback handlers
   close_application is
   -- This callback quits the program
   do
       gtk_main_quit;
   end
feature -- Creation

   make is
   local
      window : GTK_WINDOW;
      box : GTK_HBOX;
      button : GTK_BUTTON;
   do
      -- Our init, don't forget this!
      vegtk_init
      !!window.make(Gtk_window_toplevel)
      window.set_title("Arrow Buttons")

      -- It's a good idea to do this for all windows.
      signal_connect(window,"destroy",$close_application)
      -- Sets the border width of the window.
      window.set_border_width (10);
      -- Create a box to hold the arrows/buttons
      !!box.make(false, 0)
      box.set_border_width (2);
      window.add(box)

      -- Pack and show all our widgets
      box.show;

      button := create_arrow_button(Gtk_arrow_up, Gtk_shadow_in);
      box.pack_start ( button, False, False, 3);

      button := create_arrow_button(Gtk_arrow_down, Gtk_shadow_out);
      box.pack_start ( button, False, False, 3);

      button := create_arrow_button(Gtk_arrow_left, Gtk_shadow_etched_in);
      box.pack_start ( button, False, False, 3);

      button := create_arrow_button(Gtk_arrow_right, Gtk_shadow_etched_out);
      box.pack_start ( button, False, False, 3);

      window.show;

      -- Rest in gtk_main and wait for the fun to begin!
      gtk_main;
   end -- make

feature -- Support

   create_arrow_button( arrow_type : GTK_ARROW_TYPE;
                        shadow_type :GTK_SHADOW_TYPE ) : GTK_BUTTON is
   -- Create an Arrow widget with the specified parameters
   -- and pack it into a button
   local
     arrow : GTK_ARROW;
   do
      !!Result.make;
      !!arrow.make (arrow_type, shadow_type);
      Result.add (arrow);
      arrow.show;
      Result.show;
   end
end -- class ARROWS
-- example-end
