-- example-start aspectframe aspectframe.e
class ASPECTFRAME
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      window : GTK_WINDOW;
      aspect_frame : GTK_ASPECT_FRAME;
      drawing_area : GTK_DRAWING_AREA;
   do
      -- Initialise GTK
      vegtk_init
      -- Create a new window
      !!window.make (Gtk_window_toplevel);
      window.set_title("Aspect Frame");
      -- Here we connect the "destroy" event to a signal handler
      signal_connect (window, "destroy",$destroy);
      -- Sets the border width of the window.
      window.set_border_width (10);

      -- Create an aspect_frame and add it to our toplevel window

      !!aspect_frame.make ("2x1", -- label
                         0.5, -- center x
                         0.5, -- center y
                         2, -- xsize/ysize = 2
                         False -- ignore child's aspect */
                        );

      window.add (aspect_frame);
      aspect_frame.show;

      -- Now add a child widget to the aspect frame

      !!drawing_area.make;

      -- Ask for a 200x200 window, but the AspectFrame will give us a 200x100
      -- window since we are forcing a 2x1 aspect ratio
      drawing_area.set_usize (200, 200);
      aspect_frame.add (drawing_area);
      drawing_area.show;

      window.show
      gtk_main;
   end -- make
feature {NONE} -- Callbacks
   destroy is
   do
       gtk_main_quit;
   end

end -- class ASPECTFRAME
-- example-end
