-- example-start buttonbox buttonbox.e
class BUTTONBOX
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      window : GTK_WINDOW;
      vbox, main_vbox : GTK_VBOX;
      hbox : GTK_HBOX;
      frame_horz, frame_vert: GTK_FRAME;
   do
      -- Initialise GTK
      vegtk_init
      -- Create a new window
      !!window.make(Gtk_window_toplevel);
      window.set_title("Button Boxes");

      -- Here we connect the "destroy" event to a signal handler
      signal_connect (window, "destroy",$destroy);

      -- Sets the border width of the window.
      window.set_border_width (10);

      !!main_vbox.make (False, 0);
      window.add (main_vbox);

      !!frame_horz.make ("Horizontal Button Boxes");
      main_vbox.pack_start (frame_horz, True, True, 10);

      !!vbox.make (False, 0);
      vbox.set_border_width (10);
      frame_horz.add (vbox);

      vbox.pack_start (create_bbox (True, "Spread (spacing 40)",40, 85, 20,
                                    Gtk_buttonbox_spread),
                       True, True,0);

      vbox.pack_start (create_bbox (True, "Edge (spacing 30)", 30, 85, 20,
                                    Gtk_buttonbox_edge),
                       True, True, 5);

      vbox.pack_start (create_bbox (True, "Start (spacing 20)", 20, 85, 20,
                                    Gtk_buttonbox_start),
                       True, True, 5);

      vbox.pack_start (create_bbox (True, "End (spacing 10)", 10, 85, 20,
                                    Gtk_buttonbox_end),
                       True, True, 5);

      !!frame_vert.make ("Vertical Button Boxes");
      main_vbox.pack_start (frame_vert, True, True, 10);

      !!hbox.make (False, 0);
      hbox.set_border_width (10);
      frame_vert.add (hbox);

      hbox.pack_start (create_bbox (False, "Spread (spacing 5)", 5, 85, 20,
                                    Gtk_buttonbox_spread),
                       True, True, 0);

      hbox.pack_start (create_bbox (False, "Edge (spacing 30)", 30, 85, 20,
                                    Gtk_buttonbox_edge),
                       True, True, 5);

      hbox.pack_start (create_bbox (False, "Start (spacing 20)", 20, 85, 20,
                                    Gtk_buttonbox_start),
                       True, True, 5);

      hbox.pack_start (create_bbox (False, "End (spacing 20)", 20, 85, 20,
                                    Gtk_buttonbox_end),
                       True, True, 5);

      window.show_all;

      -- Enter the event loop
      gtk_main;
   end -- make

feature {NONE} -- Support
   create_bbox (horizontal : BOOLEAN;
                title : STRING;
                spacing, child_w, child_h : INTEGER;
                layout : GTK_BUTTON_BOX_STYLE) : GTK_WIDGET is
      -- Create a Button Box with the specified parameters
   local
     frame : GTK_FRAME;
     bbox : GTK_BUTTON_BOX;
     button : GTK_BUTTON;
   do
      !!frame.make(title);

      if horizontal then
        !GTK_HBUTTON_BOX!bbox.make;
      else
        !GTK_VBUTTON_BOX!bbox.make;
      end
      bbox.set_border_width (5);
      frame.add (bbox);

      -- Set the appearance of the Button Box
      bbox.set_layout (layout);
      bbox.set_spacing (spacing);
      bbox.set_child_size (child_w, child_h);

      !!button.make_with_label ("OK");
      bbox.add (button);

      !!button.make_with_label ("Cancel");
      bbox.add (button);

      !!button.make_with_label ("Help");
      bbox.add (button);
      Result := frame;
   end
feature {NONE} -- Callbacks
   destroy is
   do
       gtk_main_quit;
   end
end -- class BUTTONBOX
-- example-end
