-- example-start buttons buttons.e
class BUTTONS
inherit
   -- All constants we need are defined in the class below.
   -- eg gtk_window_toplevel etc.
   GTK_CONSTANTS
   -- This class contains common features like vegtk_init and so
   VEGTK_MAIN
   -- If we need to handle callbacks we must inherit from the below
   -- class
   VEGTK_CALLBACK_HANDLER
creation
   make
feature -- support
   xpm_label_box( parent : GTK_WIDGET;
                  xpm_filename,label_text : STRING) : GTK_BOX is
   local
      box1 : GTK_HBOX;
      label: GTK_LABEL;
      pixmapwid : GTK_PIXMAP;
      pixmap : GDK_PIXMAP;
      style : GTK_STYLE;
   do
      -- Create box for xpm and label
      !!box1.make (False, 0);
      box1.set_border_width (2);

      -- Get the style of the button to get the
      -- background color. */
      style := parent.get_style;

      -- Now on to the xpm stuff
      !!pixmap.make_from_xpm (parent.window,style.bg(Gtk_state_normal),
                            xpm_filename);
      !!pixmapwid.make(pixmap, pixmap.mask);

      --Create a label for the button
      !!label.make (label_text);

      -- Pack the pixmap and label into the box
      box1.pack_start (pixmapwid, False, False, 3);

      box1.pack_start (label, False, False, 3);

      pixmapwid.show;
      label.show

      Result := box1;
   end
feature -- Callback handlers
   callback (data : ANY) is
   -- Our usual callback.
   do
      print("Hello again - ");
      print(data);
      print(" was pressed%N");
   end

   delete_event is
   -- This callback quits the program
   do
       gtk_main_quit;
   end

feature -- Creation
   make is
   local
      window : GTK_WINDOW;
      button : GTK_BUTTON;
      box1   : GTK_BOX;
   do
      -- This is called in all GTK applications. Arguments are parsed
      -- from the command line and are returned to the application.
      vegtk_init

      -- Create a new window
      !!window.make(Gtk_window_toplevel);

      -- Set the window title
      window.set_title ("Pixmap'd Buttons!");

      -- Set a handler for delete_event that immediately
      -- exits GTK. */
      signal_connect (window, "delete_event",$delete_event);

      -- Sets the border width of the window.
      window.set_border_width ( 10);

      window.realize;

      -- Create a new button
      !!button.make;

      -- Connect the "clicked" signal of the button to our callback */
      signal_connect_with_data (button, "clicked",$callback,"cool button");

      -- This calls our box creating function
      box1 := xpm_label_box(window, "info.xpm", "cool button");

      -- Pack and show all our widgets
      box1.show;

      button.add (box1);

      button.show;

      window.add (button);

      window.show;

      -- Rest in gtk_main and wait for the fun to begin!
      gtk_main;
   end -- make
end -- class BUTTONS
-- example-end
