-- example-start entry entry.e
class ENTRY
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      vbox : GTK_VBOX;
      hbox : GTK_HBOX;
      button : GTK_BUTTON;
      checkb  : GTK_CHECK_BUTTON;
   do
      vegtk_init

      !!window.make(Gtk_window_toplevel)
      window.set_usize( 200, 100);
      window.set_title("GTK Entry");
      signal_connect(window,"destroy",$destroy_window)

      !!vbox.make (False, 0);
      window.add(vbox);
      vbox.show;

      !!entry.make_with_max_length (50);
      signal_connect(entry, "activate",$enter_callback);
      entry.set_text ("hello");
      entry.append_text (" world");
      entry.select_region (0, entry.text_length);
      vbox.pack_start (entry, True, True, 0);
      entry.show;

      !!hbox.make(False, 0);
      vbox.add (hbox);
      hbox.show;

      !!checkb.make_with_label("Editable");
      hbox.pack_start (checkb, True, True, 0);
      signal_connect (checkb, "toggled",$entry_toggle_editable);
      checkb.set_active(True);
      checkb.show;

      !!checkb.make_with_label("Visible");
      hbox.pack_start (checkb, True, True, 0);
      signal_connect (checkb, "toggled",$entry_toggle_visibility);
      checkb.set_active(True);
      checkb.show;

      !!button.make_with_label ("Close");
      signal_connect (button, "clicked",$close_application);
      vbox.pack_start (button, True, True, 0);
      button.set_flags(Gtk_can_default);
      button.grab_default;
      button.show;

      window.show;

      gtk_main
   end -- make
feature {NONE} -- Implementation

   window : GTK_WINDOW;
   entry  : GTK_ENTRY;
   destroy_window is
   do
      gtk_main_quit;
   end -- destroy_window

   enter_callback is
   do
     print ("Entry contents: ");
     print (entry.get_text);
     print("%N");
   end

   entry_toggle_editable (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
   local
      checkbutton : GTK_CHECK_BUTTON;
   do
      checkbutton ?= cb_data.get_widget;
      entry.set_editable(checkbutton.get_active);
   end

   entry_toggle_visibility (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
   local
      checkbutton : GTK_CHECK_BUTTON;
   do
     checkbutton ?= cb_data.get_widget;
     entry.set_visibility(checkbutton.get_active);
   end
   close_application is
   -- This callback quits the program
   do
       window.destroy;
   end

end -- class ENTRY
-- example-end
