-- example-start eventbox eventbox.e
class EVENTBOX
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      event_box : GTK_EVENT_BOX;
      label : GTK_LABEL;
      cursor : GDK_CURSOR;
   do
      -- Initialize the toolkit, remove gtk-related commandline stuff
      vegtk_init
      !!window.make(Gtk_window_toplevel);

      window.set_title ("Event Box");

      signal_connect (window, "destroy",$destroy);

      window.set_border_width (10);

      -- Create an EventBox and add it to our toplevel window

      !!event_box.make;
      window.add (event_box);
      event_box.show;

      -- Create a long label

      !!label.make ("Click here to quit, quit, quit, quit, quit");
      event_box.add (label);
      label.show;

      -- Clip it short.
      label.set_usize (110, 20);

      -- And bind an action to it
      event_box.set_events (Gdk_button_press_mask);
      signal_connect (event_box, "button_press_event",$destroy);

      -- Yet one more thing you need an X window for ...

      event_box.realize;
      !!cursor.make(Gdk_hand1);
      event_box.window.set_cursor(cursor);

      window.show;

      gtk_main;
   end -- make
feature {NONE} -- Implementation
   window : GTK_WINDOW;
feature {NONE} -- Callbacks
   close_application is
   -- This callback quits the program
   do
       window.destroy;
   end
   destroy is
   do
       gtk_main_quit;
   end
end -- class EVENTBOX
-- example-end
