-- example-start fixed fixed.e
class FIXED
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      i : INTEGER;
      button : GTK_BUTTON;
      window : GTK_WINDOW;
      fixed : GTK_FIXED;
   do
      -- Initialise GTK
      vegtk_init
      -- Create a new window
      !!window.make (Gtk_window_toplevel);
      window.set_title("Fixed Container");

      -- Here we connect the "destroy" event to a signal handler
      signal_connect (window, "destroy",$destroy);

      -- Sets the border width of the window.
      window.set_border_width (10);

      -- Create a Fixed Container
      !!fixed.make;
      window.add(fixed);
      fixed.show;

      from
         i := 1;
      until
         i >3
      loop
         -- Creates a new button with the label "Press me"
         !!button.make_with_label ("Press me");

         -- When the button receives the "clicked" signal, it will call the
         -- function move_button() passing it the Fixed Containter as its
         -- argument. */
         signal_connect_with_data (button,"clicked",$move_button,fixed);

         -- This packs the button into the fixed containers window.
         fixed.put (button, i*50, i*50);

         -- The final step is to display this newly created widget.
         button.show;
         i := i+1;
      end -- loop

      -- Display the window
      window.show;

      -- Enter the event loop
      gtk_main;
   end -- make
feature {NONE} -- Implementation
   -- I'm going to be lazy and use some global variables to
   -- store the position of the widget within the fixed
   -- container
   x,y : INTEGER;
feature {NONE} -- Callbacks
   destroy is
   do
       gtk_main_quit;
   end
   move_button (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      -- This callback function moves the button to a new position
      -- in the Fixed container.
   local
      fixed : GTK_FIXED;
      widget : GTK_WIDGET;
   do
     widget ?= cb_data.get_widget;
     fixed ?=  data;
     x := (x+30)\\300;
     y := (y+50)\\300;
     fixed.move (widget, x, y);
   end

end -- class FIXED
-- example-end
