-- example-start labels labels.e
class LABELS
inherit
   -- All constants we need are defined in the class below.
   -- eg gtk_window_toplevel etc.
   GTK_CONSTANTS
   -- This class contains common features like vegtk_init and so
   VEGTK_MAIN
   -- If we need to handle callbacks we must inherit from the below
   -- class
   VEGTK_CALLBACK_HANDLER
creation
   make
feature -- Callback handlers
   close_application is
   -- This callback quits the program
   do
       gtk_main_quit;
   end
feature -- Creation

   make is
   local
      window : GTK_WINDOW;
      hbox : GTK_HBOX
      vbox : GTK_VBOX
      frame : GTK_FRAME
      label : GTK_LABEL
   do
      -- Our init, don't forget this!
      vegtk_init
      !!window.make(Gtk_window_toplevel)
      signal_connect(window,"delete_event",$close_application)

      window.set_title("Label")
      !!vbox.make(false, 5)
      !!hbox.make(false, 5)
      window.add(hbox)
      hbox.pack_start(vbox, false, false, 0)
      window.set_border_width(5)

      !!frame.make("Normal Label")
      !!label.make("This is a Normal label")
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!frame.make("Multi-line Label")
      !!label.make("This is a Multi-line label.%NSecond line%NThird line")
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!frame.make("Left Justified Label")
      !!label.make("This is a Left-Justified%NMulti-line label.%NThird      line")
      label.set_justify(Gtk_justify_left)
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!frame.make("Right Justified Label")
      !!label.make("This is a Right-Justified%NMulti-line label.%NFourth line, (j/k)")
      label.set_justify(Gtk_justify_right)
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!vbox.make(false, 5)
      hbox.pack_start(vbox, false, false, 0)
      !!frame.make("Line wrapped label")
      !!label.make("This is an example of a line-wrapped label. It should not be taking %
            %up the entire %
         %width allocated to it, but automatically wraps the words to fit. %
         %The time has come, for all good men, to come to the aid of their party.%
         %The sixth sheik's six sheep's sick.%N%
         %     It supports multiple paragraphs correctly, and  correctly   adds %
         %many          extra  spaces.")
      label.set_line_wrap(true)
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!frame.make("Filled, wrapped label")
      !!label.make("This is an example of a line-wrapped, filled label.  It should be taking %
         %up the entire              width allocated to it.  Here is a seneance to prove %
         %my point.  Here is another sentence. %
         %Here comes the sun, do de do de do.%N%
         %    This is a new paragraph.%N%
         %    This is another newer, longer, better paragraph.  It is coming to an end, %
         %unfortunately.")
      label.set_justify(Gtk_justify_fill)
      label.set_line_wrap(true)
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      !!frame.make("Underlined label")
      !!label.make("This label is underlined!%N%
         %This one is underlined in quite a funky fashion")
      label.set_justify(Gtk_justify_left)
      label.set_pattern("_________________________ _ _________ _ _____ _ __ __  ___ ____ _____")
      frame.add(label)
      vbox.pack_start(frame, false, false, 0)

      window.show_all
      gtk_main;
   end -- make
end -- class LABELS
-- example-end
