-- example-start notebook notebook.e
class NOTEBOOK
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make
feature {ANY} -- Creation
   make is
   local
      window : GTK_WINDOW;
      button : GTK_BUTTON;
      table : GTK_TABLE;
      frame : GTK_FRAME;
      label : GTK_LABEL;
      checkbutton : GTK_CHECK_BUTTON;
      i : INTEGER;
      bufferf, bufferl : STRING;
   do
      vegtk_init

      !!window.make (Gtk_window_toplevel);

      signal_connect (window, "delete_event",$delete_event);

      window.set_border_width (10);

      !!table.make (3,6,False);
      window.add (table);

      -- Create a new notebook, place the position of the tabs
      !!notebook.make;
      notebook.set_tab_pos (Gtk_pos_top);
      table.attach_defaults (notebook, 0,6,0,1);
      notebook.show;

      -- Lets append a bunch of pages to the notebook
      from
         i := 0;
      until
         i >=5
      loop
         !!bufferf.make_from_string("Append Frame ")
         bufferf.append_string ((i+1).out);
         !!bufferl.make_from_string("Page ");
         bufferl.append_string ((i+1).out);

         !!frame.make(bufferf);
         frame.set_border_width (10);
         frame.set_usize (100, 75);
         frame.show;

         !!label.make (bufferf);
         frame.add (label);
         label.show;

         !!label.make (bufferl);
         notebook.append_page (frame, label);
         i := i+1;
      end -- loop

      -- Now lets add a page to a specific spot
      !!checkbutton.make_with_label ("Check me please!");
      checkbutton.set_usize(100, 75);
      checkbutton.show;

      !!label.make ("Add page");
      notebook.insert_page ( checkbutton, label, 2);

      -- Now finally lets prepend pages to the notebook
      from
         i := 0;
      until
         i >=5
      loop
         !!bufferf.make_from_string("Prepend Frame ")
         bufferf.append_string ((i+1).out);
         !!bufferl.make_from_string("PPage ");
         bufferl.append_string ((i+1).out);

         !!frame.make(bufferf);
         frame.set_border_width (10);
         frame.set_usize (100, 75);
         frame.show;

         !!label.make (bufferf);
         frame.add (label);
         label.show;

         !!label.make (bufferl);
         notebook.prepend_page (frame, label);
         i := i+1;
      end -- loop
      -- Set what page to start at (page 4)
      notebook.set_page (3);

      -- Create a bunch of buttons
      !!button.make_with_label ("close");
      signal_connect (button,"clicked",$delete_event);
      table.attach_defaults (button, 0,1,1,2);
      button.show;

      !!button.make_with_label ("next page");
      signal_connect (button,"clicked",$notebook_next_page);
      table.attach_defaults(button, 1,2,1,2);
      button.show;

      !!button.make_with_label ("prev page");
      signal_connect (button,"clicked",$notebook_prev_page);
      table.attach_defaults (button, 2,3,1,2);
      button.show;

      !!button.make_with_label ("tab position");
      signal_connect (button, "clicked",$rotate_book);
      table.attach_defaults(button, 3,4,1,2);
      button.show;

      !!button.make_with_label ("tabs/border on/off");
      signal_connect (button, "clicked",$tabsborder_book);
      table.attach_defaults(button, 4,5,1,2);
      button.show;

      !!button.make_with_label ("remove page");
      signal_connect (button, "clicked",$remove_book);
      table.attach_defaults(button, 5,6,1,2);
      button.show;

      table.show;
      window.show;

      gtk_main;
   end -- make
feature {NONE} -- Callbacks
   notebook_next_page is
   do
      notebook.next_page;
   end
   notebook_prev_page is
   do
      notebook.prev_page;
   end
   rotate_book is
      -- This procedure rotates the position of the tabs
   local
      positions : ARRAY[GTK_POSITION_TYPE];
      rotated : BOOLEAN;
      i : INTEGER;
   do
      positions := << Gtk_pos_top,
                      Gtk_pos_right,
                      Gtk_pos_bottom,
                      Gtk_pos_left >>
      from
         i := positions.lower
      until
         rotated or i > positions.upper
      loop
         if notebook.tab_pos = positions.item(i).get_value then
            notebook.set_tab_pos(positions.item((i \\ 4) +1))
            rotated := True
         end -- if
         i := i+1
      end -- loop
   end

   tabsborder_book is
      -- Add/Remove the page tabs and the borders
   local
      tval,bval : BOOLEAN;
   do
      if not notebook.show_tabs then
         tval := True;
      end
      if not notebook.show_border then
         bval := True;
      end
      notebook.set_show_tabs (tval);
      notebook.set_show_border (bval);
   end

   remove_book is
      -- Remove a page from the notebook
   do
      notebook.remove_page (notebook.get_current_page);
      -- Need to refresh the widget
      -- This forces the widget to redraw itself.
      notebook.draw(Void);
   end

   delete_event is
   do
      gtk_main_quit;
   end
feature {NONE} -- Implementation
   notebook : GTK_NOTEBOOK;
end -- class NOTEBOOK
-- example-end
