-- example-start progressbar progressbar.e
class PROGRESSBAR
inherit
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
   GTK_CONSTANTS

creation
   make

feature -- Creation

   make is
      local
         button : GTK_BUTTON
         vbox : GTK_VBOX
         vbox2 : GTK_VBOX
         hbox : GTK_HBOX
         check_button : GTK_CHECK_BUTTON
         frame : GTK_FRAME
         tab : GTK_TABLE
         label : GTK_LABEL
         align : GTK_ALIGNMENT
         adj : GTK_ADJUSTMENT
         dialog : GTK_DIALOG
      do
         -- Our init, don't forget this!
         vegtk_init
         !!dialog.make

         window := dialog

         dialog.set_policy(false, false, true)

         signal_connect(dialog,"destroy",$destroy_window)

         dialog.set_title("GtkProgressBar")
         dialog.set_border_width(0)

         !!vbox.make(false, 5)
         vbox.set_border_width(10)
         dialog.vbox.pack_start(vbox, false, true, 0)

         !!frame.make("Progress")
         vbox.pack_start(frame, false, true, 0)

         !!vbox2.make(false, 5)
         frame.add(vbox2)

         !!align.make(0.5, 0.5, 0, 0)
         vbox2.pack_start(align, false, false, 5)

         !!adj.make(0, 1, 300, 0, 0, 0)
         signal_connect(adj,"value_changed",$progress_value_changed)

         !!pbar.make_with_adjustment(adj)
         pbar.set_format_string("%%v from [%%l,%%u] (=%%p%%%%)")
         align.add(pbar)
         !!timer.make(100,current,$timer_function,void)
         timer.start

         !!align.make(0.5, 0.5, 0, 0)
         vbox2.pack_start(align, false, false, 5)

         !!hbox.make(false, 5)
         align.add(hbox)
         !!label.make("Label updated by user :")
         hbox.pack_start(label, false, true, 0)
         !!user_label.make("")
         hbox.pack_start(user_label, false, true, 0)

         !!frame.make("Options")
         vbox.pack_start(frame, false, true, 0)

         !!vbox2.make(false, 5)
         frame.add(vbox2)

         !!tab.make(7, 2, false)
         vbox2.pack_start(tab, false, true, 0)

         !!label.make("Orientation :")
         tab.attach(label, 0, 1, 0, 1,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         label.set_alignment(0, 0.5)

         omenu1 := build_option_menu (items1, 4, 0, Void)
         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 0, 1,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         hbox.pack_start(omenu1, true, true, 0)

         !!check_button.make_with_label("Show text")
         signal_connect(check_button,"clicked",$toggle_show_text)
         tab.attach(check_button, 0, 1, 1, 2,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)

         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 1, 2,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)

         !!label.make("Format : ")
         hbox.pack_start(label, false, true, 0)

         !!entry.make
         signal_connect(entry,"changed",$entry_changed)
         hbox.pack_start(entry, true, true, 0)
         entry.set_text("%%v from [%%l,%%u] (=%%p%%%%)")
         entry.set_usize(100, -1)
         entry.set_sensitive(false)

         !!label.make("Text align :")
         tab.attach(label, 0, 1, 2, 3,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         label.set_alignment(0, 0.5)

         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 2, 3,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)

         !!label.make("x :")
         hbox.pack_start(label, false, true, 5)

         !!adj.make(0.5, 0, 1, 0.1, 0.1, 0)
         !!x_align_spin.make(adj, 0, 1)
         signal_connect(adj,"value_changed",$adjust_align)
         hbox.pack_start(x_align_spin, false, true, 0)
         x_align_spin.set_sensitive(false)

         !!label.make("y :")
         hbox.pack_start(label, false, true, 5)

         !!adj.make(0.5, 0, 1, 0.1, 0.1, 0)
         !!y_align_spin.make(adj, 0, 1)
         signal_connect(adj,"value_changed",$adjust_align)
         hbox.pack_start(y_align_spin, false, true, 0)
         y_align_spin.set_sensitive(false)

         !!label.make("Bar Style :")
         tab.attach(label, 0, 1, 3, 4,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         label.set_alignment(0, 0.5)

         omenu2 := build_option_menu (items2, 2, 0, Void)
         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 3, 4,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         hbox.pack_start(omenu2, true, true, 0)

         !!label.make("Block count :")
         tab.attach(label, 0, 1, 4, 5,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         label.set_alignment(0, 0.5)

         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 4, 5,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         !!adj.make(10, 2, 20, 1, 5, 0)
         !!block_spin.make(adj, 0, 0)
         signal_connect(adj,"value_changed",$adjust_blocks)
         hbox.pack_start(block_spin, false, true, 0)
         block_spin.set_sensitive(false)

         !!check_button.make_with_label("Activity mode")
         signal_connect(check_button,"clicked",$toggle_activity_mode)
         tab.attach(check_button, 0, 1, 5, 6,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)

         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 5, 6,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         !!label.make("Step size : ")
         hbox.pack_start(label, false, true, 0)
         !!adj.make(3, 1, 20, 1, 5, 0)
         !!step_spin.make(adj, 0, 0)
         signal_connect(adj,"value_changed",$adjust_step)
         hbox.pack_start(step_spin, false, true, 0)
         step_spin.set_sensitive(false)

         !!hbox.make(false, 0)
         tab.attach(hbox, 1, 2, 6, 7,
            Gtk_expand and Gtk_fill, Gtk_expand and Gtk_fill,
            5, 5)
         !!label.make("Blocks :     ")
         hbox.pack_start(label, false, true, 0)
         !!adj.make(5, 2, 10, 1, 5, 0)
         !!act_blocks_spin.make(adj, 0, 0)
         signal_connect(adj,"value_changed",$adjust_act_blocks)
         hbox.pack_start(act_blocks_spin, false, true,0)
         act_blocks_spin.set_sensitive(false)

         !!button.make_with_label("close")
         signal_connect(button,"clicked",$destroy_window)
         button.set_flags(Gtk_can_default)
         dialog.action_area.pack_start(button, true, true, 0)
         button.grab_default
         dialog.show_all

         gtk_main
      end -- make

feature {NONE} -- implementations


   pbar : GTK_PROGRESS_BAR
   block_spin : GTK_SPIN_BUTTON
   x_align_spin : GTK_SPIN_BUTTON
   y_align_spin : GTK_SPIN_BUTTON
   step_spin : GTK_SPIN_BUTTON
   act_blocks_spin : GTK_SPIN_BUTTON
   user_label : GTK_LABEL
   omenu1 : GTK_OPTION_MENU
   omenu2 : GTK_OPTION_MENU
   entry : GTK_ENTRY
   timer : GTK_TIMEOUT;
   window : GTK_WINDOW;

   items1 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      do
         !!Result.make(0,3)
         !!item.make("Left-Right", $progressbar_toggle_orientation)
         Result.put(item,0)
         !!item.make("Right-Left", $progressbar_toggle_orientation)
         Result.put(item,1)
         !!item.make("Bottom-Top", $progressbar_toggle_orientation)
         Result.put(item,2)
         !!item.make("Top-Bottom", $progressbar_toggle_orientation)
         Result.put(item,3)
      end -- items1

   items2 : ARRAY[OPTION_MENU_ITEM] is
      local
         item : OPTION_MENU_ITEM
      do
         !!Result.make(0,1)
         !!item.make("Continuous", $progressbar_toggle_bar_style)
         Result.put(item,0)
         !!item.make("Discrete",   $progressbar_toggle_bar_style)
         Result.put(item,1)
      end -- items2

   timer_function : INTEGER is
      local
         new_val : REAL
      do
         new_val := pbar.adjustment.value + 1
         if new_val > pbar.adjustment.upper then
            new_val := pbar.adjustment.lower
         end -- if

         pbar.set_value(new_val)

         Result := 1;
      end -- timer_function

   destroy_window is
      do
         timer.stop
         window.destroy
         gtk_main_quit
      end -- destroy_window

   progressbar_toggle_orientation(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         widget : GTK_WIDGET
         i : INTEGER
         orient : GTK_PROGRESS_BAR_ORIENTATION
      do
         widget ?= cb_data.get_widget

         if widget.mapped then
            i := radio_menu_toggled(omenu1.menu_item.group)
            !!orient.make(3 - i)
            pbar.set_orientation(orient)
         end -- if
      end -- progressbar_toggle_orientation

   toggle_show_text(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         button : GTK_TOGGLE_BUTTON
      do
         button ?= cb_data.get_widget

         pbar.set_show_text(button.get_active)
         entry.set_sensitive(button.get_active)
         x_align_spin.set_sensitive(button.get_active)
         y_align_spin.set_sensitive(button.get_active)
      end -- toggle_show_text

   progressbar_toggle_bar_style(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         widget : GTK_WIDGET
         i : INTEGER
         style : GTK_PROGRESS_BAR_STYLE
      do
         widget ?= cb_data.get_widget

         if widget.mapped then
            i := radio_menu_toggled(omenu2.menu_item.group)

            i := 1 - i

            if i = 1 then
               block_spin.set_sensitive(true)
            else
               block_spin.set_sensitive(false)
            end -- if

            !!style.make(i)
            pbar.set_bar_style(style)
         end -- if
      end -- progressbar_toggle_bar_style

   progress_value_changed is
      local
         buf : STRING
      do
         if pbar.activity_mode then
            buf := "???"
         else
            !!buf.make_from_string((100.0*
               pbar.get_current_percentage).out)
         end -- if
         user_label.set_text(buf)
      end -- progress_value_changed

   adjust_blocks is
      do
         pbar.set_percentage(0)
         pbar.set_discrete_blocks(block_spin.get_value_as_int)
      end -- adjust_blocks

   adjust_step is
      do
         pbar.set_activity_step(step_spin.get_value_as_int)
      end -- adjust_step

   adjust_act_blocks is
      do
         pbar.set_activity_blocks(act_blocks_spin.get_value_as_int)
      end -- adjust_act_blocks

   adjust_align is
      do
         pbar.set_text_alignment(x_align_spin.get_value_as_float,
            y_align_spin.get_value_as_float)
      end -- adjust_align

   toggle_activity_mode(data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
      local
         button : GTK_TOGGLE_BUTTON
      do
         button ?= cb_data.get_widget

         pbar.set_activity_mode(button.get_active)
         step_spin.set_sensitive(button.get_active)
         act_blocks_spin.set_sensitive(button.get_active)
      end -- toggle_activity_mode

   entry_changed is
      do
         pbar.set_format_string(entry.get_text)
      end -- entry_changed
   build_option_menu(arg_items : ARRAY[OPTION_MENU_ITEM];
                   num_items : INTEGER;
                   history : INTEGER;
                   data : ANY) : GTK_OPTION_MENU is
      local
         omenu : GTK_OPTION_MENU
         menu : GTK_MENU
         menu_item : GTK_RADIO_MENU_ITEM
         group : G_SLIST
         i : INTEGER
      do
         !!omenu.make

         !!menu.make
         group := Void -- is this needed in eiffel?

         from
            i := 0
         until
            i = num_items
         loop
            if group=Void then
               !!menu_item.make_alone_with_label(arg_items.item(i).name)
            else
               !!menu_item.make_with_label(group,arg_items.item(i).name)
            end -- if
            signal_connect_with_data(menu_item,"activate",
                          arg_items.item(i).func, data)
            group := menu_item.group
            menu.append(menu_item)
            if i = history then
               menu_item.set_active(true)
            end -- if
            menu_item.show
            i := i+1
         end -- loop

         omenu.set_menu(menu)
         omenu.set_history(history)

         Result := omenu
      end -- build_option_menu

   radio_menu_toggled(group : G_SLIST) : INTEGER is
      local
         item : GTK_RADIO_MENU_ITEM
         i : INTEGER
      do
         from
            i := 0
            !!item.from_external(group.nth_data(i))
         until
            item.active or item.to_external = default_pointer
         loop
            !!item.from_external(group.nth_data(i))
            i := i+1
         end -- loop
         if i>0 then
            i:=i-1
         end -- if
         Result := i
      end
end -- class PROGRESSBAR
-- example-end
