-- example-start radiobuttons radiobuttons.e
class RADIOBUTTONS
inherit
   -- All constants we need are defined in the class below.
   -- eg gtk_window_toplevel etc.
   GTK_CONSTANTS
   -- This class contains common features like vegtk_init and so
   VEGTK_MAIN
   -- If we need to handle callbacks we must inherit from the below
   -- class
   VEGTK_CALLBACK_HANDLER
creation
   make
feature -- Callback handlers
   close_application is
   -- This callback quits the program
   do
       gtk_main_quit;
   end

feature -- Creation
   make is
   local
      window : GTK_WINDOW;
      rbutton : GTK_RADIO_BUTTON;
      button : GTK_BUTTON;
      box1,box2   : GTK_VBOX;
      separator : GTK_HSEPARATOR;
   do
      -- This is called in all GTK applications. Arguments are parsed
      -- from the command line and are returned to the application.
      vegtk_init;

      -- Create a new window
      !!window.make(Gtk_window_toplevel);

      -- Set the window title
      window.set_title ("radio buttons");

      -- Set a handler for delete_event that immediately
      -- exits GTK. */
      signal_connect (window, "delete_event",$close_application);

      -- Sets the border width of the window.
      window.set_border_width (0);

      !!box1.make (False, 0);
      window.add (box1);
      box1.show;

      !!box2.make (False, 10);
      box2.set_border_width (10);
      box1.pack_start (box2, True, True, 0);
      box2.show;

      !!rbutton.make_with_label (Void, "button1");
      box2.pack_start (rbutton, True, True, 0);
      rbutton.show;

      !!rbutton.make_with_label(rbutton.group, "button2");
      rbutton.set_active (True);
      box2.pack_start (rbutton, True, True, 0);
      rbutton.show;

      !!rbutton.make_with_label(rbutton.group,"button3");
      box2.pack_start (rbutton, True, True, 0);
      rbutton.show;

      !!separator.make;
      box1.pack_start (separator, False, True, 0);
      separator.show;

      !!box2.make(False, 10);
      box2.set_border_width (10);
      box1.pack_start (box2, False, True, 0);
      box2.show;

      !!button.make_with_label ("close");
      signal_connect (button, "clicked",$close_application);
      box2.pack_start (button, True, True, 0);
      button.set_flags(Gtk_can_default);
      button.grab_default;
      button.show;
      window.show;

      gtk_main;
   end -- make
end -- class RADIOBUTTONS
-- example-end
