-- example-start spinbutton spinbutton.e
class SPINBUTTON
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make
feature {ANY} -- Creation
   make is
   local
      frame : GTK_FRAME;
      hbox : GTK_HBOX;
      main_vbox, vbox, vbox2 : GTK_VBOX;
      spinner, spinner2 : GTK_SPIN_BUTTON;
      button : GTK_BUTTON;
      check_button : GTK_CHECK_BUTTON;
      label : GTK_LABEL;
      adj : GTK_ADJUSTMENT;
   do
      -- Initialise GTK
      vegtk_init

      !!window.make (Gtk_window_toplevel);

      signal_connect (window, "destroy",$destroy);

      window.set_title ("Spin Button");

      !!main_vbox.make (False, 5);
      main_vbox.set_border_width (10);
      window.add (main_vbox);

      !!frame.make ("Not accelerated");
      main_vbox.pack_start (frame, True, True, 0);

      !!vbox.make (False, 0);
      vbox.set_border_width (5);
      frame.add (vbox);

      -- Day, month, year spinners

      !!hbox.make (False, 0);
      vbox.pack_start (hbox, True, True, 5);

      !!vbox2.make (False, 0);
      hbox.pack_start (vbox2, True, True, 5);

      !!label.make ("Day :");
      label.set_alignment (0, 0.5);
      vbox2.pack_start (label, False, True, 0);

      !!adj.make (1.0, 1.0, 31.0, 1.0, 5.0, 0.0);
      !!spinner.make (adj, 0, 0);
      spinner.set_wrap (True);
      spinner.set_shadow_type (Gtk_shadow_out);
      vbox2.pack_start (spinner, False, True, 0);

      !!vbox2.make (False, 0);
      hbox.pack_start (vbox2, True, True, 5);

      !!label.make ("Month :");
      label.set_alignment (0, 0.5);
      vbox2.pack_start (label, False, True, 0);

      !!adj.make (1.0, 1.0, 12.0, 1.0, 5.0, 0.0);
      !!spinner.make (adj, 0, 0);
      spinner.set_wrap (True);
      spinner.set_shadow_type (Gtk_shadow_etched_in);
      vbox2.pack_start (spinner, False, True, 0);

      !!vbox2.make (False, 0);
      hbox.pack_start (vbox2, True, True, 5);

      !!label.make ("Year :");
      label.set_alignment (0, 0.5);
      vbox2.pack_start (label, False, True, 0);

      !!adj.make (1998.0, 0.0, 2100.0, 1.0, 100.0, 0.0);
      !!spinner.make (adj, 0, 0);
      spinner.set_wrap (False);
      spinner.set_shadow_type (Gtk_shadow_in);
      spinner.set_usize (55, 0);
      vbox2.pack_start (spinner, False, True, 0);

      !!frame.make ("Accelerated");
      main_vbox.pack_start (frame, True, True, 0);

      !!vbox.make (False, 0);
      vbox.set_border_width (5);
      frame.add (vbox);

      !!hbox.make (False, 0);
      vbox.pack_start (hbox, False, True, 5);

      !!vbox2.make (False, 0);
      hbox.pack_start (vbox2, True, True, 5);

      !!label.make ("Value :");
      label.set_alignment (0, 0.5);
      vbox2.pack_start (label, False, True, 0);

      !!adj.make (0.0, -10000.0, 10000.0, 0.5, 100.0, 0.0);
      !!spinner1.make (adj, 1.0, 2);
      spinner1.set_wrap (True);
      spinner1.set_usize (100, 0);
      vbox2.pack_start (spinner1, False, True, 0);

      !!vbox2.make (False, 0);
      hbox.pack_start (vbox2, True, True, 5);

      !!label.make ("Digits :");
      label.set_alignment (0, 0.5);
      vbox2.pack_start (label, False, True, 0);

      !!adj.make (2, 1, 5, 1, 1, 0);
      !!spinner2.make (adj, 0.0, 0);
      spinner2.set_wrap (True);
      signal_connect_with_data (adj, "value_changed",$change_digits,spinner2);
      vbox2.pack_start (spinner2, False, True, 0);

      !!hbox.make (False, 0);
      vbox.pack_start (hbox, False, True, 5);

      !!check_button.make_with_label ("Snap to 0.5-ticks");
      signal_connect_with_data (check_button, "clicked", $toggle_snap,spinner1);
      vbox.pack_start (check_button, True, True, 0);
      check_button.set_active (True);

      !!check_button.make_with_label ("Numeric only input mode");
      signal_connect_with_data (check_button, "clicked", $toggle_numeric, spinner1);
      vbox.pack_start (check_button, True, True, 0);
      check_button.set_active (True);

      !!val_label.make ("");

      !!hbox.make (False, 0);
      vbox.pack_start (hbox, False, True, 5);
      !!button.make_with_label ("Value as Int");
--      gtk_object_set_user_data (GTK_OBJECT (button), val_label);
      signal_connect_with_data (button, "clicked",$get_value,1);
      hbox.pack_start (button, True, True, 5);

      !!button.make_with_label ("Value as Float");
--      gtk_object_set_user_data (GTK_OBJECT (button), val_label);
      signal_connect_with_data (button, "clicked",$get_value,2.0);
      hbox.pack_start (button, True, True, 5);

      vbox.pack_start (val_label, True, True, 0);
      val_label.set_text ("0");

      !!hbox.make (False, 0);
      main_vbox.pack_start (hbox, False, True, 0);

      !!button.make_with_label ("Close");
      signal_connect_with_data (button, "clicked", $quit_app,window);

      hbox.pack_start (button, True, True, 5);

      window.show_all;

      -- Enter the event loop
      gtk_main;
   end

feature {NONE} -- Callbacks
   destroy is
   do
      gtk_main_quit;
   end
   quit_app is
   do
      window.destroy;
   end

   toggle_snap (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
   local
      widget : GTK_TOGGLE_BUTTON;
      spin : GTK_SPIN_BUTTON;
   do
      widget ?= cb_data.get_widget;
      spin ?= data;
      spin.set_snap_to_ticks (widget.get_active);
   end

   toggle_numeric (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
   local
      widget : GTK_TOGGLE_BUTTON;
      spin : GTK_SPIN_BUTTON;
   do
      widget ?= cb_data.get_widget;
      spin ?= data;
      spin.set_numeric(widget.get_active);
   end

   change_digits (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
   local
      spin : GTK_SPIN_BUTTON;
   do
      spin ?= data;
      spinner1.set_digits(spin.get_value_as_int );
   end

   get_value (data : ANY) is
   local
      f_value : REAL_REF;
      i_value : INTEGER_REF;
      buf : STRING;
   do
      i_value  ?= data;
      if i_value /= Void then
         buf := spinner1.get_value_as_int.out;
      else
         f_value  ?= data;
         if f_value /= Void then
            buf := spinner1.get_value_as_float.out;
         else
            buf := "";
         end
      end
      val_label.set_text (buf);
   end
feature {NONE} -- mplementation
   window : GTK_WINDOW;
   spinner1 : GTK_SPIN_BUTTON;
   val_label : GTK_LABEL;
end -- class SPINBUTTON
-- example-end
