-- example-start statusbar statusbar.e
class STATUSBAR
inherit
   GTK_CONSTANTS
   VEGTK_MAIN
   VEGTK_CALLBACK_HANDLER
creation
   make

feature -- Creation

   make is
   local
      vbox : GTK_VBOX
      button : GTK_BUTTON;
   do
      vegtk_init

      !!window.make(Gtk_window_toplevel)
      window.set_usize( 200, 100);
      window.set_title("GTK Statusbar Example");
      signal_connect(window,"delete_event",$destroy_window)

      !!vbox.make (False, 1);
      window.add(vbox);
      vbox.show;

      !!statusbar.make;
      vbox.pack_start (statusbar, True, True, 0);
      statusbar.show;

      context_id := statusbar.get_context_id("Statusbar example");

      !!button.make_with_label ("push item");
      signal_connect(button, "clicked",$push_item);
      vbox.pack_start(button, True, True, 2);
      button.show;

      !!button.make_with_label ("pop last item");
      signal_connect(button, "clicked",$pop_item);
      vbox.pack_start(button, True, True, 2);
      button.show;

      -- always display the window as the last step so it all splashes on
      -- the screen at once. */
      window.show;

      gtk_main;
   end
feature {NONE} -- implementation
   push_item is
   local
      str : STRING;
   do
     statusbar_counter := statusbar_counter+1;
     !!str.make_from_string("something ")
     str.append_string(statusbar_counter.out)
     statusbar.push(context_id,str)
   end

   pop_item is
   do
     statusbar.pop(context_id);
   end
   destroy_window is
   do
--      window.destroy
      gtk_main_quit;
   end -- destroy_window

   window : GTK_WINDOW;
   statusbar : GTK_STATUSBAR;
   statusbar_counter : INTEGER;
   context_id : INTEGER;
end -- class STATUSBAR
-- example-end
