-- example-start table table.e
class TABLE
inherit
   -- All constants we need are defined in the class below.
   -- eg gtk_window_toplevel etc.
   GTK_CONSTANTS
   -- This class contains common features like vegtk_init and so
   VEGTK_MAIN
   -- If we need to handle callbacks we must inherit from the below
   -- class
   VEGTK_CALLBACK_HANDLER
creation
   make
feature -- Callback handlers
   callback (data : ANY) is
   -- Our new improved callback.  The data passed to this function
   -- is printed
   do
      print("Hello again - ");
      print(data);
      print(" was pressed%N");
   end

   delete_event is
   -- This callback quits the program
   do
       gtk_main_quit;
   end

feature -- Creation
   make is
   local
      window : GTK_WINDOW;
      button : GTK_BUTTON;
      table  : GTK_TABLE;
   do
      -- This is called in all GTK applications. Arguments are parsed
      -- from the command line and are returned to the application.
      vegtk_init;

      -- Create a new window
      !!window.make(Gtk_window_toplevel);

      -- Set the window title
      window.set_title ("Table");

      -- Set a handler for delete_event that immediately
      -- exits GTK. */
      signal_connect (window, "delete_event",$delete_event);

      -- Sets the border width of the window.
      window.set_border_width ( 20);

      -- Create a 2x2 table
      !!table.make (2, 2, True);

      -- Put the table in the main window
      window.add (table);

      -- Create first button
      !!button.make_with_label ("button 1");

      -- When the button is clicked, we call the "callback" function
      -- with a "button 1" as its data argument
      signal_connect_with_data (button, "clicked",$callback,"button 1");


      -- Insert button 1 into the upper left quadrant of the table
      table.attach_defaults (button, 0, 1, 0, 1);

      button.show;

      -- Create second button

      !!button.make_with_label ("button 2");

      -- When the button is clicked, we call the "callback" function
      -- with "button 2" as its data argument
      signal_connect_with_data (button, "clicked",$callback,"button 2");
      -- Insert button 2 into the upper right quadrant of the table
      table.attach_defaults (button, 1, 2, 0, 1);

      button.show;

      -- Create "Quit" button
      !!button.make_with_label ("Quit");

      -- When the button is clicked, we call the "delete_event" function
      -- and the program exits
      signal_connect (button, "clicked",$delete_event);

      -- Insert the quit button into the both
      -- lower quadrants of the table
      table.attach_defaults (button, 0, 2, 1, 2);

      button.show;

      table.show;
      window.show;

      gtk_main;
   end
end -- class TABLE
-- example-end
