indexing
   title      : "Calculator in reverse polish form                           ";
   cluster    : ISE_Eiffel_Base_Calculator;
   project    : "EiffelBase Examples",
                "Based on EiffelBase examples for ISE Eiffel,                ",
                "used with permission.                                       ";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class SET_UP

feature {NONE}

        interface: INTERFACE;
        index: INTEGER;
        keys: ARRAY [STRING];

feature

        associated_operator: HASH_TABLE [INTERFACE, STRING] is
                        -- Hash-table of operations with name and help messages.
                once
                                -- Hash-tables are resizable anyway.
                        !!Result.make (10);
                end;

        enter_operator (k, m: STRING; c: CALC_STATE) is
                        -- Enter a command `c' associated with a key `k'
                        -- and an help message `m'.
                do
                        !!interface;
                        interface.set_interface (k, m, c);
                        associated_operator.put (interface, interface.operator_key)
                end;

feature {NONE}

        help_start is
                        -- Start printing available operations.
                do
                        io.put_string ("Allowable operations are: %N");
                        keys := associated_operator.current_keys;
                        index := 1
                end;

        help_next is
                do
                        index := index + 1
                end;

        help_over: BOOLEAN is
                        -- Is the number of available operations reviewed exhausted?
                do
                        Result := index = keys.count + 1
                end;

        help_action is
                        -- Print out a information on an allowable operation.
                local
                        one_key: STRING
                do
                        one_key := keys.item (index);
                        interface := associated_operator.item (one_key);
                        io.put_character ('%T');
                        io.put_character ('%'');
                        io.put_string (one_key);
                        io.put_character ('%'');
                        io.put_string (": ");
                        io.put_string (interface.help_message);
                        io.put_new_line;
                end;

        keys_messages is
                do
                        from
                                help_start
                        until
                                help_over
                        loop
                                help_action
                                help_next
                        end
                end

end -- class SET_UP
