indexing
   title      : "Calculator in reverse polish form                           ";
   cluster    : ISE_Eiffel_Base_Calculator;
   project    : "EiffelBase Examples",
                "Based on EiffelBase examples for ISE Eiffel,                ",
                "used with permission.                                       ";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class CALC_STATE

feature {NONE}

        register: REAL;
                        -- Temporary register used in classes

        operand_stack: LINKED_STACK [REAL] is
                        -- Stack of operands.
                once
                        !!Result.make
                end;

feature

        next_choice: STRING is
                        -- Last user's choice.
                do
                        Result := io.last_string
                end;

        do_one_state is
                        -- Perform operation associated with the current state
                        -- and display result.
                do
                        process;
                        display
                end;

feature {NONE}

        display is
                        -- Display the content of the accumulator.
                do
                        io.put_new_line;
                        io.put_string ("Accumulator = ");
                        io.put_real (operand_stack.item);
                        io.put_new_line
                end;

feature

        read is
                        -- Read next operation.
                do
                        io.put_new_line;
                        io.put_string ("Next operation? ");
                        io.read_line
                end;

feature {NONE}

        process is
                        -- Process user's answer.
                do
                        if operand_stack.count > 1 then
                                register := operand_stack.item;
                                operand_stack.remove;
                                operation;
                                operand_stack.remove;
                                operand_stack.put (register)
                        else
                                io.put_string ("Only one element on the stack%N")
                        end
                end;

feature

        operation is
                        -- Effective register operation.
                deferred
                end;

end -- class CALC_STATE
