indexing
   title      : "Support demo                                                ",
                "Demonstration of PRIMES, RANDOM, FIBONACCI                  ";
   cluster    : ISE_Eiffel_Base_Support_Example;
   project    : "EiffelBase Examples";
                "Based on EiffelBase examples for ISE Eiffel,                ",
                "used with permission.                                       ";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class COUNTABLES

creation
   make

feature -- Initialization

   make is
      do
         prime_demo
         random_demo
         fibonacci_demo
      end

   c : COUNTABLE [INTEGER]

   prime_demo is
      do
         io.put_string ("%NPrime Demo%N")
         !PRIMES!c
         display_first_ten
         has_test
      end

   random_demo is
      local
         r: RANDOM
      do
         io.put_string ("%NRandom Demo%N")
         !RANDOM!c.make
         display_first_ten
         io.put_string ("Change seed to 1%N")
         !!r.set_seed (1)
         c := r
         display_first_ten
         io.put_string ("Change seed to 2%N")
         r.set_seed (2)
         c := r
         display_first_ten
         has_test
      end

   fibonacci_demo is
      do
         io.put_string ("%NFibonacci Demo%N")
         !FIBONACCI!c
         display_first_ten
         has_test
      end

feature -- Output

   display_first_ten is
      local
         i : INTEGER
      do
         from
            i := 1
         until
            i > 10
         loop
            io.put_string ("Item: ")
            io.put_integer (i)
            io.put_string (" Value: ")
            io.put_integer (c.item (i))
            io.put_new_line
            i := i + 1
         end
      end

   has_test is
      local
         i : INTEGER
      do
         from
            i := 2
         until
            i > 5
         loop
            io.put_string ("Has: ")
            io.put_integer (i)
            io.put_string (" is ")
            io.put_boolean (c.has (i))
            io.put_new_line
            i := i + 1
         end
      end


end -- class COUNTABLES
