indexing
   title      : "Support demo";
   cluster    : ISE_Eiffel_Base_Support_Example;
   project    : "EiffelBase Examples";
                "Based on EiffelBase examples for ISE Eiffel,                ",
                "used with permission.                                       ";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class FORMATTING

creation
   make

feature -- Initialization

   make is
      do
         get_number
         format_integer_demo
         get_number
         format_double_demo
      end

   format_integer_demo is
      local
         i : INTEGER
         fi : FORMAT_INTEGER
      do
         i := random.i_th (item)
         io.put_string ("Unformatted             : ")
         io.put_integer (i)
         io.put_new_line
         !!fi.make (10)
         io.put_string ("Default                 : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.set_width (15)
         io.put_string ("Set width               : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.left_justify
         io.put_string ("Left justified          : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.center_justify
         io.put_string ("Centered                : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.right_justify
         io.put_string ("Right justification     : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.asterisk_fill
         io.put_string ("Asterisk fill           : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.blank_fill
         fi.comma_separate
         io.put_string (", Separator             : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.underscore_separate
         io.put_string ("_ Separator             : ")
         io.put_string (fi.formatted (i))
         io.put_new_line
         fi.sign_negative_only
         io.put_string ("Negative only           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_positive_only
         io.put_string ("Positive only           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_show
         io.put_string ("Both                    : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_leading
         io.put_string ("Leading sign            : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_trailing
         io.put_string ("Trailing sign           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_cr_dr
         io.put_string ("Sign as CR/DR           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_dr_cr
         io.put_string ("Sign as DR/CR           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_floating_dollar
         io.put_string ("Sign floating $ no sign : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_floating_dollar_signed
         io.put_string ("Sign floating $ signed  : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.set_sign ("Plus      Minus")
         io.put_string ("Sign user set           : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
         fi.sign_ignore
         fi.bracket_negative
         io.put_string ("Bracket neg             : ")
         io.put_string (fi.formatted (i))
         io.put_string ("     ")
         io.put_string (fi.formatted (-i))
         io.put_new_line
      end

   format_double_demo is
      local
         d : DOUBLE
         fd : FORMAT_DOUBLE
      do
         d := random.double_i_th (item)
         io.put_string ("Unformatted                : ")
         io.put_double (d)
         io.put_new_line
         !!fd.make (13,4)
         io.put_string ("Default                    : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.set_decimals (6)
         io.put_string ("Set decimals               : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         io.put_string ("Hide zero                  : ")
         fd.hide_zero
         io.put_string (fd.formatted (d))
         io.put_new_line
         io.put_string ("Show zero                  : ")
         fd.show_zero
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.comma_separate
         io.put_string (", Separator                : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.underscore_separate
         io.put_string ("_ Separator                : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.comma_decimal
         io.put_string (", decimal                  : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.point_decimal
         io.put_string (". decimal                  : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         d := d + 1000
         fd.no_separate_after_decimal
         io.put_string ("No separator after decimal : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.separate_after_decimal
         io.put_string ("Separation after decimal   : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
         fd.remove_separator
         io.put_string ("No separator               : ")
         io.put_string (fd.formatted (d))
         io.put_new_line
      end

feature -- Input

   get_number is
      do
         io.put_string ("Enter a number between 1 and 100: ")
         from
            io.read_integer
         until
            1 <= io.last_integer and io.last_integer <= 100
         loop
            io.put_string ("That number is not between 1 and 100%N")
            io.read_integer
         end
         item := io.last_integer
      end

feature -- Implementation

   random : RANDOM is
      once
         !!Result.make
      end

   item: INTEGER

end -- class FORMATTING
