indexing

   title:       "Example of DATE and FORMAT";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:19 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_DATE

creation
   make

feature

   f: G_SCIENTIFIC_FORMAT
   ld: LONG_DURATION
   d1, d2: DATE
   time_tools: TIME_TOOLS

   test_two_date (year1, month1, day1, year2, month2, day2: INTEGER) is
      do

         !!d1.set_date (year1, month1, day1);
         !!d2.set_date (year2, month2, day2);
         !!time_tools;
         f.print ("--------------------------------------------------------%N")
         f.printf ("First date is !a (!s). ",
                << d1, time_tools.day_name (d1.day_of_week) >>)
         f.printf ("Second date is !a (!s).%N",
                << d2, time_tools.day_name (d2.day_of_week) >>)

         if d1 < d2 then
            ld := d2.difference (d1);
         else
            ld := d1.difference (d2);
         end -- if

         -- Note that duration is measured in units
         -- So month is 30 days
         -- And year is 12 months (360 days)

         f.printf ("Difference is !i years !i month !i days. ",
                << ld.year_part, ld.month_part, ld.day_part >>)

         f.printf ("Distance is !10.0f days%N", << ld.as_days >>)

         if d1 - ld < d2 then
            d1 := d1 + ld;
         else
            d2 := d2 + ld;
         end -- if

         if not d1.is_equal (d2) then f.print ("%NError!%N") end
      end -- test_two_date

   test_now_2000 is
      do
         !! d1.set_date (2000, 1, 1);
         !! d2.set_to_now;

         test_two_date (d1.year, d1.month, d1.day,
                        d2.year, d2.month, d2.day);

      end -- test_now_2000

   make is
      do
         !!f.make
         test_two_date (1995, 9, 18, 1995, 9, 19);
         test_two_date (1995, 9, 18, 1995, 10, 18);
         test_two_date (1995, 9, 18, 1996, 9, 18);
         test_two_date (1976, 2, 29, 1976, 12, 31);
         test_two_date (1974, 2, 28, 1969, 5, 15);
         test_two_date (1974, 1, 24, 1974, 5, 9);
         test_now_2000;

         io.put_string ("Press any key ...");
         io.read_character;
      end -- make

end --  class TEST_DATE

