indexing

   title       : "Yet Another TimeDate demo";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:19 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_DOCUMENT

creation

   make

feature

   make is
      local
         a, b, c: TIMESTAMP;
         d,e: DURATION;
         t: TIME_TOOLS;
         i: INTEGER;
         da, db: DATE;
         f : G_SCIENTIFIC_FORMAT
      do
         !!f.make
         !! b.set_local_time;                    -- today

         f.printf ("Today is !a, !t%N", << b, b >>)
         f.printf ("!i years, !i months, !i days, ",
                <<b.year, b.month, b.day>>)
         f.printf ("!i hours, !i minutes, !i.!03i seconds.%N",
                <<b.hour, b.minute, b.second, b.millisecond>>)

         !! t
         f.printf ("Today is !s %N", << t.day_name (b.day_of_week)>>);

         !! a.set (b.year, 1, 1, 0, 0, 0);  -- begin of this year
         f.printf ("Begin of this year was !a, !t%N", << a, a >>)

         d := b.difference (a);             -- calculate duration

         f.printf ("Elapsed !020.3f minutes%N", << d.as_minutes >>)
         f.printf ("Elapsed !020.3f hours%N", << d.as_hours >>)
         f.printf ("Elapsed !020.3f days%N", << d.as_days >>)

         --
         !! d.set_from_compressed (7, 0);   -- one week
         f.printf ("After a week it will be !a%N", << b.plus (d) >>)
         f.printf ("After four weeks it will be !a%N", << b.plus (d.multiply_by (4)) >>)
         --
         -- measures some activities
         !! a.set_to_now
         f.print ("Moment A%N")
         -- ..
         -- do first activity (x seconds)
         !! b.set_to_now
         f.print ("Moment B%N")
         -- ..
         -- do second activity (y seconds)
         !! c.set_to_now
         f.print ("Moment C%N")

         d := b.difference (a);
         e := c.difference (b);

         --
         -- another way to calculate the difference between
         -- two DATES
         !! da.set_date (1996, 7, 13);
         !! db.set_date (1995, 7, 13);
         i := da.absolute_days - db.absolute_days;
         f.print (i);

         io.put_string ("Press any key ...");
         io.read_character;
    end -- make

end --  class TEST_DOCUMENT
