indexing

   title       : "Example of DURATION class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:19 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_DURATION

inherit
   IO_USER

creation
   make

feature

   dd1, dd2, dd3, dd4: DURATION


   test_duration is
      do
         put_nl ("Initialize duration -------------");
         !! dd1.set (995, 6, 10, 10, 20, 30.1);
         !! dd2.set_from_compressed (358385, 469230100);
         !! dd3.set_from_compressed (-358395, 394769900);
         !! dd4.set_from_compressed (358395, -394769900)

         put_nl (x.s_duration (dd1)); -- print variable
         put_nl (x.s_duration (dd2));
         put_nl (x.s_duration (dd3));
         put_nl (x.s_duration (dd4));
         put_nl (x.s_duration (dd1 + dd2 - dd3 + dd4));
         put_nl (x.s_duration (dd1.multiply_by (4)));

         -- compare the two dates
         io.put_boolean (dd1.plus (dd2) < dd2 + dd3);
         io.put_new_line; io.put_new_line;

         put_nl ("Some magic calculation with long_duration ----");
         dd3 := dd2.multiply_by (dd4.ratio(dd1.divide_by (2)).rounded) - dd1;
         put_nl (x.s_duration (dd3));
         io.put_double (dd3.as_years); put_nl (" as years ");
         io.put_double (dd3.as_months); put_nl (" as months");
         io.put_double (dd3.as_days); put_nl (" as days");
         io.put_double (dd3.as_hours); put_nl (" as hours");
         io.put_double (dd3.as_minutes); put_nl (" as minutes");
         io.put_double (dd3.as_seconds); put_nl (" as seconds");
         io.put_new_line
      end -- test_duration


   test_two_duration (days1, ms1, days2, ms2: INTEGER) is
      do
         !! dd1.set_from_compressed (days1, ms1);
         !! dd2.set_from_compressed (days2, ms2);
         put_nl (x.s_duration (dd1)); -- print variable
         put_nl (x.s_duration (dd2));
         put_nl (x.s_duration (dd1 + dd2));

         if dd1 < dd2 then
            dd3 := dd2 - dd1;
         else
            dd3 := dd1 - dd2;
         end -- if

         put_nl (x.s_duration (dd3));
         io.put_double (dd1.ratio (dd2)); put_nl (" dd1 ratio dd2 ");
         io.put_double (dd2.ratio (dd1)); put_nl (" dd2 ratio dd1 ");
      end -- test_two_duration

   make is
      do
         test_duration;
         test_two_duration (200, 10000, 20, 1000);
         test_two_duration (500, 500000, -250, -250000);
         test_two_duration (10000, 222222, -10000, -222222);

         io.put_string ("Press any key ...");
         io.read_character;
      end -- make

end --  class TEST_DURATION

