indexing

   title:       "Example of LONG_DURATION class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:20 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_LONG_DURATION

inherit
   IO_USER

creation
   make

feature

   ld1, ld2, ld3: LONG_DURATION


   test_long_duration is
      do
         put_nl ("Initialize long_duration -------------");
         !! ld1.set_date (1995, 1, 10);
         !! ld2.set_days (+ 100); -- hundred days
         !! ld3.set_days (- 100); -- minus 100 days

         put_nl (x.s_long_duration (ld1)); -- print variable
         put_nl (x.s_long_duration (ld2));
         put_nl (x.s_long_duration (ld3));

         -- hundred days later
         put_nl (x.s_long_duration (ld1 + ld2));
         -- hundred days before
         put_nl (x.s_long_duration (ld1 + ld3));

         -- compare the two dates
         io.put_boolean (ld1.plus (ld2) < ld2 + ld3);
         io.put_new_line; io.put_new_line;

         put_nl ("Some magic calculation with long_duration ----");
         ld3 := ld2.multiply_by (10);
         put_nl (x.s_long_duration (ld3)); -- should be 1000 days
         io.put_double (ld3.as_years); put_nl (" as years");
         io.put_double (ld3.as_months); put_nl (" as months");
         io.put_double (ld3.as_days); put_nl (" as days");

         ld2 :=  ld1.plus (ld3.multiply_by (10));
         put_nl (x.s_long_duration (ld2));  -- 1000 days after 1995,1,10
         io.put_new_line
      end -- test_long_duration

   test_two_duration (days1, days2: INTEGER) is
      do
         !! ld1.set_days (days1);
         !! ld2.set_days (days2);
         put_nl (x.s_long_duration (ld1)); -- print variable
         put_nl (x.s_long_duration (ld2));
         put_nl (x.s_long_duration (ld1+ld2));

         if ld1 < ld2 then
            ld3 := ld2 - ld1;
         else
            ld3 := ld1 - ld2;
         end -- if

         put_nl (x.s_long_duration (ld3));
         io.put_double (ld1.ratio (ld2)); put_nl (" ld1 ratio ld2 ");
         io.put_double (ld2.ratio (ld1)); put_nl (" ld2 ratio ld1 ");
      end -- test_two_duration

   make is
      do
         test_long_duration;
         test_two_duration (1000, 10000);
         test_two_duration (-999, 333);
         test_two_duration (-25, -25);

         io.put_string ("Press any key ...");
         io.read_character;
      end -- make

end --  class TEST_LONG_DURATION

