indexing

   title       : "Example of SHORT_DURATION class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:20 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_SHORT_DURATION

inherit
   IO_USER

creation
   make

feature

   sd1, sd2, sd3, sd4: SHORT_DURATION

   test_short_duration is
      do
         put_nl ("Initialize short_duration -------------");
         !! sd1.set_time (10, 0, 0.111);
         !! sd2.set_seconds (144000.444);
         !! sd3.set_from_milliseconds (-72000222);
         !! sd4.clear;
         put_nl (x.s_short_duration (sd1)); -- print variable
         put_nl (x.s_short_duration (sd2));
         put_nl (x.s_short_duration (sd3));
         put_nl (x.s_short_duration (sd4));

         put_nl (x.s_short_duration ((sd1 + sd2).multiply_by (2)));
         put_nl (x.s_short_duration ((sd4 - sd3).multiply_by (6) - sd2.divide_by (2)));
         put_nl (x.s_short_duration (sd2.multiply_by (sd2.ratio (sd4 - sd3).rounded) + sd1.multiply_by (2)));

         -- compare the two dates
         io.put_boolean (sd1.plus (sd3) < sd4);
         io.put_new_line; io.put_new_line;

      end

   test_magic_calculation (seconds : REAL) is
      do
         put_nl ("Some magic calculation with long_duration ----");
         !! sd1.set_seconds (seconds);
         put_nl (x.s_short_duration (sd1));
         sd2 := sd1.multiply_by (10);
         put_nl (x.s_short_duration (sd2));
         io.put_double (sd2.as_hours); put_nl (" as hours");
         io.put_double (sd2.as_minutes); put_nl (" as minutes");
         io.put_double (sd2.as_seconds); put_nl (" as seconds");

         sd1 := (sd2.minus (sd2.divide_by (5))).divide_by (8);
         put_nl (x.s_short_duration (sd1));
         io.put_new_line
      end

   make is
      do
         test_magic_calculation (1000.020);
         test_magic_calculation (20000.0);
         test_magic_calculation (100.101);
         test_short_duration;

         io.put_string ("Press any key ...");
         io.read_character;
      end

end --  class TEST_SHORT_DURATION

