indexing

   title       : "Example of TIME class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:20 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_TIME

inherit
   IO_USER

creation
   make

feature

   sd            : SHORT_DURATION
   t1, t2, t3, t4: TIME
   ts            : TIMESTAMP
   time_tools    : TIME_TOOLS

   test_time_calculation is
      do
         put_nl ("Print some times ------------------");
         !!t1.clear; -- one hour, ten seconds
         t1.set_time (1, 0, 10.0); -- one hour, ten seconds
         !!t2.set_from_milliseconds (3601000);
         !!t3.set_time (20, 30, 0.0); -- twenty hours, 30 minutes
         put_nl (x.s_time (t1));
         put_nl (x.s_time (t2)); -- ???  should be one hour, one second
         put_nl (x.s_time (t3));

         sd := t3.difference (t1);
         put_nl (x.s_short_duration (sd)); --
         io.put_double (sd.as_hours); put_nl (" as hours");
         io.put_double (sd.as_minutes); put_nl (" as minutes");
         io.put_double (sd.as_seconds); put_nl (" as seconds");

         t2 := t1 + sd;
         put_nl (x.s_time (t2)); -- should be equal to t3 above

         !!sd.set_time (500, 0, 0.0) -- how many days are 500 hours ?
         !!t1.clear
         t1 := t1 + sd;
         ts ?= t1
         if ts = void then
            put_nl ("Error - must be TIMESTAMP")
         else
            put_nl (x.s_timestamp (ts));
         end -- if

         !!sd.set_time (-500, 0, 0.0)
         !!t4.clear
         t4 := t4 - sd;
         ts ?= t4
         if ts = void then
            put_nl ("Error - must be TIMESTAMP")
         else
            put_nl (x.s_timestamp (ts));
         end -- if
         put_nl (" t2 > t3 ");
         io.put_boolean ( t2 > t3 );
         io.put_new_line;
         put_nl (" t1 < t4 ");
         io.put_boolean (t1 < t4);
         io.put_new_line;
      end

   test_time_loop is
      local
         i : INTEGER
      do
         !!t1.set_to_now;
         put_nl (x.s_time (t1));
         io.put_string ("Begin loop, please wait ...%N")
         from
            i := 1;
         until
            i >= 10000000
         loop
            i := i + 1;
         end -- from
         io.put_string ("End loop%N")

         !!t2.set_to_now;
         put_nl (x.s_time (t2));
         sd := t2.difference (t1);
         io.put_double (sd.as_hours); put_nl (" as hours");
         io.put_double (sd.as_minutes); put_nl (" as minutes");
         io.put_double (sd.as_seconds); put_nl (" as seconds");

      end

   make is

      do
         test_time_calculation;
         test_time_loop;

         io.put_string ("Press any key ...");
         io.read_character;
      end

end --  class TEST_TIME

