indexing

   title:       "Example of TIME_TOOLS class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:20 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_TIME_TOOLS

inherit

   IO_USER

creation

   make

feature

   d: DATE
   time_tools: TIME_TOOLS

   print_leap_years (a, b: INTEGER) is
      require
         b > a
      local
         i: INTEGER
         t: DATE
      do
         from
            io.put_new_line
            i := a
         until
            i > b
         loop
            if i \\ 50 = 0 then
               io.put_new_line
            end
            !! t.set_date (i, 1, 1)
            if t.is_leap_year then
               io.put_integer (i)
               io.put_string (" ")
            end
            i := i + 1
         end
         io.put_new_line
      end

   day_test (year: INTEGER) is
      local
         month, day : INTEGER
      do
         -- make some tests with the days of a week
         !! time_tools

         io.put_new_line io.put_integer (year) io.put_string ("----")
         from month := 1
         until month > 12
         loop
            io.put_new_line io.put_string (time_tools.month_name (month))
            from day := 27
            until day > 31
            loop
               io.put_string (" ")
               if time_tools.valid_date (year, month, day) then
                  !! d.set_date (year, month, day)
                  io.put_string (time_tools.day_name (d.day_of_week))
               else
                  io.put_string ("invalid")
               end
               day := day + 1
            end
            month := month + 1
         end
         io.put_new_line
      end

   day_of_week_test (year, month, day: INTEGER) is
      do

         !! d.set_date (year, month, day)
         !GERMAN_TIME_TOOLS! time_tools
         put_nl (time_tools.day_name (d.day_of_week))

         !FRENCH_TIME_TOOLS! time_tools
         put_nl (time_tools.day_name (d.day_of_week))

         !! time_tools
         put_nl (time_tools.day_name (d.day_of_week))
         put_nl (x.s_date (d))
      end

   make is
      do

         print_leap_years (1890, 2040)

         put_nl (" %N * * * Test calculation of  day of week * * * ")
         day_of_week_test (1995, 9, 18)
         day_of_week_test (666, 6, 6)
         day_of_week_test (2000, 1, 1)

         day_test (1999)
         day_test (2000)
         day_test (1996)

         io.put_string ("Press any key ...")
         io.read_character
      end

end --  class TEST_TIME_TOOLS

