indexing

   title       : "Example of TIMESTAMP class usage";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:21 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEST_TIMESTAMP

inherit
   IO_USER

creation
   make

feature

   dd: DURATION
   ts1, ts2: TIMESTAMP
   time_tools: TIME_TOOLS


   test_timestamp is
      do
         put_nl ("test TIMESTAMP ----------------")
         !! time_tools
         !! ts1.set_to_now -- actual time
         io.put_string (time_tools.day_name (ts1.day_of_week))
         put_nl (x.s_timestamp (ts1))
         !! dd.set (0, 0, 8, 4, 0, 0.0)
         -- 8 days + 4 hours in future
         io.put_string (time_tools.day_name ((ts1 + dd).day_of_week))
         put_nl (x.s_timestamp (ts1 + dd))
         io.put_string (time_tools.day_name ((ts1 - dd).day_of_week))
         put_nl (x.s_timestamp (ts1 - dd))
         -- 8 days + 4 hours in past
         dd := (ts1 + dd).difference (ts1 - dd)
         put_nl (x.s_duration (dd))
      end

   test_2000 is
      do
         -- how many days or seconds until year 2000 ?
         !! ts1.set_to_now
         io.put_string (time_tools.day_name (ts1.day_of_week))
         put_nl (x.s_timestamp (ts1))
         !! ts2.set (2000, 1, 1, 0, 0, 0.0)
         io.put_string (time_tools.day_name (ts2.day_of_week))
         put_nl (x.s_timestamp (ts2))
         dd := ts2.difference (ts1)
         put_nl (x.s_duration (dd))
         io.put_double (dd.as_years) put_nl (" as years to year 2000")
         io.put_double (dd.as_months) put_nl (" as months")
         io.put_double (dd.as_days) put_nl (" as days")
         io.put_double (dd.as_hours) put_nl (" as hours")
         io.put_double (dd.as_minutes) put_nl (" as minutes")
         io.put_double (dd.as_seconds) put_nl (" as seconds")
      end

   test_date_to_now (yr, mh, dy, hr, me: INTEGER sd: REAL) is
      do
         !! ts1.set (yr, mh, dy, hr, me, sd)
         !! ts2.set_local_time
         io.put_string (time_tools.day_name (ts1.day_of_week))
         put_nl (x.s_timestamp (ts1))
         io.put_string (time_tools.day_name (ts2.day_of_week))
         put_nl (x.s_timestamp (ts2))
         if ts1 < ts2 then
            dd := ts2.difference (ts1)
         else
            dd := ts1.difference (ts2)
         end -- if

         put_nl (x.s_duration (dd))
         io.put_double (dd.as_years) put_nl (" as years ")
         io.put_double (dd.as_months) put_nl (" as months")
         io.put_double (dd.as_days) put_nl (" as days")
         io.put_double (dd.as_hours) put_nl (" as hours")
         io.put_double (dd.as_minutes) put_nl (" as minutes")
         io.put_double (dd.as_seconds) put_nl (" as seconds")
      end

   make is

      do
         test_timestamp
         test_2000
         test_date_to_now (1974, 1, 24, 2, 45, 0.0)
         test_date_to_now (1950, 8, 6, 0, 0, 0.0)
         test_date_to_now (1995, 12, 31, 23, 59, 59.999)

         io.put_string ("Press any key ...")
         io.read_character
      end

end --  class TEST_TIMESTAMP

