indexing

   title       : "Utilities for testing";
   project:     "Visual Eiffel";
   date:        "$Date: 2005/02/18 15:35:19 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions:"[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TESTUTIL

inherit

   IO_USER

feature

   s_short_duration (p: SHORT_DURATION): STRING is
      do
         Result := "HMS: "
         Result.append_string (p.hour_part.out) Result.append_character (':')
         Result.append_string (p.minute_part.out) Result.append_character (':')
         Result.append_string (p.second_part.out) Result.append_character (' ')
      end

   s_long_duration (p: LONG_DURATION): STRING is
      do
         Result := "YMD: "
         Result.append_string (p.year_part.out) Result.append_character (':')
         Result.append_string (p.month_part.out) Result.append_character (':')
         Result.append_string (p.day_part.out) Result.append_character (' ')
      end

   s_duration (p: DURATION): STRING is
      do
         Result := s_long_duration (p)
         Result.append_character ('+')
         Result.append_string (s_short_duration (p))
      end

   s_time (p: TIME): STRING is
      local
         s: STRING
      do
         Result := "Time: "
         Result.append_string (p.hour.out) Result.append_character (':')
         Result.append_string (p.minute.out) Result.append_character (':')
         Result.append_string (p.second.out)
         if p.millisecond /= 0 then
            Result.append_string (".000")
            s := p.millisecond.out
            Result.replace_substring (s, Result.count - 2, Result.count)
         end
         Result.append_character (' ')
      end

   s_date (p: DATE): STRING is
      do
         Result := "Date:"
         Result.append_string (p.year.out) Result.append_character ('/')
         Result.append_string (p.month.out) Result.append_character ('/')
         Result.append_string (p.day.out) Result.append_character (' ')
      end

   s_timestamp (p: TIMESTAMP): STRING is
      do
         Result := s_date (p)
         Result.append_character ('+')
         Result.append_string (s_time (p))
      end

end -- class TESTUTIL

