indexing

   title:      "Specific facilities of the guide for class LIST_";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class CHAIN_

   inherit
      CHAIN_CORE_
         end

   creation {SIMPLE_CONTAINER_}
      make


   feature -- Queries

      make (host: SIMPLE_CONTAINER_; init_size: INTEGER) is
            -- sets initial values of the guide: 'host' is the structure
            -- the guide belongs to and 'init_size' - the initial amount
            -- of slots to be allocated
         local
            pos: INTEGER

         do
            target := host
            !!next.make (1, init_size)
            first_free := next.count

            from
               pos := first_free
            until
               pos = 0
            loop
               next.put (pos - 1, pos)
               pos := pos - 1
            end

            !!prev.make (1, init_size)
         end


   feature {SIMPLE_CONTAINER_} -- Queries

      last: INTEGER is
            -- gives the position of the last entry
         do
            Result := entrance
         end

      back (pos: INTEGER): INTEGER is
            -- gives the position of the previous (about 'pos') entry
         do
            Result := prev.item (pos)

            if Result < 0 then
               Result := 0
            end
         end


   feature {NONE} -- Implementation

      out_marker: INTEGER is
            -- gives zero once and forever ...
         once
         end

      resizing (new_size: INTEGER) is
            -- increases the amount of slots allocated
         do
            next.resize (1, new_size)
            prev.resize (1, new_size)
         end

end
