indexing

   title:      "Specific facilities of the guide for class TABLE";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class CHAINING_WITH_KEYS_[H]

   inherit
      POOL_[H]
         rename
            next as right
         end

      WITH_KEYS_FOR_ORDERING_[H]
         end

   creation {SIMPLE_CONTAINER_}
      make


   feature -- Queries

      last: INTEGER is
            -- gives the position of the last entry
         do
            Result := entrance
         end

      back (pos: INTEGER): INTEGER is
            -- gives the position of the previous (about 'pos') entry
         do
            Result := prev.item (pos)

            if Result < 0 then
               Result := 0
            end
         end

      search (k: H): INTEGER is
            -- gives the position of the entry
         do
            from
               Result := first
            until
               Result = 0 or else k.is_equal (keys.item (Result))
            loop
               Result := forth (Result)
            end
         end


   feature {NONE} -- Implementation

      out_marker: INTEGER is
            -- gives zero once and forever ...
         once
         end

      resizing (new_size: INTEGER) is
            -- changes the amount of slots allocated
         do
            keys.resize (1, new_size)
            prev.resize (1, new_size)
            right.resize (1, new_size)
         end

      subsequent_init (size: INTEGER) is
            -- initializes the internal arrays other than 'next' or 'right'
            -- it's the second outstanding part of creation procedure 'make'
         do
            !!prev.make (1, size)
         end

end
