indexing

   title:      "Facilities for dispensers with one element entries";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class DISPENSER_[G]

   inherit
      CONTAINER_[G]
         export {NONE}
            make
         end

      SIMPLE_DISPENSER_[G]
         end


   feature -- Queries

      capacity: INTEGER is
            -- gives the number of all the slots allocated in the dispenser
            -- (all the dispensers may have not only slots occupied by the
            -- entries already put into but unused ones also)
         do
            if pool /= Void then
               Result := pool.capacity
            end
         end

      count: INTEGER is
            -- gives the number of entries in the dispenser or equally
            -- the number of the slots used for storing the entries
         do
            if pool /= Void then
               Result := pool.count
            end
         end

      list_of_elements: LIST_[G] is
            -- delivers all the entries of the dispenser in the order in
            -- which they would be repeatedly removed if it really happened
         deferred
         ensure
            well_done: not empty implies Result /= Void
         end


   feature {NONE} -- Implementation

      cs:   CURSOR_
      pool: LIST_[G] -- the real receptacle for entries to be stored

end
