indexing

   title:      "The project-wide universal properties: error handling",
               "facilities - the class may be used as ancestor by other",
               "classes or as a supplier of them ...";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class ERROR_HANDLER_

   inherit
      EXCEPTIONS
         end


   feature -- Operations

      err_report (location, message: STRING; code: INTEGER; xobject: ANY) is
            -- builds an error report according to the actual argument list
            -- and raises a user defined exception ...
            --
         require
            valid_location: location /= Void
            valid_message: message /= Void

         local
            final_message: STRING
         do
            !!final_message.make_from_string (message)
            final_message.append_string (" at ");
            final_message.append_string (location)

            raise (final_message)
         end

end
