indexing

   title:      "List iterators: tools for traversing the lists",
               "(except the lists of class SIMPLE_LIST_)";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class LIST_ITERATOR_[G]

   inherit
      ITERATOR_
         end


   feature -- Operations

      attach (x: LIST_[G]) is
            -- selects the target for traversal
         require
            proper_list: x /= Void
         do
            target := x
         ensure
            well_done: target /= Void
         end


   feature -- Queries

      extract_list: like target is
            -- delivers all the entries of the list attached which are
            -- satisfied the conditions put by 'test'
         require
            proper_target: target /= Void

         do
            !!Result.make (target.unique_items)
            from
               cs := target.cursor
            until
               cs.is_finished
            loop
               if test then
                  Result.put (item)
               end
               cs.forth
            end
         end

      target: LIST_[G] -- the structure to be traversed


   feature {NONE} -- Implementation

      item: G is
            -- delivers the current entry for "being touched" in features
            -- 'action' and 'test' while traversing the list
         require
            proper_cursor: cs /= Void and then cs.target = target
         do
            Result := target.item_at (cs)
         end

end
