indexing

   title:      "Some universal common facilities of the guides for classes",
               "HASH_LIST_ and SORTED_LIST_";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:21 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class ON_ITEMS_FOR_ORDERING_[G]

   inherit
      SIMPLE_POOL_
         rename
            next as right
         redefine
            target
         end


   feature {SIMPLE_CONTAINER_} -- Operations


      make (host: LIST_[G]; init_size: INTEGER) is
            -- sets initial values of the guide: 'host' is the structure
            -- the guide belongs to and 'init_size' - the initial amount
            -- of slots to be allocated
         local
            pos: INTEGER

         do
            target := host
            !!right.make (1, init_size)
            first_free := right.count

            from
               pos := first_free
            until
               pos = 0
            loop
               right.put (pos - 1, pos)
               pos := pos - 1
            end

            subsequent_init (init_size)
         end


      put_key (x: G; pos: INTEGER) is
            -- a dummy procedure ...
         once
         end

      remove_key (pos: INTEGER) is
            -- a dummy procedure ...
         once
         end


   feature {SIMPLE_CONTAINER_} -- Queries

      get_key (pos: INTEGER): G is
            -- delivers the entry of the guide actually kept out of it
         do
            Result := target.store.item (pos)
         end

      target: LIST_[G]
            -- reference to the container attached to the ordering structure
            -- (the guide) and which keeps real data


   feature {NONE} -- Implementation

      subsequent_init (size: INTEGER) is
            -- initializes the internal arrays other than 'next' or 'right' ...
         require
            proper_size: size = capacity

         deferred
         end

end
