indexing

   title:      "Specific facilities of the guide for class SORTED_TABLE_";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:22 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class ORDER_WITH_KEYS_[H -> COMPARABLE]

   inherit
      ORDER_[H]
         redefine
            remove_internal, resizing
         end

      WITH_KEYS_FOR_ORDERING_[H]
         end

   creation {SIMPLE_CONTAINER_}
      make


   feature {SIMPLE_CONTAINER_} -- Operations

      remove_internal (pos: INTEGER) is
            -- brings the duplicate out of the order of the guide
         local
            host, next, prev: INTEGER

         do
            next := right.item (pos)
            prev := left.item (pos)

            if prev > 0 and then next > 0 then
               -- it's neither the head nor the tail of the internal nodes

               entrance := root
               chain_remove (pos)
               chain_count := chain_count - 1

            else
               -- it's either the head or the tail or both in one ...

               if next <= 0 then
                  -- it's the tail of the internal nodes

                  check
                     non_zero: next /= 0
                  end

                  out_marker := left.item (- next)
                  host       := get_host (out_marker, - next)

                  check
                     proper_entrance: entrance = pos
                  end

               else
                  -- it's the head of the internal nodes

                  out_marker := prev
                  host       := get_host (out_marker, pos)

                  check
                     proper_entrance: entrance = - parent.item (host)
                  end

               end

               chain_remove (pos)
               chain_count := chain_count - 1


               if entrance = 0 then
                  -- there is no duplicate copies any longer
                  parent.put (- out_marker, host)
               else
                  -- there are still some of them ...
                  parent.put (- entrance, host)
               end
            end

            frozen_put_in_stock (pos)
         end


   feature {NONE} -- Implementation

      resizing (new_size: INTEGER) is
            -- changes the amount of slots allocated
         do
            keys.resize (1, new_size)
            left.resize (1, new_size)
            right.resize (1, new_size)
            color.resize (0, new_size)
            parent.resize (0, new_size)
         end

end
