indexing

   title:      "Some universal common facilites of the guides for classes",
               "HASH_LIST_, HASH_TABLE_, SORTED_LIST_ and SORTED_TABLE_";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:22 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class POOL_[G]

   inherit
      CHAIN_CORE_
         end


   feature {SIMPLE_CONTAINER_} -- Operations

      put_key (x: G; pos: INTEGER) is
            -- adds the new entry into the guide
         require
            valid_key:       x /= Void
            proper_position: pos > 0 and then pos <= capacity

         deferred
         ensure
            well_done: search (x) > 0
         end

      remove_key (pos: INTEGER) is
            -- actually deletes the entry from the guide
         require
            proper_position: pos > 0 and then pos <= capacity

         deferred
         end


   feature {SIMPLE_CONTAINER_} -- Queries

      get_key (pos: INTEGER): G is
            -- delivers the entry stored in the guide at position 'pos'
         require
            proper_position: pos > 0 and then pos <= capacity

         deferred
         end

      search (x: G): INTEGER is
            -- gives the position (a positive integer) of the entry if it
            -- exists; otherwise - a non-positive integer
         require
            valid_key: x /= Void

         deferred
         ensure
            well_done: Result >= - capacity and then Result <= capacity
         end


   feature {NONE} -- Implementation

      subsequent_init (size: INTEGER) is
            -- initializes the internal arrays other than 'next' or 'right' ...
         require
            proper_size: size = capacity

         deferred
         end

end
