indexing

   title:      "Simple cursors: tools for traversing all the ancestors",
               "of class SIMPLE_TRAVERSABLE_ (a class of USCL)";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:22 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class SIMPLE_CURSOR_

   creation {SIMPLE_TRAVERSABLE_}
      make


   feature -- Operations

      first is
            -- positions on the first item
         do
            activate
            -- if the structure is empty the cursor will be 'stop'-ed
            target.first (Current)
         end

      forth is
            -- moves one item forward
         require
            still_inside: not is_finished

         do
            -- if the end is reached the cursor will be 'stop'-ed
            target.forth (Current)
         end

      stop is
            -- stops traversal
         do
            if not is_finished then
               is_finished := true
               target.check_out
            end
         end


   feature -- Queries

      is_finished: BOOLEAN;        --  is the end of the structure reached ?

      target: SIMPLE_TRAVERSABLE_  --  the structure the cursor belongs to


   feature {SIMPLE_TRAVERSABLE_} -- Implementation

      position: INTEGER; -- position of the current item if 'not is_finished'

      make (tgt: SIMPLE_TRAVERSABLE_) is
            -- ...
         require
            valid_argument: tgt /= Void

         do
            target := tgt
            is_finished := true
         end

      set_position (pos: INTEGER) is
            -- keeps the position of the cursor's current item of the structure
         require
            valid_position: pos > 0

         do
            position := pos
         end

      activate is
            -- makes the cursor is active
         require
            is_attached: target /= Void

         do
            if is_finished then
               is_finished := false
               target.check_in
            end
         end

end
