indexing

   title:      "The project-wide universal properties:",
               "the class is an ancestor to all the dispensers";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:22 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class SIMPLE_DISPENSER_[G]


   feature -- Operations

      remove is
            -- deletes the "active entry" and sets 'item' and possibly 'key'
            -- to another one (algorithms of selecting a new "active entry"
            -- differ in all dispensers) or - Void if there're no more entries
         require
            not_empty: not empty

         deferred
         end


   feature -- Queries

      empty: BOOLEAN is
            -- is the dispenser empty ?
         deferred
         end

      item: G -- the "active entry" of the dispenser - in dispensers with two
              -- element entries attribute 'key' will be also considered as a
              -- part of the "active entry"


   feature {NONE} -- Implementation

      make (is_unigue: BOOLEAN) is
            -- needn't be used for the dispensers ...
         do
         end

end
