indexing

   title:      "Some universal common facilities of the guides for classes",
               "TABLE_, HASH_TABLE_ and SORTED_TABLE_";
   cluster:    "containers";
   project:    "Visual Eiffel";
   date:       "$Date: 2005/02/15 16:21:22 $";
   revision:   "$Revision: 1.2 $";
   copyright:  "Copyright (C) 1996-2005 Object Tools Group";
   license:    "http://visual-eiffel.com/license";
   disclaimer: "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class WITH_KEYS_FOR_ORDERING_[H]

   inherit
      SIMPLE_POOL_
         rename
            next as right
         end


   feature {SIMPLE_CONTAINER_} -- Operations

      make (host: SIMPLE_CONTAINER_; init_size: INTEGER) is
            -- sets initial values of the guide: 'host' is the structure
            -- the guide belongs to and 'init_size' - the initial amount
            -- of slots to be allocated
         local
            pos: INTEGER

         do
            target := host
            !!right.make (1, init_size)
            first_free := right.count

            from
               pos := first_free
            until
               pos = 0
            loop
               right.put (pos - 1, pos)
               pos := pos - 1
            end

            !!keys.make (1, init_size)
            subsequent_init (init_size)
         end

      put_key (k: H; pos: INTEGER) is
            -- adds the new entry into the guide
         do
            keys.put (k, pos)
            put (pos)
         end

      remove_key (pos: INTEGER) is
            -- actually deletes the entry from the guide
         do
            keys.put (key_default, pos)
         end


   feature {SIMPLE_CONTAINER_} -- Queries

      get_key (pos: INTEGER): H is
            -- delivers the entry stored in the guide at position 'pos'
         do
            Result := keys.item (pos)
         end

      keys: ARRAY [H] -- entries actually stored or kept in the guide


   feature {NONE} -- Implementation

      key_default: H

      subsequent_init (size: INTEGER) is
            -- initializes the internal arrays other than 'next' or 'right' ...
         require
            proper_size: size = capacity

         deferred
         end

end
