indexing

   title      : "Abstract commercial formatter class";
   copyright  : "Object Tools, 1996-2001";
   original   : "08 Sep 1996";
   version    : "1.2";
   last_change: "17 Jun 2001";
   licence   : "Eiffel-forum freeware licence"

deferred class G_ABSTRACT_COMMERCIAL_FORMATTER

inherit

   G_ABSTRACT_FORMATTER
      undefine
         make
      redefine
         output, raise_exception
      end

feature

   picture: STRING

   set_picture (p: STRING) is
      do
         picture := ""
         x_append (picture, p);
      end -- set_picture

   set_blank_when_zero is
      do
         raise_exception ("Illegal command");
      end -- set_blank_when_zero

   set_justified_right is
      do
         raise_exception ("Illegal command");
      end -- set_justified_right

   set_justified_left is
      do
         raise_exception ("Illegal command");
      end -- set_justified_left

   set_upper_character is
      do
         raise_exception("Illegal command");
      end -- set_upper_character

   set_lower_character is
      do
         raise_exception("Illegal command");
      end -- set_lower_character

   set_sign_leading is
      do
         raise_exception("Illegal command");
      end -- set_sign_leading

   set_sign_trailing is
      do
         raise_exception("Illegal command");
      end -- set_sign_trailing

   set_sign_leading_separate is
      do
         raise_exception("Illegal command");
      end -- set_sign_leading_separate

   set_sign_trailing_separate is
      do
         raise_exception("Illegal command");
      end -- set_sign_trailing_separate

   set_currency (s: STRING) is
      require
         one_char_currency_sign: s.count = 1
      do
      end -- set_currency

   set_point (c: CHARACTER) is
      do
      end -- set_point

   set_delimiters (s: STRING) is
      do
      end -- set_delimiters

   output : STRING is
      deferred
      end -- output

feature {G_ABSTRACT_COMMERCIAL_FORMATTER}

   raise_exception (msg: STRING) is
      local
         s: STRING
      do
         s := "Bad Picture("
         x_append(s, msg);
         x_extend(s, ')');
         exc.report("G_COMMERCIAL_FORMATTER", s, 0, Current);
      end -- raise_exception

end -- class G_ABSTRACT_COMMERCIAL_FORMATTER
