indexing
   title      : "Container for the arguments array";
   copyright  : "Object Tools, 1995-2001";
   original   : "08 Sep 1996";
   version    : "1.2"
   last_change: "17 Jun 2001";
   licencse   : "Eiffel-forum freeware licence"

class G_ARGUMENTS_ITERATOR

creation

   make

feature -- Creation

   make (a: ARRAY [ ANY]) is
     do
       arg := a
       if arg /= Void then
         cur := arg.lower
       end
     end -- make

   current_item : ANY is
      do
       if arg = Void or else cur > arg.upper then
         raise_exception ("Not enough arguments");
       else
         Result := arg.item(cur);
         --    debug
         --             io.put_string("Result: ");
         --             print(Result);
         --             print(arg);
         --             io.put_new_line;

         --          end;
         --          double_ref ?= Result
         --          if double_ref /= Void then
         --             Result := double_ref.truncated_to_real
         --          end
       end
     ensure
       Result /= Void
     end -- current_item

   go_forth is
     require
       arg /= Void
     do
       cur := cur + 1
     end -- go_forth

   check_finished is
       -- all arguments taken?
     do
       if arg /= Void and then cur <= arg.upper then
         raise_exception ("Too much arguments");
       end
     end -- check_finished

   arg : ARRAY [ANY] -- iterated array

       --    print_arg is
       --     local i: INTEGER;
       --     do
       --       from i := 1
       --       until i > arg.upper
       --       loop
       --         io.put_string("arg.item("); io.put_integer(i);
       --         io.put_string("): ");
       --         print (arg.item(i));
       --         io.put_new_line;
       --         i := i + 1;
       --       end;
       --     end; -- print_args

feature { NONE }

   cur : INTEGER

   exc : G_FORMAT_ERROR_HANDLER is
     once
       !!Result
     end -- exc

   raise_exception (msg: STRING) is
     local
       m: STRING
       tools: G_STRING_TOOLS
     do
       !!tools
       m := ""
       tools.x_adapt (m, "Bad format (");
       tools.x_append (m, msg);
       tools.x_extend (m, ')');
       exc.report ("G_SCIENTIFIC_FORMAT", m, 0, Current);
     end -- raise_exception

end -- class G_ARGUMENTS_ITERATOR
