indexing
   copyright  : "Object Tools, 1996-2001";
   original   : "08 Sep 1996";
   version    : "1.2";
   last_change: "17 Jun 2001"
   done_at    : "Object Tools (info@object-tools.com)";
   licence    : "Eiffel-forum freeware licence";

class G_DATE_FORMATTER

inherit

   G_STRING_FORMATTER
      rename
         make as string_make
      redefine
         output
      end
      
   G_ABSTRACT_FORMATTER
      undefine
         set_width, set_precision,  set_align_left, set_align_right,
         set_align_center
      redefine
         make
      select
         make
      end

creation

   make

feature

   make (d: DATE) is
     require else
       format_date: d /= Void
     local
       s : STRING
     do
       s := ""
       x_append (s, make_two_digit (d.month));
       x_append (s, "/");
       x_append (s, make_two_digit (d.day));
       x_append (s, "/");
       x_append (s, make_two_digit (d.year \\ 100));
       string_make (s)
     end -- make

   output : STRING is
     do
       if prec >= 8 then
         set_precision (8)
       elseif prec >= 5 then
         set_precision (5)
       elseif prec >= 2 then
         set_precision (2)
       else
         set_precision (0)
       end
       Result := Precursor
     end -- output

feature {NONE}

   make_two_digit (i: INTEGER): STRING is
     local
       i_f : G_INTEGER_FORMATTER
     do
       !!i_f.make (i);
       i_f.set_width (2);
       i_f.set_align_char ('0');
       Result:= i_f.output
     end -- make_two_digit

end -- class G_DATE_FORMATTER
