indexing

   copyright:   "Object Tools, 1996-2001";
   original:    "08 Sep 1996";
   version:     "1.1";
   last_change: "21 Dec 2001";
   licence:     "Eiffel-forum freeware licence";

class G_FLOAT_POINT_FORMATTER

inherit
   G_FIXED_POINT_FORMATTER
      redefine
         make, output, set_item
   end

creation
   make, make_real

feature {G_ABSTRACT_FORMATTER}

   exponent : INTEGER

feature

   make (f : DOUBLE_REF) is
   -- save new part - exponent, other save as fixed point :-)
   require else
      format_real: f /= Void
   local
      fa, mantissa, fsgn: DOUBLE
   do
      fa := f.item.abs
      fsgn := double_sign (f.item);
      if f.item /= 0 then
         exponent := (log10 (fa)).floor
      else
         exponent := 0
      end
      mantissa := fa / ten_power (exponent);
      Precursor (fsgn*mantissa);
   end -- make

   set_item (f: DOUBLE) is
         -- Set the new value without changing the format
      local
         fa, mantissa, fsgn: DOUBLE
      do
         fa := f.abs
         fsgn := double_sign (f);
         if f /= 0 then
            exponent := (log10 (fa)).floor
         else
            exponent := 0
         end
         mantissa := fa / ten_power (exponent)
         Precursor (fsgn*mantissa)
      end

   output: STRING is
   local
      e_f : G_INTEGER_FORMATTER
   do
      Result := make_fract_part
      -- make exponent part
      !!e_f.make (exponent);
      e_f.set_precision (2);
      e_f.set_sign ('+');
      x_extend (Result, 'e');
      x_append (Result, e_f.output);
      -- make integer part and finish alignment
      inspect alignment
      when align_left then
         i_f.set_width (1);
         Result.prepend (i_f.output);
         Result := right_pad (Result, ' ', width);
      when align_right then
         i_f.set_width (width-Result.count);
         i_f.set_align_right
         Result.prepend (i_f.output);
      when align_center then
         i_f.set_width (1);
         Result.prepend (i_f.output);
         Result := center_pad (Result,  ' ',  width);
      end
   end -- output

end -- class G_FLOAT_POINT_FORMATTER
