indexing
   copyright  : "Object Tools, 1996-2001";
   original   : "08 Sep 1996";
   version    : "1.2";
   last_change: "17 Jun 2001";

class G_FORMAT_ERROR_HANDLER

inherit

   EXCEPTIONS

feature -- Operations

   report (name, msg: STRING; code: INTEGER; xobject: ANY) is
   -- builds error report according to the actual argument list,
   -- prints it and raises a user defined exception: if proper
   -- 'error_types.item (code)' is defined it'll be used as 'msg'
   -- supplement otherwise only numeric 'code' is appended to ...
   -- (this routine is supported by Eiffel/S of Object Tools GmbH)
   --
   require
      valid_name: name /= Void
   local
      msg_name: STRING
   do
      -- Printing out the error report ...
      --
      !!msg_name.make_from_string ("%NError: ");
      msg_name.append_string (msg);
      msg_name.append_string (" in class: ");
      msg_name.append_string (name);
      -- Raising a user defined exception which stops the execution ...
      --
      io.put_string (msg_name);
      raise (msg_name)
   end -- report

end -- class G_FORMAT_ERROR_HANDLER
