indexing
   copyright  : "Object Tools, 1996-1997";
   original   : "8,Sep,1996";
   version    : "1.1";
   last_change: "1999,August"
   licencse   : "Eiffel-forum freeware licence"
-----------------------------------------------------------------------------
class G_FORMAT_TABLE [ G -> G_FORMAT_TABLE_ELEMENT ]
-----------------------------------------------------------------------------
inherit
   ARRAY [ G ]
      rename
         make as array_make
   end
-----------------------------------------------------------------------------
creation
   make
-----------------------------------------------------------------------------
feature
-----------------------------------------------------------------------------
   -- Attention: All methods affect this attributes
   found       : BOOLEAN
   found_item  : G
   found_index : INTEGER
------------------------------------------------------------------------ make
   make is
   do
      array_make (1, 0);
   end -- make
-----------------------------------------------------------------------------
feature  -- search
---------------------------------------------------------------------- search
   search (g: G) is
   require
      non_void_parameter: g /= Void
   do
      from
         found_index := lower;
         found := false
      until
         found or else found_index  > upper
      loop
         if g.is_equal (item (found_index)) then
            found_item := item (found_index);
            found := true
         else
            found_index := found_index + 1
         end
      end -- loop
   end -- search
----------------------------------------------------------- search_by_example
   search_by_example (sample : ANY) is
	  -- in ISE-Eiffel a naked floated point value is assumed to be a 
	  -- `DOUBLE', because `DOUBLE' does not conform to `REAL' we can't assing 
	  -- one 
	  -- to another. We check `sample' to be a REAL_REF and then we promote 
	  -- it to a `DOUBLE_REF'
	  -- should be corrected ASAP 14.07.99 (frido)
	  -- maybe adding a `DOUBLE_FORMATTER'?
	  -- more interesting: 
	  -- naked floating point number in ISE-Eiffel -> DOUBLE
	  -- naked floating point number in Visual Eiffel -> REAL 
	  -- arrg
	  
	  require
		 non_void_parameter: sample /= Void
	  local
		 real_ref: REAL_REF;
		 double_ref: DOUBLE_REF;
	  do
		 real_ref ?= sample;
		 if real_ref /= Void then
			!!double_ref;
			double_ref.set_item(real_ref.item + 0.0);
		 end;
		 -- if double_val = Void then
-- 			double_val ?= sample
-- 		 end;
		 from
			found_index := lower;
			found := false
		 until
			found or else found_index > upper
		 loop
			if item (found_index).sample.conforms_to(sample) 
			   or else ((double_ref /= Void) 
						and then item(found_index).sample.conforms_to(double_ref))
			 then
			   found_item := item (found_index);
			   found := true
			else 
			   found_index := found_index  + 1;
			end
		 end -- loop
	  end -- search_by_example
   -----------------------------------------------------------------------------
feature  -- add/modify
------------------------------------------------------------------------- add
   put_at_end (new_g: G) is
   require
      non_Void_new_item: new_g /= Void
   do
      force (new_g, count + 1);
   ensure
      count > 0
   end -- put_at_end
--------------------------------------------------------------------- contain
   contain (g : G) : BOOLEAN is
   do
      search (g);
      Result := found
   end -- contain
-----------------------------------------------------------------------------
end -- class G_FORMAT_TABLE
