indexing

   copyright:   "Object Tools, 1996-2001";
   original:    "08 Sep 1996";
   version:     "1.3";
   last_change: "21 Dec 2001";
   licence:     "Eiffel-forum freeware licence";

class G_INTEGER_FORMATTER

inherit

   G_UNSIGNED_DECIMAL_INTEGER_FORMATTER
      redefine
         make, set_sign, output, set_item
      end
   
   G_EXTENDED_MATH

creation

    make

feature

   sign : STRING
   minus_sign: CHARACTER is '-';

   make (i : INTEGER_REF) is
      require else
         format_number: i /= Void
      do
         Precursor (int_abs (i.item));
         sign := ""
         if i.item < 0 then
            x_extend(sign, minus_sign);
         end
      end -- make

    set_sign (s : CHARACTER) is
       require else
          legal_sign: (s.is_equal (' ')) or else (s.is_equal ('+'))
       do
          -- don't redefine sign if it is "-" or "+" (C) POSIX
          if not sign.is_equal ("-") and then not sign.is_equal ("+") then
             sign := ""
             x_extend (sign, s);
          end
       end -- set_sign

   set_item (i: INTEGER) is
         -- Set the new value without changing the format
      do
         Precursor (int_abs (i));
         sign := ""
         if i.item < 0 then
            x_extend (sign, minus_sign)
         end
      end

   output : STRING is
     local
       str : STRING
     do
       if prec /= -1 then    -- precision was set; POSIX rulez
         set_align_char (' ');
       end
       str := get_plain_number_image (int_abs (inum));
       if (prec=0) and then (inum=0) then
         Result := ""
       else
         str := left_pad (str, '0', prec);
         inspect alignment
         when align_left then
            x_prepend (str, sign);
            Result := right_pad (str, align_char, width);
         when align_right then
            if align_char = '0' then
              str := left_pad (str, align_char, width-sign.count);
              x_prepend (str, sign);
              Result := str
            else -- align right with ' '
              x_prepend (str, sign);
              Result := left_pad (str, align_char, width);
            end
         when align_center then
            x_prepend (str, sign);
            Result := center_pad (str,  ' ', width);
         end
       end
     end -- output

end -- class G_INTEGER_FORMATTER

