indexing

   copyright  : "Object Tools, 1996-2001";
   original   : "08 Sep 1996";
   version    : "1.2";
   last_change: "17 Jun 2001";
   licence    : "Eiffel-forum freeware licence";

class G_REAL_COMMERCIAL_FORMATTER

inherit

   G_ABSTRACT_COMMERCIAL_FORMATTER
      redefine
         set_currency, set_point, set_delimiters
      end
      
   G_EXTENDED_MATH
   G_STRING_TOOLS

creation

   make

feature

   make (r : DOUBLE_REF) is
      do
         sign       := double_sign (r.item);
         num        := r.item.abs  -- abs(r.item);
         point      := '.'
         currency   := '$'
         delimiters := ""
      end

   set_point (c : CHARACTER) is
      require else
         Point_Not_Null: c /= '%U'
      do
         point := c
      end

   set_delimiters (s : STRING) is
      do
         x_adapt (delimiters,s);
      end

   set_currency (s : STRING) is
      require else
         String_Not_Void: s /= Void
      do
         currency := s.item (1);
      end

   output : STRING is
      require else
         Non_void_picture: picture /= Void
      local
         icf     : G_INTEGER_COMMERCIAL_FORMATTER
         i, j    : INTEGER
         int,
         frac    : STRING
         anum,
         fracnum : DOUBLE
      do
         i := index (picture, '.');
         if i = 0 then
            --!!icf.make (floor (abs (num))*double_sign (num));
            !!icf.make ((num.abs.floor)*double_sign (num));
            icf.set_picture (picture);
            Result := icf.output
         else
            int := picture.substring (1, i-1);
            frac := picture.substring (i+1, picture.count);
            check_frac (frac);
            from
               i := 0
               j := 1
            until
               j > frac.count
            loop
               if frac.item (j) = '9' then
                  i := i + 1
               end
               j := j + 1
            end
            anum := num.abs
            fracnum := anum - anum.floor
            !!icf.make (((fracnum*ten_power (i)+0.5)*double_sign (num)).floor);
            icf.set_picture (frac);
            Result := ""
            x_append (Result, icf.output);
            Result.precede (point);
            !!icf.make ((num.abs.floor)*double_sign (num));
            icf.set_picture (int);
            Result.prepend (icf.output);
         end
      end

feature {NONE}

   num        : DOUBLE
   sign       : INTEGER
   point      : CHARACTER
   currency   : CHARACTER
   delimiters : STRING

   -- routines for fractional part
   check_frac (pic: STRING) is
   local
      i               : INTEGER;
      no_more_sign,
      no_more_dollar,
      is_last_char    : BOOLEAN
   do
      no_more_sign   := False
      no_more_dollar := False
      is_last_char   := True
      from
         i := pic.count
      until
         i < 1
      loop
         if pic.item (i) = '$' then
            if no_more_dollar then
               raise_exception ("Illegal place for dollar");
            end
            if is_last_char then
               no_more_dollar := True
            else
               raise_exception ("Illegal place for dollar");
            end
         elseif contain ("+-", pic.item (i)) then
            if no_more_dollar then
               raise_exception ("Illegal place for sign");
            end
            if is_last_char then
               no_more_sign := True
            else
               raise_exception ("Illegal place for sign");
            end
         elseif pic.item (i) = '9' then
            no_more_sign := True
            no_more_dollar := True
            is_last_char := False
         else
            raise_exception ("Illegal char in frac part");
         end
         i := i - 1
      end
   end -- check_frac

end -- class G_REAL_COMMERCIAL_FORMATTER
