indexing

   copyright:   "Object Tools, 1996-2001";
   original:    "08 Sep 1996";
   version:     "1.2";
   last_change: "21 Dec 2001";
   licence:     "Eiffel-forum freeware licence";

class G_REAL_FORMATTER

inherit
   G_ABSTRACT_FORMATTER
      redefine
         make, set_width, set_precision, set_align_left, set_align_right,
         set_align_char, set_align_center, set_sign
      end
   G_EXTENDED_MATH

creation
   make, make_real

feature

   fl_f : G_FLOAT_POINT_FORMATTER
   fx_f : G_FIXED_POINT_FORMATTER


   -- `DOUBLE' does not conform to `REAL' so, promote a `REAL' to a `DOUBLE' 
   -- possibly this may help to provide the with HACK! marked pieces of the 
   -- formatterclasses 
   
   make (d : DOUBLE_REF) is
   require else
      format_real: d /= Void
   do
      Precursor (d.item);
      !!fl_f.make (d);
      !!fx_f.make (d);
      fl_f.set_zero_strip (true);
      fx_f.set_zero_strip (true);
   end -- make


   make_real (r: REAL_REF) is
	  require
		 real_not_void: r /= Void;
	  local
		 double_of_r : DOUBLE;
	  do
		double_of_r := r.item;
		make (double_of_r);
	  end;

   set_item (f: DOUBLE) is
         -- Set the new value without changing the format
      do
         fl_f.set_item (f)
         fx_f.set_item (f)
      end

   set_width (w : INTEGER) is
   do
      fl_f.set_width (w);
      fx_f.set_width (w);
   end -- set_width

   set_precision (p : INTEGER) is
   do
      fl_f.set_precision(p);
      fx_f.set_precision(p);
   end -- set_precision

   set_sign (s : CHARACTER) is
   do
      fl_f.set_sign (s);
      fx_f.set_sign (s);
   end -- set_sign

   set_align_left is
   do
      fl_f.set_align_left
      fx_f.set_align_left
   end -- set_align_left

   set_align_right is
   do
      fl_f.set_align_right
      fx_f.set_align_right
   end -- set_align_right

   set_align_center is
   do
      fl_f.set_align_center
      fx_f.set_align_center
   end -- set_align_center

   set_align_char (c : CHARACTER) is
   do
      fl_f.set_align_char (c);
      fx_f.set_align_char (c);
   end -- set_align_char

   output : STRING is
   local
      sap : INTEGER
   do
      if fl_f.exponent < -4 or else fl_f.exponent >= fl_f.prec then
         fl_f.set_precision (fl_f.prec-1);
         Result := fl_f.output
      else
         -- significant after point
         sap := fx_f.prec-fl_f.exponent-1
         if sap <= 0 then
            fx_f.set_precision (0);
         else
            fx_f.set_precision (fx_f.prec-fl_f.exponent-1);
         end
         Result := fx_f.output
      end
   end -- output

end -- class G_REAL_FORMATTER
