indexing

   copyright  : "Object Tools, 1996-2001";
   original   : "08 Sep 1996";
   version    : "1.2";
   last_change: "17 Jun 2001";
   licence    : "Eiffel-forum freeware licence";

class G_STRING_COMMERCIAL_FORMATTER

inherit

   G_ABSTRACT_COMMERCIAL_FORMATTER
      redefine
         set_justified_right,
         set_justified_left,
         set_upper_character,
         set_lower_character
      end

creation

   make

feature

   make (s : STRING) is
      require else
         String_Not_Void: s /= Void
      do
         str := ""
         x_append (str, s);
         justify_left := False
      end

   set_justified_right is
      do
         justify_left := False
      end

   set_justified_left is
      do
         justify_left := True
      end

   set_upper_character is
      do
         str.to_upper
      end

   set_lower_character is
      do
         str.to_lower
      end

   output : STRING is
      require else
         Non_void_picture: picture /= Void
      local
         i, min_char: INTEGER
         is_float, center: BOOLEAN
         sf: G_SCIENTIFIC_FORMAT
         half_pad: INTEGER
      do
         !!sf.make
         from
            i := 1
            is_float := False
            center := False
            min_char := 0
         until
            i > picture.count
         loop
            if picture.item (i) = 'X' then
               min_char := min_char + 1
            elseif picture.item (i) = 'I' then
               min_char := min_char + 1
               center := True
            elseif picture.item (i) = 'x' then
               is_float := True
            elseif picture.item (i) = 'i' then
               is_float := True
               center := True
            else
               raise_exception ("Illegal char in string picture");
            end
            i := i + 1
         end
         if is_float then
            Result := sf.sprintf ("!s", <<str>>);
         elseif center then
            if str.count > min_char then
               Result := sf.sprintf ("!s", <<str>>);
            else
               half_pad := (min_char-str.count)//2
               Result := sf.sprintf ("!*c!s!*c",  << half_pad, ' ', str,
                                       min_char-str.count-half_pad, ' '>>);
            end
         else
            if justify_left then
               Result := sf.sprintf ("!-*.*s", <<min_char, min_char, str>>);
            else
               Result := sf.sprintf ("!*.*s", <<min_char, min_char, str>>);
            end
         end
      end

feature {NONE}

   str: STRING
   justify_left: BOOLEAN

end -- class G_STRING_COMMERCIAL_FORMATTER
