--
-- SUMMARY:      
--
-- AUTHOR:       Friedrich Dominicus
-- ORG:          No Org
-- ORIG-DATE:     9-Aug-99 at 18:13:35
-- LAST-MOD:     10-Aug-99 at 10:07:36 by Friedrich Dominicus
-- DESCRIPTION:  
-- DESCRIP-END.
indexing
   title:       "Additional math service";
   project:     "The Universal Simple Formatting Library (USFL)";
   copyright:   "SIG Computer, 1995";
   author:      "Igor Nesterof (nest@eiffel.ru)";
   original:    "08,Sep,1995";
   version:     1.2;
   last_modified: "1999-08-09";
   done_at:     "SIG Computer (info@eiffel.ru)";
   modified:    "has to be adjusted to be usable for SmallEiffel, there is%
                 % no class SINGLE_MATH available and all values are promoted %
                 % to Double";
   comment:     "Interface adopted to fit the DOUBLE_MATH class of ISE- %
                 % Eiffel and Visual-Eiffel";
   last_modified: "1999-08-09";
   maintainer: "Friedrich Dominicus";



class G_EXTENDED_MATH 


  inherit
	MATH
   

feature

   log10 (x: DOUBLE): DOUBLE is
      local
         temp1: DOUBLE
         temp2: DOUBLE
      do
         temp1 := log (x.truncated_to_real)
         temp2 := log (10)
         Result := temp1/temp2
      end

--------------------------------------------------------------------- int_abs
   int_abs (i: INTEGER): INTEGER is
   do
      if i >= 0 then
         Result :=  i
      else
         Result := -i
      end
   end -- int_abs
------------------------------------------------------------------- real_sign
   double_sign (r: DOUBLE): INTEGER is
   do
      if r > 0.0 then
         Result :=  1
      elseif r = 0.0 then
         Result := 0
      else
         Result := -1
      end
   end -- real_sign
-------------------------------------------------------------------- int_sign
   int_sign (i: INTEGER): INTEGER is
   do
      if i > 0 then
         Result :=  1
      elseif i = 0 then
         Result := 0
      else
         Result := -1
      end
   end -- int_sign
------------------------------------------------------------------- ten_power
   ten_power (x: INTEGER): DOUBLE is
      do
		 if x < 0 then
			Result := 1.0 / (10.0^(-x));
		 else
			Result := 10.0^x
		 end
	  end -- ten_power

end
