#include "eif_callback.h"

eif_call_data *eif_call_data_new (EIF_REFERENCE object,
                        VEGTK_EIF_FN_BOOL func,
                        EIF_REFERENCE data)
{
  eif_call_data *e_data = (eif_call_data*) g_malloc (sizeof(eif_call_data));
  if (e_data) {
     if (object){
#ifdef VEGTK_VE
       eif_adopt(object);
       e_data->eiffel_object = object;
#else
       e_data->eiffel_object = eif_adopt(object);
#endif
     } else
       e_data->eiffel_object=0;

     if (data){
#ifdef VEGTK_VE
       eif_adopt(data);
       e_data->data = data;
#else
       e_data->data = eif_adopt(data);
#endif
     } else
       e_data->data = 0;

     e_data->eiffel_func = func;
  }
  return e_data;
}

void free_cb_data (eif_call_data *e_data)
{
  if (e_data) {
    if ( e_data->eiffel_object)
      eif_wean(e_data->eiffel_object);
    if ( e_data->data)
      eif_wean(e_data->data);
    g_free(e_data);
  }
}

EIF_INTEGER eif_callback_int (gpointer data)
{
  eif_call_data *e_data = data;
  if (e_data && e_data->eiffel_func && e_data->eiffel_object)
    return ((VEGTK_EIF_FN_INT)e_data->eiffel_func)((EIF_REFERENCE)eif_access(e_data->eiffel_object),
                                 (EIF_REFERENCE)(e_data->data?eif_access(e_data->data):0));
  else
    return 0;
}

void cb_destroy_call_eiffel (gpointer data)
{
  eif_call_data *e_data = (eif_call_data*) data;
  if (e_data){
  //  g_print("ctree destroy func e_data = %p e_data->data=%p\n",e_data,e_data->data);
    if (e_data->eiffel_func && e_data->eiffel_object)
      ((VEGTK_EIF_PROC)e_data->eiffel_func)((EIF_REFERENCE)eif_access(e_data->eiffel_object),
                                      (EIF_REFERENCE)(e_data->data?eif_access(e_data->data):0));

    free_cb_data (e_data);
  }
}
#if 0
void cb_destroy(gpointer data)
{
  eif_call_data* e_data = (eif_call_data*)data;
  if ( e_data) {
    if ( e_data->eiffel_object)
      eif_wean(e_data->eiffel_object);
    if ( e_data->data)
      eif_wean(e_data->data);
    g_free(e_data);
  }
}
#endif
