/*
You may be able to redistribute and/or modify this program.
See the README for details.
Copyright (C) 1999 Andrew Klochkov, Eugene Melekhov
*/

#include <gtk/gtk.h>
#include <vegtk.h>


GNode* c_g_node_new (EIF_REFERENCE data)
{
  GNode *node = g_node_new(0);
  if (node){
    if (data){
#ifdef VEGTK_VE
      eif_adopt(data);
      node->data = data;
#else
      node->data = eif_adopt(data);
#endif
    }else
      node->data=0;
  }
  return node;
}

EIF_REFERENCE g_node_data_acr(GNode *node)
{
  if ( node && node->data)
    return (EIF_REFERENCE) eif_access(node->data);
  else
    return (EIF_REFERENCE)0;
}

void g_node_data_acw(GNode *node, EIF_REFERENCE new_data)
{
  if (node){
    if (node->data){
      eif_wean(node->data);
      //g_print("node_wean %p\n", node->data);
    }
    if (new_data) {
      //g_print("node_adopt %p\n", new_data);
#ifdef VEGTK_VE
      eif_adopt(new_data);
      node->data = new_data;
#else
      node->data = eif_adopt(new_data);
#endif
    }else {
      node->data = 0;
      //g_print("node_set 0 %p\n", node->data);
    }
  }
}

void c_g_node_wean_data(GNode *node)
{
// I dont know why but this does not work

  //g_print("g_node wean node %p data %p ...",node,node->data);
  if(node->data)
    eif_wean(node->data);
  node->data = 0;
  //g_print("ok\n");
}
