/*
You may be able to redistribute and/or modify this program.
See the README for details.
Copyright (C) 1999 Andrew Klochkov, Eugene Melekhov
*/


#include <gdk/gdk.h>
#include <vegtk.h>

EIF_BOOLEAN gdk_color_isequal(GdkColor *c1, GdkColor *c2)
{
 if ((c1->red != c2->red) || (c1->green != c2->green) || (c1->blue != c2->blue)) return 0;
 else return 1;
}

GdkColor* gdk_color_new_with_values(EIF_INTEGER red, EIF_INTEGER green, EIF_INTEGER blue)
{
 GdkColor* color = (GdkColor*) g_malloc(sizeof(GdkColor));

 color->red = red;
 color->green = green;
 color->blue = blue;

 return color;
}

GdkColor* gdk_color_makecopy(GdkColor* color)
{
 GdkColor* copy = (GdkColor*) g_malloc(sizeof(GdkColor));
 copy->red = color->red;
 copy->green = color->green;
 copy->blue = color->blue;
 return copy;
}

void gdk_color_dispose(GdkColor* color)
{
 g_free(color);
}

EIF_INTEGER  gdk_color_pixel_acr (GdkColor * obj)
{
  return obj->pixel;
}
EIF_INTEGER  gdk_color_red_acr (GdkColor * obj)
{
  return obj->red;
}
EIF_INTEGER  gdk_color_green_acr (GdkColor * obj)
{
  return obj->green;
}
EIF_INTEGER  gdk_color_blue_acr (GdkColor * obj)
{
  return obj->blue;
}
void  gdk_color_set_pixel_acw (GdkColor * obj,EIF_INTEGER arg_pixel)
{
  obj->pixel=arg_pixel;
}
void  gdk_color_set_red_acw (GdkColor * obj,EIF_INTEGER arg_red)
{
  obj->red=arg_red;
}
void  gdk_color_set_green_acw (GdkColor * obj,EIF_INTEGER arg_green)
{
  obj->green=arg_green;
}
void  gdk_color_set_blue_acw (GdkColor * obj,EIF_INTEGER arg_blue)
{
  obj->blue=arg_blue;
}
