/*
You may be able to redistribute and/or modify this program.
See the README for details.
Copyright (C) 1999 Andrew Klochkov, Eugene Melekhov
*/
#define GDK_DISABLE_COMPAT_H

#include <gdk/gdk.h>

//#define gdk_draw_pixmap                gdk_draw_drawable
void gdk_draw_pixmap	 (GdkDrawable  *drawable,
			  GdkGC	       *gc,
			  GdkDrawable  *src,
			  gint		xsrc,
			  gint		ysrc,
			  gint		xdest,
			  gint		ydest,
			  gint		width,
			  gint		height)
{
  gdk_draw_drawable (drawable,gc,src,xsrc,ysrc,xdest,ydest,width,height);
}
//#define gdk_draw_bitmap                gdk_draw_drawable
void gdk_draw_bitmap (GdkDrawable  *drawable,
		          GdkGC	       *gc,
			  GdkDrawable  *src,
			  gint		xsrc,
			  gint		ysrc,
			  gint		xdest,
			  gint		ydest,
			  gint		width,
			  gint		height)
{
  gdk_draw_drawable (drawable,gc,src,xsrc,ysrc,xdest,ydest,width,height);
}

//#define gdk_window_get_size            gdk_drawable_get_size
void gdk_window_get_size (GdkWindow *drawable,
			  gint	          *width,
			  gint  	  *height)
{
  gdk_drawable_get_size (drawable,width,height);
}

//#define gdk_window_get_type            gdk_drawable_get_type
GdkDrawableType gdk_window_get_type (GdkDrawable *window)
{
  return gdk_drawable_get_type (window);
}

//#define gdk_window_get_colormap        gdk_drawable_get_colormap
GdkColormap* gdk_window_get_colormap (GdkDrawable *drawable)
{
  return gdk_drawable_get_colormap (drawable);
}

//#define gdk_window_set_colormap        gdk_drawable_set_colormap
void gdk_window_set_colormap (GdkDrawable *drawable,
			      GdkColormap *colormap)
{
  gdk_drawable_set_colormap (drawable,colormap);  
}
//#define gdk_window_get_visual          gdk_drawable_get_visual
GdkVisual* gdk_window_get_visual (GdkDrawable *drawable)
{
  return gdk_drawable_get_visual (drawable);
}

//#define gdk_window_ref                 gdk_drawable_ref
GdkDrawable* gdk_window_ref (GdkDrawable    *drawable)
{
  return gdk_drawable_ref(drawable);
}
//#define gdk_window_unref               gdk_drawable_unref
void gdk_window_unref (GdkDrawable    *drawable)
{
  gdk_drawable_unref (drawable);
}
//#define gdk_bitmap_ref                 gdk_drawable_ref
GdkDrawable* gdk_bitmap_ref (GdkDrawable    *drawable)
{
  return gdk_drawable_ref(drawable);
}
//#define gdk_bitmap_unref               gdk_drawable_unref
void gdk_bitmap_unref (GdkDrawable *drawable)
{
  gdk_drawable_unref (drawable);
}
//#define gdk_pixmap_ref                 gdk_drawable_ref
GdkDrawable* gdk_pixmap_ref (GdkDrawable *drawable)
{
  return gdk_drawable_ref(drawable);
}
//#define gdk_pixmap_unref               gdk_drawable_unref
void gdk_pixmap_unref (GdkDrawable *drawable)
{
  gdk_drawable_unref (drawable);
}

//#define gdk_window_copy_area(drawable,gc,x,y,source_drawable,source_x,source_y,width,height) \
//   gdk_draw_pixmap(drawable,gc,source_drawable,source_x,source_y,x,y,width,height)
void	      gdk_window_copy_area   (GdkWindow	   *drawable,
				      GdkGC	   *gc,
				      gint	    x,
				      gint	    y,
				      GdkWindow	   *source_drawable,
				      gint	    source_x,
				      gint	    source_y,
				      gint	    width,
				      gint	    height)
{
  gdk_draw_pixmap(drawable,gc,source_drawable,source_x,source_y,x,y,width,height);
}
//#define gdk_gc_destroy                 gdk_gc_unref
void   gdk_gc_destroy (GdkGC *gc)
{
  gdk_gc_unref(gc);  
}

//#define gdk_image_destroy              gdk_image_unref
void   gdk_image_destroy (GdkImage *image)
{
  gdk_image_unref(image);  
}

//#define gdk_cursor_destroy             gdk_cursor_unref
void gdk_cursor_destroy (GdkCursor *cursor)
{
  gdk_cursor_unref(cursor);
}
