/*
You may be able to redistribute and/or modify this program.
See the README for details.
Copyright (C) 1999 Andrew Klochkov, Eugene Melekhov
*/


#include <gtk/gtk.h>
#include <eif_callback.h>

void c_gtk_clist_moveto(GtkCList *clist,EIF_INTEGER row,EIF_INTEGER column,EIF_REAL row_align,EIF_REAL col_align)
{
 gtk_clist_moveto(clist,row,column,row_align,col_align);
}

GList *gtk_clist_row_list_acr(GtkCList *clist)
{
 return clist->row_list;
}

GdkWindow *gtk_clist_clist_window_acr(GtkCList *clist)
{
 return clist->clist_window;
}

GList *gtk_clist_selection_acr(GtkCList *clist)
{
 return clist->selection;
}

GtkSelectionMode gtk_clist_selection_mode_acr(GtkCList *clist)
{
 return clist->selection_mode;
}

EIF_INTEGER gtk_clist_focus_row_acr(GtkCList *list)
{
 return list->focus_row;
}

EIF_INTEGER gtk_clist_sort_column_acr(GtkCList *list)
{
 return list->sort_column;
}

GtkSortType gtk_clist_sort_type_acr(GtkCList *list)
{
 return list->sort_type;
}

void
c_gtk_clist_set_row_data_full (GtkCList    *clist,
                               gint row,
                               EIF_REFERENCE    data,
                               EIF_REFERENCE    object,
                               void             *func)
{
  eif_call_data *e_data = eif_call_data_new(object,func,data);
  if (e_data)
    gtk_clist_set_row_data_full(clist, row, e_data, cb_destroy_call_eiffel);
}

void
c_gtk_clist_set_row_data (GtkCList *clist, gint row, EIF_REFERENCE data)
{
  //g_print("clist %p,row %d,data %p\n",clist,row,data);
  c_gtk_clist_set_row_data_full(clist, row, data, NULL, NULL);
}

EIF_REFERENCE c_gtk_clist_get_row_data(GtkCList* clist, gint row)
{
  eif_call_data *e_data = (eif_call_data*) gtk_clist_get_row_data(clist,row);
//  g_print("clist get_row_data e_data = %p,row = %d,data %p\n",e_data,row,e_data->data);
  if (e_data)
    if (e_data->data)
      return (EIF_REFERENCE)eif_access(e_data->data);
    return 0;
}

EIF_INTEGER c_gtk_clist_find_row_from_data(GtkCList* clist, EIF_REFERENCE data)
{
  GList *list;
  gint n;

  eif_call_data *e_data;

  EIF_REFERENCE c_data;
  EIF_INTEGER result=-1;

#ifdef VEGTK_ISE
  if (data)
    c_data = eif_adopt(data);
  else
    c_data =0;
#else
  c_data = data;
#endif

  g_return_val_if_fail (clist != NULL, -1);
  g_return_val_if_fail (GTK_IS_CLIST (clist), -1);

  for (n = 0, list = clist->row_list; list; n++, list = list->next){
    e_data = (eif_call_data *)GTK_CLIST_ROW (list)->data;
    if (e_data){
      if (e_data->data && c_data){
        if (((EIF_REFERENCE)eif_access(e_data->data)) == (EIF_REFERENCE)eif_access(c_data)){
          result = n;
          break;
        }
      }else if (e_data->data == c_data){
          result = n;
          break;
      }
    } else if (c_data==0){
      result = n;
      break;
    }
  }

#ifdef VEGTK_ISE
  if (c_data)
    eif_wean(c_data);
#endif
  return result;
}
EIF_INTEGER gtk_clist_rows_acr (GtkCList* clist)
{
  return clist->rows;
}
EIF_INTEGER gtk_clist_columns_acr (GtkCList* clist)
{
  return clist->columns;
}
GtkAdjustment* gtk_clist_hadjustment_acr (GtkCList* clist)
{
  return clist->hadjustment;
}

GtkAdjustment* gtk_clist_vadjustment_acr (GtkCList* clist)
{
  return clist->vadjustment;
}
