/*
You may be able to redistribute and/or modify this program.
See the README for details.
Copyright (C) 1999 Andrew Klochkov, Eugene Melekhov
*/


#include <gtk/gtk.h>
#include <vegtk.h>

EIF_REAL* c_gtk_curve_get_vector(GtkCurve* curve, EIF_INTEGER veclen)
{
 gfloat *vector;
 EIF_REAL *double_vector;
 EIF_INTEGER i;

 vector = (gfloat*) g_malloc( sizeof(gfloat)*veclen );
 gtk_curve_get_vector(curve, veclen, vector);

 double_vector = (EIF_REAL*) g_malloc( sizeof(EIF_REAL)*veclen );
 for (i=0; i<veclen; i++)
   double_vector[i] = vector[i];

 g_free(vector);

 return double_vector;
}

void c_gtk_curve_set_vector(GtkCurve* curve, EIF_INTEGER veclen, EIF_REAL vector[])
{
 gfloat* float_vector;
 EIF_INTEGER i;

 float_vector = (gfloat*) g_malloc( sizeof(gfloat)*veclen );
 for (i=0; i<veclen; i++)
   float_vector[i] = vector[i];
 gtk_curve_set_vector(curve,veclen,float_vector);
 g_free(float_vector);
}

void c_gtk_curve_set_gamma (GtkCurve *curve, EIF_REAL gamma)
{
 gtk_curve_set_gamma(curve,gamma);
}

void c_gtk_curve_set_range (GtkCurve *curve, EIF_REAL min_x, EIF_REAL max_x, EIF_REAL min_y, EIF_REAL max_y)
{
 gtk_curve_set_range(curve,min_x,max_x,min_y,max_y );
}
