indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_flags.e,v 1.4 2000/03/13 18:19:50 eugenem Exp $";

class GDK_FLAGS
   inherit
      ANY
         redefine
            is_equal
         end

creation

   make

feature -- Comparsion

   is_equal(other : like current) : BOOLEAN is
      do
         result := value = other.value
      end

feature -- Access

   make, set_value(new_value : INTEGER) is
      do
         value := new_value
      end

   get_value : INTEGER is
      do
         Result := value
      end

feature -- Queries

   infix "and" (other : like current) : like current is
   local
      bit1: BIT 32;
      bit2: BIT 32;
   do
      bit1 := integer_to_bit(value);
      bit2 := integer_to_bit(other.value);
      !!Result.make(bit_to_integer(bit1 or bit2));
   end

feature {GDK_FLAGS} -- Implementation

   value : INTEGER

feature {NONE}

   bit_to_integer(b : BIT 32) : INTEGER is
      local
         i, j : INTEGER
      do
         from
            i := 1
            j := 1
         until
            i > 32
         loop
            if b.item(i) then
               Result := Result + j
            end
            i := i+1
            j := j*2
         end
      end

   integer_to_bit(int : INTEGER) : BIT 32 is
      local
         i, j : INTEGER
      do
         from
            i := int
            j := 1
         until
            i = 0
         loop
            Result.put(i - 2*(i // 2) /= 0, j)
            i := i//2
            j := j+1
         end
         Result.put(i - 2*(i // 2) /= 0, j)
      end

end -- class GDK_FLAGS
