indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_drawable.e,v 1.5 2000/03/16 14:03:50 eugenem Exp $";

class GDK_DRAWABLE
inherit
   GDK_DRAWABLE_NP
   GDK_DRAWABLE_EXTERNALS
   GDK_OBJECT
creation
   from_external

feature -- operations

   set_data (key : STRING; data : POINTER; destroy_func : POINTER) is
      do
         np_gdk_drawable_set_data  (to_external, key, data, destroy_func);
      end
   draw_point (gc : GDK_GC; x : INTEGER; y : INTEGER) is
      do
         gdk_drawable_draw_point  (to_external, gc.to_external, x, y);
      end
   draw_line (gc : GDK_GC; x1 : INTEGER; y1 : INTEGER; x2 : INTEGER; y2 : INTEGER) is
      do
         gdk_drawable_draw_line  (to_external, gc.to_external, x1, y1, x2, y2);
      end
   draw_rectangle (gc : GDK_GC; filled : INTEGER; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_drawable_draw_rectangle  (to_external, gc.to_external, filled, x, y, width, height);
      end
   draw_arc (gc : GDK_GC; filled : INTEGER; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; angle1 : INTEGER; angle2 : INTEGER) is
      do
         gdk_drawable_draw_arc  (to_external, gc.to_external, filled, x, y, width, height, angle1, angle2);
      end
   draw_polygon (gc : GDK_GC; filled : INTEGER; points : ARRAY[GDK_POINT]) is
      local
         points_array : VEGTK_EXTERNAL_OBJECTS
      do
         !!points_array.make(points)
         c_gdk_drawable_draw_polygon  (to_external, gc.to_external, filled, points_array.to_external, points.count);
      end
   draw_string (font : GDK_FONT; gc : GDK_GC; x : INTEGER; y : INTEGER; str : STRING) is
      do
         np_gdk_drawable_draw_string  (to_external, font.to_external, gc.to_external, x, y, str);
      end
   draw_text (font : GDK_FONT; gc : GDK_GC; x : INTEGER; y : INTEGER; text : STRING) is
      do
         np_gdk_drawable_draw_text  (to_external, font.to_external, gc.to_external, x, y, text, text.count);
      end
   draw_text_wc (font : GDK_FONT; gc : GDK_GC; x : INTEGER; y : INTEGER; text : STRING) is
      do
         np_gdk_drawable_draw_text_wc  (to_external, font.to_external, gc.to_external, x, y, text, text.count);
      end
   draw_pixmap (gc : GDK_GC; src : GDK_DRAWABLE; xsrc : INTEGER; ysrc : INTEGER; xdest : INTEGER; ydest : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_drawable_draw_pixmap  (to_external, gc.to_external, src.to_external, xsrc, ysrc, xdest, ydest, width, height);
      end
--   draw_bitmap (gc : GDK_GC; src : GDK_DRAWABLE; xsrc : INTEGER; ysrc : INTEGER; xdest : INTEGER; ydest : INTEGER; width : INTEGER; height : INTEGER) is
--      do
--         gdk_drawable_draw_bitmap  (to_external, gc.to_external, src.to_external, xsrc, ysrc, xdest, ydest, width, height);
--      end
   draw_image (gc : GDK_GC; image : GDK_IMAGE; xsrc : INTEGER; ysrc : INTEGER; xdest : INTEGER; ydest : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_drawable_draw_image  (to_external, gc.to_external, image.to_external, xsrc, ysrc, xdest, ydest, width, height);
      end
   draw_points (gc : GDK_GC; points : ARRAY[GDK_POINT]; npoints : INTEGER) is
      local
         points_array : VEGTK_EXTERNAL_OBJECTS
      do
         !!points_array.make(points)
         gdk_drawable_draw_points  (to_external, gc.to_external, points_array.to_external, npoints);
      end
   draw_segments (gc : GDK_GC; segs : ARRAY[GDK_SEGMENT]; nsegs : INTEGER) is
      local
         segs_array : VEGTK_EXTERNAL_OBJECTS
      do
         !!segs_array.make(segs)
         gdk_drawable_draw_segments  (to_external, gc.to_external, segs_array.to_external, nsegs);
      end
   draw_lines (gc : GDK_GC; points : ARRAY[GDK_POINT]; npoints : INTEGER) is
      local
         points_array : VEGTK_EXTERNAL_OBJECTS
      do
         !!points_array.make(points)
         gdk_drawable_draw_lines  (to_external, gc.to_external, points_array.to_external, npoints);
      end

end -- class GDK_DRAWABLE
