indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_event_factory.e,v 1.5 2000/03/16 14:03:50 eugenem Exp $";

class GDK_EVENT_FACTORY
inherit
   GDK_CONSTANTS export {GDK_EVENT_FACTORY} all end
feature -- Commands
   create_gdk_event_from_ptr (p : POINTER) : GDK_EVENT is
   local
      type : GDK_EVENT_TYPE;
   do
      !!type.make(gdk_event_type(p))
      Result := create_gdk_event_from_type_ptr (type, p);
   end
   create_gdk_event_from_type_ptr (type : GDK_EVENT_TYPE; p : POINTER) : GDK_EVENT is
   do
      if Gdk_button_press.is_equal(type)
         or Gdk_2button_press.is_equal(type)
         or Gdk_3button_press.is_equal(type)
         or Gdk_button_release.is_equal(type) then
         !GDK_EVENT_BUTTON!Result.from_external(p)
      elseif Gdk_key_press.is_equal(type)
         or Gdk_key_release.is_equal(type) then
         !GDK_EVENT_KEY!Result.from_external(p)
      elseif Gdk_enter_notify.is_equal(type)
	 or Gdk_leave_notify.is_equal(type) then
         !GDK_EVENT_CROSSING!Result.from_external(p)
      elseif Gdk_focus_change.is_equal(type) then
         !GDK_EVENT_FOCUS!Result.from_external(p)
      elseif Gdk_configure.is_equal(type) then
         !GDK_EVENT_CONFIGURE!Result.from_external(p)
      elseif Gdk_property_notify.is_equal(type) then
         !GDK_EVENT_PROPERTY!Result.from_external(p)
      elseif Gdk_selection_clear.is_equal(type)
         or Gdk_selection_request.is_equal(type)
         or Gdk_selection_notify.is_equal(type) then
         !GDK_EVENT_SELECTION!Result.from_external(p)
      elseif Gdk_proximity_in.is_equal(type)
         or Gdk_proximity_out.is_equal(type) then
         !GDK_EVENT_PROXIMITY!Result.from_external(p)
      elseif Gdk_client_event.is_equal(type) then
         !GDK_EVENT_CLIENT!Result.from_external(p)
      elseif Gdk_drag_enter.is_equal(type)
         or Gdk_drag_leave.is_equal(type)
         or Gdk_drag_motion.is_equal(type)
         or Gdk_drag_status.is_equal(type)
         or Gdk_drop_start.is_equal(type)
         or Gdk_drop_finished.is_equal(type) then
         !GDK_EVENT_DND!Result.from_external(p)
      elseif Gdk_motion_notify.is_equal(type) then
         !GDK_EVENT_MOTION!Result.from_external(p)
      elseif Gdk_expose.is_equal(type) then
         !GDK_EVENT_EXPOSE!Result.from_external(p)
      elseif Gdk_no_expose.is_equal(type) then
         !GDK_EVENT_NO_EXPOSE!Result.from_external(p)
      elseif Gdk_visibility_notify.is_equal(type)  then
         !GDK_EVENT_VISIBILITY!Result.from_external(p)
      else
          !GDK_EVENT!Result.from_external(p)
      end
   end
   gdk_event_type (p:POINTER) : INTEGER is
      external "C"
      alias "gdk_event_type_acr"
   end
end -- class GDK_EVENT_FACTORY

--  GDK_NOTHING      = -1,
--  GDK_DELETE       = 0,
--  GDK_DESTROY      = 1,
--  GDK_MAP       = 14,
--  GDK_UNMAP     = 15,

