indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_font.e,v 1.5 2000/03/16 14:03:50 eugenem Exp $";

class GDK_FONT
inherit
   GDK_FONT_NP
   GDK_FONT_EXTERNALS
   GDK_OBJECT
creation
   from_external, load, fontset_load

feature -- operations

   type : GDK_FONT_TYPE is
      do
         !!result.make(gdk_font_type_acr  (to_external));
      end
   ascent : INTEGER is
      do
         Result:= gdk_font_ascent_acr  (to_external);
      end
   descent : INTEGER is
      do
         Result:= gdk_font_descent_acr  (to_external);
      end
   load (font_name : STRING) is
      do
         from_external(np_gdk_font_load  (font_name))
      end
   fontset_load (fontset_name : STRING)  is
      do
         from_external(np_gdk_font_fontset_load  (fontset_name))
      end
   ref is
      do
         gdk_font_ref  (to_external);
      end
   unref is
      do
         gdk_font_unref  (to_external);
      end
   id : INTEGER is
      do
         Result:= gdk_font_id  (to_external);
      end
   isequal (fontb : GDK_FONT) : BOOLEAN is
      do
         Result:= gdk_font_isequal  (to_external, fontb.to_external);
      end
   string_width (str : STRING) : INTEGER is
      do
         Result:= np_gdk_font_string_width  (to_external, str);
      end
   text_width (text : STRING; text_length : INTEGER) : INTEGER is
      do
         Result:= np_gdk_font_text_width  (to_external, text, text_length);
      end
   text_width_wc (text : STRING; text_length : INTEGER) : INTEGER is
      do
         Result:= np_gdk_font_text_width_wc  (to_external, text, text_length);
      end
   char_width (character : CHARACTER) : INTEGER is
      do
         Result:= gdk_font_char_width  (to_external, character);
      end
   char_width_wc (character : CHARACTER) : INTEGER is
      do
         Result:= gdk_font_char_width_wc  (to_external, character);
      end
   string_measure (str : STRING) : INTEGER is
      do
         Result:= np_gdk_font_string_measure  (to_external, str);
      end
   text_measure (text : STRING; text_length : INTEGER) : INTEGER is
      do
         Result:= np_gdk_font_text_measure  (to_external, text, text_length);
      end
   char_measure (character : CHARACTER) : INTEGER is
      do
         Result:= gdk_font_char_measure  (to_external, character);
      end
   string_height (str : STRING) : INTEGER is
      do
         Result:= np_gdk_font_string_height  (to_external, str);
      end
   text_height (text : STRING; text_length : INTEGER) : INTEGER is
      do
         Result:= np_gdk_font_text_height  (to_external, text, text_length);
      end
   char_height (character : CHARACTER) : INTEGER is
      do
         Result:= gdk_font_char_height  (to_external, character);
      end
   text_extents (text : STRING; text_length : INTEGER; lbearing : POINTER; rbearing : POINTER; width : POINTER; arg_ascent : POINTER; arg_descent : POINTER) is
      do
         np_gdk_font_text_extents  (to_external, text, text_length, lbearing, rbearing, width, arg_ascent, arg_descent);
      end
   text_extents_wc (text : STRING; text_length : INTEGER; lbearing : POINTER; rbearing : POINTER; width : POINTER; arg_ascent : POINTER; arg_descent : POINTER) is
      do
         np_gdk_font_text_extents_wc  (to_external, text, text_length, lbearing, rbearing, width, arg_ascent, arg_descent);
      end
   string_extents (str : STRING; lbearing : POINTER; rbearing : POINTER; width : POINTER; arg_ascent : POINTER; arg_descent : POINTER) is
      do
         np_gdk_font_string_extents  (to_external, str, lbearing, rbearing, width, arg_ascent, arg_descent);
      end

end -- class GDK_FONT
