indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_image.e,v 1.7 2000/03/20 07:54:44 eugenem Exp $";

class GDK_IMAGE
inherit
   GDK_IMAGE_EXTERNALS
   GDK_OBJECT
creation
   from_external, make
feature -- creation
   make (arg_type : GDK_IMAGE_TYPE; arg_visual : GDK_VISUAL; arg_width : INTEGER; arg_height : INTEGER) is
      do
         from_external(gdk_image_new  (arg_type.get_value, arg_visual.to_external, arg_width, arg_height));
      end

feature -- operations

   type : GDK_IMAGE_TYPE is
      do
         !!result.make(gdk_image_type_acr  (to_external));
      end
   visual : GDK_VISUAL is
      do
         !!Result.from_external(gdk_image_visual_acr  (to_external));
      end
   byte_order : GDK_BYTE_ORDER is
      do
         !!result.make(gdk_image_byte_order_acr  (to_external));
      end
   width : INTEGER is
      do
         Result:= gdk_image_width_acr  (to_external);
      end
   height : INTEGER is
      do
         Result:= gdk_image_height_acr  (to_external);
      end
   depth : INTEGER is
      do
         Result:= gdk_image_depth_acr  (to_external);
      end
   bpp : INTEGER is
      do
         Result:= gdk_image_bpp_acr  (to_external);
      end
   bpl : INTEGER is
      do
         Result:= gdk_image_bpl_acr  (to_external);
      end
   new_bitmap (arg_visual : GDK_VISUAL; data : POINTER; arg_width : INTEGER; arg_height : INTEGER) : GDK_IMAGE is
      do
         !!Result.from_external(gdk_image_new_bitmap  (arg_visual.to_external, data, arg_width, arg_height));
      end
--   bitmap_new (arg_type : GDK_IMAGE_TYPE; arg_visual : GDK_VISUAL; arg_width : INTEGER; arg_height : INTEGER) : GDK_IMAGE is
--      do
--         !!Result.from_external(gdk_image_bitmap_new  (arg_type.get_value, arg_visual.to_external, arg_width, arg_height));
--      end
   put_pixel (x : INTEGER; y : INTEGER; pixel : INTEGER) is
      do
         gdk_image_put_pixel  (to_external, x, y, pixel);
      end
   get_pixel (x : INTEGER; y : INTEGER) : INTEGER is
      do
         Result:= gdk_image_get_pixel  (to_external, x, y);
      end
   destroy is
      do
         gdk_image_destroy  (to_external);
      end

end -- class GDK_IMAGE
