indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_pixmap.e,v 1.5 2000/03/16 14:03:50 eugenem Exp $";

class GDK_PIXMAP
inherit
   GDK_PIXMAP_NP
   GDK_PIXMAP_EXTERNALS
   GDK_DRAWABLE
creation
   make,
   make_default,
   make_from_xpm,
   make_from_xpm_d,
   create_pixmap,
   from_external

feature -- Creation

   make (window : GDK_WINDOW; width : INTEGER; height : INTEGER; depth : INTEGER) is
      do
         from_external(gdk_pixmap_new  (window.to_external, width, height, depth))
         mask := Void
      end

   create_pixmap (pixptr, maskptr : POINTER) is
      do
         from_external (pixptr)
         !!mask.from_external(pixptr)
      end

   make_from_xpm (window : GDK_WINDOW; transparent_color : GDK_COLOR;
                  filename : STRING) is
      local
         t_color : POINTER
      do
         t_color := to_external_with_check(transparent_color)
         from_external (np_ext_pixmap_create_from_xpm(window.to_external, $maskobj,
                                                 t_color,filename))
         !!mask.from_external(maskobj)
      end -- make

   make_from_xpm_d (window : GDK_WINDOW; transparent_color : GDK_COLOR;
                    data : ARRAY[STRING]) is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
         t_color : POINTER
      do
         !!tmp.make(data)
         t_color := to_external_with_check(transparent_color)
         from_external(
            ext_pixmap_create_from_xpm_d(window.to_external, $maskobj,
                                         t_color,tmp.to_external))
         !!mask.from_external(maskobj)
      end

   make_default is
      do
         from_external(default_pointer)
         !!mask.from_external(default_pointer)
      end

feature -- Commands

   -- I think you have to do this explicitly.
   destroy is
      do
         unref
      end

   ref : GDK_PIXMAP is
      do
         !!Result.from_external(gdk_pixmap_ref  (to_external));
      end
   unref is
      do
         gdk_pixmap_unref  (to_external);
      end

   mask : GDK_BITMAP

feature {GTK_WIDGET}

   maskobj : POINTER

invariant
end
