indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_region.e,v 1.5 2000/03/16 14:03:50 eugenem Exp $";

class GDK_REGION
inherit
   GDK_REGION_EXTERNALS
   GDK_OBJECT
creation
   from_external, make
feature -- creation
   make is
      do
         from_external(gdk_region_new)
      end

feature -- operations

   destroy is
      do
         gdk_region_destroy  (to_external);
      end
   get_clipbox (rectangle : GDK_RECTANGLE) is
      do
         gdk_region_get_clipbox  (to_external, rectangle.to_external);
      end
   empty : BOOLEAN is
      do
         result := gdk_region_empty  (to_external)
      end
   isequal (region2 : GDK_REGION) : BOOLEAN is
      do
         Result:= gdk_region_equal  (to_external, region2.to_external);
      end
   point_in (x : INTEGER; y : INTEGER) : BOOLEAN is
      do
         Result:= gdk_region_point_in  (to_external, x, y);
      end
   rect_in (rect : GDK_RECTANGLE) : GDK_OVERLAP_TYPE is
      do
         !!result.make(gdk_region_rect_in  (to_external, rect.to_external))
      end
   polygon (points : ARRAY[GDK_POINT]; npoints : INTEGER; fill_rule : GDK_FILL_RULE) : GDK_REGION is
      local
        tmp : VEGTK_EXTERNAL_OBJECTS
      do
         !!tmp.make(points);
         !!Result.from_external(gdk_region_polygon  (tmp.to_external, npoints, fill_rule.get_value));
      end
   offset (dx : INTEGER; dy : INTEGER) is
      do
         gdk_region_offset  (to_external, dx, dy);
      end
   shrink (dx : INTEGER; dy : INTEGER) is
      do
         gdk_region_shrink  (to_external, dx, dy);
      end
   union_with_rect (rect : GDK_RECTANGLE) : GDK_REGION is
      do
         !!Result.from_external(gdk_region_union_with_rect  (to_external, rect.to_external));
      end
   intersect (source2 : GDK_REGION) : GDK_REGION is
      do
         !!Result.from_external(gdk_regions_intersect  (to_external, source2.to_external));
      end
   union (source2 : GDK_REGION) : GDK_REGION is
      do
         !!Result.from_external(gdk_regions_union  (to_external, source2.to_external));
      end
   subtract (source2 : GDK_REGION) : GDK_REGION is
      do
         !!Result.from_external(gdk_regions_subtract  (to_external, source2.to_external));
      end
   do_xor (source2 : GDK_REGION) : GDK_REGION is
      do
         !!Result.from_external(gdk_regions_xor  (to_external, source2.to_external));
      end

end -- class GDK_REGION
