indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_window.e,v 1.3 2000/03/16 14:03:51 eugenem Exp $";

class GDK_WINDOW
inherit
   GDK_WINDOW_NP
   GDK_WINDOW_EXTERNALS
   GDK_DRAWABLE
creation
   from_external, make
feature -- creation
   make (parent : GDK_WINDOW; attributes : GDK_WINDOW_ATTR; attributes_mask : INTEGER) is
      do
         from_external(gdk_window_new  (parent.to_external, attributes.to_external, attributes_mask))
      end

feature -- operations

   destroy is
      do
         gdk_window_destroy  (to_external);
      end
   ref : GDK_WINDOW is
      do
         !!Result.from_external(gdk_window_ref  (to_external));
      end
   unref is
      do
         gdk_window_unref  (to_external);
      end
   at_pointer (win_x : POINTER; win_y : POINTER) : GDK_WINDOW is
      do
         !!Result.from_external(gdk_window_at_pointer  (win_x, win_y));
      end
   show is
      do
         gdk_window_show  (to_external);
      end
   hide is
      do
         gdk_window_hide  (to_external);
      end
   withdraw is
      do
         gdk_window_withdraw  (to_external);
      end
   move (x : INTEGER; y : INTEGER) is
      do
         gdk_window_move  (to_external, x, y);
      end
   resize (width : INTEGER; height : INTEGER) is
      do
         gdk_window_resize  (to_external, width, height);
      end
   move_resize (x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_window_move_resize  (to_external, x, y, width, height);
      end
   reparent (new_parent : GDK_WINDOW; x : INTEGER; y : INTEGER) is
      do
         gdk_window_reparent  (to_external, new_parent.to_external, x, y);
      end
   clear is
      do
         gdk_window_clear  (to_external);
      end
   clear_area (x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_window_clear_area  (to_external, x, y, width, height);
      end
   clear_area_e (x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_window_clear_area_e  (to_external, x, y, width, height);
      end
   copy_area (gc : GDK_GC; x : INTEGER; y : INTEGER; source_window : GDK_WINDOW; source_x : INTEGER; source_y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         gdk_window_copy_area  (to_external, gc.to_external, x, y, source_window.to_external, source_x, source_y, width, height);
      end
   raise is
      do
         gdk_window_raise  (to_external);
      end
   lower is
      do
         gdk_window_lower  (to_external);
      end
   set_user_data (user_data : POINTER) is
      do
         gdk_window_set_user_data  (to_external, user_data);
      end
   set_override_redirect (override_redirect : BOOLEAN) is
      do
         gdk_window_set_override_redirect  (to_external, override_redirect);
      end
   add_filter (function : POINTER; data : POINTER) is
      do
         gdk_window_add_filter  (to_external, function, data);
      end
   remove_filter (function : POINTER; data : POINTER) is
      do
         gdk_window_remove_filter  (to_external, function, data);
      end
   shape_combine_mask (shape_mask : GDK_BITMAP; offset_x : INTEGER; offset_y : INTEGER) is
      do
         gdk_window_shape_combine_mask  (to_external, shape_mask.to_external, offset_x, offset_y);
      end
   set_child_shapes is
      do
         gdk_window_set_child_shapes  (to_external);
      end
   merge_child_shapes is
      do
         gdk_window_merge_child_shapes  (to_external);
      end
   is_visible : BOOLEAN is
      do
         Result:= gdk_window_is_visible  (to_external);
      end
   is_viewable : BOOLEAN is
      do
         Result:= gdk_window_is_viewable  (to_external);
      end
   set_static_gravities (use_static : BOOLEAN) : BOOLEAN is
      do
         Result:= gdk_window_set_static_gravities  (to_external, use_static);
      end
   set_hints (x : INTEGER; y : INTEGER; min_width : INTEGER; min_height : INTEGER; max_width : INTEGER; max_height : INTEGER; flags : INTEGER) is
      do
         gdk_window_set_hints  (to_external, x, y, min_width, min_height, max_width, max_height, flags);
      end
   set_geometry_hints (geometry : GDK_GEOMETRY; flags : GDK_WINDOW_HINTS) is
      do
         gdk_window_set_geometry_hints  (to_external, geometry.to_external, flags.get_value);
      end
   set_title (title : STRING) is
      do
         np_gdk_window_set_title  (to_external, title);
      end
   set_role (role : STRING) is
      do
         np_gdk_window_set_role  (to_external, role);
      end
   set_transient_for (leader : GDK_WINDOW) is
      do
         gdk_window_set_transient_for  (to_external, leader.to_external);
      end
   set_background (color : GDK_COLOR) is
      do
         gdk_window_set_background  (to_external, color.to_external);
      end
   set_back_pixmap (pixmap : GDK_PIXMAP; parent_relative : INTEGER) is
      do
         gdk_window_set_back_pixmap  (to_external, pixmap.to_external, parent_relative);
      end
   set_cursor (cursor : GDK_CURSOR) is
      do
         gdk_window_set_cursor  (to_external, cursor.to_external);
      end
   set_colormap (colormap : GDK_COLORMAP) is
      do
         gdk_window_set_colormap  (to_external, colormap.to_external);
      end
   get_user_data (data : POINTER) is
      do
         gdk_window_get_user_data  (to_external, data);
      end
   get_geometry (x : POINTER; y : POINTER; width : POINTER; height : POINTER; depth : POINTER) is
      do
         gdk_window_get_geometry  (to_external, x, y, width, height, depth);
      end
   get_position (x : POINTER; y : POINTER) is
      do
         gdk_window_get_position  (to_external, x, y);
      end
   get_size (width : POINTER; height : POINTER) is
      do
         gdk_window_get_size  (to_external, width, height);
      end
   get_visual : GDK_VISUAL is
      do
         !!Result.from_external(gdk_window_get_visual  (to_external));
      end
   get_colormap : GDK_COLORMAP is
      do
         !!Result.from_external(gdk_window_get_colormap  (to_external));
      end
   get_type : GDK_WINDOW_TYPE is
      do
         !!result.make(gdk_window_get_type  (to_external))
      end
   get_origin (x : POINTER; y : POINTER) : INTEGER is
      do
         Result:= gdk_window_get_origin  (to_external, x, y);
      end
   get_deskrelative_origin (x : POINTER; y : POINTER) : BOOLEAN is
      do
         Result:= gdk_window_get_deskrelative_origin  (to_external, x, y);
      end
   get_root_origin (x : POINTER; y : POINTER) is
      do
         gdk_window_get_root_origin  (to_external, x, y);
      end
   get_pointer (x : POINTER; y : POINTER; mask : POINTER) : GDK_WINDOW is
      do
         !!Result.from_external(gdk_window_get_pointer  (to_external, x, y, mask));
      end
   get_parent : GDK_WINDOW is
      do
         !!Result.from_external(gdk_window_get_parent  (to_external));
      end
   get_toplevel : GDK_WINDOW is
      do
         !!Result.from_external(gdk_window_get_toplevel  (to_external));
      end
   get_children : ARRAY[GDK_WINDOW] is
      do
--         !!Result.from_external(gdk_window_get_children  (to_external));
      end
   get_events : GDK_EVENT_MASK is
      do
         !!result.make(gdk_window_get_events  (to_external))
      end
   set_events (event_mask : GDK_EVENT_MASK) is
      do
         gdk_window_set_events  (to_external, event_mask.get_value);
      end
   set_icon (icon_window : GDK_WINDOW; pixmap : GDK_PIXMAP; mask : GDK_BITMAP) is
      do
         gdk_window_set_icon  (to_external, icon_window.to_external, pixmap.to_external, mask.to_external);
      end
   set_icon_name (name : STRING) is
      do
         np_gdk_window_set_icon_name  (to_external, name);
      end
   set_group (leader : GDK_WINDOW) is
      do
         gdk_window_set_group  (to_external, leader.to_external);
      end
   set_decorations (decorations : ARRAY[GDK_WMDECORATION]) is
      local
         t : ANY
      do
         t := decorations.to_c
         gdk_window_set_decorations  (to_external, $t);
      end
   set_functions (functions : ARRAY[GDK_WMFUNCTION]) is
      local
         t : ANY
      do
         t := functions.to_c
         gdk_window_set_functions  (to_external, $t);
      end
   register_dnd is
      do
         gdk_window_register_dnd  (to_external);
      end

end -- class GDK_WINDOW
