indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_gc.e,v 1.3 2000/03/16 14:03:51 eugenem Exp $";

class GDK_GC
inherit
   GDK_GC_NP
   GDK_GC_EXTERNALS
   GDK_OBJECT
creation
   from_external, make, make_with_values
feature -- creation
   make (window : GDK_WINDOW) is
      do
         from_external(gdk_gc_new  (window.to_external))
      end
   make_with_values (window : GDK_WINDOW; values : ARRAY[GDK_GCVALUES]; values_mask : GDK_GCVALUES_MASK) is
      local
        tmp : VEGTK_EXTERNAL_OBJECTS
      do
         !!tmp.make(values);
         from_external(gdk_gc_new_with_values  (window.to_external, tmp.to_external, values_mask.get_value))
      end

feature -- operations

   get_values (values : ARRAY[GDK_GCVALUES]) is
      do
         np_gdk_gc_get_values  (values);
      end
   set_foreground (color : GDK_COLOR) is
      do
         gdk_gc_set_foreground  (to_external, color.to_external);
      end
   set_background (color : GDK_COLOR) is
      do
         gdk_gc_set_background  (to_external, color.to_external);
      end
   set_font (font : GDK_FONT) is
      do
         gdk_gc_set_font  (to_external, font.to_external);
      end
   set_function (function : GDK_FUNCTION) is
      do
         gdk_gc_set_function  (to_external, function.get_value);
      end
   set_fill (fill : GDK_FILL) is
      do
         gdk_gc_set_fill  (to_external, fill.get_value);
      end
   set_tile (tile : GDK_PIXMAP) is
      do
         gdk_gc_set_tile  (to_external, tile.to_external);
      end
   set_stipple (stipple : GDK_PIXMAP) is
      do
         gdk_gc_set_stipple  (to_external, stipple.to_external);
      end
   set_ts_origin (x : INTEGER; y : INTEGER) is
      do
         gdk_gc_set_ts_origin  (to_external, x, y);
      end
   set_clip_origin (x : INTEGER; y : INTEGER) is
      do
         gdk_gc_set_clip_origin  (to_external, x, y);
      end
   set_clip_mask (mask : GDK_BITMAP) is
      do
         gdk_gc_set_clip_mask  (to_external, mask.to_external);
      end
   set_clip_rectangle (rectangle : GDK_RECTANGLE) is
      do
         gdk_gc_set_clip_rectangle  (to_external, rectangle.to_external);
      end
   set_clip_region (rectangle : GDK_REGION) is
      do
         gdk_gc_set_clip_region  (to_external, rectangle.to_external);
      end
   set_subwindow (mode : GDK_SUBWINDOW_MODE) is
      do
         gdk_gc_set_subwindow  (to_external, mode.get_value);
      end
   set_exposures (exposures : BOOLEAN) is
      do
         gdk_gc_set_exposures  (to_external, exposures.to_integer);
      end
   set_line_attributes (line_width : INTEGER; line_style : GDK_LINE_STYLE; cap_style : GDK_CAP_STYLE; join_style : GDK_JOIN_STYLE) is
      do
         gdk_gc_set_line_attributes  (to_external, line_width, line_style.get_value, cap_style.get_value, join_style.get_value);
      end
   set_dashes (dash_offset : INTEGER; dash_list : ARRAY[CHARACTER]; n : INTEGER) is
      do
         np_gdk_gc_set_dashes  (to_external, dash_offset, dash_list, n);
      end

end -- class GDK_GC
