indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_colormap.e,v 1.4 2000/03/20 07:54:45 eugenem Exp $";

class GDK_COLORMAP
inherit
   GDK_COLORMAP_EXTERNALS
   GDK_OBJECT
creation
   from_external, make, make_system
feature -- creation
   make (visual : GDK_VISUAL; allocate : INTEGER) is
      do
         from_external(gdk_colormap_new  (visual.to_external, allocate))
      end
   make_system is
      do
         from_external(gdk_colormap_get_system);
      end

feature -- operations

   ref is
      do
         gdk_colormap_ref  (to_external);
      end
   unref is
      do
         gdk_colormap_unref  (to_external);
      end
   get_system_size : INTEGER is
      do
         Result:= gdk_colormap_get_system_size;
      end
   change (ncolors : INTEGER) is
      do
         gdk_colormap_change  (to_external, ncolors);
      end
   alloc_colors (colors : ARRAY[GDK_COLOR]; ncolors : INTEGER; writeable : BOOLEAN; best_match : BOOLEAN) : INTEGER is
      local
         tmp : VEGTK_EXTERNAL_OBJECTS
         success : INTEGER;
      do
         !!tmp.make(colors)
         Result:= gdk_colormap_alloc_colors  (to_external, tmp.to_external, ncolors, writeable, best_match, $success);
      end
   alloc_color (color : GDK_COLOR; writeable : BOOLEAN; best_match : BOOLEAN) : BOOLEAN is
      do
         Result:= gdk_colormap_alloc_color  (to_external, color.to_external, writeable, best_match);
      end
   free_colors (colors : ARRAY[GDK_COLOR]; ncolors : INTEGER) is
      local
         tmp : VEGTK_EXTERNAL_OBJECTS
      do
         !!tmp.make(colors)
         gdk_colormap_free_colors  (to_external, tmp.to_external, ncolors);
      end
   get_visual : GDK_VISUAL is
      do
         !!Result.from_external(gdk_colormap_get_visual  (to_external));
      end

end -- class GDK_COLORMAP
