indexing
    title       : "GTK ";
    cluster     : "VEGDK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gdk_color.e,v 1.6 2000/03/16 14:03:51 eugenem Exp $";

class GDK_COLOR
inherit
   ANY
      redefine
         is_equal
      end
   GDK_COLOR_NP
      undefine
         is_equal
      end
   GDK_COLOR_EXTERNALS
      undefine
         is_equal
      end
   GDK_OBJECT
      undefine
         is_equal
      end
--   MEMORY
--      undefine
--         is_equal
--      redefine
--         dispose
--      end
creation
   from_external, make, make_with_values

feature -- creation
   make is
      do
         from_external(default_pointer)
--         made_in_eiffel := false
      end
   make_with_values (arg_red : INTEGER; arg_green : INTEGER; arg_blue : INTEGER) is
      do
         from_external(gdk_color_new_with_values  (arg_red, arg_green, arg_blue))
--         made_in_eiffel := true
      end
--   dispose is
--      do
--         if made_in_eiffel then
--            gdk_color_dispose(to_external)
--         end
--      end

feature -- operations

   pixel : INTEGER is
      do
         Result:= gdk_color_pixel_acr  (to_external);
      end
   red : INTEGER is
      do
         Result:= gdk_color_red_acr  (to_external);
      end
   green : INTEGER is
      do
         Result:= gdk_color_green_acr  (to_external);
      end
   blue : INTEGER is
      do
         Result:= gdk_color_blue_acr  (to_external);
      end
   set_pixel (arg_pixel : INTEGER) is
      do
         gdk_color_set_pixel_acw  (to_external, arg_pixel);
      end
   set_red (arg_red : INTEGER) is
      do
         gdk_color_set_red_acw  (to_external, arg_red);
      end
   set_green (arg_green : INTEGER) is
      do
         gdk_color_set_green_acw  (to_external, arg_green);
      end
   set_blue (arg_blue : INTEGER) is
      do
         gdk_color_set_blue_acw  (to_external, arg_blue);
      end
   makecopy : GDK_COLOR is
      do
         !!Result.from_external(gdk_color_makecopy  (to_external));
      end
   free is
      do
         gdk_color_free  (to_external);
      end
   parse (spec : STRING) : INTEGER is
      do
         Result:= np_gdk_color_parse  (to_external, spec);
      end
   hash : INTEGER is
      do
         Result:= gdk_color_hash  (to_external);
      end
   is_equal (colorb : like current) : BOOLEAN is
      do
         Result:= gdk_color_isequal  (to_external, colorb.to_external);
      end

--feature {NONE} -- Implementations

--   made_in_eiffel : BOOLEAN

end -- class GDK_COLOR
