deferred class GTK_ENUM
inherit
   ANY
      redefine
         is_equal
      end

feature -- Comparsion

   is_equal(other : like current) : BOOLEAN is
      do
    result := value = other.value
      end

feature -- Access

   make, set_value(new_value : INTEGER) is
      require
         new_value >= min_value
         new_value < max_value
      do
         value := new_value
      end

   get_value : INTEGER is
      do
         Result := value
      end

feature {GTK_ENUM} -- private

   value : INTEGER

feature

   min_value : INTEGER is
      deferred
      end

   max_value : INTEGER is
      deferred
      end

invariant

   value >= min_value
   value < max_value

end -- class GTK_ENUM
