indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: g_node.e,v 1.7 2000/03/16 14:03:51 eugenem Exp $";

class G_NODE
inherit
   VEGTK_EXTERNAL_OBJECT
   end
creation
   make, from_external

feature -- creation

   make(arg_data : ANY) is
      do
         from_external(c_g_node_new (arg_data))
      end

feature -- access

   data : ANY is
      do
         Result := g_node_data_acr(to_external)
      end

   set_data (new_data : ANY) is
      do
         g_node_data_acw(to_external, new_data)
      end

feature -- operations

   destroy is
      do
         g_node_wean_data(to_external);
         g_node_destroy (to_external);
      end

   unlink is
      do
         g_node_unlink(to_external)
      end

   insert(position : INTEGER; node : G_NODE) is
      do
         from_external(g_node_insert(to_external, position, node.to_external))
      end

   insert_before(sibling : G_NODE; node : G_NODE) is
      do
         from_external(g_node_insert_before(to_external, sibling.to_external, node.to_external))
      end

   prepend(node : G_NODE) is
      do
         from_external(g_node_prepend(to_external, node.to_external))
      end

   n_nodes(flags : INTEGER) : INTEGER is
      do
         Result := g_node_n_nodes(to_external, flags)
      end

   get_root : G_NODE is
      do
         !!Result.from_external(g_node_get_root (to_external))
      end

   is_ancestor(descendant : G_NODE) : BOOLEAN is
      do
         Result := g_node_is_ancestor(to_external, descendant.to_external)
      end

   depth : INTEGER is
      do
         Result := g_node_depth(to_external)
      end

   find(order : INTEGER; flags : INTEGER; arg_data : POINTER) : G_NODE is
      do
         !!Result.from_external(g_node_find(to_external, order, flags, arg_data))
      end

feature {NONE} -- C externals

   g_node_wean_data (node : POINTER) is
      -- calls eif_wean(gnode->data). Any better ideas?
      external "C"
      alias "c_g_node_wean_data"
      end

   g_node_data_acw (node : POINTER; new_data : ANY) is
      external "C"
      alias "g_node_data_acw"
      end
   g_node_data_acr(node : POINTER) : ANY is
      external "C"
      alias "g_node_data_acr"
      end
   c_g_node_new(arg_data : ANY) : POINTER is
      external "C"
      alias "c_g_node_new"
      end
   g_node_destroy(root : POINTER) is
      external "C"
      alias "g_node_destroy"
      end
   g_node_unlink(node : POINTER) is
      external "C"
      alias "g_node_unlink"
      end
   g_node_insert(parent : POINTER; position : INTEGER; node : POINTER) : POINTER is
      external "C"
      alias "g_node_insert"
      end
   g_node_insert_before(parent : POINTER; sibling : POINTER; node : POINTER) : POINTER is
      external "C"
      alias "g_node_insert_before"
      end
   g_node_prepend(parent : POINTER; node : POINTER) : POINTER is
      external "C"
      alias "g_node_prepend"
      end
   g_node_n_nodes(root : POINTER; flags : INTEGER) : INTEGER is
      external "C"
      alias "g_node_n_nodes"
      end
   g_node_get_root(node : POINTER) : POINTER is
      external "C"
      alias "g_node_get_root"
      end
   g_node_is_ancestor(node: POINTER; descendant : POINTER) : BOOLEAN is
      external "C"
      alias "g_node_is_ancestor"
      end
   g_node_depth(node : POINTER) : INTEGER is
      external "C"
      alias "g_node_depth"
      end
   g_node_find(root : POINTER; order : INTEGER; flags : INTEGER; arg_data : POINTER) : POINTER is
      external "C"
      alias "g_node_find"
      end

end -- class G_NODE
