indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: g_slist.e,v 1.6 2000/03/20 07:54:45 eugenem Exp $";

class G_SLIST
inherit
   VEGTK_EXTERNAL_OBJECT
creation
   from_external, make

feature -- operations

   make is
      do
         from_external(default_pointer)
      end

--   push_allocator (allocator : GALLOCATOR) is
--      do
--         g_slist_push_allocator  (allocator);
--      end
--   pop_allocator is
--      do
--         g_slist_pop_allocator;
--      end
   alloc is
      do
         from_external(g_slist_alloc)
      end
   free is
      do
         g_slist_free  (to_external);
      end
   free_1 is
      do
         g_slist_free_1  (to_external);
      end
   append (data : POINTER) is
      do
         from_external(g_slist_append  (to_external, data))
      end
   prepend (data : POINTER) is
      do
         from_external(g_slist_prepend  (to_external, data))
      end
   insert (data : POINTER; arg_position : INTEGER) is
      do
         from_external(g_slist_insert  (to_external, data, arg_position))
      end
--   insert_sorted (data : POINTER; func : GCOMPARE_FUNC) : G_SLIST is
--      do
--         Result:= g_slist_insert_sorted  (to_external, data, func);
--      end
   concat (list2 : G_SLIST) is
      do
         from_external(g_slist_concat(to_external, list2.to_external))
      end
   remove (data : POINTER) is
      do
         from_external(g_slist_remove  (to_external, data))
      end
   remove_link (llink : G_SLIST) is
      do
         from_external(g_slist_remove_link  (to_external, llink.to_external))
      end
   reverse is
      do
         from_external(g_slist_reverse  (to_external))
      end
   make_copy : G_SLIST is
      do
         !!Result.from_external(g_slist_copy  (to_external));
      end
   nth (n : INTEGER) : G_SLIST is
      do
         !!Result.from_external(g_slist_nth  (to_external, n));
      end
   find (data : POINTER) : G_SLIST is
      do
         !!Result.from_external(g_slist_find  (to_external, data));
      end
--   find_custom (data : POINTER; func : GCOMPARE_FUNC) : G_SLIST is
--      do
--         Result:= g_slist_find_custom  (to_external, data, func);
--      end
   position (llink : G_SLIST) : INTEGER is
      do
         Result:= g_slist_position  (to_external, llink.to_external);
      end
   index (data : POINTER) : INTEGER is
      do
         Result:= g_slist_index  (to_external, data);
      end
   last : G_SLIST is
      do
         !!Result.from_external(g_slist_last  (to_external));
      end
   length : INTEGER is
      do
         Result:= g_slist_length  (to_external);
      end
--   foreach (func : GFUNC; user_data : POINTER) is
--      do
--         g_slist_foreach  (to_external, func, user_data);
--      end
--   sort (compare_func : GCOMPARE_FUNC) : G_SLIST is
--      do
--         Result:= g_slist_sort  (to_external, compare_func);
--      end
   nth_data (n : INTEGER) : POINTER is
      do
         Result:= g_slist_nth_data  (to_external, n);
      end

feature {NONE} -- external C features

--   g_slist_push_allocator (allocator : GALLOCATOR) is
--      external "C"
--      alias "g_slist_push_allocator"
--      end
--   g_slist_pop_allocator is
--      external "C"
--      alias "g_slist_pop_allocator"
--      end
   g_slist_alloc : POINTER is
      external "C"
      alias "g_slist_alloc"
      end
   g_slist_free (alist : POINTER) is
      external "C"
      alias "g_slist_free"
      end
   g_slist_free_1 (alist : POINTER) is
      external "C"
      alias "g_slist_free_1"
      end
   g_slist_append (alist : POINTER; data : POINTER) : POINTER is
      external "C"
      alias "g_slist_append"
      end
   g_slist_prepend (alist : POINTER; data : POINTER) : POINTER is
      external "C"
      alias "g_slist_prepend"
      end
   g_slist_insert (alist : POINTER; data : POINTER; arg_position : INTEGER) : POINTER is
      external "C"
      alias "g_slist_insert"
      end
--   g_slist_insert_sorted (list : POINTER; data : POINTER; func : GCOMPARE_FUNC) : G_SLIST is
--      external "C"
--      alias "g_slist_insert_sorted"
--      end
   g_slist_concat (list1 : POINTER; list2 : POINTER) : POINTER is
      external "C"
      alias "g_slist_concat"
      end
   g_slist_remove (alist : POINTER; data : POINTER) : POINTER is
      external "C"
      alias "g_slist_remove"
      end
   g_slist_remove_link (alist : POINTER; llink : POINTER) : POINTER is
      external "C"
      alias "g_slist_remove_link"
      end
   g_slist_reverse (alist : POINTER) : POINTER is
      external "C"
      alias "g_slist_reverse"
      end
   g_slist_copy (alist : POINTER) : POINTER is
      external "C"
      alias "g_slist_copy"
      end
   g_slist_nth (alist : POINTER; n : INTEGER) : POINTER is
      external "C"
      alias "g_slist_nth"
      end
   g_slist_find (alist : POINTER; data : POINTER) : POINTER is
      external "C"
      alias "g_slist_find"
      end
--   g_slist_find_custom (list : POINTER; data : POINTER; func : GCOMPARE_FUNC) : G_SLIST is
--      external "C"
--      alias "g_slist_find_custom"
--      end
   g_slist_position (alist : POINTER; llink : POINTER) : INTEGER is
      external "C"
      alias "g_slist_position"
      end
   g_slist_index (alist : POINTER; data : POINTER) : INTEGER is
      external "C"
      alias "g_slist_index"
      end
   g_slist_last (alist : POINTER) : POINTER is
      external "C"
      alias "g_slist_last"
      end
   g_slist_length (alist : POINTER) : INTEGER is
      external "C"
      alias "g_slist_length"
      end
--   g_slist_foreach (list : POINTER; func : GFUNC; user_data : POINTER) is
--      external "C"
--      alias "g_slist_foreach"
--      end
--   g_slist_sort (list : POINTER; compare_func : GCOMPARE_FUNC) : G_SLIST is
--      external "C"
--      alias "g_slist_sort"
--      end
   g_slist_nth_data (alist : POINTER; n : INTEGER) : POINTER is
      external "C"
      alias "g_slist_nth_data"
      end
end -- class G_SLIST
