indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_accel_group.e,v 1.5 2000/03/16 14:03:51 eugenem Exp $";

class GTK_ACCEL_GROUP
inherit
   GTK_ACCEL_GROUP_NP
   GTK_ACCEL_GROUP_EXTERNALS
   VEGTK_EXTERNAL_OBJECT
creation
   from_external, make
feature -- creation
   make is
      do
         from_external(gtk_accel_group_new)
      end

feature -- operations

   get_default : GTK_ACCEL_GROUP is
      do
         !!Result.from_external(gtk_accel_group_get_default);
      end
   ref : GTK_ACCEL_GROUP is
      do
         !!Result.from_external(gtk_accel_group_ref  (to_external));
      end
   unref is
      do
         gtk_accel_group_unref  (to_external);
      end
   activate (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE) : BOOLEAN is
      do
         Result:= gtk_accel_group_activate  (to_external, accel_key, accel_mods.get_value);
      end
   attach (object : GTK_OBJECT) is
      do
         gtk_accel_group_attach  (to_external, object.to_external);
      end
   detach (object : GTK_OBJECT) is
      do
         gtk_accel_group_detach  (to_external, object.to_external);
      end
   lock is
      do
         gtk_accel_group_lock  (to_external);
      end
   unlock is
      do
         gtk_accel_group_unlock  (to_external);
      end
   get_entry (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE) : GTK_ACCEL_ENTRY is
      do
         !!Result.from_external(gtk_accel_group_get_entry  (to_external, accel_key, accel_mods.get_value));
      end
   lock_entry (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE) is
      do
         gtk_accel_group_lock_entry  (to_external, accel_key, accel_mods.get_value);
      end
   unlock_entry (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE) is
      do
         gtk_accel_group_unlock_entry  (to_external, accel_key, accel_mods.get_value);
      end
   add (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE; accel_flags : GTK_ACCEL_FLAGS; object : GTK_OBJECT; accel_signal : STRING) is
      do
         np_gtk_accel_group_add  (to_external, accel_key, accel_mods.get_value, accel_flags.get_value, object.to_external, accel_signal);
      end
   remove (accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE; object : GTK_OBJECT) is
      do
         gtk_accel_group_remove  (to_external, accel_key, accel_mods.get_value, object.to_external);
      end
   handle_add (object : GTK_OBJECT; accel_signal_id : INTEGER; accel_group : GTK_ACCEL_GROUP; accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE; accel_flags : GTK_ACCEL_FLAGS) is
      do
         gtk_accel_group_handle_add  (object.to_external, accel_signal_id, accel_group.to_external, accel_key, accel_mods.get_value, accel_flags.get_value);
      end
   handle_remove (object : GTK_OBJECT; accel_group : GTK_ACCEL_GROUP; accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE) is
      do
         gtk_accel_group_handle_remove  (object.to_external, accel_group.to_external, accel_key, accel_mods.get_value);
      end
   create_add (class_type : GTK_TYPE; signal_flags : GTK_SIGNAL_RUN_TYPE; handler_offset : INTEGER) : INTEGER is
      do
         Result:= gtk_accel_group_create_add  (class_type.to_external, signal_flags.get_value, handler_offset);
      end
   create_remove (class_type : GTK_TYPE; signal_flags : GTK_SIGNAL_RUN_TYPE; handler_offset : INTEGER) : INTEGER is
      do
         Result:= gtk_accel_group_create_remove  (class_type.to_external, signal_flags.get_value, handler_offset);
      end
--   entries_from_object (object : GTK_OBJECT) : G_SLIST is
--      do
--         !!Result.from_external(gtk_accel_group_entries_from_object  (object.to_external));
--      end

end -- class GTK_ACCEL_GROUP
