indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_adjustment.e,v 1.5 2000/03/16 14:03:51 eugenem Exp $";

class GTK_ADJUSTMENT
inherit
   GTK_ADJUSTMENT_NP
   GTK_ADJUSTMENT_EXTERNALS
   GTK_DATA
      redefine
         make_for_register
      end
creation
   from_external, make
feature -- creation
   make (arg_value : REAL; arg_lower : REAL; arg_upper : REAL; arg_step_increment : REAL; arg_page_increment : REAL; arg_page_size : REAL) is
      do
         from_external(
            np_gtk_adjustment_new  (arg_value, arg_lower, arg_upper, arg_step_increment,
                                     arg_page_increment,arg_page_size))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_adjustment_get_type)
      end

feature -- queries

   lower : REAL is
      do
         Result:= gtk_adjustment_lower_acr  (to_external);
      end
   upper : REAL is
      do
         Result:= gtk_adjustment_upper_acr  (to_external);
      end
   value : REAL is
      do
         Result:= gtk_adjustment_value_acr  (to_external);
      end
   step_increment : REAL is
      do
         Result:= gtk_adjustment_step_increment_acr  (to_external);
      end
   page_increment : REAL is
      do
         Result:= gtk_adjustment_page_increment_acr  (to_external);
      end
   page_size : REAL is
      do
         Result:= gtk_adjustment_page_size_acr  (to_external);
      end
feature -- Actions
   changed is
      do
         gtk_adjustment_changed  (to_external);
      end
   value_changed is
      do
         gtk_adjustment_value_changed  (to_external);
      end
   clamp_page (arg_lower : REAL; arg_upper : REAL) is
      do
         np_gtk_adjustment_clamp_page  (to_external, arg_lower, arg_upper);
      end
   set_value (arg_value : REAL) is
      do
         np_gtk_adjustment_set_value  (to_external, arg_value);
      end
   set_lower  (arg_lower : REAL) is
      do
         gtk_adjustment_lower_acw  (to_external,arg_lower);
      end
   set_upper  (arg_upper : REAL) is
      do
         gtk_adjustment_upper_acw  (to_external, arg_upper);
      end
   set_step_increment (arg_step_increment : REAL) is
      do
         gtk_adjustment_step_increment_acw  (to_external, arg_step_increment);
      end
   set_page_increment (arg_page_increment : REAL) is
      do
         gtk_adjustment_page_increment_acw  (to_external, arg_page_increment);
      end
   set_page_size (arg_page_size : REAL) is
      do
         gtk_adjustment_page_size_acw  (to_external, arg_page_size);
      end

end -- class GTK_ADJUSTMENT
