class GTK_CELL_FACTORY
inherit
   GTK_CONSTANTS

feature

   make_cell_from_pointer (p : POINTER) : GTK_CELL is
      local
         c: GTK_CELL
      do
         !!c.from_external (p)
         if c.type.is_equal(Gtk_cell_empty) then
            Result := c
         else
            if c.type.is_equal(Gtk_cell_text) then
               !GTK_CELL_TEXT!Result.from_external(c.to_external)
            else
               if c.type.is_equal(Gtk_cell_pixmap) then
                  !GTK_CELL_PIXMAP!Result.from_external(c.to_external)
               else
                  if c.type.is_equal(Gtk_cell_pixtext) then
                     !GTK_CELL_PIXTEXT!Result.from_external(c.to_external)
                  else
                     !GTK_CELL_WIDGET!Result.from_external(c.to_external)
                  end -- if
               end -- if
            end -- if
         end -- if
      end -- make_cell_from_pointer

feature {NONE} -- private

   make_cells_from_pointers (pointers : ARRAY[POINTER]) : ARRAY[GTK_CELL] is
      local
         i : INTEGER
         item : GTK_CELL
      do
         !!Result.make(1,pointers.count)
         from
            i := pointers.lower
         until
            i > pointers.upper
         loop
            Result.put(make_cell_from_pointer(pointers.item(i))
, i)
            i := i+1
         end -- loop
      end -- pointers_to_widgets

end -- class GTK_CELL_FACTORY
