indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_command_type.e,v 1.4 2000/03/13 18:19:52 eugenem Exp $";

class GTK_COMMAND_TYPE

inherit
   VEGTK_CALLBACK_HANDLER

feature {GTK_OBJECT}

--        entry_from_gtk (argc: INTEGER; argp: POINTER) is
                        -- this routine is called from the C code when signals or
                        -- events occur
--                do
                        -- retrieve any arguments passed to this callback
--                        if (argc /= 0) and not skip_arguments then
--                                fetch_callback_arguments (argc, argp)
--                        end
                        -- process the callback
--                        execute
--                end

--    skip_arguments: BOOLEAN
          -- if set to true, the arguments from callback will be
          -- ignored. Set to False by default

--    fetch_callback_arguments (argc: INTEGER; argp: POINTER) is
          -- redefine in descendant as needed depending on type of
          -- callback
--       do
--       end

    connect (new_event: STRING; new_parent: like parent) is
          -- connect command to a widget event
       require
          event_valid: new_event /= Void
          parent_valid: new_parent /= Void
       do
          event_name := new_event
          parent := new_parent
          signal_connect (parent, event_name, $execute)
          gtk_command_id := last_signal_id
       ensure
          parent /= Void
       end


    disconnect is
          -- remove the command from the widget
       require
          parent_not_void: parent /= Void
       do
          signal_disconnect (parent, gtk_command_id)
          parent := Void
       end

feature

    parent: GTK_OBJECT
          -- object to which we are connected

    event_name: STRING
          -- name of event we're connected to

    execute (data : ANY; cb_data : VEGTK_CALLBACK_DATA) is
          -- handle callback
       do
       end

feature {NONE}

    gtk_command_id: INTEGER
          -- ID of this handler

end -- class GTK_COMMAND_TYPE
