indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_file_selection.e,v 1.6 2000/03/16 14:03:51 eugenem Exp $";

class GTK_FILE_SELECTION
inherit
   GTK_FILE_SELECTION_NP
   GTK_FILE_SELECTION_EXTERNALS
   GTK_WINDOW
      rename
        make as make_window
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (title : STRING) is
      do
         from_external(np_gtk_file_selection_new  (title))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_file_selection_get_type)
      end

feature -- access

   ok_button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_file_selection_ok_button_acr (to_external))
      end

   cancel_button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_file_selection_cancel_button_acr (to_external))
      end

   action_area : GTK_BOX is
      do
         !!Result.from_external(gtk_file_selection_action_area_acr (to_external))
      end

feature -- operations

   set_filename (filename : STRING) is
      do
         np_gtk_file_selection_set_filename  (to_external, filename);
      end
   get_filename : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external(gtk_file_selection_get_filename  (to_external))
      end
   show_fileop_buttons is
      do
         gtk_file_selection_show_fileop_buttons  (to_external);
      end
   hide_fileop_buttons is
      do
         gtk_file_selection_hide_fileop_buttons  (to_external);
      end

end -- class GTK_FILE_SELECTION
