indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_font_selection_dialog.e,v 1.6 2000/03/16 14:03:51 eugenem Exp $";

class GTK_FONT_SELECTION_DIALOG
inherit
   GTK_FONT_SELECTION_DIALOG_NP
   GTK_FONT_SELECTION_DIALOG_EXTERNALS
   GTK_WINDOW
      rename
         make as make_window
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (title : STRING) is
      do
         from_external(np_gtk_font_selection_dialog_new  (title))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_font_selection_dialog_get_type)
      end

feature -- access

   fontsel : GTK_FONT_SELECTION is
      do
         !!Result.from_external(gtk_font_selection_dialog_fontsel_acr(to_external))
      end

   main_vbox : GTK_VBOX is
      do
         !!Result.from_external(gtk_font_selection_dialog_main_vbox_acr(to_external))
      end

   ok_button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_font_selection_dialog_ok_button_acr(to_external))
      end

   cancel_button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_font_selection_dialog_cancel_button_acr(to_external))
      end

   apply_button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_font_selection_dialog_apply_button_acr(to_external))
      end

feature -- operations

   get_font_name : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external_with_free (gtk_font_selection_dialog_get_font_name  (to_external))
      end
   get_font : GDK_FONT is
      do
         !!Result.from_external(gtk_font_selection_dialog_get_font  (to_external));
      end
   set_font_name (fontname : STRING) : BOOLEAN is
      do
         Result:= np_gtk_font_selection_dialog_set_font_name  (to_external, fontname);
      end
   set_filter (filter_type : GTK_FONT_FILTER_TYPE; font_type : GTK_FONT_TYPE; foundries : POINTER; weights : POINTER; slants : POINTER; setwidths : POINTER; spacings : POINTER; charsets : POINTER) is
      do
         gtk_font_selection_dialog_set_filter  (to_external, filter_type.get_value, font_type.get_value, foundries, weights, slants, setwidths, spacings, charsets);
      end
   get_preview_text : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external(gtk_font_selection_dialog_get_preview_text  (to_external))
      end
   set_preview_text (text : STRING) is
      do
         np_gtk_font_selection_dialog_set_preview_text  (to_external, text);
      end

end -- class GTK_FONT_SELECTION_DIALOG
