indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_layout.e,v 1.5 2000/03/16 14:03:52 eugenem Exp $";

class GTK_LAYOUT
inherit
   GTK_LAYOUT_EXTERNALS
   GTK_CONTAINER
creation
   from_external, make
feature -- creation
   make (hadjustment : GTK_ADJUSTMENT; vadjustment : GTK_ADJUSTMENT) is
      do
         from_external(gtk_layout_new  (to_external_with_check(hadjustment), to_external_with_check(vadjustment)))
      end

feature -- operations

   put (widget : GTK_WIDGET; x : INTEGER; y : INTEGER) is
      do
         gtk_layout_put  (to_external, widget.to_external, x, y);
      end
   move (widget : GTK_WIDGET; x : INTEGER; y : INTEGER) is
      do
         gtk_layout_move  (to_external, widget.to_external, x, y);
      end
   set_size (width : INTEGER; height : INTEGER) is
      do
         gtk_layout_set_size  (to_external, width, height);
      end
   get_hadjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_layout_get_hadjustment  (to_external));
      end
   get_vadjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_layout_get_vadjustment  (to_external));
      end
   set_hadjustment (adjustment : GTK_ADJUSTMENT) is
      do
         gtk_layout_set_hadjustment  (to_external, adjustment.to_external);
      end
   set_vadjustment (adjustment : GTK_ADJUSTMENT) is
      do
         gtk_layout_set_vadjustment  (to_external, adjustment.to_external);
      end
   freeze is
      do
         gtk_layout_freeze  (to_external);
      end
   thaw is
      do
         gtk_layout_thaw  (to_external);
      end

end -- class GTK_LAYOUT
