indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_radio_button.e,v 1.5 2000/03/13 18:19:52 eugenem Exp $";

class GTK_RADIO_BUTTON
inherit
   GTK_RADIO_BUTTON_NP
   GTK_RADIO_BUTTON_EXTERNALS
   GTK_CHECK_BUTTON
      rename
         make as make_check_button,
         make_with_label as make_with_label_check_button
      redefine
         make_for_register
      end
creation
   from_external, make, make_with_label, make_with_label_from_widget,
   make_alone, make_alone_with_label, make_for_register
feature -- creation
   make (arg_group : G_SLIST) is
      do
         from_external(gtk_radio_button_new  (to_external_with_check(arg_group)));
      end
   make_with_label (arg_group : G_SLIST; label : STRING) is
      do
         from_external(np_gtk_radio_button_new_with_label  (to_external_with_check(arg_group), label))
      end
   make_with_label_from_widget (arg_group : GTK_RADIO_BUTTON; label : STRING) is
      do
         from_external(np_gtk_radio_button_new_with_label_from_widget  (arg_group.to_external, label));
      end
   make_alone is
      do
         from_external(gtk_radio_button_new (default_pointer));
      end
   make_alone_with_label (label : STRING) is
      do
         from_external(np_gtk_radio_button_new_with_label_from_widget  (default_pointer, label));
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_radio_button_get_type)
      end

feature -- operations

   new_from_widget : GTK_WIDGET is
      do
         !!Result.from_external(gtk_radio_button_new_from_widget  (to_external));
      end
   group : G_SLIST is
      do
         !!Result.from_external(gtk_radio_button_group  (to_external));
      end
   set_group (arg_group : G_SLIST) is
      do
         gtk_radio_button_set_group  (to_external, arg_group.to_external);
      end

end -- class GTK_RADIO_BUTTON
