indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_rc.e,v 1.5 2000/03/13 18:19:52 eugenem Exp $";

class GTK_RC
inherit
   GTK_RC_NP
   GTK_RC_EXTERNALS
feature -- operations

   init is
   do
      gtk_rc_init;
   end

   parse (filename : STRING) is
   do
      np_gtk_rc_parse (filename);
   end

   add_default_file (filename : STRING) is
   do
      np_gtk_rc_add_default_file (filename);
   end

   set_default_files (filenames : ARRAY[STRING]) is
   local
      tmp : VEGTK_EXTERNAL_STRINGS
   do
      !!tmp.make(filenames);
      gtk_rc_set_default_files (tmp.to_external);
   end

   parse_string (rc_string : STRING) is
   do
      np_gtk_rc_parse_string (rc_string);
   end

   reparse_all: BOOLEAN is
   do
      Result := gtk_rc_reparse_all;
   end

   add_widget_name_style (rc_style : GTK_RC_STYLE; pattern : STRING) is
   do
      np_gtk_rc_add_widget_name_style (rc_style.to_external, pattern);
   end

   add_widget_class_style (rc_style : GTK_RC_STYLE; pattern : STRING) is
   do
      np_gtk_rc_add_widget_class_style (rc_style.to_external, pattern);
   end

   add_class_style (rc_style : GTK_RC_STYLE; pattern : STRING) is
   do
      np_gtk_rc_add_class_style (rc_style.to_external, pattern);
   end

   set_image_loader (loader : POINTER) is
   do
      gtk_rc_set_image_loader (loader);
   end

feature -- Queries

   get_default_files : ARRAY[STRING] is
--   local
--      tmp : VEGTK_EXTERNAL_STRINGS;
   do
--      !!tmp.from_external(gtk_rc_get_default_files);
--      Result := tmp.get_strings;
   end

   get_style (widget: GTK_WIDGET): GTK_RC_STYLE is
   do
      !!Result.from_external(gtk_rc_get_style(widget.to_external));
   end


   load_image (colourmap : GDK_COLORMAP; transparent_colour : GDK_COLOR;
               filename: STRING): GDK_PIXMAP is
   do
      !!Result.from_external (np_gtk_rc_load_image (colourmap.to_external,
                                                    transparent_colour.to_external,
                                                    filename));
   end
--   rc_find_pixmap_in_path (scanner : G_SCANNER, pixmap_file: STRING): STRING is
--   do
--      Result := np_gtk_rc_find_pixmap_in_path (scanner.to_external, pixmap_file);
--   end

   find_module_in_path (module_file: STRING): STRING is
   local
      sh : VEGTK_STRING_HELPER
   do
      !!sh
      Result := sh.string_from_external (np_gtk_rc_find_module_in_path (module_file));
   end
   get_theme_dir: STRING is
   local
      sh : VEGTK_STRING_HELPER
   do
      !!sh
      Result := sh.string_from_external (gtk_rc_get_theme_dir);
   end
   get_module_dir: STRING is
   local
      sh : VEGTK_STRING_HELPER
   do
      !!sh
      Result := sh.string_from_external (gtk_rc_get_module_dir);
   end
end -- class GTK_RC

