indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_scrolled_window.e,v 1.5 2000/03/16 14:03:52 eugenem Exp $";

class GTK_SCROLLED_WINDOW
inherit
   GTK_SCROLLED_WINDOW_EXTERNALS
   GTK_CONTAINER
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (hadjustment : GTK_ADJUSTMENT; vadjustment : GTK_ADJUSTMENT) is
      do
         from_external(gtk_scrolled_window_new  (
            to_external_with_check(hadjustment),
            to_external_with_check(vadjustment)))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_scrolled_window_get_type)
      end

feature -- operations

   set_hadjustment (hadjustment : GTK_ADJUSTMENT) is
      do
         gtk_scrolled_window_set_hadjustment  (to_external, hadjustment.to_external);
      end
   set_vadjustment (hadjustment : GTK_ADJUSTMENT) is
      do
         gtk_scrolled_window_set_vadjustment  (to_external, hadjustment.to_external);
      end
   add_with_viewport (child : GTK_WIDGET) is
      do
         gtk_scrolled_window_add_with_viewport  (to_external, child.to_external);
      end
   get_hadjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_scrolled_window_get_hadjustment  (to_external));
      end
   get_vadjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_scrolled_window_get_vadjustment  (to_external));
      end
   set_policy (hscrollbar_policy : GTK_POLICY_TYPE; vscrollbar_policy : GTK_POLICY_TYPE) is
      do
         gtk_scrolled_window_set_policy  (to_external, hscrollbar_policy.get_value, vscrollbar_policy.get_value);
      end
   set_placement (window_placement : GTK_CORNER_TYPE) is
      do
         gtk_scrolled_window_set_placement  (to_external, window_placement.get_value);
      end

end -- class GTK_SCROLLED_WINDOW
