indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_target_entry.e,v 1.6 2000/03/16 14:03:52 eugenem Exp $";

class GTK_TARGET_ENTRY
inherit
   GTK_TARGET_ENTRY_NP
   GTK_TARGET_ENTRY_EXTERNALS
   VEGTK_EXTERNAL_OBJECT

creation
   from_external, make

feature -- Creation

   make(arg_target : STRING; arg_flags, arg_info : INTEGER) is
      do
         from_external(np_gtk_target_entry_new(arg_target, arg_flags, arg_info))
      end -- make

feature -- Queries

   target : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external (gtk_target_entry_target_acr(to_external))
      end -- target

   flags : INTEGER is
      do
         Result := gtk_target_entry_flags_acr(to_external)
      end -- flags

   info : INTEGER is
      do
         Result := gtk_target_entry_info_acr(to_external)
      end -- info

feature -- Operations

   set_target(arg_target : STRING) is
      do
         np_gtk_target_entry_target_acw(to_external, arg_target)
      end -- set_target

   set_flags(arg_flags : INTEGER) is
      do
         gtk_target_entry_flags_acw(to_external, arg_flags)
      end -- set_flags

   set_info(arg_info : INTEGER) is
      do
         gtk_target_entry_info_acw(to_external, arg_info)
      end -- set_info

end -- class GTK_TARGET_ENTRY
