indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_timeout.e,v 1.4 2000/03/13 18:19:52 eugenem Exp $";

class GTK_TIMEOUT
inherit
   GTK_TIMEOUT_EXTERNALS
creation
   make

feature -- Creation

   make, configure(arg_interval : INTEGER; arg_object : ANY; arg_func : POINTER; arg_data : ANY) is
      do
         interval := arg_interval
         function := arg_func
         object := arg_object
         data := arg_data
      end

feature {ANY} -- Operations

   start is
      do
         timeout_id := c_gtk_timeout_add(interval, object, function, data)
      end

   stop is
      do
         if timeout_id>0 then
            gtk_timeout_remove(timeout_id)
            timeout_id := 0
         end
      end

feature {ANY} -- Queries

   interval : INTEGER

   object : ANY            -- callback object
   function : POINTER      -- callback routine

   data : ANY              -- callback data

   is_on : BOOLEAN is
      do
         if timeout_id>0 then
            Result := true
         else
            Result := false
         end
      end

feature {NONE} -- Implementation

   timeout_id : INTEGER

end -- class GTK_TIMEOUT
