indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_tree_item.e,v 1.5 2000/03/16 14:03:52 eugenem Exp $";

class GTK_TREE_ITEM
inherit
   GTK_TREE_ITEM_NP
   GTK_TREE_ITEM_EXTERNALS
   GTK_ITEM
      rename
         do_select as do_select_item,
         deselect as deselect_item
      redefine
         make_for_register
      end
creation
   from_external, make, make_with_label, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_tree_item_new)
      end
   make_with_label (label : STRING) is
      do
         from_external(np_gtk_tree_item_new_with_label  (label))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_tree_item_get_type)
      end

feature -- access

   subtree : GTK_TREE is
      local
         tmp : POINTER
      do
         tmp := gtk_tree_item_subtree_acr(to_external)
         if tmp /= default_pointer then
            !!Result.from_external(tmp)
         end
      end

feature -- operations

   set_subtree (arg_subtree : GTK_WIDGET) is
      do
         gtk_tree_item_set_subtree  (to_external, arg_subtree.to_external);
      end
   remove_subtree is
      do
         gtk_tree_item_remove_subtree  (to_external);
      end
   do_select is
      do
         gtk_tree_item_select  (to_external);
      end
   deselect is
      do
         gtk_tree_item_deselect  (to_external);
      end
   expand is
      do
         gtk_tree_item_expand  (to_external);
      end
   collapse is
      do
         gtk_tree_item_collapse  (to_external);
      end

end -- class GTK_TREE_ITEM
