indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_container.e,v 1.6 2000/03/16 14:03:54 eugenem Exp $";

class GTK_CONTAINER
inherit
   GTK_CONTAINER_EXTERNALS
   GTK_WIDGET
      redefine
         make_for_register
      end
creation
   from_external

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_container_get_type)
      end

feature -- access

   focus_child : GTK_WIDGET is
      do
         Result ?= object_factory.make_object_from_pointer(gtk_container_focus_child_acr (to_external));
      end

   border_width : INTEGER is
      do
         Result := gtk_container_border_width_acr(to_external)
      end

   need_resize : INTEGER is
      do
         Result := gtk_container_need_resize_acr(to_external)
      end

   resize_mode : INTEGER is
      do
         Result := gtk_container_resize_mode_acr(to_external)
      end

feature -- operations

   set_border_width (arg_border_width : INTEGER) is
      do
         gtk_container_set_border_width  (to_external, arg_border_width);
      end
   add (widget : GTK_WIDGET) is
      do
         gtk_container_add  (to_external, widget.to_external);
      end
   remove (widget : GTK_WIDGET) is
      do
         gtk_container_remove  (to_external, widget.to_external);
      end
   set_resize_mode (arg_resize_mode : GTK_RESIZE_MODE) is
      do
         gtk_container_set_resize_mode  (to_external, arg_resize_mode.get_value);
      end
   check_resize is
      do
         gtk_container_check_resize  (to_external);
      end

   children_array : ARRAY [GTK_WIDGET] is
      local
         tmp_list : G_LIST_OF_GTK_WIDGET;
      do
         !!tmp_list.from_external (gtk_container_children (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end -- children_array

   children_list : G_LIST [GTK_WIDGET] is
      do
         !G_LIST_OF_GTK_WIDGET!
            Result.from_external (gtk_container_children (to_external));
      end -- children_list

   focus (direction : GTK_DIRECTION_TYPE) : INTEGER is
      do
         Result:= gtk_container_focus  (to_external, direction);
      end
   set_focus_child (child : GTK_WIDGET) is
      do
         gtk_container_set_focus_child  (to_external, child.to_external);
      end
   set_focus_vadjustment (adjustment : GTK_ADJUSTMENT) is
      do
         gtk_container_set_focus_vadjustment  (to_external, adjustment.to_external);
      end
   set_focus_hadjustment (adjustment : GTK_ADJUSTMENT) is
      do
         gtk_container_set_focus_hadjustment  (to_external, adjustment.to_external);
      end
   register_toplevel is
      do
         gtk_container_register_toplevel  (to_external);
      end
   unregister_toplevel is
      do
         gtk_container_unregister_toplevel  (to_external);
      end
   resize_children is
      do
         gtk_container_resize_children  (to_external);
      end

end -- class GTK_CONTAINER

