indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_list.e,v 1.5 2000/03/13 18:19:55 eugenem Exp $";

class GTK_LIST
inherit
   GTK_LIST_NP
   GTK_LIST_EXTERNALS
   GTK_CONTAINER
      redefine
         children_array,
         children_list,
         make_for_register
      end
creation
   from_external, make
feature -- creation
   make is
      do
         from_external(gtk_list_new)
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_list_get_type)
      end

feature -- access

   children_list : G_LIST [GTK_LIST_ITEM] is
      do
         !G_LIST_OF_GTK_LIST_ITEM!
            Result.from_external (gtk_list_children_acr (to_external));
      end -- children_list

   children_array : ARRAY [GTK_LIST_ITEM] is
      local
         tmp_list :G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_external (gtk_list_children_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end -- children_array

   selection_array : ARRAY [GTK_LIST_ITEM] is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_external (gtk_list_selection_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end -- selection_array

   selection_list : G_LIST [GTK_LIST_ITEM] is
      do
         !G_LIST_OF_GTK_LIST_ITEM!
            Result.from_external (gtk_list_selection_acr (to_external));
      end -- selection_list

   undo_selection_list : G_LIST [GTK_LIST_ITEM] is
      do
         !G_LIST_OF_GTK_LIST_ITEM!
            Result.from_external (gtk_list_undo_unselection_acr (to_external));
      end -- undo_selection

   undo_selection_array : ARRAY [GTK_LIST_ITEM] is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_external (gtk_list_undo_unselection_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end -- undo_selection_array

   last_focus_child : GTK_LIST_ITEM is
      do
--         !!Result.from_external(gtk_list_last_focus_child_acr (to_external))
         Result ?= object_factory.make_object_from_pointer(gtk_list_last_focus_child_acr (to_external));
      end

   undo_focus_child : GTK_LIST_ITEM is
      do
--         !!Result.from_external (gtk_list_undo_focus_child_acr (to_external))
         Result ?= object_factory.make_object_from_pointer(gtk_list_undo_focus_child_acr (to_external));
      end

   htimer : INTEGER is
      do
         Result := gtk_list_htimer_acr (to_external)
      end

   vtimer : INTEGER is
      do
         Result := gtk_list_vtimer_acr (to_external)
      end

   anchor : INTEGER is
      do
         Result := gtk_list_anchor_acr (to_external)
      end

   drag_pos : INTEGER is
      do
         Result := gtk_list_drag_pos_acr (to_external)
      end

   anchor_state : GTK_STATE_TYPE is
      do
         Result := gtk_list_anchor_state_acr (to_external)
      end

   selection_mode : GTK_SELECTION_MODE is
      do
         !!Result.make (gtk_list_selection_mode_acr (to_external));
      end

   drag_selection : INTEGER is
      do
         Result := gtk_list_drag_selection_acr (to_external)
      end

   add_mode : INTEGER is
      do
         Result := gtk_list_add_mode_acr (to_external)
      end

feature -- operations

   insert_items_array (items : ARRAY [GTK_LIST_ITEM]; position : INTEGER) is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_array (items);
         if tmp_list /= Void then
            gtk_list_insert_items  (to_external,tmp_list.to_external,position);
         end
      end

   insert_items_list (items : G_LIST [GTK_LIST_ITEM]; position : INTEGER) is
      do
         gtk_list_insert_items  (to_external,items.to_external,position);
      end

   append_items_array (items : ARRAY [GTK_LIST_ITEM]) is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_array (items);
         if tmp_list /= Void then
            gtk_list_append_items (to_external,tmp_list.to_external);
         end
      end

   append_items_list (items : G_LIST [GTK_LIST_ITEM]) is
      do
         gtk_list_append_items (to_external, items.to_external);
      end

   prepend_items_array (items : ARRAY [GTK_LIST_ITEM]) is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_array (items);
         if tmp_list /= Void then
            gtk_list_prepend_items (to_external,tmp_list.to_external);
         end
      end

   prepend_items_list (items : G_LIST [GTK_LIST_ITEM]) is
      do
         gtk_list_prepend_items (to_external, items.to_external);
      end

   remove_items_array (items : ARRAY [GTK_LIST_ITEM]) is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_array (items);
         if tmp_list /= Void then
            gtk_list_remove_items (to_external,tmp_list.to_external);
         end
      end

   remove_items_list (items : G_LIST [GTK_LIST_ITEM]) is
      do
         gtk_list_remove_items (to_external,items.to_external);
      end

   remove_items_array_no_unref (items : ARRAY [GTK_LIST_ITEM]) is
      local
         tmp_list : G_LIST_OF_GTK_LIST_ITEM;
      do
         !!tmp_list.from_array (items);
         if tmp_list /= Void then
            gtk_list_remove_items_no_unref (to_external,tmp_list.to_external);
         end
      end

   remove_items_list_no_unref (items : G_LIST [GTK_LIST_ITEM]) is
      do
         gtk_list_remove_items_no_unref (to_external,items.to_external);
      end

   clear_items (start : INTEGER; upper : INTEGER) is
      do
         gtk_list_clear_items  (to_external, start, upper);
      end

   select_item (item : INTEGER) is
      do
         gtk_list_select_item  (to_external, item);
      end

   unselect_item (item : INTEGER) is
      do
         gtk_list_unselect_item  (to_external, item);
      end

   select_child (child : GTK_LIST_ITEM) is
      do
         gtk_list_select_child  (to_external, child.to_external);
      end

   unselect_child (child : GTK_LIST_ITEM) is
      do
         gtk_list_unselect_child  (to_external, child.to_external);
      end

   child_position (child : GTK_LIST_ITEM) : INTEGER is
      do
         Result:= gtk_list_child_position  (to_external, child.to_external);
      end

   set_selection_mode (mode : GTK_SELECTION_MODE) is
      do
         gtk_list_set_selection_mode  (to_external, mode.get_value);
      end

   extend_selection (scroll_type : GTK_SCROLL_TYPE; position : REAL;
                     auto_start_selection : BOOLEAN) is
      do
         np_gtk_list_extend_selection  (to_external, scroll_type.get_value,
                                        position, auto_start_selection);
      end

   end_selection is
      do
         gtk_list_end_selection  (to_external);
      end

   select_all is
      do
         gtk_list_select_all  (to_external);
      end

   unselect_all is
      do
         gtk_list_unselect_all  (to_external);
      end

   scroll_horizontal (scroll_type : GTK_SCROLL_TYPE; position : REAL) is
      do
         np_gtk_list_scroll_horizontal (to_external, scroll_type.get_value,
                                        position)
      end

   scroll_vertical (scroll_type : GTK_SCROLL_TYPE; position : REAL) is
      do
         np_gtk_list_scroll_vertical  (to_external, scroll_type.get_value,
                                       position);
      end

   toggle_focus_row is
      do
         gtk_list_toggle_focus_row (to_external);
      end

   toggle_row (item : GTK_LIST_ITEM) is
      do
         gtk_list_toggle_row  (to_external, item.to_external);
      end

   do_undo_selection is
      do
         gtk_list_undo_selection  (to_external);
      end

   end_drag_selection is
      do
         gtk_list_end_drag_selection (to_external);
      end

feature {NONE} -- Private

end -- class GTK_LIST
