indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_clist.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_CLIST
inherit
   GTK_CLIST_NP
   GTK_CLIST_EXTERNALS
   GTK_CONTAINER
      rename
         remove as remove_container
      redefine
         make_for_register
      end
creation
   from_external, make, make_with_titles, make_for_register
feature -- creation
   make (arg_columns : INTEGER) is
      do
         from_external(gtk_clist_new  (arg_columns))
      end
   make_with_titles (arg_columns : INTEGER; titles : ARRAY[STRING]) is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(titles)
         from_external(gtk_clist_new_with_titles  (arg_columns, tmp.to_external))
      end
feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_clist_get_type)
      end

feature -- access

   clist_window : GDK_WINDOW is
      do
         !!Result.from_external (gtk_clist_clist_window_acr (to_external))
      end
--   row : GTK_CLIST_ROW is
--      do
--         !!Result.from_external (gtk_clist_row_acr (to_external))
--      end
   selected_rows_array : ARRAY [INTEGER] is
      local
         tmp_list : G_LIST_OF_INTEGER;
      do
         !!tmp_list.from_external(gtk_clist_selection_acr (to_external));
         if (tmp_list /= Void) then
            Result := tmp_list.to_array;
         end
      end -- selected_rows_array

   selected_rows_list : G_LIST [INTEGER] is
      do
         !G_LIST_OF_INTEGER!
            Result.from_external(gtk_clist_selection_acr (to_external));
      end -- selected_rows_array

   selection_mode : GTK_SELECTION_MODE is
      do
         !!result.make(gtk_clist_selection_mode_acr (to_external))
      end

   sort_column : INTEGER is
      do
         Result := gtk_clist_sort_column_acr (to_external)
      end

   sort_type : GTK_SORT_TYPE is
      do
         !!result.make(gtk_clist_sort_type_acr (to_external))
      end

   focus_row : INTEGER is
      do
         Result := gtk_clist_focus_row_acr (to_external)
      end

   row_list : G_LIST [GTK_CLIST_ROW] is
      do
         !G_LIST_OF_GTK_CLIST_ROW!
            Result.from_external (gtk_clist_row_list_acr (to_external));
      end

   row_array : ARRAY [GTK_CLIST_ROW] is
      local
         tmp_list : G_LIST_OF_GTK_CLIST_ROW;
      do
         !!tmp_list.from_external (gtk_clist_row_list_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end

feature -- operations

   construct (arg_columns : INTEGER; titles : ARRAY[STRING]) is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(titles)
         gtk_clist_construct  (to_external, arg_columns, tmp.to_external);
      end

   set_shadow_type (arg_type : GTK_SHADOW_TYPE) is
      do
         gtk_clist_set_shadow_type  (to_external, arg_type.get_value);
      end

   set_selection_mode (mode : GTK_SELECTION_MODE) is
      do
         gtk_clist_set_selection_mode  (to_external, mode.get_value);
      end

   set_reorderable (reorderable : BOOLEAN) is
      do
         gtk_clist_set_reorderable  (to_external, reorderable.to_integer);
      end

   freeze is
      do
         gtk_clist_freeze  (to_external);
      end

   thaw is
      do
         gtk_clist_thaw  (to_external);
      end

   column_titles_show is
      do
         gtk_clist_column_titles_show  (to_external);
      end

   column_titles_hide is
      do
         gtk_clist_column_titles_hide  (to_external);
      end

   column_title_active (column : INTEGER) is
      do
         gtk_clist_column_title_active  (to_external, column);
      end

   column_title_passive (column : INTEGER) is
      do
         gtk_clist_column_title_passive  (to_external, column);
      end

   column_titles_active is
      do
         gtk_clist_column_titles_active  (to_external);
      end

   column_titles_passive is
      do
         gtk_clist_column_titles_passive  (to_external);
      end

   set_column_title (column : INTEGER; title : STRING) is
      do
         np_gtk_clist_set_column_title  (to_external, column, title);
      end

   get_column_title (column : INTEGER) : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external(gtk_clist_get_column_title  (to_external, column))
      end

   set_column_widget (column : INTEGER; widget : GTK_WIDGET) is
      do
         gtk_clist_set_column_widget  (to_external, column, widget.to_external);
      end

   get_column_widget (column : INTEGER) : GTK_WIDGET is
      do
         !!Result.from_external(gtk_clist_get_column_widget  (to_external, column));
      end

   set_column_justification (column : INTEGER; justification : GTK_JUSTIFICATION) is
      do
         gtk_clist_set_column_justification  (to_external, column, justification.get_value);
      end

   set_column_visibility (column : INTEGER; arg_visible : BOOLEAN) is
      do
         gtk_clist_set_column_visibility  (to_external, column, arg_visible.to_integer);
      end

   set_column_resizeable (column : INTEGER; resizeable : BOOLEAN) is
      do
         gtk_clist_set_column_resizeable  (to_external, column, resizeable.to_integer);
      end

   set_column_auto_resize (column : INTEGER; auto_resize : BOOLEAN) is
      do
         gtk_clist_set_column_auto_resize  (to_external, column, auto_resize.to_integer);
      end

   columns_autosize : INTEGER is
      do
         result := gtk_clist_columns_autosize  (to_external)
      end

   set_column_width (column : INTEGER; width : INTEGER) is
      do
         gtk_clist_set_column_width  (to_external, column, width);
      end

   set_column_min_width (column : INTEGER; min_width : INTEGER) is
      do
         gtk_clist_set_column_min_width  (to_external, column, min_width);
      end

   set_column_max_width (column : INTEGER; max_width : INTEGER) is
      do
         gtk_clist_set_column_max_width  (to_external, column, max_width);
      end

   set_row_height (height : INTEGER) is
      do
         gtk_clist_set_row_height  (to_external, height);
      end

   moveto (row : INTEGER; column : INTEGER; row_align : REAL; col_align : REAL) is
      do
         np_gtk_clist_moveto  (to_external, row, column, row_align, col_align);
      end

   row_is_visible (row : INTEGER) : GTK_VISIBILITY is
      do
         !!result.make(gtk_clist_row_is_visible  (to_external, row));
      end

   get_cell_type (row : INTEGER; column : INTEGER) : GTK_CELL_TYPE is
      do
         !!result.make(gtk_clist_get_cell_type  (to_external, row, column))
      end

   set_text (row : INTEGER; column : INTEGER; text : STRING) is
      do
         np_gtk_clist_set_text  (to_external, row, column, text);
      end

   get_text (row : INTEGER; column : INTEGER) : STRING is
      local
         tmp : INTEGER
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         tmp := gtk_clist_get_text (to_external, row, column, $tmp_text)
         Result := sh.string_from_external(tmp_text)
      end

   set_pixmap (row : INTEGER; column : INTEGER; pixmap : GDK_PIXMAP; mask : GDK_BITMAP) is
      do
         gtk_clist_set_pixmap  (to_external, row, column, pixmap.to_external, mask.to_external);
      end

   set_pixtext (row : INTEGER; column : INTEGER; text : STRING; spacing : INTEGER; pixmap : GDK_PIXMAP; mask : GDK_BITMAP) is
      do
         np_gtk_clist_set_pixtext  (to_external, row, column, text, spacing, pixmap.to_external, mask.to_external);
      end

   set_foreground (row : INTEGER; color : GDK_COLOR) is
      do
         gtk_clist_set_foreground  (to_external, row, color.to_external);
      end

   set_background (row : INTEGER; color : GDK_COLOR) is
      do
         gtk_clist_set_background  (to_external, row, color.to_external);
      end

   set_cell_style (row : INTEGER; column : INTEGER; arg_style : GTK_STYLE) is
      do
         gtk_clist_set_cell_style  (to_external, row, column, arg_style.to_external);
      end

   get_cell_style (row : INTEGER; column : INTEGER) : GTK_STYLE is
      do
         !!Result.from_external(gtk_clist_get_cell_style  (to_external, row, column));
      end

   set_row_style (row : INTEGER; arg_style : GTK_STYLE) is
      do
         gtk_clist_set_row_style  (to_external, row, arg_style.to_external);

      end

   get_row_style (row : INTEGER) : GTK_STYLE is
      do
         !!Result.from_external(gtk_clist_get_row_style  (to_external, row));
      end

   set_shift (row : INTEGER; column : INTEGER; vertical : INTEGER; horizontal : INTEGER) is
      do
         gtk_clist_set_shift  (to_external, row, column, vertical, horizontal);
      end

   set_selectable (row : INTEGER; selectable : BOOLEAN) is
      do
         gtk_clist_set_selectable  (to_external, row, selectable.to_integer);
      end

   get_selectable (row : INTEGER) : BOOLEAN is
      do
         Result:= gtk_clist_get_selectable  (to_external, row);
      end

   prepend (text : ARRAY[STRING]) : INTEGER is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(text)
         Result:= gtk_clist_prepend  (to_external, tmp.to_external);
      end

   append (text : ARRAY[STRING]) : INTEGER is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(text)
         Result:= gtk_clist_append  (to_external, tmp.to_external);
      end

   insert (row : INTEGER; text : ARRAY[STRING]) : INTEGER is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(text)
         Result:= gtk_clist_insert  (to_external, row, tmp.to_external);
      end

   remove (row : INTEGER) is
      do
         gtk_clist_remove  (to_external, row);
      end

   set_row_data (row : INTEGER; data : ANY) is
      do
         c_gtk_clist_set_row_data  (to_external, row, data);
      end

   get_row_data (row : INTEGER) : ANY is
      do
         Result:= c_gtk_clist_get_row_data  (to_external, row);
      end

   find_row_from_data (data : ANY) : INTEGER is
      do
         Result:= c_gtk_clist_find_row_from_data  (to_external, data);
      end

   select_row (row : INTEGER; column : INTEGER) is
      do
         gtk_clist_select_row  (to_external, row, column);
      end

   unselect_row (row : INTEGER; column : INTEGER) is
      do
         gtk_clist_unselect_row  (to_external, row, column);
      end

   undo_selection is
      do
         gtk_clist_undo_selection  (to_external);
      end

   clear is
      do
         gtk_clist_clear  (to_external);
      end

   select_all is
      do
         gtk_clist_select_all  (to_external);
      end

   unselect_all is
      do
         gtk_clist_unselect_all  (to_external);
      end

   swap_rows (row1 : INTEGER; row2 : INTEGER) is
      do
         gtk_clist_swap_rows  (to_external, row1, row2);
      end

   set_sort_column (column : INTEGER) is
      do
         gtk_clist_set_sort_column  (to_external, column);
      end

   set_sort_type (arg_sort_type : GTK_SORT_TYPE) is
      do
         gtk_clist_set_sort_type  (to_external, arg_sort_type.get_value);
      end

   sort is
      do
         gtk_clist_sort  (to_external);
      end

   set_auto_sort (auto_sort : BOOLEAN) is
      do
         gtk_clist_set_auto_sort  (to_external, auto_sort.to_integer);
      end

   rows : INTEGER is
      do
         Result := gtk_clist_rows_acr (to_external);
      end

   columns : INTEGER is
      do
         Result := gtk_clist_columns_acr (to_external);
      end

   hadjustment : GTK_ADJUSTMENT is
      local
         ptr : POINTER;
      do
         ptr := gtk_clist_hadjustment_acr (to_external);
         if ptr /= default_pointer then
            !!Result.from_external (ptr);
         end
      end

   vadjustment : GTK_ADJUSTMENT is
      local
         ptr : POINTER;
      do
         ptr := gtk_clist_vadjustment_acr (to_external);
         if ptr /= default_pointer then
            !!Result.from_external (ptr);
         end
      end

feature {NONE}

   tmp_text : POINTER
      -- temporary pointer for get_text feature

end -- class GTK_CLIST
