indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_color_selection.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_COLOR_SELECTION
inherit
   GTK_COLOR_SELECTION_EXTERNALS
   GTK_COLOR_SELECTION_NP
   GTK_VBOX
      rename
         make as make_vbox
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register

feature -- creation

   make is
      do
         from_external(gtk_color_selection_new)
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_color_selection_get_type)
      end

feature -- operations

   set_update_policy (policy : GTK_UPDATE_TYPE) is
      do
         gtk_color_selection_set_update_policy  (to_external, policy.get_value);
      end
   set_opacity (use_opacity : BOOLEAN) is
      do
         gtk_color_selection_set_opacity  (to_external, use_opacity.to_integer);
      end
   set_color (color : ARRAY[DOUBLE]) is
      require
         is_color: color.count = 4
      do
         np_gtk_color_selection_set_color  (to_external, color);
      end
   get_color : ARRAY[DOUBLE] is
      local
         res : ARRAY[DOUBLE]
      do
         !!res.make(1,4)
         np_gtk_color_selection_get_color (to_external , res)
         Result := res
      ensure
         is_color: Result.count = 4
      end

end -- class GTK_COLOR_SELECTION
