indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_combo.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_COMBO
inherit
   GTK_COMBO_NP
   GTK_COMBO_EXTERNALS
   GTK_HBOX
      rename
         make as make_hbox,
         popup as popup_hbox
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_combo_new)
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_combo_get_type)
      end

feature -- access

   entry : GTK_ENTRY is
      do
         !!Result.from_external(gtk_combo_entry_acr(to_external))
      end

   button : GTK_BUTTON is
      do
         !!Result.from_external(gtk_combo_button_acr(to_external))
      end

   popup : GTK_WIDGET is --  what is it in fact?
      do
         !!Result.from_external(gtk_combo_popup_acr(to_external))
      end

   popwin : GTK_WINDOW is -- or not window ?
      do
         !!Result.from_external(gtk_combo_popwin_acr(to_external))
      end

   list : GTK_WIDGET is -- what is it in fact?
      do
         !!Result.from_external(gtk_combo_list_acr(to_external))
      end

   value_in_list : BOOLEAN is
      do
         Result := gtk_combo_value_in_list_acr(to_external)
      end

   ok_if_empty : BOOLEAN is
      do
         Result := gtk_combo_ok_if_empty_acr(to_external)
      end

   case_sensitive : BOOLEAN is
      do
         Result := gtk_combo_case_sensitive_acr(to_external)
      end

   use_arrows : BOOLEAN is
      do
         Result := gtk_combo_use_arrows_acr(to_external)
      end

   use_arrows_always : BOOLEAN is
      do
         Result := gtk_combo_use_arrows_always_acr(to_external)
      end

feature -- operations

   set_value_in_list (val : BOOLEAN; arg_ok_if_empty : BOOLEAN) is
      do
         gtk_combo_set_value_in_list  (to_external, val.to_integer, arg_ok_if_empty.to_integer);
      end
   set_use_arrows (val : BOOLEAN) is
      do
         gtk_combo_set_use_arrows  (to_external, val.to_integer);
      end
   set_use_arrows_always (val : BOOLEAN) is
      do
         gtk_combo_set_use_arrows_always  (to_external, val.to_integer);
      end
   set_case_sensitive (val : BOOLEAN) is
      do
         gtk_combo_set_case_sensitive  (to_external, val.to_integer);
      end
   set_item_string (item : GTK_ITEM; item_value : STRING) is
      do
         np_gtk_combo_set_item_string  (to_external, item.to_external, item_value);
      end
   disable_activate is
      do
         gtk_combo_disable_activate  (to_external);
      end
   set_popdown_strings (strings : ARRAY[STRING]) is
      local
         temp : VEGTK_EXTERNAL_STRINGS
      do
         !!temp.make(strings)
         c_gtk_combo_set_popdown_strings(to_external, temp.to_external, strings.count)
      end

end -- class GTK_COMBO
