indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_ctree.e,v 1.4 2000/03/16 14:03:55 eugenem Exp $";

class GTK_CTREE
inherit
   GTK_CTREE_NP
   GTK_CTREE_EXTERNALS
   GTK_CLIST
      rename
         make_with_titles as make_with_titles_clist,
         make as make_clist,
         construct as construct_clist,
         is_ancestor as is_ancestor_widget
      redefine
         make_for_register,
--         selected_rows,
         row_list,
         row_array
      end
creation
   from_external, make_with_titles, make, make_for_register
feature -- creation

   make_with_titles (arg_columns : INTEGER; arg_tree_column : INTEGER; titles : ARRAY[STRING]) is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(titles)
         from_external(gtk_ctree_new_with_titles  (arg_columns, arg_tree_column, tmp.to_external))
      end
   make (arg_columns : INTEGER; arg_tree_column : INTEGER) is
      do
         from_external(gtk_ctree_new  (arg_columns, arg_tree_column))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_ctree_get_type)
      end

feature -- access

   line_style : GTK_CTREE_LINE_STYLE is
      do
         !!result.make(gtk_ctree_line_style_acr  (to_external));
      end

   tree_spacing : INTEGER is
      do
         result :=  gtk_ctree_tree_spacing_acr (to_external)
      end

   tree_column : INTEGER is
      do
         Result := gtk_ctree_tree_column_acr(to_external)
      end

   tree_indent : INTEGER is
      do
         Result := gtk_ctree_tree_indent_acr(to_external)
      end

feature -- operations

   construct (arg_columns : INTEGER; arg_tree_column : INTEGER; titles : ARRAY[STRING]) is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
      do
         !!tmp.make(titles)
         gtk_ctree_construct  (to_external, arg_columns, arg_tree_column, tmp.to_external);
      end
   insert_node (arg_parent : GTK_CTREE_NODE; sibling : GTK_CTREE_NODE; text : ARRAY[STRING]; spacing : INTEGER; pixmap_closed : GDK_PIXMAP; mask_closed : GDK_BITMAP; pixmap_opened : GDK_PIXMAP; mask_opened : GDK_BITMAP; is_leaf : BOOLEAN; arg_expanded : BOOLEAN) : GTK_CTREE_NODE is
      local
         tmp : VEGTK_EXTERNAL_STRINGS
         par : POINTER
         sib : POINTER
         opened_ptr, opened_mask_ptr : POINTER
         closed_ptr, closed_mask_ptr : POINTER
      do
         par := to_external_with_check(arg_parent)
         sib := to_external_with_check(sibling)
         opened_ptr := to_external_with_check(pixmap_opened)
         opened_mask_ptr := to_external_with_check(mask_opened)
         closed_ptr := to_external_with_check(pixmap_closed)
         closed_mask_ptr := to_external_with_check(mask_closed)
         !!tmp.make(text)
         !!Result.from_external ( gtk_ctree_insert_node (to_external, par, sib, tmp.to_external,
                                   spacing, closed_ptr, closed_mask_ptr,
                                   opened_ptr, opened_mask_ptr,
                                   is_leaf.to_integer, arg_expanded.to_integer));
      end
   remove_node (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_remove_node  (to_external, node.to_external);
      end
   is_viewable (node : GTK_CTREE_NODE) : BOOLEAN is
      do
         Result:= gtk_ctree_is_viewable  (to_external, node.to_external);
      end
   last (node : GTK_CTREE_NODE) : GTK_CTREE_NODE is
      do
         !!Result.from_external(gtk_ctree_last  (to_external, node.to_external));
      end
   node_nth (row : INTEGER) : GTK_CTREE_NODE is
      local
         tmp : POINTER
      do
         tmp := gtk_ctree_node_nth  (to_external, row)
         if tmp /= default_pointer then
            !!Result.from_external(tmp);
         end
      end
   find (node : GTK_CTREE_NODE; child : GTK_CTREE_NODE) : BOOLEAN is
      do
         Result:= gtk_ctree_find  (to_external, node.to_external, child.to_external);
      end
   is_ancestor (node : GTK_CTREE_NODE; child : GTK_CTREE_NODE) : BOOLEAN is
      do
         Result:= gtk_ctree_is_ancestor  (to_external, node.to_external, child.to_external);
      end
   find_by_row_data (node : GTK_CTREE_NODE; data : ANY) : GTK_CTREE_NODE is
      local
         ptr : POINTER;
      do
         ptr := c_gtk_ctree_find_by_row_data  (to_external, node.to_external, data);
         if ptr /= default_pointer then
           !!Result.from_external(ptr);
         end
      end
   is_hot_spot (x : INTEGER; y : INTEGER) : BOOLEAN is
      do
         Result:= gtk_ctree_is_hot_spot  (to_external, x, y);
      end
   move (node : GTK_CTREE_NODE; new_parent : GTK_CTREE_NODE; new_sibling : GTK_CTREE_NODE) is
      do
         gtk_ctree_move  (to_external, node.to_external, new_parent.to_external, new_sibling.to_external);
      end
   expand (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_expand  (to_external, node.to_external);
      end
   expand_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_expand_recursive  (to_external, to_external_with_check(node));
      end
   expand_to_depth (node : GTK_CTREE_NODE; depth : INTEGER) is
      do
         gtk_ctree_expand_to_depth  (to_external, node.to_external, depth);
      end
   collapse (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_collapse  (to_external, node.to_external);
      end
   collapse_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_collapse_recursive  (to_external, to_external_with_check(node));
      end
   collapse_to_depth (node : GTK_CTREE_NODE; depth : INTEGER) is
      do
         gtk_ctree_collapse_to_depth  (to_external, node.to_external, depth);
      end
   toggle_expansion (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_toggle_expansion  (to_external, node.to_external);
      end
   toggle_expansion_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_toggle_expansion_recursive  (to_external, node.to_external);
      end
   do_select (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_select  (to_external, node.to_external);
      end
   select_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_select_recursive  (to_external, to_external_with_check(node));
      end
   unselect (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_unselect  (to_external, node.to_external);
      end
   unselect_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_unselect_recursive  (to_external, to_external_with_check(node));
      end
   real_select_recursive (node : GTK_CTREE_NODE; arg_state : INTEGER) is
      do
         gtk_ctree_real_select_recursive  (to_external, node.to_external, arg_state);
      end
   node_set_text (node : GTK_CTREE_NODE; column : INTEGER; text : STRING) is
      do
         np_gtk_ctree_node_set_text  (to_external, node.to_external, column, text);
      end
   node_set_pixmap (node : GTK_CTREE_NODE; column : INTEGER; pixmap : GDK_PIXMAP; mask : GDK_BITMAP) is
      do
         gtk_ctree_node_set_pixmap  (to_external, node.to_external, column, pixmap.to_external, mask.to_external);
      end
   node_set_pixtext (node : GTK_CTREE_NODE; column : INTEGER; text : STRING; spacing : INTEGER; pixmap : GDK_PIXMAP; mask : GDK_BITMAP) is
      do
         np_gtk_ctree_node_set_pixtext  (to_external, node.to_external, column, text, spacing, pixmap.to_external, mask.to_external);
      end
   set_node_info (node : GTK_CTREE_NODE; text : STRING; spacing : INTEGER; pixmap_closed : GDK_PIXMAP; mask_closed : GDK_BITMAP; pixmap_opened : GDK_PIXMAP; mask_opened : GDK_BITMAP; is_leaf : BOOLEAN; arg_expanded : BOOLEAN) is
      do
         np_gtk_ctree_set_node_info (to_external, node.to_external, text,
                                     spacing, to_external_with_check(pixmap_closed),
                                     to_external_with_check(mask_closed),
                                     to_external_with_check(pixmap_opened),
                                     to_external_with_check(mask_opened),
                                     is_leaf,arg_expanded);
      end
   node_set_shift (node : GTK_CTREE_NODE; column : INTEGER; vertical : INTEGER; horizontal : INTEGER) is
      do
         gtk_ctree_node_set_shift  (to_external, node.to_external, column, vertical, horizontal);
      end
   node_set_selectable (node : GTK_CTREE_NODE; selectable : BOOLEAN) is
      do
         gtk_ctree_node_set_selectable  (to_external, node.to_external, selectable);
      end
   node_get_selectable (node : GTK_CTREE_NODE) : BOOLEAN is
      do
         Result:= gtk_ctree_node_get_selectable  (to_external, node.to_external);
      end
   node_get_cell_type (node : GTK_CTREE_NODE; column : INTEGER) : GTK_CELL_TYPE is
      do
         !!result.make(gtk_ctree_node_get_cell_type  (to_external, node.to_external, column))
      end
   node_get_text (node : GTK_CTREE_NODE; column : INTEGER; text : POINTER) : INTEGER is
      do
         Result:= gtk_ctree_node_get_text  (to_external, node.to_external, column, text);
      end
   node_get_pixmap (node : GTK_CTREE_NODE; column : INTEGER; pixmap : POINTER; mask : POINTER) : INTEGER is
      do
         Result:= gtk_ctree_node_get_pixmap  (to_external, node.to_external, column, pixmap, mask);
      end
   node_get_pixtext (node : GTK_CTREE_NODE; column : INTEGER; text : POINTER; spaceing : POINTER; pixmap : POINTER; mask : POINTER) : INTEGER is
      do
         Result:= gtk_ctree_node_get_pixtext  (to_external, node.to_external, column, text, spaceing, pixmap, mask);
      end
   get_node_info (node : GTK_CTREE_NODE; text : POINTER; spacing : POINTER; pixmap_closed : POINTER; mask_closed : POINTER; pixmap_opened : POINTER; mask_opened : POINTER; is_leaf : POINTER; arg_expanded : POINTER) is
      local
         tmp : INTEGER
      do
         tmp := gtk_ctree_get_node_info  (to_external, node.to_external,text, spacing, pixmap_closed, mask_closed, pixmap_opened, mask_opened, is_leaf, arg_expanded);
      end
   node_set_row_style (node : GTK_CTREE_NODE; arg_style : GTK_STYLE) is
      do
         gtk_ctree_node_set_row_style  (to_external, node.to_external, to_external_with_check(arg_style))
      end
   node_get_row_style (node : GTK_CTREE_NODE) : GTK_STYLE is
      do
         !!Result.from_external(gtk_ctree_node_get_row_style  (to_external, node.to_external));
      end
   node_set_cell_style (node : GTK_CTREE_NODE; column : INTEGER; arg_style : GTK_STYLE) is
      do
         gtk_ctree_node_set_cell_style  (to_external, node.to_external, column, arg_style.to_external);
      end
   node_get_cell_style (node : GTK_CTREE_NODE; column : INTEGER) : GTK_STYLE is
      do
         !!Result.from_external(gtk_ctree_node_get_cell_style  (to_external, node.to_external, column));
      end
   node_set_foreground (node : GTK_CTREE_NODE; color : GDK_COLOR) is
      do
         gtk_ctree_node_set_foreground  (to_external, node.to_external, color.to_external);
      end
   node_set_background (node : GTK_CTREE_NODE; color : GDK_COLOR) is
      do
         gtk_ctree_node_set_background  (to_external, node.to_external, color.to_external);
      end
   node_set_row_data (node : GTK_CTREE_NODE; data : ANY) is
      do
         c_gtk_ctree_node_set_row_data  (to_external, node.to_external, data);
      end
   node_set_row_data_full (node : GTK_CTREE_NODE; data : ANY; object : ANY; func : POINTER) is
      do
         c_gtk_ctree_node_set_row_data_full (to_external, node.to_external, data, object, func)
      end
   node_get_row_data (node : GTK_CTREE_NODE) : ANY is
      do
         Result:= c_gtk_ctree_node_get_row_data  (to_external, node.to_external)
      end
   node_moveto (node : GTK_CTREE_NODE; column : INTEGER; row_align : REAL; col_align : REAL) is
      do
         np_gtk_ctree_node_moveto  (to_external, node.to_external, column, row_align,col_align);
      end
   node_is_visible (node : GTK_CTREE_NODE) : GTK_VISIBILITY is
      do
         !!result.make(gtk_ctree_node_is_visible  (to_external, node.to_external))
      end
   set_indent (indent : INTEGER) is
      do
         gtk_ctree_set_indent  (to_external, indent);
      end
   set_spacing (spacing : INTEGER) is
      do
         gtk_ctree_set_spacing  (to_external, spacing);
      end
   set_line_style (arg_line_style : GTK_CTREE_LINE_STYLE) is
      do
         gtk_ctree_set_line_style  (to_external, arg_line_style.get_value);
      end
   set_expander_style (expander_style : GTK_CTREE_EXPANDER_STYLE) is
      do
         gtk_ctree_set_expander_style  (to_external, expander_style.get_value);
      end
   sort_node (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_sort_node  (to_external, node.to_external);
      end
   sort_recursive (node : GTK_CTREE_NODE) is
      do
         gtk_ctree_sort_recursive  (to_external, to_external_with_check(node))
      end

   pre_recursive(node : GTK_CTREE_NODE; object : ANY; func : POINTER; data : ANY) is
      local
         node_ptr : POINTER
      do
         node_ptr := to_external_with_check(node)
         c_gtk_ctree_pre_recursive(to_external, node_ptr, object, func, data)
      end

   post_recursive(node : GTK_CTREE_NODE; object : ANY; func : POINTER; data : ANY) is
      local
         node_ptr : POINTER
      do
         node_ptr := to_external_with_check(node)
         c_gtk_ctree_post_recursive(to_external, node_ptr, object, func, data)
      end

   insert_gnode(arg_parent : GTK_CTREE_NODE; sibling : GTK_CTREE_NODE;
      gnode : G_NODE; object : ANY; func : POINTER; data : ANY) : GTK_CTREE_NODE is
      local
         parent_ptr,
         sibling_ptr : POINTER
      do
         parent_ptr := to_external_with_check(arg_parent)
         sibling_ptr := to_external_with_check(sibling)
         !!Result.from_external(c_gtk_ctree_insert_gnode(to_external,parent_ptr,
            sibling_ptr, gnode.to_external, object, func, data))
      end

   export_to_gnode(arg_parent : G_NODE; sibling : G_NODE; node : GTK_CTREE_NODE;
      object : ANY; func : POINTER; data : ANY) : G_NODE is
      local
         parent_ptr,
         sibling_ptr : POINTER
         tmp : POINTER
      do
         parent_ptr := to_external_with_check(arg_parent)
         sibling_ptr := to_external_with_check(sibling)
         tmp := c_gtk_ctree_export_to_gnode(to_external,
            parent_ptr, sibling_ptr, node.to_external, object, func, data)
         if tmp /= default_pointer then
            !!Result.from_external(tmp)
         end
      end

   selected_nodes_array : ARRAY [GTK_CTREE_NODE] is
      local
         tmp_list : G_LIST_OF_GTK_CTREE_NODE;
      do
         !!tmp_list.from_external (gtk_clist_selection_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array
         end
      end -- selected_nodes_array

   selected_nodes_list : G_LIST [GTK_CTREE_NODE] is
      local
         tmp_list : G_LIST_OF_GTK_CTREE_NODE;
      do
         !G_LIST_OF_GTK_CTREE_NODE!
            Result.from_external (gtk_clist_selection_acr (to_external));
      end
--   selected_rows : G_LIST [INTEGER] is
--      do
--      end

   row_list : G_LIST [GTK_CTREE_ROW] is
      do
         !G_LIST_OF_GTK_CTREE_ROW!
            Result.from_external (gtk_clist_row_list_acr (to_external));
      end

   row_array : ARRAY [GTK_CTREE_ROW] is
      local
         tmp_list : G_LIST_OF_GTK_CTREE_ROW;
      do
         !!tmp_list.from_external (gtk_clist_row_list_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end

end -- class GTK_CTREE

