indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_ctree_np.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_CTREE_NP
inherit
   GTK_CTREE_EXTERNALS
feature {NONE} -- non portable calls
   np_gtk_ctree_node_set_text (ctree : POINTER; node : POINTER;
                                column : INTEGER; text : STRING) is
   local
      mem : MEMORY
   do
      !!mem
      mem.collection_off;
      gtk_ctree_node_set_text (ctree, node, column, text.to_external);
      mem.collection_on;
   end
   np_gtk_ctree_node_set_pixtext (ctree : POINTER; node : POINTER; column : INTEGER; text : STRING; spacing : INTEGER; pixmap : POINTER; mask : POINTER) is
   local
      mem : MEMORY
   do
      !!mem
      mem.collection_off;
      gtk_ctree_node_set_pixtext (ctree, node, column, text.to_external, spacing, pixmap, mask);
      mem.collection_on;
   end
   np_gtk_ctree_set_node_info (ctree : POINTER; node : POINTER; text : STRING;
                                spacing : INTEGER; pixmap_closed : POINTER;
                                mask_closed : POINTER; pixmap_opened : POINTER;
                                mask_opened : POINTER; is_leaf : BOOLEAN;
                                arg_expanded : BOOLEAN) is
   local
      mem : MEMORY
   do
      !!mem
      mem.collection_off;
      gtk_ctree_set_node_info (ctree, node, text.to_external, spacing,
                                pixmap_closed, mask_closed, pixmap_opened,
                                mask_opened,
                                is_leaf.to_integer, arg_expanded.to_integer)
      mem.collection_on;
   end
   np_gtk_ctree_node_moveto (ctree : POINTER; node : POINTER; column : INTEGER; row_align : REAL; col_align : REAL) is
   do
      gtk_ctree_node_moveto (ctree, node, column, real_to_float(row_align), real_to_float(col_align))
   end
end -- class GTK_CTREE_NP
