indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_editable.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_EDITABLE
inherit
   GTK_EDITABLE_NP
   GTK_EDITABLE_EXTERNALS
   GTK_WIDGET
      redefine
         make_for_register
      end
creation
   from_external, make_for_register

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_editable_get_type)
      end

feature -- operations

   select_region (start : INTEGER; upper : INTEGER) is
      do
         gtk_editable_select_region  (to_external, start, upper);
      end
   insert_text (new_text : STRING; new_text_length : INTEGER; position : INTEGER) is
      do
         np_gtk_editable_insert_text  (to_external, new_text, new_text_length, position);
      end
   delete_text (start_pos : INTEGER; end_pos : INTEGER) is
      do
         gtk_editable_delete_text  (to_external, start_pos, end_pos);
      end
   get_chars (start_pos : INTEGER; end_pos : INTEGER) : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external( gtk_editable_get_chars  (to_external, start_pos, end_pos))
      end
   cut_clipboard is
      do
         gtk_editable_cut_clipboard  (to_external);
      end
   copy_clipboard is
      do
         gtk_editable_copy_clipboard  (to_external);
      end
   paste_clipboard is
      do
         gtk_editable_paste_clipboard  (to_external);
      end
   claim_selection (claim : BOOLEAN; time : INTEGER) is
      do
         gtk_editable_claim_selection  (to_external, claim.to_integer, time);
      end
   delete_selection is
      do
         gtk_editable_delete_selection  (to_external);
      end
   changed is
      do
         gtk_editable_changed  (to_external);
      end
   set_position (position : INTEGER) is
      do
         gtk_editable_set_position  (to_external, position);
      end
   get_position : INTEGER is
      do
         Result:= gtk_editable_get_position  (to_external);
      end
   set_editable (is_editable : BOOLEAN) is
      do
         gtk_editable_set_editable  (to_external, is_editable.to_integer);
      end

end -- class GTK_EDITABLE
