indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_entry.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_ENTRY
inherit
   GTK_ENTRY_NP
   GTK_ENTRY_EXTERNALS
   GTK_EDITABLE
      rename
         set_position as set_position_editable,
         select_region as select_region_editable,
         set_editable as set_editable_editable
      redefine
         make_for_register
      end
creation
   from_external, make, make_with_max_length, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_entry_new)
      end
   make_with_max_length (max : INTEGER) is
      do
         from_external(gtk_entry_new_with_max_length  (max))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_entry_get_type)
      end

feature -- queries

   text_length : INTEGER is
      do
         Result := gtk_entry_text_length_acr(to_external)
      end

feature -- operations

   set_text (text : STRING) is
      do
         np_gtk_entry_set_text  (to_external, text);
      end
   append_text (text : STRING) is
      do
         np_gtk_entry_append_text  (to_external, text);
      end
   prepend_text (text : STRING) is
      do
         np_gtk_entry_prepend_text  (to_external, text);
      end
   set_position (position : INTEGER) is
      do
         gtk_entry_set_position  (to_external, position);
      end
   get_text : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external( gtk_entry_get_text  (to_external))
      end
   select_region (start : INTEGER; upper : INTEGER) is
      do
         gtk_entry_select_region  (to_external, start, upper);
      end
   set_visibility (arg_visible : BOOLEAN) is
      do
         gtk_entry_set_visibility  (to_external, arg_visible.to_integer);
      end
   set_editable (editable : BOOLEAN) is
      do
         gtk_entry_set_editable  (to_external, editable.to_integer);
      end
   set_max_length (max : INTEGER) is
      do
         gtk_entry_set_max_length  (to_external, max);
      end

end -- class GTK_ENTRY
