indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_label.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_LABEL
inherit
   GTK_LABEL_NP
   GTK_LABEL_EXTERNALS
   GTK_MISC
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register

feature -- creation

   make (str : STRING) is
      do
         if str = Void then
            from_external (gtk_label_new (default_pointer))
         else
            from_external(np_gtk_label_new  (str))
         end
      end

feature {GTK_OBJECT} -- Creation for registration

   make_for_register is
      do
         register_without_external(gtk_label_get_type)
      end

feature -- operations

   set_text (str : STRING) is
      do
         np_gtk_label_set_text  (to_external, str);
      end
   set_justify (jtype : GTK_JUSTIFICATION) is
      do
         gtk_label_set_justify  (to_external, jtype.get_value);
      end
   set_pattern (pattern : STRING) is
      do
         np_gtk_label_set_pattern  (to_external, pattern);
      end
   set_line_wrap (wrap : BOOLEAN) is
      do
         gtk_label_set_line_wrap  (to_external, wrap.to_integer);
      end
   get : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external (gtk_label_get_acr(to_external))
      end

end -- class GTK_LABEL
