indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_menu_item.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_MENU_ITEM
inherit
   GTK_MENU_ITEM_NP
   GTK_MENU_ITEM_EXTERNALS
   GTK_ITEM
      rename
         do_select as do_select_item,
         deselect as deselect_item,
         activate as activate_widget
      redefine
         make_for_register
      end
creation
   from_external, make, make_with_label, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_menu_item_new)
      end
   make_with_label (label : STRING) is
      do
         from_external(np_gtk_menu_item_new_with_label  (label))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_menu_item_get_type)
      end

feature -- operations

   set_submenu (submenu : GTK_WIDGET) is
      do
         gtk_menu_item_set_submenu  (to_external, submenu.to_external);
      end
   remove_submenu is
      do
         gtk_menu_item_remove_submenu  (to_external);
      end
   set_placement (placement : GTK_SUBMENU_PLACEMENT) is
      do
         gtk_menu_item_set_placement  (to_external, placement.get_value);
      end
   configure (show_toggle_indicator : BOOLEAN; show_submenu_indicator : BOOLEAN) is
      do
         gtk_menu_item_configure  (to_external, show_toggle_indicator.to_integer,
                                    show_submenu_indicator.to_integer);
      end
   do_select is
      do
         gtk_menu_item_select  (to_external);
      end
   deselect is
      do
         gtk_menu_item_deselect  (to_external);
      end
   activate is
      do
         gtk_menu_item_activate  (to_external);
      end
   right_justify is
      do
         gtk_menu_item_right_justify  (to_external);
      end

end -- class GTK_MENU_ITEM
