indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_notebook.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_NOTEBOOK
inherit
   GTK_NOTEBOOK_NP
   GTK_NOTEBOOK_EXTERNALS
   GTK_CONTAINER
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_notebook_new)
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_notebook_get_type)
      end

feature -- operations

   append_page (child : GTK_WIDGET; tab_label : GTK_WIDGET) is
      do
         gtk_notebook_append_page  (to_external, child.to_external, tab_label.to_external);
      end
   append_page_menu (child : GTK_WIDGET; tab_label : GTK_WIDGET; menu_label : GTK_WIDGET) is
      do
         gtk_notebook_append_page_menu  (to_external, child.to_external, tab_label.to_external, menu_label.to_external);
      end
   prepend_page (child : GTK_WIDGET; tab_label : GTK_WIDGET) is
      do
         gtk_notebook_prepend_page  (to_external, child.to_external, tab_label.to_external);
      end
   prepend_page_menu (child : GTK_WIDGET; tab_label : GTK_WIDGET; menu_label : GTK_WIDGET) is
      do
         gtk_notebook_prepend_page_menu  (to_external, child.to_external, tab_label.to_external, menu_label.to_external);
      end
   insert_page (child : GTK_WIDGET; tab_label : GTK_WIDGET; position : INTEGER) is
      do
         gtk_notebook_insert_page  (to_external, child.to_external, tab_label.to_external, position);
      end
   insert_page_menu (child : GTK_WIDGET; tab_label : GTK_WIDGET; menu_label : GTK_WIDGET; position : INTEGER) is
      do
         gtk_notebook_insert_page_menu  (to_external, child.to_external, tab_label.to_external, menu_label.to_external, position);
      end
   remove_page (arg_page_num : INTEGER) is
      do
         gtk_notebook_remove_page  (to_external, arg_page_num);
      end
   get_current_page : INTEGER is
      do
         Result:= gtk_notebook_get_current_page  (to_external);
      end
   get_nth_page (arg_page_num : INTEGER) : GTK_WIDGET is
      do
         !!Result.from_external(gtk_notebook_get_nth_page  (to_external, arg_page_num));
      end
   page_num (child : GTK_WIDGET) : INTEGER is
      do
         Result:= gtk_notebook_page_num  (to_external, child.to_external);
      end
   set_page (arg_page_num : INTEGER) is
      do
         gtk_notebook_set_page  (to_external, arg_page_num);
      end
   next_page is
      do
         gtk_notebook_next_page  (to_external);
      end
   prev_page is
      do
         gtk_notebook_prev_page  (to_external);
      end
   set_show_border (arg_show_border : BOOLEAN) is
      do
         gtk_notebook_set_show_border  (to_external, arg_show_border.to_integer);
      end
   set_show_tabs (arg_show_tabs : BOOLEAN) is
      do
         gtk_notebook_set_show_tabs  (to_external, arg_show_tabs.to_integer);
      end
   set_tab_pos (pos : GTK_POSITION_TYPE) is
      do
         gtk_notebook_set_tab_pos  (to_external, pos.get_value);
      end
   set_homogeneous_tabs (homogeneous : BOOLEAN) is
      do
         gtk_notebook_set_homogeneous_tabs  (to_external, homogeneous.to_integer);
      end
   set_scrollable (scrollable : INTEGER) is
      do
         gtk_notebook_set_scrollable  (to_external, scrollable);
      end
   set_tab_border (arg_border_width : INTEGER) is
      do
         gtk_notebook_set_tab_border  (to_external, arg_border_width);
      end
   set_tab_hborder (tab_hborder : INTEGER) is
      do
         gtk_notebook_set_tab_hborder  (to_external, tab_hborder);
      end
   set_tab_vborder (tab_vborder : INTEGER) is
      do
         gtk_notebook_set_tab_vborder  (to_external, tab_vborder);
      end
   popup_enable is
      do
         gtk_notebook_popup_enable  (to_external);
      end
   popup_disable is
      do
         gtk_notebook_popup_disable  (to_external);
      end
   get_tab_label (child : GTK_WIDGET) : GTK_WIDGET is
      do
         !!Result.from_external(gtk_notebook_get_tab_label  (to_external, child.to_external));
      end
   set_tab_label (child : GTK_WIDGET; tab_label : GTK_WIDGET) is
      do
         gtk_notebook_set_tab_label  (to_external, child.to_external, tab_label.to_external);
      end
   set_tab_label_text (child : GTK_WIDGET; tab_text : STRING) is
      do
         np_gtk_notebook_set_tab_label_text  (to_external, child.to_external, tab_text);
      end
   get_menu_label (child : GTK_WIDGET) : GTK_WIDGET is
      do
         !!Result.from_external(gtk_notebook_get_menu_label  (to_external, child.to_external));
      end
   set_menu_label (child : GTK_WIDGET; menu_label : GTK_WIDGET) is
      do
         gtk_notebook_set_menu_label  (to_external, child.to_external, menu_label.to_external);
      end
   set_menu_label_text (child : GTK_WIDGET; menu_text : STRING) is
      do
         np_gtk_notebook_set_menu_label_text  (to_external, child.to_external, menu_text);
      end
   tab_pos : INTEGER is
      do
         Result := gtk_notebook_tab_pos_acr (to_external)
      end
   query_tab_label_packing (child : GTK_WIDGET; expand : POINTER; fill : POINTER; pack_type : POINTER) is
      do
         gtk_notebook_query_tab_label_packing  (to_external, child.to_external, expand, fill, pack_type);
      end
   set_tab_label_packing (child : GTK_WIDGET; expand : BOOLEAN; fill : BOOLEAN; pack_type : GTK_PACK_TYPE) is
      do
         gtk_notebook_set_tab_label_packing  (to_external, child.to_external, expand.to_integer, fill.to_integer, pack_type.get_value);
      end
   reorder_child (child : GTK_WIDGET; position : INTEGER) is
      do
         gtk_notebook_reorder_child  (to_external, child.to_external, position);
      end
feature -- Queries
   show_tabs : BOOLEAN is
   do
      Result := gtk_notebook_show_tabs_acr (to_external);
   end
   show_border : BOOLEAN is
   do
      Result := gtk_notebook_show_border_acr (to_external);
   end
end -- class GTK_NOTEBOOK
