indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_paned.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_PANED
inherit
   GTK_PANED_EXTERNALS
   GTK_CONTAINER
      redefine
         make_for_register
      end
creation
   from_external, make_for_register

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_paned_get_type)
      end

feature -- access

   child1 : GTK_WIDGET is
      do
         !!Result.from_external(gtk_paned_child1_acr(to_external))
      end

   child2 : GTK_WIDGET is
      do
         !!Result.from_external(gtk_paned_child2_acr(to_external))
      end

   position_set : BOOLEAN is
      do
         Result := gtk_paned_position_set_acr(to_external)
      end

   in_drag : BOOLEAN is
      do
         Result := gtk_paned_in_drag_acr(to_external)
      end

   child1_shrink : BOOLEAN is
      do
         Result := gtk_paned_child1_shrink_acr(to_external)
      end

   child1_resize : BOOLEAN is
      do
         Result := gtk_paned_child1_resize_acr(to_external)
      end

   child2_shrink : BOOLEAN is
      do
         Result := gtk_paned_child2_shrink_acr(to_external)
      end

   child2_resize : BOOLEAN is
      do
         Result := gtk_paned_child2_resize_acr(to_external)
      end

feature -- operations

   add1 (child : GTK_WIDGET) is
      do
         gtk_paned_add1  (to_external, child.to_external);
      end
   add2 (child : GTK_WIDGET) is
      do
         gtk_paned_add2  (to_external, child.to_external);
      end
   pack1 (child : GTK_WIDGET; resize : BOOLEAN; shrink : BOOLEAN) is
      do
         gtk_paned_pack1  (to_external, child.to_external,
                            resize.to_integer, shrink.to_integer);
      end
   pack2 (child : GTK_WIDGET; resize : BOOLEAN; shrink : BOOLEAN) is
      do
         gtk_paned_pack2  (to_external, child.to_external, resize.to_integer,
                            shrink.to_integer);
      end
   set_position (position : INTEGER) is
      do
         gtk_paned_set_position  (to_external, position);
      end
   set_handle_size (size : INTEGER) is
      do
         gtk_paned_set_handle_size  (to_external, size);
      end
   set_gutter_size (size : INTEGER) is
      do
         gtk_paned_set_gutter_size  (to_external, size);
      end

end -- class GTK_PANED
