indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_preview.e,v 1.4 2000/03/20 07:54:45 eugenem Exp $";

class GTK_PREVIEW
inherit
   GTK_PREVIEW_NP
   GTK_PREVIEW_EXTERNALS
   GTK_WIDGET
      rename
         get_visual as get_visual_widget
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (arg_type : GTK_PREVIEW_TYPE) is
      do
         from_external(gtk_preview_new  (arg_type.get_value));
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_preview_get_type)
      end

feature -- operations

   uninit is
      do
         gtk_preview_uninit;
      end
   size (width : INTEGER; height : INTEGER) is
      do
         gtk_preview_size  (to_external, width, height);
      end
   set_expand (expand : BOOLEAN) is
      do
         gtk_preview_set_expand  (to_external, expand.to_integer);
      end
   set_gamma (gamma : REAL) is
      do
         np_gtk_preview_set_gamma  (gamma);
      end
   set_color_cube (nred_shades : INTEGER; ngreen_shades : INTEGER; nblue_shades : INTEGER; ngray_shades : INTEGER) is
      do
         gtk_preview_set_color_cube  (nred_shades, ngreen_shades, nblue_shades, ngray_shades);
      end
   set_install_cmap (install_cmap : BOOLEAN) is
      do
         gtk_preview_set_install_cmap  (install_cmap.to_integer);
      end
   set_reserved (nreserved : INTEGER) is
      do
         gtk_preview_set_reserved  (nreserved);
      end
   get_visual : GDK_VISUAL is
      do
         !!Result.from_external(gtk_preview_get_visual);
      end
   get_cmap : GDK_COLORMAP is
      do
         !!Result.from_external(gtk_preview_get_cmap);
      end
   reset is
      do
         gtk_preview_reset;
      end

end -- class GTK_PREVIEW
