indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_table.e,v 1.3 2000/03/16 14:03:55 eugenem Exp $";

class GTK_TABLE
inherit
   GTK_TABLE_EXTERNALS
   GTK_CONTAINER
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (rows : INTEGER; columns : INTEGER; homogenous : BOOLEAN) is
      do
         from_external(gtk_table_new  (rows, columns, homogenous.to_integer))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_table_get_type)
      end

feature -- operations

   resize (rows : INTEGER; columns : INTEGER) is
      do
         gtk_table_resize  (to_external, rows, columns);
      end
   attach (child : GTK_WIDGET; left_attach : INTEGER; right_attach : INTEGER; top_attach : INTEGER; bottom_attach : INTEGER; xoptions : GTK_ATTACH_OPTIONS; yoptions : GTK_ATTACH_OPTIONS; xpadding : INTEGER; ypadding : INTEGER) is
      do
         gtk_table_attach  (to_external, child.to_external, left_attach, right_attach, top_attach, bottom_attach, xoptions.get_value, yoptions.get_value, xpadding, ypadding);
      end
   attach_defaults (child : GTK_WIDGET; left_attach : INTEGER; right_attach : INTEGER; top_attach : INTEGER; bottom_attach : INTEGER) is
      do
         gtk_table_attach_defaults  (to_external, child.to_external, left_attach, right_attach, top_attach, bottom_attach);
      end
   set_row_spacing (row : INTEGER; spacing : INTEGER) is
      do
         gtk_table_set_row_spacing  (to_external, row, spacing);
      end
   set_col_spacing (column : INTEGER; spacing : INTEGER) is
      do
         gtk_table_set_col_spacing  (to_external, column, spacing);
      end
   set_row_spacings (spacing : INTEGER) is
      do
         gtk_table_set_row_spacings  (to_external, spacing);
      end
   set_col_spacings (spacing : INTEGER) is
      do
         gtk_table_set_col_spacings  (to_external, spacing);
      end
   set_homogeneous (homogeneous : BOOLEAN) is
      do
         gtk_table_set_homogeneous  (to_external, homogeneous.to_integer);
      end

end -- class GTK_TABLE
