indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_toolbar.e,v 1.4 2000/03/20 07:54:45 eugenem Exp $";

class GTK_TOOLBAR
inherit
   GTK_TOOLBAR_NP
   GTK_TOOLBAR_EXTERNALS
   GTK_CONTAINER
      rename
         set_style as set_style_widget
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (orientation : GTK_ORIENTATION; arg_style : GTK_TOOLBAR_STYLE) is
      do
         from_external(gtk_toolbar_new  (orientation.get_value, arg_style.get_value));
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_toolbar_get_type)
      end

feature -- queries

   last_added_element : GTK_WIDGET

   num_children : INTEGER is
      do
         Result := gtk_toolbar_num_children_acr(to_external)
      end

feature -- operations

   insert_element (element_type : GTK_TOOLBAR_CHILD_TYPE; widget : GTK_WIDGET;
      text, tooltip_text, tooltip_private_text : STRING; icon : GTK_WIDGET;
      callback_handler : VEGTK_CALLBACK_HANDLER; callback : POINTER;
      user_data : ANY; position : INTEGER) is
      local
         c_object : POINTER
      do
         c_object := np_gtk_toolbar_insert_element(to_external,
               element_type.get_value, to_external_with_check(widget), text,
               tooltip_text, tooltip_private_text, icon.to_external, position)
         if c_object = default_pointer then
            last_added_element := Void
         else
            if element_type.is_equal(Gtk_toolbar_child_button) then
               !GTK_BUTTON!last_added_element.from_external(c_object)
            else
               if element_type.is_equal(Gtk_toolbar_child_togglebutton) then
                  !GTK_TOGGLE_BUTTON!last_added_element.from_external(c_object)
               else
                  if element_type.is_equal(Gtk_toolbar_child_radiobutton) then
                     !GTK_RADIO_BUTTON!last_added_element.from_external(c_object)
                  else
                     !GTK_WIDGET!last_added_element.from_external(c_object)
                  end
               end
            end
            if callback_handler /= Void and callback /= default_pointer
            then
               callback_handler.signal_connect_with_data(last_added_element,"clicked",callback,user_data)
            end
         end
      ensure
         element_not_null: (not (element_type.is_equal(Gtk_toolbar_child_space))) implies last_added_element /= Void
      end

   append_element (child_type : GTK_TOOLBAR_CHILD_TYPE; widget : GTK_WIDGET;
      text, tooltip_text, tooltip_private_text : STRING;
      icon : GTK_WIDGET;
      callback_handler : VEGTK_CALLBACK_HANDLER; callback : POINTER;
      user_data : ANY) is
      do
         insert_element(child_type, widget, text, tooltip_text,
            tooltip_private_text, icon, callback_handler, callback,
            user_data, num_children)
      end

   prepend_element (child_type : GTK_TOOLBAR_CHILD_TYPE; widget : GTK_WIDGET;
      text, tooltip_text, tooltip_private_text : STRING;
      icon : GTK_WIDGET;
      callback_handler : VEGTK_CALLBACK_HANDLER; callback : POINTER;
      user_data : ANY) is
      do
         insert_element(child_type, widget, text, tooltip_text,
            tooltip_private_text, icon, callback_handler, callback,
            user_data, 0)
      end

   append_item(text, tooltip_text, tooltip_private_text : STRING;
      icon : GTK_WIDGET; callback_handler : VEGTK_CALLBACK_HANDLER;
      callback : POINTER; user_data : ANY) is
      do
         insert_element(Gtk_toolbar_child_button, Void, text, tooltip_text,
            tooltip_private_text, icon, callback_handler, callback,
            user_data, num_children)
      end
   append_space is
      do
         gtk_toolbar_append_space  (to_external);
      end
   prepend_space is
      do
         gtk_toolbar_prepend_space  (to_external);
      end
   insert_space (position : INTEGER) is
      do
         gtk_toolbar_insert_space  (to_external, position);
      end
   append_widget (Widget : GTK_WIDGET; tooltip_text : STRING; tooltip_private_text : STRING) is
      do
         np_gtk_toolbar_append_widget  (to_external, Widget.to_external, tooltip_text, tooltip_private_text);
      end
   prepend_widget (Widget : GTK_WIDGET; tooltip_text : STRING; tooltip_private_text : STRING) is
      do
         np_gtk_toolbar_prepend_widget  (to_external, Widget.to_external, tooltip_text, tooltip_private_text);
      end
   insert_widget (widget : GTK_WIDGET; tooltip_text : STRING; tooltip_private_text : STRING; position : INTEGER) is
      do
         np_gtk_toolbar_insert_widget  (to_external, widget.to_external, tooltip_text, tooltip_private_text, position);
      end
   set_orientation (orientation : GTK_ORIENTATION) is
      do
         gtk_toolbar_set_orientation  (to_external, orientation.get_value);
      end
   set_style (arg_style : GTK_TOOLBAR_STYLE) is
      do
         gtk_toolbar_set_style  (to_external, arg_style.get_value);
      end
   set_space_size (space_size : INTEGER) is
      do
         gtk_toolbar_set_space_size  (to_external, space_size);
      end
   set_space_style (space_style : GTK_TOOLBAR_SPACE_STYLE) is
      do
         gtk_toolbar_set_space_style  (to_external, space_style.get_value);
      end
   set_tooltips (enable : BOOLEAN) is
      do
         gtk_toolbar_set_tooltips  (to_external, enable.to_integer);
      end
   set_button_relief (relief : GTK_RELIEF_STYLE) is
      do
         gtk_toolbar_set_button_relief  (to_external, relief.get_value);
      end
   get_button_relief : GTK_RELIEF_STYLE is
      do
         !!result.make(gtk_toolbar_get_button_relief  (to_external));
      end

end -- class GTK_TOOLBAR
