indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_tree.e,v 1.2 2000/03/13 18:19:56 eugenem Exp $";

class GTK_TREE
inherit
   GTK_TREE_EXTERNALS
   GTK_CONTAINER
      redefine
         make_for_register
      end
creation
   from_external, make
feature -- creation
   make is
      do
         from_external (gtk_tree_new);
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_tree_get_type)
      end

feature -- access

   selection_list : G_LIST [GTK_TREE_ITEM] is
      do
         !G_LIST_OF_GTK_TREE_ITEM!Result.from_external (gtk_tree_selection_acr(to_external))
      end -- selection

   selection_array : ARRAY [GTK_TREE_ITEM] is
      local
         tmp_list : G_LIST_OF_GTK_TREE_ITEM;
      do
         !!tmp_list.from_external (gtk_tree_selection_acr(to_external))
         if tmp_list /= Void then
            Result := tmp_list.to_array
         end
      end -- selection


feature -- queries

   level : INTEGER is
      do
         Result := gtk_tree_level_acr (to_external)
      end

feature -- operations

   append (child : GTK_TREE_ITEM) is
      do
         gtk_tree_append  (to_external, child.to_external);
      end

   prepend (child : GTK_TREE_ITEM) is
      do
         gtk_tree_prepend  (to_external, child.to_external);
      end

   insert (child : GTK_TREE_ITEM; position : INTEGER) is
      do
         gtk_tree_insert  (to_external, child.to_external, position);
      end

   remove_items_list (items : G_LIST[GTK_TREE_ITEM]) is
      do
         gtk_tree_remove_items  (to_external, items.to_external);
      end

   remove_items_array (items : ARRAY [GTK_TREE_ITEM]) is
      local
         tmp_list : G_LIST_OF_GTK_TREE_ITEM;
      do
         !!tmp_list.from_array (items);
         gtk_tree_remove_items  (to_external, tmp_list.to_external);
      end

   clear_items (start : INTEGER; upper : INTEGER) is
      do
         gtk_tree_clear_items  (to_external, start, upper);
      end

   select_item (item : INTEGER) is
      do
         gtk_tree_select_item  (to_external, item);
      end

   unselect_item (item : INTEGER) is
      do
         gtk_tree_unselect_item  (to_external, item);
      end

   select_child (child : GTK_TREE_ITEM) is
      do
         gtk_tree_select_child  (to_external, child.to_external);
      end

   unselect_child (child : GTK_TREE_ITEM) is
      do
         gtk_tree_unselect_child  (to_external, child.to_external);
      end

   child_position (child : GTK_TREE_ITEM) : INTEGER is
      do
         Result:= gtk_tree_child_position  (to_external, child.to_external);
      end

   set_selection_mode (mode : GTK_SELECTION_MODE) is
      do
         gtk_tree_set_selection_mode  (to_external, mode.get_value);
      end

   set_view_mode (mode : GTK_TREE_VIEW_MODE) is
      do
         gtk_tree_set_view_mode  (to_external, mode.get_value);
      end

   set_view_lines (flag : BOOLEAN) is
      do
         gtk_tree_set_view_lines  (to_external, flag.to_integer);
      end

   remove_item (child : GTK_TREE_ITEM) is
      do
         gtk_tree_remove_item  (to_external, child.to_external);
      end

end -- class GTK_TREE
