indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_widget.e,v 1.5 2002/09/03 13:59:41 eugenem Exp $";

class GTK_WIDGET
inherit
   GTK_WIDGET_EXTERNALS
   GTK_WIDGET_NP
   GTK_OBJECT
      rename
         destroy as destroy_object,
         ref as ref_object,
         unref as unref_object
      redefine
         make_for_register
      end
creation
   from_external, make_for_register

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_widget_get_type)
      end

feature -- access

   parent : GTK_CONTAINER is
      do
         Result ?= object_factory.make_object_from_pointer(gtk_widget_parent_acr(to_external))
      end

   mapped : BOOLEAN is
      do
         Result := gtk_widget_mapped_macro  (to_external)
      end

   window : GDK_WINDOW is
      do
         !!Result.from_external(gtk_widget_window_acr  (to_external));
      end

   allocation : GTK_ALLOCATION is
      do
         !!result.from_external(gtk_widget_allocation_acr (to_external))
      end

feature -- operations

   visible : BOOLEAN is
      do
         Result := gtk_widget_visible (to_external)
      end
   state : GTK_STATE_TYPE is
      do
         !!result.make(gtk_widget_state  (to_external))
      end
   flags : GTK_WIDGET_FLAGS is
      do
         !!result.make(gtk_widget_flags  (to_external))
      end
   set_flags (arg_flags : GTK_WIDGET_FLAGS) is
      do
         gtk_widget_set_flags  (to_external, arg_flags.get_value);
      end
   unset_flags (arg_flags : GTK_WIDGET_FLAGS) is
      do
         gtk_widget_unset_flags  (to_external, arg_flags.get_value);
      end
   destroy is
      do
         gtk_widget_destroy  (to_external);
      end
   motion_notify_event(arg_event : GDK_EVENT) is
      do
         gtk_widget_motion_notify_event(to_external,arg_event.to_external)
      end
   unparent is
      do
         gtk_widget_unparent  (to_external);
      end
   show is
      do
         gtk_widget_show  (to_external);
      end
   hide is
      do
         gtk_widget_hide  (to_external);
      end
   show_all is
      do
         gtk_widget_show_all  (to_external);
      end
   hide_all is
      do
         gtk_widget_hide_all  (to_external);
      end
   map is
      do
         gtk_widget_map  (to_external);
      end
   unmap is
      do
         gtk_widget_unmap  (to_external);
      end
   realize is
      do
         gtk_widget_realize  (to_external);
      end
   unrealize is
      do
         gtk_widget_unrealize  (to_external);
      end
   add_accelerator (accel_signal : STRING; accel_group : GTK_ACCEL_GROUP; accel_key : INTEGER; accel_mods : GDK_MODIFIER_TYPE; accel_flags : GTK_ACCEL_FLAGS) is
      do
         np_gtk_widget_add_accelerator  (to_external, accel_signal, accel_group.to_external, accel_key, accel_mods.get_value, accel_flags.get_value);
      end
   remove_accelerator (accel_group : GTK_ACCEL_GROUP; accel_key : INTEGER; accel_mods : INTEGER) is
      do
         gtk_widget_remove_accelerator  (to_external, accel_group.to_external, accel_key, accel_mods);
      end
   event (arg_event : GDK_EVENT) : BOOLEAN is
      do
         Result:= gtk_widget_event  (to_external, arg_event.to_external);
      end
   activate is
      do
         gtk_widget_activate  (to_external);
      end
   reparent (new_parent : GTK_WIDGET) is
      do
         gtk_widget_reparent  (to_external, new_parent.to_external);
      end
   popup (x : INTEGER; y : INTEGER) is
      do
         gtk_widget_popup  (to_external, x, y);
      end
   grab_focus is
      do
         gtk_widget_grab_focus  (to_external);
      end
   grab_default is
      do
         gtk_widget_grab_default  (to_external);
      end
   grab_add is
      do
         ext_real_gtk_grab_add (to_external);
      end
   grab_remove is
      do
         ext_real_gtk_grab_remove (to_external);
      end
   set_name (name : STRING) is
      do
         np_gtk_widget_set_name  (to_external, name);
      end
   get_name : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external (gtk_widget_get_name  (to_external));
      end
   set_state (arg_state : GTK_STATE_TYPE) is
      do
         gtk_widget_set_state  (to_external, arg_state.get_value);
      end
   set_sensitive (sensitive : BOOLEAN) is
      do
         gtk_widget_set_sensitive  (to_external, sensitive.to_integer);
      end
   set_parent (arg_parent : GTK_WIDGET) is
      do
         gtk_widget_set_parent  (to_external, arg_parent.to_external);
      end
   set_style (arg_style : GTK_STYLE) is
      do
         gtk_widget_set_style  (to_external, arg_style.to_external);
      end
   set_uposition (x : INTEGER; y : INTEGER) is
      do
         gtk_widget_set_uposition  (to_external, x, y);
      end
   set_usize (height : INTEGER; width : INTEGER) is
      do
         gtk_widget_set_usize  (to_external, height, width);
      end
   set_events (events : GDK_EVENT_MASK) is
      do
         gtk_widget_set_events  (to_external, events.get_value);
      end
   set_extension_events (events : GDK_EXTENSION_MODE) is
      do
         gtk_widget_set_extension_events  (to_external, events.get_value);
      end
   get_toplevel : GTK_WIDGET is
      do
         !!Result.from_external(gtk_widget_get_toplevel  (to_external));
      end
   get_colormap : GDK_COLORMAP is
      do
         !!Result.from_external(gtk_widget_get_colormap  (to_external));
      end
   get_visual : GDK_VISUAL is
      do
         !!Result.from_external(gtk_widget_get_visual  (to_external));
      end
   get_style : GTK_STYLE is
      do
         !!Result.from_external(gtk_widget_get_style  (to_external));
      end
   get_events : GDK_EVENT_MASK is
      do
         !!result.make(gtk_widget_get_events  (to_external));
      end
   get_extension_events : GDK_EVENT_MASK is
      do
         !!result.make(gtk_widget_get_extension_events  (to_external));
      end
   is_ancestor (ancestor : GTK_WIDGET) : BOOLEAN is
      do
         Result:= gtk_widget_is_ancestor  (to_external, ancestor.to_external);
      end
   push_colormap (cmap : GDK_COLORMAP) is
      do
         gtk_widget_push_colormap  (cmap.to_external);
      end
   push_visual (visual : GDK_VISUAL) is
      do
         gtk_widget_push_visual  (visual.to_external);
      end
   push_style (arg_style : GTK_STYLE) is
      do
         gtk_widget_push_style  (arg_style.to_external);
      end
   pop_colormap is
      do
         gtk_widget_pop_colormap;
      end
   pop_visual is
      do
         gtk_widget_pop_visual;
      end
   pop_style is
      do
         gtk_widget_pop_style;
      end
   set_default_colormap (cmap : GDK_COLORMAP) is
      do
         gtk_widget_set_default_colormap  (cmap.to_external);
      end
   set_default_visual (visual : GDK_VISUAL) is
      do
         gtk_widget_set_default_visual  (visual.to_external);
      end
   set_default_style (arg_style : GTK_STYLE) is
      do
         gtk_widget_set_default_style  (arg_style.to_external);
      end
   get_default_colormap : GDK_COLORMAP is
      do
         !!Result.from_external(gtk_widget_get_default_colormap);
      end
   get_default_visual : GDK_VISUAL is
      do
         !!Result.from_external(gtk_widget_get_default_visual);
      end
   get_default_style : GTK_STYLE is
      do
         !!Result.from_external(gtk_widget_get_default_style);
      end
   ref is
      do
         gtk_widget_ref  (to_external);
      end
   unref is
      do
         gtk_widget_unref  (to_external);
      end
   destroyed (widget_pointer : POINTER) is
      do
         gtk_widget_destroyed  (to_external, widget_pointer);
      end
   show_now is
      do
         gtk_widget_show_now  (to_external);
      end
   queue_draw is
      do
         gtk_widget_queue_draw  (to_external);
      end
   queue_draw_area(x, y, width, height : INTEGER) is
      do
         gtk_widget_queue_draw_area(to_external, x, y, width, height)
      end
   queue_clear is
      do
         gtk_widget_queue_clear(to_external)
      end
   queue_clear_area(x, y, width, height : INTEGER) is
      do
         gtk_widget_queue_clear_area(to_external, x, y, width, height)
      end
   queue_resize is
      do
         gtk_widget_queue_resize  (to_external);
      end
   draw (area : GDK_RECTANGLE) is
      do
         gtk_widget_draw  (to_external, to_external_with_check(area));
      end
   draw_focus is
      do
         gtk_widget_draw_focus  (to_external);
      end
   draw_default is
      do
         gtk_widget_draw_default  (to_external);
      end
   accelerator_signal (accel_group : GTK_ACCEL_GROUP; accel_key : INTEGER; accel_mods : INTEGER) : INTEGER is
      do
         Result:= gtk_widget_accelerator_signal  (to_external, accel_group.to_external, accel_key, accel_mods);
      end
   lock_accelerators is
      do
         gtk_widget_lock_accelerators  (to_external);
      end
   unlock_accelerators is
      do
         gtk_widget_unlock_accelerators  (to_external);
      end
   set_scroll_adjustments (hadjustment : GTK_ADJUSTMENT; vadjustment : GTK_ADJUSTMENT) : INTEGER is
      do
         Result:= gtk_widget_set_scroll_adjustments  (to_external, hadjustment.to_external, vadjustment.to_external);
      end
   intersect (area : GDK_RECTANGLE; intersection : GDK_RECTANGLE) : INTEGER is
      do
         Result:= gtk_widget_intersect  (to_external, area.to_external, intersection.to_external);
      end
   set_parent_window (parent_window : GDK_WINDOW) is
      do
         gtk_widget_set_parent_window  (to_external, parent_window.to_external);
      end
   get_parent_window : GDK_WINDOW is
      do
         !!Result.from_external(gtk_widget_get_parent_window  (to_external));
      end
   get_ancestor (widget_type : GTK_TYPE) : GTK_WIDGET is
      do
         !!Result.from_external(gtk_widget_get_ancestor  (to_external, widget_type.to_external));
      end
   get_pointer (x : POINTER; y : POINTER) is
      do
         gtk_widget_get_pointer  (to_external, x, y);
      end
   hide_on_delete : INTEGER is
      do
         Result:= gtk_widget_hide_on_delete  (to_external);
      end
   set_rc_style is
      do
         gtk_widget_set_rc_style  (to_external);
      end
   ensure_style is
      do
         gtk_widget_ensure_style  (to_external);
      end
   restore_default_style is
      do
         gtk_widget_restore_default_style  (to_external);
      end
   reset_rc_styles is
      do
         gtk_widget_reset_rc_styles  (to_external);
      end
   shape_combine_mask (shape_mask : GDK_BITMAP; offset_x : INTEGER; offset_y : INTEGER) is
      do
         gtk_widget_shape_combine_mask  (to_external, shape_mask.to_external, offset_x, offset_y);
      end
   path (path_length : POINTER; arg_path : POINTER; path_reserved : POINTER) is
      do
         gtk_widget_path  (to_external, path_length, arg_path, path_reserved);
      end
   class_path (path_length : POINTER; arg_path : POINTER; path_reserved : POINTER) is
      do
         gtk_widget_class_path  (to_external, path_length, arg_path, path_reserved);
      end
   selection_owner_set(selection : GDK_ATOM; time : INTEGER) : INTEGER is
      do
         Result := gtk_selection_owner_set(to_external,selection,time)
      end
   selection_add_target(selection, target : GDK_ATOM; info : INTEGER) is
      do
         gtk_selection_add_target(to_external,selection,target,info)
      end
   selection_add_targets(selection : GDK_ATOM; targets : ARRAY[GTK_TARGET_ENTRY]) is
      local
         tmp : VEGTK_EXTERNAL_OBJECTS
      do
         !!tmp.make(targets)
         gtk_selection_add_targets(to_external,selection,tmp.to_external)
      end
   selection_convert(selection, target : GDK_ATOM; time : INTEGER) : INTEGER is
      do
         Result := gtk_selection_convert(to_external,selection,target,time)
      end
   size_allocate(alloc : POINTER) is
      do
         gtk_widget_size_allocate(to_external, alloc)
      end

end -- class GTK_WIDGET

