indexing
    title       : "GTK ";
    cluster     : "VEGTK_Common";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: vegtk_callback_handler.e,v 1.5 2000/03/16 14:03:55 eugenem Exp $";

class VEGTK_CALLBACK_HANDLER

feature
   last_signal_id: INTEGER;
feature -- signal connection procedures

   signal_connect(widget : GTK_OBJECT; sig_name :STRING;func_addr : POINTER) is
      local
         cb_data : VEGTK_CALLBACK_DATA;
         t : ANY
      do
         !!cb_data.make(widget,current,func_addr);
         cb_array_index := cb_array_index + 1
         cb_array.force(cb_data, cb_array_index)

         t := sig_name.to_c
         last_signal_id :=  ext_signal_connect(widget.to_external,
                                               $t, cb_data)
      end -- signal_connect

   signal_connect_with_data(widget : GTK_OBJECT; sig_name:STRING;func_addr : POINTER;
                            data : ANY) is
      local
         cb_data : VEGTK_CALLBACK_DATA;
         t : ANY
      do
         !!cb_data.make_with_data(widget,current,func_addr,data);
         cb_array_index := cb_array_index + 1
         cb_array.force(cb_data, cb_array_index)

         t := sig_name.to_c
         last_signal_id :=  ext_signal_connect(widget.to_external,
                                               $t, cb_data)

      end -- signal_connect_with_data

   signal_connect_after(widget : GTK_OBJECT; sig_name:STRING;func_addr : POINTER;
                            data : ANY) is
      local
         cb_data : VEGTK_CALLBACK_DATA;
         t : ANY
      do
         !!cb_data.make_with_data(widget,current,func_addr,data);
         cb_array.force(cb_data,cb_array.count+1);

         t := sig_name.to_c
         last_signal_id :=  ext_signal_connect_after(widget.to_external,
                                               $t, cb_data)
      end -- signal_connect_with_data

   signal_disconnect(widget : GTK_OBJECT; sig_id : INTEGER) is
   do
      gtk_signal_disconnect(widget.to_external,sig_id);
   end
feature {NONE}
   -- saved callback data
   cb_array : ARRAY[VEGTK_CALLBACK_DATA] is
      do
         if callback_data_array = Void then
            !!callback_data_array.make(1,50);
            cb_array_index := 1
         end
         Result:=callback_data_array;
      end
   callback_data_array : ARRAY[VEGTK_CALLBACK_DATA]
   cb_array_index : INTEGER

feature {NONE} -- external C functions
   ext_signal_connect(widget : POINTER; sig_name : POINTER;
                      cb_data : VEGTK_CALLBACK_DATA) : INTEGER is
      external "C"
      alias "ext_signal_connect"
      end
   ext_signal_connect_after(widget : POINTER; sig_name : POINTER;
                      cb_data : VEGTK_CALLBACK_DATA) : INTEGER is
      external "C"
      alias "ext_signal_connect_after"
      end
   gtk_signal_disconnect(widget : POINTER;sig_id :INTEGER) is
      external "C"
      alias "gtk_signal_disconnect"
      end

end -- class VEGTK_CALLBACK_HANDLER
