indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: vegtk_init_np.e,v 1.5 2000/03/16 14:03:55 eugenem Exp $";

class VEGTK_INIT_NP
inherit
   VEGTK_INIT

feature -- Queries

   vegtk_args : ARRAY[STRING]

feature -- Operations

   vegtk_init is
      local
         strings : VEGTK_EXTERNAL_STRINGS
         i, size, new_size : INTEGER
         s : STRING
         t_args : ARRAY[STRING];
         args : expanded ARGUMENTS
         sh : expanded VEGTK_STRING_HELPER
      once
         !!t_args.make(0,args.argument_count)
         -- create the temporary array with first item= program name
         from
            i := 0
         until
            i > args.argument_count
         loop
            t_args.put(args.argument(i),i);
            i := i+1
         end

         !!strings.make(t_args)
         ext_vegtk_init(t_args.count, strings.to_external)
         new_size := ext_vegtk_args_get_count
         !!vegtk_args.make(0,new_size-1)
         from
            i := 0
         until
            i > new_size-1
         loop
            s := sh.string_from_external(ext_vegtk_args_get_i(i))
            vegtk_args.put(s,i)
            i := i+1
         end
         ext_vegtk_args_free

         register_common_classes
   end

feature {NONE} -- C externals


   ext_vegtk_init(argc : INTEGER; argv : POINTER) is
      external "C"
      end
   ext_vegtk_args_get_count : INTEGER is
      external "C"
      end
   ext_vegtk_args_get_i(i : INTEGER) : POINTER is
      external "C"
      end
   ext_vegtk_args_free is
      external "C"
      end

end -- class VEGTK_INIT_NP
