indexing
    title       : "GTK ";
    cluster     : "VEGTK_Common";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: vegtk_callback_data.e,v 1.7 2002/09/03 13:59:41 eugenem Exp $";

class VEGTK_CALLBACK_DATA
creation
   make,make_with_data
feature
   make (arg_widget : GTK_OBJECT; arg_object : ANY; arg_routine :POINTER) is
      do
         fld_widget := arg_widget
         fld_object :=  arg_object
         fld_routine := arg_routine

         -- fight agains SmallEiffel optimization :-)
         fld_data := Void
         fld_signal_id := 0
         fld_is_event := 0
         fld_nparams := 0
         fld_args := default_pointer
         fld_arg_types := default_pointer
         fld_return_type := 0
         fld_return_arg := default_pointer
      end
   make_with_data (arg_widget : GTK_OBJECT;arg_object : ANY; arg_routine : POINTER;arg_data: ANY) is
      do
         fld_widget := arg_widget
         fld_object :=  arg_object
         fld_routine := arg_routine
         fld_data := arg_data
      end
feature -- queries
   is_event : BOOLEAN is
      do
         Result := (fld_is_event = 1)
      end
   get_arg_count : INTEGER is
      do
         Result := fld_nparams;
      end
   get_args : ARRAY[ANY] is
      local
         i,argc : INTEGER;
      do
         argc := get_arg_count;
         !!Result.make(1,0);
         from i := 1 until i > argc
         loop
            Result.force(get_arg(i),Result.count+1);
            i := i+1;
         end -- loop
      end
   get_widget : GTK_OBJECT is
      do
         Result := fld_widget;
      end
   get_data : ANY is
      do
         Result := fld_data;
      end
   get_widget_ext : POINTER is
      do
         Result := fld_widget.to_external;
      end
   get_signal_id : INTEGER is
      do
         Result := fld_signal_id;
      end
   get_event : GDK_EVENT is
      do
         if is_event then
           Result:=get_arg_event(1);
         end
      end
   return_type_is_integer : BOOLEAN is
      local
         int_type : GTK_TYPE
      do
         !!int_type.from_name("gint")
         Result := fld_return_type = int_type.value
      end
   return_type_is_boolean : BOOLEAN is
      local
         bool_type : GTK_TYPE
      do
         !!bool_type.from_name("gboolean")
         Result := fld_return_type = bool_type.value
      end
feature -- operations
   set_signal_id (arg_signal_id : INTEGER) is
      do
         fld_signal_id := arg_signal_id;
      end
   set_is_event (arg_is_event : INTEGER) is
      do
         fld_is_event := arg_is_event
      end
   set_nparams (arg_nparams : INTEGER) is
      do
         fld_nparams := arg_nparams
      end
   set_args (arg_args : POINTER) is
      do
         fld_args := arg_args
      end
   set_arg_types (arg_arg_types : POINTER) is
      do
         fld_arg_types := arg_arg_types
      end
   set_return_type (arg_return_type : INTEGER) is
      do
         fld_return_type := arg_return_type
      end
   set_return_arg (arg_return_arg : POINTER) is
      do
         fld_return_arg := arg_return_arg
      end
   set_return_value_integer (arg_return_arg : INTEGER) is
      require
         return_arg_exists: fld_return_arg /= default_pointer
         return_type_is_integer: return_type_is_integer
      do
         ext_set_return_arg_integer (Current, arg_return_arg)
      end
   set_return_value_boolean (arg_return_arg : BOOLEAN) is
      require
         return_arg_exists: fld_return_arg /= default_pointer
         return_type_is_boolean: return_type_is_boolean
      do
         ext_set_return_arg_boolean (Current, arg_return_arg)
      end
feature -- real storage
   fld_object        : ANY;
   fld_routine       : POINTER;
   fld_widget        : GTK_OBJECT;
   fld_data          : ANY;
   fld_signal_id     : INTEGER;
   fld_is_event      : INTEGER;
-- This is used in marshalling
   fld_nparams       : INTEGER;
   fld_args          : POINTER;
   fld_arg_types     : POINTER;
   fld_return_type   : INTEGER;
   fld_return_arg    : POINTER;

-- Arguments handling functions
   get_arg_type (n : INTEGER) : GTK_TYPE is
      do
         !!Result.make(ext_get_arg_type(current,n))
      end
   get_arg (n : INTEGER) : ANY is
      local
         type         : GTK_TYPE;
         fund_type    : GTK_FUNDAMENTAL_TYPE;
         constants    : GTK_CONSTANTS;
      do
         !!constants
         type := get_arg_type(n);
         fund_type := type.fundamental;
         if fund_type.is_equal(constants.Gtk_type_int)
            or fund_type.is_equal(constants.Gtk_type_uint)
            or fund_type.is_equal(constants.Gtk_type_long)
            or fund_type.is_equal(constants.Gtk_type_ulong) then
            Result := get_arg_int(n);
         elseif fund_type.is_equal(constants.Gtk_type_char)
            or fund_type.is_equal(constants.Gtk_type_uchar) then
            Result := get_arg_int(n);
         elseif fund_type.is_equal(constants.Gtk_type_float) then
            Result := get_arg_float(n)
         elseif fund_type.is_equal(constants.Gtk_type_double) then
            Result := get_arg_double(n)
         elseif fund_type.is_equal(constants.Gtk_type_bool) then
            Result := get_arg_bool(n)
         elseif fund_type.is_equal(constants.Gtk_type_string) then
            Result := get_arg_string(n)
         elseif fund_type.is_equal(constants.Gtk_type_pointer) then
            Result := get_arg_pointer(n)
         elseif fund_type.is_equal(constants.Gtk_type_object) then
            Result := get_arg_object(n,type)

         -- Here is dirty hack, should be changed in the feature!
         elseif fund_type.is_equal(constants.Gtk_type_boxed) then
            Result := make_boxed(type.name,get_arg_pointer(n));
         elseif fund_type.is_equal(constants.Gtk_type_enum)
            or fund_type.is_equal(constants.Gtk_type_flags) then
            Result := make_flag_enum(type.name,get_arg_int(n));
         else
            Result := get_arg_pointer(n)
         end

         -- Gtk_type_invalid
         -- Gtk_type_none
         -- Gtk_type_signal
         -- Gtk_type_args
         -- Gtk_type_callback
         -- Gtk_type_c_callback
         -- Gtk_type_foreign
      end

   get_arg_pointer(n : INTEGER) : POINTER is
      do
         Result := ext_get_arg_pointer(current,n);
      end
   get_arg_int(n : INTEGER) : INTEGER is
      do
         Result := ext_get_arg_int(current,n);
      end
   get_arg_float (n : INTEGER) : REAL is
      do
         Result := ext_get_arg_float (current,n);
      end
   get_arg_double (n : INTEGER) : REAL is
      do
         Result := ext_get_arg_double (current,n);
      end
   get_arg_bool(n : INTEGER) : BOOLEAN is
      local
         arg_int : INTEGER;
      do
         arg_int := ext_get_arg_int(current,n);
         if arg_int = 0 then
            Result := False;
         else
            Result := True
         end
      end
   get_arg_string(n : INTEGER) : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external (ext_get_arg_pointer(current,n))
      end

   get_arg_object(n : INTEGER;type : GTK_TYPE) : GTK_OBJECT is
      local
         of : VEGTK_OBJECT_FACTORY;
         arg_ptr : POINTER;
      do
         !!of
         arg_ptr := ext_get_arg_pointer(current,n);
         if arg_ptr /= default_pointer then
            Result := of.make_object_from_pointer(arg_ptr);
         end
      end
   get_arg_event (n: INTEGER) : GDK_EVENT is
      do
         Result:=make_event(get_arg_pointer(n));
      end
feature { NONE }

   make_event (p: POINTER) : GDK_EVENT is
      local
         ef : GDK_EVENT_FACTORY
      do
         if p /= default_pointer then
            !!ef
            Result:=ef.create_gdk_event_from_ptr(p);
         end
      end

   make_flag_enum (name : STRING; val : INTEGER) : ANY is
      do
         if name.is_equal("GtkAccelFlags") then
            !GTK_ACCEL_FLAGS!Result.make(val);
         elseif name.is_equal("GtkCalendarDisplayOptions") then
            !GTK_CALENDAR_DISPLAY_OPTIONS!Result.make(val);
         elseif name.is_equal("GtkCellType") then
            !GTK_CELL_TYPE!Result.make(val);
         elseif name.is_equal("GtkCListDragPos") then
            !GTK_CLIST_DRAG_POS!Result.make(val);
         elseif name.is_equal("GtkButtonAction") then
            !GTK_BUTTON_ACTION!Result.make(val);
         elseif name.is_equal("GtkCTreePos") then
            !GTK_CTREE_POS!Result.make(val);
         elseif name.is_equal("GtkCTreeLineStyle") then
            !GTK_CTREE_LINE_STYLE!Result.make(val);
         elseif name.is_equal("GtkCTreeExpanderStyle") then
            !GTK_CTREE_EXPANDER_STYLE!Result.make(val);
         elseif name.is_equal("GtkCTreeExpansionType") then
            !GTK_CTREE_EXPANSION_TYPE!Result.make(val);
         elseif name.is_equal("GtkDebugFlag") then
            !GTK_DEBUG_FLAG!Result.make(val);
         elseif name.is_equal("GtkDestDefaults") then
            !GTK_DEST_DEFAULTS!Result.make(val);
         elseif name.is_equal("GtkTargetFlags") then
            !GTK_TARGET_FLAGS!Result.make(val);
         elseif name.is_equal("GtkArrowType") then
            !GTK_ARROW_TYPE!Result.make(val);
         elseif name.is_equal("GtkAttachOptions") then
            !GTK_ATTACH_OPTIONS!Result.make(val);
         elseif name.is_equal("GtkButtonBoxStyle") then
            !GTK_BUTTON_BOX_STYLE!Result.make(val);
         elseif name.is_equal("GtkCurveType") then
            !GTK_CURVE_TYPE!Result.make(val);
         elseif name.is_equal("GtkDirectionType") then
            !GTK_DIRECTION_TYPE!Result.make(val);
         elseif name.is_equal("GtkJustification") then
            !GTK_JUSTIFICATION!Result.make(val);
         elseif name.is_equal("GtkMatchType") then
            !GTK_MATCH_TYPE!Result.make(val);
         elseif name.is_equal("GtkMenuDirectionType") then
            !GTK_MENU_DIRECTION_TYPE!Result.make(val);
         elseif name.is_equal("GtkMenuFactoryType") then
            !GTK_MENU_FACTORY_TYPE!Result.make(val);
         elseif name.is_equal("GtkMetricType") then
            !GTK_METRIC_TYPE!Result.make(val);
         elseif name.is_equal("GtkOrientation") then
            !GTK_ORIENTATION!Result.make(val);
         elseif name.is_equal("GtkCornerType") then
            !GTK_CORNER_TYPE!Result.make(val);
         elseif name.is_equal("GtkPackType") then
            !GTK_PACK_TYPE!Result.make(val);
         elseif name.is_equal("GtkPathPriorityType") then
            !GTK_PATH_PRIORITY_TYPE!Result.make(val);
         elseif name.is_equal("GtkPathType") then
            !GTK_PATH_TYPE!Result.make(val);
         elseif name.is_equal("GtkPolicyType") then
            !GTK_POLICY_TYPE!Result.make(val);
         elseif name.is_equal("GtkPositionType") then
            !GTK_POSITION_TYPE!Result.make(val);
         elseif name.is_equal("GtkPreviewType") then
            !GTK_PREVIEW_TYPE!Result.make(val);
         elseif name.is_equal("GtkReliefStyle") then
            !GTK_RELIEF_STYLE!Result.make(val);
         elseif name.is_equal("GtkResizeMode") then
            !GTK_RESIZE_MODE!Result.make(val);
         elseif name.is_equal("GtkSignalRunType") then
            !GTK_SIGNAL_RUN_TYPE!Result.make(val);
         elseif name.is_equal("GtkScrollType") then
            !GTK_SCROLL_TYPE!Result.make(val);
         elseif name.is_equal("GtkSelectionMode") then
            !GTK_SELECTION_MODE!Result.make(val);
         elseif name.is_equal("GtkShadowType") then
            !GTK_SHADOW_TYPE!Result.make(val);
         elseif name.is_equal("GtkStateType") then
            !GTK_STATE_TYPE!Result.make(val);
         elseif name.is_equal("GtkSubmenuDirection") then
            !GTK_SUBMENU_DIRECTION!Result.make(val);
         elseif name.is_equal("GtkSubmenuPlacement") then
            !GTK_SUBMENU_PLACEMENT!Result.make(val);
         elseif name.is_equal("GtkToolbarStyle") then
            !GTK_TOOLBAR_STYLE!Result.make(val);
         elseif name.is_equal("GtkTroughType") then
            !GTK_TROUGH_TYPE!Result.make(val);
         elseif name.is_equal("GtkUpdateType") then
            !GTK_UPDATE_TYPE!Result.make(val);
         elseif name.is_equal("GtkVisibility") then
            !GTK_VISIBILITY!Result.make(val);
         elseif name.is_equal("GtkWindowPosition") then
            !GTK_WINDOW_POSITION!Result.make(val);
         elseif name.is_equal("GtkWindowType") then
            !GTK_WINDOW_TYPE!Result.make(val);
         elseif name.is_equal("GtkSortType") then
            !GTK_SORT_TYPE!Result.make(val);
         elseif name.is_equal("GtkFontMetricType") then
            !GTK_FONT_METRIC_TYPE!Result.make(val);
         elseif name.is_equal("GtkFontType") then
            !GTK_FONT_TYPE!Result.make(val);
         elseif name.is_equal("GtkFontFilterType") then
            !GTK_FONT_FILTER_TYPE!Result.make(val);
         elseif name.is_equal("GtkObjectFlags") then
            !GTK_OBJECT_FLAGS!Result.make(val);
         elseif name.is_equal("GtkArgFlags") then
            !GTK_ARG_FLAGS!Result.make(val);
         elseif name.is_equal("GtkPackerOptions") then
            !GTK_PACKER_OPTIONS!Result.make(val);
         elseif name.is_equal("GtkSideType") then
            !GTK_SIDE_TYPE!Result.make(val);
         elseif name.is_equal("GtkAnchorType") then
            !GTK_ANCHOR_TYPE!Result.make(val);
         elseif name.is_equal("GtkPrivateFlags") then
            !GTK_PRIVATE_FLAGS!Result.make(val);
         elseif name.is_equal("GtkProgressBarStyle") then
            !GTK_PROGRESS_BAR_STYLE!Result.make(val);
         elseif name.is_equal("GtkProgressBarOrientation") then
            !GTK_PROGRESS_BAR_ORIENTATION!Result.make(val);
         elseif name.is_equal("GtkRcFlags") then
            !GTK_RC_FLAGS!Result.make(val);
         elseif name.is_equal("GtkRcTokenType") then
            !GTK_RC_TOKEN_TYPE!Result.make(val);
         elseif name.is_equal("GtkSpinButtonUpdatePolicy") then
            !GTK_SPIN_BUTTON_UPDATE_POLICY!Result.make(val);
         elseif name.is_equal("GtkSpinType") then
            !GTK_SPIN_TYPE!Result.make(val);
         elseif name.is_equal("GtkToolbarChildType") then
            !GTK_TOOLBAR_CHILD_TYPE!Result.make(val);
         elseif name.is_equal("GtkToolbarSpaceStyle") then
            !GTK_TOOLBAR_SPACE_STYLE!Result.make(val);
         elseif name.is_equal("GtkTreeViewMode") then
            !GTK_TREE_VIEW_MODE!Result.make(val);
         elseif name.is_equal("GtkFundamentalType") then
            !GTK_FUNDAMENTAL_TYPE!Result.make(val);
         elseif name.is_equal("GtkWidgetFlags") then
            !GTK_WIDGET_FLAGS!Result.make(val);
         elseif name.is_equal("GdkColorContextMode") then
            !GDK_COLOR_CONTEXT_MODE!Result.make(val);
         elseif name.is_equal("GdkCursorType") then
            !GDK_CURSOR_TYPE!Result.make(val);
         elseif name.is_equal("GdkDragAction") then
            !GDK_DRAG_ACTION!Result.make(val);
         elseif name.is_equal("GdkDragProtocol") then
            !GDK_DRAG_PROTOCOL!Result.make(val);
         elseif name.is_equal("GdkDrawableType")
                or name.is_equal("GdkWindowType") then
--            !GDK_DRAWABLE_TYPE!Result.make(val); Temporary workaround
--  for for gtk-1.3 on Win32
            !GDK_WINDOW_TYPE!Result.make(val);
         elseif name.is_equal("GdkFilterReturn") then
            !GDK_FILTER_RETURN!Result.make(val);
         elseif name.is_equal("GdkEventType") then
            !GDK_EVENT_TYPE!Result.make(val);
         elseif name.is_equal("GdkEventMask") then
            !GDK_EVENT_MASK!Result.make(val);
         elseif name.is_equal("GdkVisibilityState") then
            !GDK_VISIBILITY_STATE!Result.make(val);
         elseif name.is_equal("GdkNotifyType") then
            !GDK_NOTIFY_TYPE!Result.make(val);
         elseif name.is_equal("GdkCrossingMode") then
            !GDK_CROSSING_MODE!Result.make(val);
         elseif name.is_equal("GdkPropertyState") then
            !GDK_PROPERTY_STATE!Result.make(val);
         elseif name.is_equal("GdkFontType") then
            !GDK_FONT_TYPE!Result.make(val);
         elseif name.is_equal("GdkCapStyle") then
            !GDK_CAP_STYLE!Result.make(val);
         elseif name.is_equal("GdkFill") then
            !GDK_FILL!Result.make(val);
         elseif name.is_equal("GdkFunction") then
            !GDK_FUNCTION!Result.make(val);
         elseif name.is_equal("GdkJoinStyle") then
            !GDK_JOIN_STYLE!Result.make(val);
         elseif name.is_equal("GdkLineStyle") then
            !GDK_LINE_STYLE!Result.make(val);
         elseif name.is_equal("GdkSubwindowMode") then
            !GDK_SUBWINDOW_MODE!Result.make(val);
         elseif name.is_equal("GdkGCValuesMask") then
            !GDK_GCVALUES_MASK!Result.make(val);
         elseif name.is_equal("GdkIMStyle") then
            !GDK_IMSTYLE!Result.make(val);
         elseif name.is_equal("GdkICAttributesType") then
            !GDK_ICATTRIBUTES_TYPE!Result.make(val);
         elseif name.is_equal("GdkImageType") then
            !GDK_IMAGE_TYPE!Result.make(val);
         elseif name.is_equal("GdkExtensionMode") then
            !GDK_EXTENSION_MODE!Result.make(val);
         elseif name.is_equal("GdkInputSource") then
            !GDK_INPUT_SOURCE!Result.make(val);
         elseif name.is_equal("GdkInputMode") then
            !GDK_INPUT_MODE!Result.make(val);
         elseif name.is_equal("GdkAxisUse") then
            !GDK_AXIS_USE!Result.make(val);
         elseif name.is_equal("GdkPropMode") then
            !GDK_PROP_MODE!Result.make(val);
         elseif name.is_equal("GdkFillRule") then
            !GDK_FILL_RULE!Result.make(val);
         elseif name.is_equal("GdkOverlapType") then
            !GDK_OVERLAP_TYPE!Result.make(val);
         elseif name.is_equal("GdkRgbDither") then
            !GDK_RGB_DITHER!Result.make(val);
         elseif name.is_equal("GdkSelection") then
            !GDK_SELECTION!Result.make(val);
         elseif name.is_equal("GdkTarget") then
            !GDK_TARGET!Result.make(val);
         elseif name.is_equal("GdkSelectionType") then
            !GDK_SELECTION_TYPE!Result.make(val);
         elseif name.is_equal("GdkByteOrder") then
            !GDK_BYTE_ORDER!Result.make(val);
         elseif name.is_equal("GdkModifierType") then
            !GDK_MODIFIER_TYPE!Result.make(val);
         elseif name.is_equal("GdkInputCondition") then
            !GDK_INPUT_CONDITION!Result.make(val);
         elseif name.is_equal("GdkStatus") then
            !GDK_STATUS!Result.make(val);
         elseif name.is_equal("GdkVisualType") then
            !GDK_VISUAL_TYPE!Result.make(val);
         elseif name.is_equal("GdkWindowClass") then
            !GDK_WINDOW_CLASS!Result.make(val);
         elseif name.is_equal("GdkWindowAttributesType") then
            !GDK_WINDOW_ATTRIBUTES_TYPE!Result.make(val);
         elseif name.is_equal("GdkWindowHints") then
            !GDK_WINDOW_HINTS!Result.make(val);
         elseif name.is_equal("GdkWMDecoration") then
            !GDK_WMDECORATION!Result.make(val);
         elseif name.is_equal("GdkWMFunction") then
            !GDK_WMFUNCTION!Result.make(val);
         end
      end
   make_boxed (name : STRING; ptr : POINTER) : ANY is
      do
         if name.is_equal("GtkAccelGroup") then
            !GTK_ACCEL_GROUP!Result.from_external(ptr);
         elseif name.is_equal("GtkSelectionData") then
            !GTK_SELECTION_DATA!Result.from_external(ptr);
         elseif name.is_equal("GtkStyle") then
            !GTK_STYLE!Result.from_external(ptr);
         elseif name.is_equal("GtkCTreeNode") then
            !GTK_CTREE_NODE!Result.from_external(ptr);
         elseif name.is_equal("GdkColormap") then
            !GDK_COLORMAP!Result.from_external(ptr);
         elseif name.is_equal("GdkVisual") then
            !GDK_VISUAL!Result.from_external(ptr);
         elseif name.is_equal("GdkFont") then
            !GDK_FONT!Result.from_external(ptr);
         elseif name.is_equal("GdkWindow") then
            !GDK_WINDOW!Result.from_external(ptr);
         elseif name.is_equal("GdkDragContext") then
            !GDK_DRAG_CONTEXT!Result.from_external(ptr);
         elseif name.is_equal("GdkEvent") then
            Result := make_event(ptr);
         elseif name.is_equal("GdkColor") then
            !GDK_COLOR!Result.from_external(ptr);
         end
      end
feature {NONE} -- external C functions
   ext_get_arg_type(p: like current;n : INTEGER) : INTEGER is
      external "C"
      alias "ext_get_arg_type"
      end
   ext_get_arg_pointer(p: like current;n : INTEGER) : POINTER is
      external "C"
      alias "ext_get_arg_pointer"
      end
   ext_get_arg_int(p: like current; n : INTEGER) : INTEGER is
      external "C"
      alias "ext_get_arg_int"
      end
   ext_get_arg_float (p: like current; n : INTEGER) : REAL is
      external "C"
      alias "ext_get_arg_float"
      end
   ext_get_arg_double (p: like current; n : INTEGER) : REAL is
      external "C"
      alias "ext_get_arg_double"
      end
   ext_set_return_arg_integer(p : like Current; value : INTEGER) is
      external "C"
      end
   ext_set_return_arg_boolean(p : like Current; value : BOOLEAN) is
      external "C"
      end

end -- class VEGTK_CALLBACK_DATA
