indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_style.e,v 1.3 2000/03/16 14:03:56 eugenem Exp $";

class GTK_STYLE
inherit
   VEGTK_EXTERNAL_OBJECT
   GTK_STYLE_EXTERNALS
creation
   from_external, make
feature -- creation
   make is
      do
         from_external(gtk_style_new)
      end

feature -- operations

   make_copy : GTK_STYLE is
      do
         !!Result.from_external(gtk_style_copy  (to_external));
      end
   attach (window : GDK_WINDOW) : GTK_STYLE is
      do
         !!Result.from_external(gtk_style_attach  (to_external, window.to_external));
      end
   detach is
      do
         gtk_style_detach  (to_external);
      end
   ref : GTK_STYLE is
      do
         !!Result.from_external(gtk_style_ref  (to_external));
      end
   unref is
      do
         gtk_style_unref  (to_external);
      end
   set_background (window : GDK_WINDOW; state_type : GTK_STATE_TYPE) is
      do
         gtk_style_set_background  (to_external, window.to_external, state_type.get_value);
      end
   apply_default_background (window : GDK_WINDOW; arg_set_bg : BOOLEAN;
                              state_type : GTK_STATE_TYPE;
                              area : GDK_RECTANGLE; x,y,width,height : INTEGER) is
      do
         gtk_style_apply_default_background  (to_external, window.to_external,
                                               arg_set_bg,
                                               state_type.get_value,
                                               area.to_external, x, y, width,
                                               height);
      end
   fg (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_fg_acr  (to_external, state.get_value));
      end
   set_fg (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_fg_acw (to_external, state.get_value, color.to_external)
      end
   bg (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_bg_acr  (to_external, state.get_value));
      end
   set_bg (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_bg_acw (to_external, state.get_value, color.to_external)
      end
   light (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_light_acr  (to_external, state.get_value));
      end
   set_light (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_light_acw (to_external, state.get_value, color.to_external)
      end
   dark (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_dark_acr  (to_external, state.get_value));
      end
   set_dark (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_dark_acw (to_external, state.get_value, color.to_external)
      end
   mid (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_mid_acr  (to_external, state.get_value));
      end
   set_mid (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_mid_acw (to_external, state.get_value, color.to_external)
      end
   text (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_text_acr  (to_external, state.get_value));
      end
   set_text (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_text_acw (to_external, state.get_value, color.to_external)
      end
   base (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_base_acr  (to_external, state.get_value));
      end
   set_base (state : GTK_STATE_TYPE; color : GDK_COLOR) is
      do
         gtk_style_base_acw (to_external, state.get_value, color.to_external)
      end
   black : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_black_acr  (to_external));
      end
   white : GDK_COLOR is
      do
         !!Result.from_external(gtk_style_white_acr  (to_external));
      end
   font : GDK_FONT is
      do
         !!Result.from_external(gtk_style_font_acr  (to_external));
      end
   set_font (arg_font : GDK_FONT) is
      do
         gtk_style_font_acw (to_external,to_external_with_check(arg_font));
      end
   fg_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_fg_gc_acr  (to_external, state.get_value));
      end
   bg_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_bg_gc_acr  (to_external, state.get_value));
      end
   light_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_light_gc_acr  (to_external, state.get_value));
      end
   dark_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_dark_gc_acr  (to_external, state.get_value));
      end
   mid_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_mid_gc_acr  (to_external, state.get_value));
      end
   text_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_text_gc_acr  (to_external, state.get_value));
      end
   base_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
         !!Result.from_external(gtk_style_base_gc_acr  (to_external, state.get_value));
      end
   black_gc : GDK_GC is
      do
         !!Result.from_external(gtk_style_black_gc_acr  (to_external));
      end
   white_gc : GDK_GC is
      do
         !!Result.from_external(gtk_style_white_gc_acr  (to_external));
      end
   bg_pixmap (state : GTK_STATE_TYPE) : GDK_PIXMAP is
      do
         !!Result.from_external(gtk_style_bg_pixmap_acr  (to_external, state.get_value));
      end
   draw_hline (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; x1 : INTEGER; x2 : INTEGER; y : INTEGER) is
      do
         ext_real_gtk_draw_hline (to_external, window.to_external, state_type.get_value, x1, x2, y);
      end
   draw_vline (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; y1 : INTEGER; y2 : INTEGER; x : INTEGER) is
      do
         ext_real_gtk_draw_vline (to_external, window.to_external, state_type.get_value, y1, y2, x);
      end
   draw_shadow (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      do
         ext_real_gtk_draw_shadow (to_external, window.to_external, state_type.get_value, shadow_type.get_value, x, y, width, height);
      end
   draw_polygon (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                  shadow_type : GTK_SHADOW_TYPE; points : GDK_POINT;
                  npoints : INTEGER; fill : BOOLEAN) is
      do
         ext_real_gtk_draw_polygon (to_external, window.to_external,
                                     state_type.get_value, shadow_type.get_value,
                                     points.to_external, npoints, fill);
      end
   draw_arrow (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                shadow_type : GTK_SHADOW_TYPE; arrow_type : GTK_ARROW_TYPE;
                fill : BOOLEAN; x : INTEGER; y : INTEGER; width : INTEGER;
                height : INTEGER) is
      do
         ext_real_gtk_draw_arrow (to_external, window.to_external,
                                   state_type.get_value, shadow_type.get_value,
                                   arrow_type.get_value, fill,
                                   x, y, width, height);
      end
   draw_box (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
              shadow_type : GTK_SHADOW_TYPE; x : INTEGER; y : INTEGER;
              width : INTEGER; height : INTEGER) is
      do
         ext_real_gtk_draw_box (to_external, window.to_external,
                                 state_type.get_value, shadow_type.get_value,
                                 x, y, width, height);
      end
   paint_hline (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                 area : GDK_RECTANGLE; widget : GTK_WIDGET;
                 detail : STRING; x1 : INTEGER; x2 : INTEGER; y : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_hline (to_external, window.to_external,
                           state_type.get_value, area.to_external,
                           widget.to_external, detail.to_external,
                           x1, x2, y);
         mem.collection_on;
      end
   paint_vline (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                 area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING;
                 y1 : INTEGER; y2 : INTEGER; x : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_vline (to_external, window.to_external, state_type.get_value,
                           area.to_external, widget.to_external,
                           detail.to_external, y1, y2, x);
         mem.collection_on;
      end
   paint_shadow (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                  shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE;
                  widget : GTK_WIDGET; detail : STRING; x : INTEGER;
                  y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_shadow (to_external, window.to_external,
                            state_type.get_value, shadow_type.get_value,
                            area.to_external, widget.to_external,
                            detail.to_external, x, y, width, height);
         mem.collection_on;
      end

--   paint_polygon (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
--                   shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE;
--                  widget : GTK_WIDGET; detail : STRING; points : GDK_POINT;
--                   npoints : INTEGER; fill : BOOLEAN) is
--      local
--         mem : MEMORY
--      do
--         !!mem
--         mem.collection_off;
--         gtk_paint_polygon (to_external, window.to_external,
--                             state_type.get_value, shadow_type.get_value,
--                             area.to_external, widget.to_external,
--                             detail.to_external, points.to_external,
--                             npoints, fill);
--      end
   paint_arrow (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                 shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE;
                 widget : GTK_WIDGET; detail : STRING;
                 arrow_type : GTK_ARROW_TYPE; fill : BOOLEAN; x : INTEGER;
                 y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_arrow (to_external, window.to_external, state_type.get_value,
                           shadow_type.get_value, area.to_external,
                           widget.to_external, detail.to_external,
                           arrow_type.get_value,fill,
                           x, y, width, height);
         mem.collection_on;
      end
   paint_diamond (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_diamond (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_oval (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_oval (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_string (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; string : STRING) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_string (to_external, window.to_external, state_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, string.to_external);
         mem.collection_on;
      end
   paint_box (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_box (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_flat_box (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_flat_box (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_check (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_check (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_option (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_option (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_cross (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_cross (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_ramp (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; arrow_type : GTK_ARROW_TYPE; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_ramp (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, arrow_type.get_value, x, y, width, height);
         mem.collection_on;
      end
   paint_tab (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_tab (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_shadow_gap (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; gap_side : GTK_POSITION_TYPE; gap_x : INTEGER; gap_width : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_shadow_gap (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height, gap_side.get_value, gap_x, gap_width);
         mem.collection_on;
      end
   paint_box_gap (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; gap_side : GTK_POSITION_TYPE; gap_x : INTEGER; gap_width : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_box_gap (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height, gap_side.get_value, gap_x, gap_width);
         mem.collection_on;
      end
   paint_extension (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; gap_side : GTK_POSITION_TYPE) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_extension (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height, gap_side.get_value);
         mem.collection_on;
      end
   paint_focus (window : GDK_WINDOW; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_focus (to_external, window.to_external, area.to_external, widget.to_external, detail.to_external, x, y, width, height);
         mem.collection_on;
      end
   paint_slider (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; orientation : GTK_ORIENTATION) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_slider (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height, orientation.get_value);
         mem.collection_on;
      end
   paint_handle (window : GDK_WINDOW; state_type : GTK_STATE_TYPE; shadow_type : GTK_SHADOW_TYPE; area : GDK_RECTANGLE; widget : GTK_WIDGET; detail : STRING; x : INTEGER; y : INTEGER; width : INTEGER; height : INTEGER; orientation : GTK_ORIENTATION) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_paint_handle (to_external, window.to_external, state_type.get_value, shadow_type.get_value, area.to_external, widget.to_external, detail.to_external, x, y, width, height, orientation.get_value);
         mem.collection_on;
      end
   draw_diamond (window : GDK_WINDOW; state_type : GTK_STATE_TYPE;
                  shadow_type : GTK_SHADOW_TYPE; string : STRING) is
      local
         mem : MEMORY
      do
         !!mem
         mem.collection_off;
         gtk_draw_diamond (to_external, window.to_external, state_type.get_value, shadow_type.get_value, string.to_external);
         mem.collection_on;
      end

end -- class GTK_STYLE

