indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_menu.e,v 1.3 2000/03/16 14:03:56 eugenem Exp $";

class GTK_MENU
inherit
   GTK_MENU_EXTERNALS
   GTK_MENU_SHELL
      rename
         append as append_menu_shell,
         prepend as prepend_menu_shell,
         insert as insert_menu_shell,
         popup as popup_widget
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_menu_new)
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_menu_get_type)
      end

feature -- operations

   reposition is
      do
         gtk_menu_reposition  (to_external);
      end
   set_accel_group (accel_group : GTK_ACCEL_GROUP) is
      do
         gtk_menu_set_accel_group  (to_external, accel_group.to_external);
      end
   set_tearoff_state (torn_off : BOOLEAN) is
      do
         gtk_menu_set_tearoff_state  (to_external, torn_off);
      end
   append (child : GTK_WIDGET) is
      do
         gtk_menu_append  (to_external, child.to_external);
      end
   prepend (child : GTK_WIDGET) is
      do
         gtk_menu_prepend  (to_external, child.to_external);
      end
   insert (child : GTK_WIDGET; position : INTEGER) is
      do
         gtk_menu_insert  (to_external, child.to_external, position);
      end
--    popup(parent_menu_shell, parent_menu_item : GTK_WIDGET; object : ANY; func : POINTER; data : ANY; button, activate_time : INTEGER) is
   popup(parent_menu_shell, parent_menu_item : GTK_WIDGET; button, activate_time : INTEGER) is
      do
         gtk_menu_popup(to_external, to_external_with_check(parent_menu_shell), to_external_with_check(parent_menu_item), default_pointer, default_pointer, button, activate_time)
      end
   popdown is
      do
         gtk_menu_popdown  (to_external);
      end
   get_active : GTK_WIDGET is
      do
         !!Result.from_external(gtk_menu_get_active  (to_external));
      end
   set_active (index : INTEGER) is
      do
         gtk_menu_set_active  (to_external, index);
      end
   get_attach_widget : GTK_WIDGET is
      do
         !!Result.from_external(gtk_menu_get_attach_widget  (to_external));
      end
   detach is
      do
         gtk_menu_detach  (to_external);
      end

end -- class GTK_MENU
