indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_progress.e,v 1.3 2000/03/16 14:03:56 eugenem Exp $";

class GTK_PROGRESS
inherit
   GTK_PROGRESS_NP
   GTK_PROGRESS_EXTERNALS
   GTK_WIDGET
      redefine
         make_for_register
      end
creation
   from_external, make_for_register

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_progress_get_type)
      end

feature -- access

   adjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_progress_adjustment_acr(to_external))
      end

   offscreen_pixmap : GDK_PIXMAP is
      do
         !!Result.from_external(gtk_progress_offscreen_pixmap_acr(to_external))
      end

   format : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external(gtk_progress_format_acr(to_external))
      end

   x_align : REAL is
      do
         Result := gtk_progress_x_align_acr(to_external)
      end

   y_align : REAL is
      do
         Result := gtk_progress_y_align_acr(to_external)
      end

   show_text : BOOLEAN is
      do
         Result := gtk_progress_show_text_acr(to_external)
      end

   activity_mode : BOOLEAN is
      do
         Result := gtk_progress_activity_mode_acr(to_external)
      end

feature -- operations

   set_show_text (arg_show_text : BOOLEAN) is
      do
         gtk_progress_set_show_text  (to_external, arg_show_text);
      end
   set_text_alignment (arg_x_align : REAL; arg_y_align : REAL) is
      do
         np_gtk_progress_set_text_alignment  (to_external, arg_x_align, arg_y_align);
      end
   set_format_string (arg_format : STRING) is
      do
         np_gtk_progress_set_format_string  (to_external, arg_format);
      end
   set_adjustment (arg_adjustment : GTK_ADJUSTMENT) is
      do
         gtk_progress_set_adjustment  (to_external, arg_adjustment.to_external);
      end
   configure (value : REAL; min : REAL; max : REAL) is
      do
         np_gtk_progress_configure  (to_external, value, min, max);
      end
   set_percentage (percentage : REAL) is
      do
         np_gtk_progress_set_percentage  (to_external, percentage);
      end
   set_value (value : REAL) is
      do
         np_gtk_progress_set_value  (to_external, value);
      end
   get_value : REAL is
      do
         Result:= np_gtk_progress_get_value (to_external)
      end
   set_activity_mode (arg_activity_mode : BOOLEAN) is
      do
         gtk_progress_set_activity_mode  (to_external, arg_activity_mode);
      end
   get_current_text : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external_with_free (gtk_progress_get_current_text  (to_external))
      end
   get_text_from_value (value : REAL) : STRING is
      local
         sh : VEGTK_STRING_HELPER
      do
         !!sh
         Result := sh.string_from_external (np_gtk_progress_get_text_from_value  (to_external, value));
      end
   get_current_percentage : REAL is
      do
         Result:= np_gtk_progress_get_current_percentage  (to_external)
      end
   get_percentage_from_value (value : REAL) : REAL is
      do
         Result:= np_gtk_progress_get_percentage_from_value (to_external, value)
      end

end -- class GTK_PROGRESS
