indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_spin_button.e,v 1.3 2000/03/16 14:03:56 eugenem Exp $";

class GTK_SPIN_BUTTON
inherit
   GTK_SPIN_BUTTON_NP
   GTK_SPIN_BUTTON_EXTERNALS
   GTK_ENTRY
      rename
         make as make_entry
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (adjustment : GTK_ADJUSTMENT; climb_rate : REAL; digits : INTEGER) is
      do
         from_external(np_gtk_spin_button_new  (adjustment.to_external, climb_rate, digits))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_spin_button_get_type)
      end

feature -- operations

   configure (adjustment : GTK_ADJUSTMENT; climb_rate : REAL; digits : INTEGER) is
      do
         np_gtk_spin_button_configure  (to_external, adjustment.to_external, climb_rate, digits);
      end
   set_adjustment (adjustment : GTK_ADJUSTMENT) is
      do
         gtk_spin_button_set_adjustment  (to_external, adjustment.to_external);
      end
   get_adjustment : GTK_ADJUSTMENT is
      do
         !!Result.from_external(gtk_spin_button_get_adjustment  (to_external));
      end
   set_digits (digits : INTEGER) is
      do
         gtk_spin_button_set_digits  (to_external, digits);
      end
   get_value_as_float : REAL is
      do
         Result:= np_gtk_spin_button_get_value_as_float(to_external);
      end
   get_value_as_int : INTEGER is
      do
         Result:= gtk_spin_button_get_value_as_int  (to_external);
      end
   set_value (value : REAL) is
      do
         np_gtk_spin_button_set_value  (to_external, value);
      end
   set_update_policy (policy : GTK_SPIN_BUTTON_UPDATE_POLICY) is
      do
         gtk_spin_button_set_update_policy  (to_external, policy.get_value);
      end
   set_numeric (numeric : BOOLEAN) is
      do
         gtk_spin_button_set_numeric  (to_external, numeric);
      end
   spin (direction : GTK_SPIN_TYPE; increment : REAL) is
      do
         np_gtk_spin_button_spin  (to_external, direction.get_value, increment);
      end
   set_wrap (wrap : BOOLEAN) is
      do
         gtk_spin_button_set_wrap  (to_external, wrap);
      end
   set_shadow_type (shadow_type : GTK_SHADOW_TYPE) is
      do
         gtk_spin_button_set_shadow_type  (to_external, shadow_type.get_value);
      end
   set_snap_to_ticks (snap_to_ticks : BOOLEAN) is
      do
         gtk_spin_button_set_snap_to_ticks  (to_external, snap_to_ticks);
      end

end -- class GTK_SPIN_BUTTON
