indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_text.e,v 1.3 2000/03/16 14:03:56 eugenem Exp $";

class GTK_TEXT
inherit
   GTK_TEXT_NP
   GTK_TEXT_EXTERNALS
   GTK_EDITABLE
      rename
         set_editable as set_editable_editable
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (arg_hadj : GTK_ADJUSTMENT; arg_vadj : GTK_ADJUSTMENT) is
      do
         from_external(gtk_text_new  (to_external_with_check(arg_hadj),
            to_external_with_check(arg_vadj)))
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_text_get_type)
      end

feature -- Queries

  hadj : GTK_ADJUSTMENT is
     do
        !!Result.from_external(gtk_text_hadj_acr(to_external))
     end

  vadj : GTK_ADJUSTMENT is
     do
        !!Result.from_external(gtk_text_vadj_acr(to_external))
     end

feature -- operations

   set_editable (editable : BOOLEAN) is
      do
         gtk_text_set_editable  (to_external, editable);
      end
   set_word_wrap (word_wrap : BOOLEAN) is
      do
         gtk_text_set_word_wrap  (to_external, word_wrap);
      end
   set_line_wrap (line_wrap : BOOLEAN) is
      do
         gtk_text_set_line_wrap  (to_external, line_wrap);
      end
   set_adjustments (arg_hadj : GTK_ADJUSTMENT; arg_vadj : GTK_ADJUSTMENT) is
      do
         gtk_text_set_adjustments  (to_external, arg_hadj.to_external, arg_vadj.to_external);
      end
   set_point (index : INTEGER) is
      do
         gtk_text_set_point  (to_external, index);
      end
   get_point : INTEGER is
      do
         Result:= gtk_text_get_point  (to_external);
      end
   get_length : INTEGER is
      do
         Result:= gtk_text_get_length  (to_external);
      end
   freeze is
      do
         gtk_text_freeze  (to_external);
      end
   thaw is
      do
         gtk_text_thaw  (to_external);
      end
   insert (font : GDK_FONT; fore : GDK_COLOR; back : GDK_COLOR; chars : STRING) is
      do
         np_gtk_text_insert  (to_external, to_external_with_check(font), to_external_with_check(fore), to_external_with_check(back), chars, chars.count);
      end
   backward_delete (nchars : INTEGER) is
      do
         gtk_text_backward_delete  (to_external, nchars);
      end
   forward_delete (nchars : INTEGER) is
      do
         gtk_text_forward_delete  (to_external, nchars);
      end

end -- class GTK_TEXT
