indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_window.e,v 1.4 2000/03/20 07:54:45 eugenem Exp $";

class GTK_WINDOW
inherit
   GTK_WINDOW_NP
   GTK_WINDOW_EXTERNALS
   GTK_BIN
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make (arg_type : GTK_WINDOW_TYPE) is
      do
         from_external(gtk_window_new  (arg_type.get_value));
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_window_get_type)
      end

feature -- operations

   set_title (title : STRING) is
      do
         np_gtk_window_set_title  (to_external, title);
      end
   set_wmclass (wmclass_class : STRING; wmclass_name : STRING) is
      do
         np_gtk_window_set_wmclass  (to_external, wmclass_class, wmclass_name);
      end
   set_focus (arg_focus : GTK_WIDGET) is
      do
         gtk_window_set_focus  (to_external, arg_focus.to_external);
      end
   set_default (arg_default : GTK_WIDGET) is
      do
         gtk_window_set_default  (to_external, arg_default.to_external);
      end
   set_policy (allow_shrink : BOOLEAN; allow_grow : BOOLEAN; auto_shrink : BOOLEAN) is
      do
         gtk_window_set_policy  (to_external, allow_shrink, allow_grow, auto_shrink);
      end
   add_accel_group (accel_group : GTK_ACCEL_GROUP) is
      do
         gtk_window_add_accel_group  (to_external, accel_group.to_external);
      end
   remove_accel_group (accel_group : GTK_ACCEL_GROUP) is
      do
         gtk_window_remove_accel_group  (to_external, accel_group.to_external);
      end
   set_position (position : GTK_WINDOW_POSITION) is
      do
         gtk_window_set_position  (to_external, position.get_value);
      end
   activate_focus : INTEGER is
      do
         Result:= gtk_window_activate_focus  (to_external);
      end
   activate_default : INTEGER is
      do
         Result:= gtk_window_activate_default  (to_external);
      end
   set_transient_for (arg_parent : GTK_WINDOW) is
      do
         gtk_window_set_transient_for  (to_external, arg_parent.to_external);
      end
   set_geometry_hints (geometry_widget : GTK_WIDGET; geometry : GDK_GEOMETRY; geom_mask : GDK_WINDOW_HINTS) is
      do
         gtk_window_set_geometry_hints  (to_external, geometry_widget.to_external, geometry.to_external, geom_mask.get_value);
      end
   set_default_size (width : INTEGER; height : INTEGER) is
      do
         gtk_window_set_default_size  (to_external, width, height);
      end
   set_modal (modal : BOOLEAN) is
      do
         gtk_window_set_modal  (to_external, modal);
      end

end -- class GTK_WINDOW
