indexing
    title       : "GTK ";
    cluster     : "VEGTK";
    project     : "VEGTK library v 1.2.1 GTK+ 1.2.x";
    copyright   : "Object Tools, 1999-2000";
    key         : "GTK", "GUI";
    cvs         : "$Id: gtk_packer.e,v 1.6 2000/03/16 14:03:56 eugenem Exp $";

class GTK_PACKER
inherit
   GTK_PACKER_EXTERNALS
   GTK_CONTAINER
      rename
         add as add_container
      redefine
         make_for_register
      end
creation
   from_external, make, make_for_register
feature -- creation
   make is
      do
         from_external(gtk_packer_new )
      end

feature {GTK_OBJECT} -- Creation for register purposes

   make_for_register is
      do
         register_without_external (gtk_packer_get_type)
      end

feature -- Queries

   packer_children_array : ARRAY [GTK_PACKER_CHILD] is
      local
         tmp_list : G_LIST_OF_GTK_PACKER_CHILD;
      do
         !!tmp_list.from_external (gtk_packer_children_acr (to_external));
         if tmp_list /= Void then
            Result := tmp_list.to_array;
         end
      end -- packer_children_array

   packer_children_list : G_LIST [GTK_PACKER_CHILD] is
      do
         !G_LIST_OF_GTK_PACKER_CHILD!
            Result.from_external (gtk_packer_children_acr (to_external));
      end -- packer_children_list

feature -- operations

   add_defaults (child : GTK_WIDGET; side : GTK_SIDE_TYPE; anchor : GTK_ANCHOR_TYPE; options : GTK_PACKER_OPTIONS) is
      do
         gtk_packer_add_defaults  (to_external, child.to_external, side.get_value, anchor.get_value, options.get_value);
      end

   add (child : GTK_WIDGET; side : GTK_SIDE_TYPE; anchor : GTK_ANCHOR_TYPE; options : GTK_PACKER_OPTIONS; border : INTEGER; pad_x : INTEGER; pad_y : INTEGER; i_pad_x : INTEGER; i_pad_y : INTEGER) is
      do
         gtk_packer_add  (to_external, child.to_external, side.get_value, anchor.get_value, options.get_value, border_width, pad_x, pad_y, i_pad_x, i_pad_y);
      end

   set_child_packing (child : GTK_WIDGET; side : GTK_SIDE_TYPE; anchor : GTK_ANCHOR_TYPE; options : GTK_PACKER_OPTIONS; border : INTEGER; pad_x : INTEGER; pad_y : INTEGER; i_pad_x : INTEGER; i_pad_y : INTEGER) is
      do
         gtk_packer_set_child_packing  (to_external, child.to_external, side.get_value, anchor.get_value, options.get_value, border_width, pad_x, pad_y, i_pad_x, i_pad_y);
      end

   reorder_child (child : GTK_WIDGET; position : INTEGER) is
      do
         gtk_packer_reorder_child  (to_external, child.to_external, position);
      end

   set_spacing (spacing : INTEGER) is
      do
         gtk_packer_set_spacing  (to_external, spacing);
      end

   set_default_border_width (border : INTEGER) is
      do
         gtk_packer_set_default_border_width  (to_external, border);
      end

   set_default_pad (pad_x : INTEGER; pad_y : INTEGER) is
      do
         gtk_packer_set_default_pad  (to_external, pad_x, pad_y);
      end

   set_default_ipad (i_pad_x : INTEGER; i_pad_y : INTEGER) is
      do
         gtk_packer_set_default_ipad  (to_external, i_pad_x, i_pad_y);
      end
end -- class GTK_PACKER
