class VEGTK_EXTERNAL_REALS
inherit
   VEGTK_EXTERNAL_OBJECT
   MEMORY
      redefine
         dispose
      end

creation
   make

feature -- Creation

   make (array : ARRAY[REAL]) is
      require
         not_null: array /= Void
      local
         i, j : INTEGER
      do
         from_external(c_make_array_of_reals(array.count))
         from
            i := array.lower
         until
            i > array.upper
         loop
            c_array_put_real(to_external, i-array.lower, array.item(i))
            i := i+1
         end -- loop
      end

feature -- memory managment

   dispose is
      do
         g_free(to_external)
         from_external(default_pointer)
      end

feature {NONE} -- C externals

   c_make_array_of_reals(n : INTEGER) : POINTER is
      external "C"
      alias "c_make_array_of_reals"
      end
   c_array_put_real(array : POINTER; i : INTEGER; item : REAL) is
      external "C"
      alias "c_array_put_real"
      end
   g_free(p : POINTER) is
      external "C"
      alias "g_free"
      end

end -- class VEGTK_EXTERNAL_REALS
