indexing

   title:       "Access to command-line arguments.",
                "This class may be used as ancestor by classes needing its %
                %facilities.";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library";
   date:        "$Date: 2005/02/01 10:20:11 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class ARGUMENTS

feature -- Access

   argument (i: INTEGER): STRING is
         -- 'i-th' argument of command that started system execution
         -- (the command name if i = 0)
      require
         index_large_enough: i >= 0
         index_small_enough: i <= argument_count
      external "C"
         alias "_ARG_argument"
      end

   frozen arguments: ARRAY [STRING] is
         -- Arguments of command that started system execution; Void if none
      external "C"
         alias "_ARG_arguments"
      end

   command_name: STRING is
         -- Name of command that started system execution
      external "C"
         alias "_ARG_program_name"
      ensure
         definition: Result = argument (0)
      end

feature -- Measurement

   argument_count: INTEGER is
         -- Number of arguments given to command that started
         -- system execution (command name does not count)
      external "C"
         alias "_ARG_argument_count"
      ensure
         non_negative_result: Result >= 0
      end

end