indexing

   title:       "Byte input stream";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library: input and output";
   date:        "$Date: 2005/02/15 16:22:03 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class BYTE_INPUT_STREAM

feature -- Status report

   is_open: BOOLEAN is
         -- May read from stream?
      deferred
      end

feature {PROXY_BYTE_INPUT_STREAM} -- Implementation: input

   read_buffer (buffer: POINTER; amount: INTEGER): INTEGER is
         -- Read 'amount' bytes into 'buffer' at current position.
         -- Return actual number of bytes read.
      require
         is_open: is_open
         buffer_exists: buffer /= default_pointer
         non_negative_amount: amount >= 0
      deferred
      ensure
         non_negative_result: Result >= 0
         valid_result: Result <= amount
      end

end