indexing

   title:       "Input of data";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library: input and output";
   copyright:   "Object Tools, 1999-2003";
   original:    "12 May 1999";
   version:     "$Revision: 1.1 $";
   last_change: "$Date: 2005/02/01 10:20:13 $";
   key:         "input", "data", "data input";
   done_at:     "Object Tools (info@object-tools.com)";

deferred class DATA_INPUT

feature -- Status report

   is_open: BOOLEAN is
         -- May read data?
      deferred
      end

feature -- Status report

   last_character: CHARACTER
      -- Last character read by 'read_character'

   last_double: DOUBLE
      -- Last double read by 'read_double'

   last_integer: INTEGER
      -- Last integer read by 'read_integer'

   last_real: REAL
      -- Last real read by 'read_real'

   last_string: STRING
      -- Last string read by 'read_stream'

feature -- Input

   read_character is
         -- Read a new character.
         -- Make result available in 'last_character'
      require
         is_open: is_open
      deferred
      end

   read_double is
         -- Read a new double.
         -- Make result available in 'last_double'
      require
         is_open: is_open
      deferred
      end

   read_integer is
         -- Read a new integer.
         -- Make result available in 'last_integer'
      require
         is_open: is_open
      deferred
      end

   read_real is
         -- Read a new real.
         -- Make result available in 'last_real'
      require
         is_open: is_open
      deferred
      end

   read_stream (nb_char: INTEGER) is
         -- Read a string of a most 'nb_char' bound characters or
         -- until end of file.
         -- Make result available in 'last_string'
      require
         is_open: is_open
         correct_nb_char: nb_char > 0
      deferred
      end

end