indexing

   title:       "Output stream of data";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library: input and output";
   date:        "$Date: 2005/02/01 10:20:13 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class DATA_OUTPUT

feature -- Status report

   is_open: BOOLEAN is
         -- May write data?
      deferred
      end

feature -- Output

   put_boolean (b: BOOLEAN) is
         -- Write value of 'b' at current position
      require
         is_open: is_open
      deferred
      end

   put_character (c: CHARACTER) is
         -- Write 'c' at current position
      require
         is_open: is_open
      deferred
      end

   put_double (d: DOUBLE) is
         -- Write value of 'd' at current position
      require
         is_open: is_open
      deferred
      end

   put_integer (i: INTEGER) is
         -- Write value of 'i' at current position
      require
         is_open: is_open
      deferred
      end

   put_real (r: REAL) is
         -- Write value of 'r' at current position
      require
         is_open: is_open
      deferred
      end

   put_string (s: STRING) is
         -- Write 's' at current position
      require
         is_open: is_open
         s_not_void: s /= Void
      deferred
      end

end