indexing

   title:       "Input stream";
   cluster:     "kernel.io";
   project:     "Eiffel Kernel Library: input and output";
   copyright:   "Object Tools, 2004";
   original:    "18 Mar 2004";
   version:     "$Revision: 1.2 $";
   last_change: "$Date: 2005/02/15 16:22:03 $";
   key:         "input", "stream", "input_stream";
   done_at:     "Object Tools (info@object-tools.com)";

deferred class INPUT_STREAM [G]

feature -- Status report

   is_open: BOOLEAN is
         -- Is stream open?
      deferred
      end

   end_of_stream: BOOLEAN is
         -- Has end of stream been detected?
      require
         is_open: is_open
      deferred
      end

feature -- Status setting

   close is
         -- Close stream.
         -- Set `is_open' to false on success.
      require
         is_open: is_open
      deferred
      end

feature -- Access

   item: G is
         -- Last item read from the stream
      deferred
      end

feature -- Read

   read is
         -- Read a next item from the stream if
         -- possible and make it available in `item'.
         -- Set `end_of_stream' to true if there are
         -- no more items in the stream.
      require
         is_open: is_open
         not_end_of_stream: not end_of_stream
      deferred
      ensure
         is_open: is_open
      end

end