indexing

   title:       "Input stream working as a proxy to another input stream";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library: input and output";
   date:        "$Date: 2005/02/15 16:22:03 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class PROXY_BYTE_INPUT_STREAM

inherit

   BYTE_INPUT_STREAM

create

   make

feature {NONE} -- Creation

   make (input: BYTE_INPUT_STREAM) is
         -- Connect to the given 'input' stream.
      require
         non_void_input: input /= Void
      do
         input_stream := input
      ensure
         connected: input_stream = input
      end

feature -- Status report

   input_stream: BYTE_INPUT_STREAM
         -- Stream which is used for actual input

   is_open: BOOLEAN is
         -- May read from stream?
      do
         Result := input_stream.is_open
      end

feature {NONE} -- Implementation: input

   read_buffer (buffer: POINTER; amount: INTEGER): INTEGER is
         -- Read 'amount' bytes into 'buffer' at current position.
         -- Return actual number of bytes read.
      do
         Result := input_stream.read_buffer (buffer, amount)
      end

invariant

   connected: input_stream /= Void

end