indexing

   title:       "Output stream of data in textual format";
   cluster:     "kernel";
   project:     "Eiffel Kernel Library: input and output";
   date:        "$Date: 2005/02/15 16:22:03 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TEXT_OUTPUT_STREAM

inherit

   DATA_OUTPUT

   MEMORY

   PROXY_BYTE_OUTPUT_STREAM

create

   make

feature -- Status setting

   close is
         -- Release any associated resources.
         -- Leave `output_stream' intact.
      do
         -- Nothing to do here
      end

feature -- Output

   put_boolean (b: BOOLEAN) is
         -- Write ASCII value of 'b' at current position.
      do
         put_string (b.out)
      end

   put_character (c: CHARACTER) is
         -- Write 'c' at current position.
      do
         put_buffer ($c, 1)
      end

   put_double (d: DOUBLE) is
         -- Write ASCII value of 'd' at current position.
      do
         put_string (d.out)
      end

   put_integer (i: INTEGER) is
         -- Write ASCII value of 'i' at current position.
      do
         put_string (i.out)
      end

   put_real (r: REAL) is
         -- Write ASCII value of 'r' at current position.
      do
         put_string (r.out)
      end

   put_string (s: STRING) is
         -- Write 's' at current position.
      local
         c: INTEGER
         gc_off: BOOLEAN
      do
         if s /= Void then
            c := s.count
            if c /= 0 then
               collection_off
               gc_off := True
               put_buffer (s.to_c, c)
               collection_on
            end
         end
      rescue
         if gc_off then
            gc_off := False
            collection_on
         end
      end

end