indexing

   title:       "Top class to access memory.";
   cluster:     "Run_Time_System";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:14 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class RTS_MEMORY

inherit

   ANY
      redefine
         is_equal
      end

feature -- Access

   area: POINTER is
         -- Pointer to memory data
      deferred
      end

feature -- Measurement

   size: INTEGER is
         -- Size of data in bytes
      deferred
      ensure
         non_negative_size: size >= 0
      end

feature -- Status report

   empty: BOOLEAN is
         -- Is memory data empty?
      do
         Result := size = 0
      end

   is_initialized: BOOLEAN is
      do
         Result := area /= default_pointer
      end

feature -- Comparison

   is_equal (other: like Current): BOOLEAN is
         -- Is array made of same items as 'other' ?
      do
         if size = other.size then
            Result := memory.mem_cmp (area, other.area, size) = 0
         end
      end

feature {NONE} -- Implementation

   memory: MEMORY is
      once
         create Result
      end

invariant

   empty_definition: empty = (size = 0)
   non_negative_size: size >= 0

end