indexing

   title:       "Memory which could be byte-compared.";
   cluster:     "Run_Time_System";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:14 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class RTS_MEMORY_COMPARABLE

inherit

   RTS_MEMORY
      end

   COMPARABLE
      undefine
         is_equal
      end

feature -- Comparison

   infix "<" ( other : like Current ) : BOOLEAN is
         -- Returns True if 'Current' memory region is lexicographically
         -- less than 'other' memory region (byte comparison is used)
      local
         byte_count: INTEGER
         difference: INTEGER
      do
         byte_count := other.size
         if size < byte_count then
            Result     := True
            byte_count := size
         end
         difference := memory.mem_cmp (area, other.area, size)
         if difference /= 0 then
            Result := difference < 0
         end
      end

end