indexing

   title:       "Memory allocated to Eiffel object.";
   cluster:     "Run_Time_System";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:14 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class RTS_MEMORY_OBJECT

inherit

   RTS_MEMORY
      end

feature -- Access

   anchor: ANY
         -- Object used for mapping

   area: POINTER is
      do
         Result.from_integer (anchor.object_id)
      end

feature -- Initialization

   make (a: ANY) is
         -- Sets 'anchor' to the given object
      require
         non_void_anchor: a /= Void
      do
         anchor := a
      ensure
         anchor_set: anchor = a
      end

invariant

   non_void_anchor: anchor /= Void
   area_definition: anchor.object_id = area.to_integer

end