indexing

   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:15 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_ARG_LOC

inherit

   RTS_SERVER
      end

creation

   make

feature {NONE} -- Data

   father: RTS_ROUTINE_INFO
   argloc_id: INTEGER

feature -- Operations

   make (f: RTS_ROUTINE_INFO; id: INTEGER) is
      require
         non_void_father: f /= Void
         valid_father: f.number_of_args_locs > 0
         valid_id: id > 0 and then id <= f.number_of_args_locs
      do
         father := f
         argloc_id := id
      end

   name: STRING is
      do
         Result := father.argloc_name (argloc_id)
      ensure
         valid_name: Result /= Void and then Result.count > 0
      end

   offset: INTEGER is
      do
         Result := father.args_locs_offsets_table.item (argloc_id).as_integer
      ensure
         valid_offset: Result /= 0
      end

   type: RTS_CLASS_INFO is
      do
         Result := class_info_from_union(
            father.args_locs_types_table.item (argloc_id)
         )
      ensure
         valid_type: Result /= Void
      end

end
