indexing

   project:     "Visual Eiffel run-time system";
   copyright:   "Object Tools, 1998-2003";
   date:        "$Date: 2005/02/01 10:20:15 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_FEATURE_SELECTION_TABLE

inherit

   RTS_MEMORY_AREA
      rename
         make as set_address
      end

   RTS_SERVER
      undefine
        copy, is_equal
      end

creation

   make

feature -- Data

   table: RTS_MEMORY_MAPPED_AREA_ARRAY [INTEGER]

feature -- Creation

   make (p: POINTER) is
      require
         valid_pointer: p /= default_pointer
      do
         set_address (p)
         if type = 4 then
            !!table.make (table_address, count)
         else
            !!table.make (table_address, count * 2)
         end
      end

feature -- Property

   type: INTEGER is
      do
         memory.mem_copy ($Result, area, 4)
      end

   table_address: POINTER is
      do
         if type = 4 then
            Result := area + 4
         else
            Result := area + 2 * 4
         end
      ensure
         valid_address: Result /= default_pointer
      end

feature -- Measurement

   count: INTEGER is
      do
         if type /= 4 then
            memory.mem_copy ($Result, area + 4, 4)
         else
            Result := rts_main_data.compiler_data.max_id
         end
      end

   size: INTEGER is
      do
         if type /= 4 then
            Result := 2 * 4 + 2 * count * 4
         else
            Result := 4 + count * 4
         end
      end

feature -- Access

   get_element_by_typeid (typeid: INTEGER): INTEGER is
      require
         valid_typeid: valid_id (typeid)
         non_deferred_class: not id2class_info (typeid).is_deferred
      local
         low, mid, high: INTEGER
      do
         if type = 4 then
            Result := table.item (typeid)
         else
            from
               high  := count - 1
               mid   := high
            until
               low > high or else Result /= 0
            loop
               mid := (low + high) // 2
               if typeid = table.item (mid + 1) then
                  Result := table.item (count + mid + 1)
               elseif typeid < table.item (mid + 1) then
                 high := mid - 1
               else
                 low  := mid + 1
               end
            end
         end
      ensure
         valid_result: Result /= 0
      end

   get_element (obj: ANY): INTEGER is
      require
         non_void_object: obj /= Void
      do
         Result := get_element_by_typeid (object2class_id (obj))
      ensure
         valid_result: Result /= 0
      end

end