indexing

   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:15 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_MAIN

inherit

creation

feature -- Data

   module_handle: INTEGER
   DLL_PROCESS_ATTACH: INTEGER is 1
   DLL_THREAD_ATTACH: INTEGER is 2
   DLL_THREAD_DETACH: INTEGER is 3
   DLL_PROCESS_DETACH: INTEGER is 0

feature -- Operations

   frozen win_main(
      hInstance, hPrev: INTEGER; lpszCmdParam: POINTER; nCmdShow: INTEGER
   ) is
      do
         module_handle := hInstance
      end

   frozen dll_main(
      hdll_instance, fdw_reason: INTEGER; lpv_reserved: POINTER
   ) is
      do
         inspect
            fdw_reason
         when DLL_PROCESS_ATTACH  then
            module_handle := hdll_instance
            on_process_attach
         when DLL_THREAD_ATTACH then
            on_tread_attach
         when DLL_THREAD_DETACH then
            on_tread_detach
         when DLL_PROCESS_DETACH then
            on_process_detach
         else
            -- to prevent exception BAD_INSPECT_CHOICE or something like this
         end
      end

   get_module_handle: INTEGER is
      do
         Result := module_handle
      end

   on_process_attach is
      do
      end

   on_process_detach is
      do
      end

   on_tread_attach is
      do
      end

   on_tread_detach is
      do
      end

   get_dll_main_address: POINTER is
      do
         Result.set_item ($dll_main)
      end

   get_win_main_address: POINTER is
      do
         Result.set_item ($win_main)
      end

end