indexing

   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:15 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_MAIN_DATA

inherit

   RTS_MEMORY_MAPPED_AREA [POINTER]
      rename
         make as make_from_address
      end

   RTS_SERVER
      undefine
        copy, is_equal
      end

creation

   make, make_from_address

feature -- Measurement

   count: INTEGER is 11

feature {NONE} -- Creation

   make is
      local
         p: POINTER
      do
         p := get_rts_data
         memory.mem_copy ($p, p, Pointer_bytes)
         make_from_address (p)
      end

feature -- Access

   compiler_data: RTS_COMPILER_DATA is
      do
         !!Result.make (area)
      end

   module_data: RTS_MODULE_DATA is
      do
         !!Result.make (area + 16)
      end

feature {NONE} -- Implementation

   get_rts_data: POINTER is
   external "C"
      alias "__get_rts_data"
   end

end