indexing

   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:15 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_MODULE_DATA

inherit

   RTS_MEMORY_MAPPED_AREA [POINTER]
      end

creation

   make

feature -- Data

   count: INTEGER is 27

feature -- Status

   is_eiffel_code (a: POINTER): BOOLEAN is
      do
         Result :=
            a.to_integer >= eiffel_first_address.to_integer and then
            a.to_integer <  eiffel_last_address.to_integer
      end

feature -- Addresses

   eiffel_first_address: POINTER is
      do
         Result := item (1)
      ensure
         valid_result: Result /= default_pointer
      end

   native_assertions_start_address: POINTER is
      do
         Result := item (2)
      end

   native_class_invariant_start_address: POINTER is
      do
         Result := item (3)
      end

   p_assertions_start_address: POINTER is
      do
         Result := item (4)
      end

   p_code_class_invariant_start_address: POINTER is
      do
         Result := item (5)
      end

   native_code_start_address: POINTER is
      do
         Result := item (6)
      ensure
         valid_result: Result /= default_pointer
      end

   p_code_start_address: POINTER is
      do
         Result := item (7)
      end

   eiffel_last_address: POINTER is
      do
         Result := item (8)
      ensure
         valid_result: Result /= default_pointer
      end

   start_of_rtns_table: POINTER is
      do
         Result := item (9)
      ensure
         valid_result: Result /= default_pointer
      end

   end_of_rtns_table: POINTER is
      do
         Result := item (10)
      ensure
         valid_result: Result /= default_pointer and Result /= start_of_rtns_table
      end

   debug_keys_table: POINTER is
      do
         Result := item (11)
      end

   end_of_debug_keys_table: POINTER is
      do
         Result := item (12)
      ensure
         valid_result :
            debug_keys_table /= default_pointer implies Result /= default_pointer
      end

   optimal_once_tab: POINTER is
      do
         Result := item (13)
      end

   not_use_assertion_flag: POINTER is
      do
         Result := item (14)
      end

   ref_once_tab: POINTER is
      do
         Result := item (15)
      end

   endof_ref_once_tab: POINTER is
      do
         Result := item (16)
      ensure
         valid_result:
            ref_once_tab /= default_pointer implies Result /= default_pointer
      end

   opt_once_tab: POINTER is
      do
         Result := item (17)
      end

   endof_opt_once_tab: POINTER is
      do
         Result := item (18)
      ensure
         valid_result:
            opt_once_tab /= default_pointer implies Result /= default_pointer
      end

   interpreter_start: POINTER is
      do
         Result := item (19)
      end

   interpreter_end: POINTER is
      do
         Result := item (20)
      ensure
         valid_result:
            interpreter_start /= default_pointer implies Result /= default_pointer
      end

   p_hSupHeap: POINTER is
      do
         Result := item (21)
      end

   print_error: POINTER is
      do
         Result := item (22)
      end

   reserved1: POINTER is
      do
         Result := item (23)
      end

   reserved2: POINTER is
      do
         Result := item (24)
      end

   io_detach: POINTER is
      do
         Result := item (25)
      ensure
         valid_result: Result /= default_pointer
      end

   winapi_stack_buffer: POINTER is
      do
         Result := item (26)
      end

   p_winapi_stack: POINTER is
      do
         Result := item (27)
      end

end