indexing

   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:14 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

expanded class RTS_SHORT_INTEGER

obsolete "Visual Eiffel 4.1 compatibility: use INTEGER_16 instead"

inherit

   COMPARABLE
      redefine
         out
      end

feature {NONE} -- Data

   data: INTEGER_16

feature -- Access

   item: INTEGER is
      do
         Result := data.as_integer
      end

   set_item (i: INTEGER) is
      do
         data.from_integer (i)
      end

   low8: CHARACTER is
      local
         b32: BIT 32
      do
         b32.from_integer (item)
         Result.from_integer ((b32 and 11111111B).to_integer)
      end

feature -- Comparison

   infix "<" (other: like Current): BOOLEAN is
         -- Is current integer less than 'other' ?
         -- (From COMPARABLE)
      do
         Result := item < other.item
      end

feature -- Output

   out: STRING is
         -- Printable representation of short integer value
         -- (From GENERAL)
      do
         Result := data.out
      end

end