indexing

   title:       "2-byte unsigned integer values";
   cluster:     "Run_Time_System";
   project:     "Visual Eiffel run-time system";
   date:        "$Date: 2005/02/01 10:20:14 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_UINTEGER_2

feature -- Access

   byte0: CHARACTER
         -- Least significant byte

   byte1: CHARACTER
         -- Most significant byte

   item: RTS_UINTEGER_2 is
         -- The value
      do
         Result := Current
      end

feature -- Modification

   set_item (other: RTS_UINTEGER_2) is
      do
         copy (other)
      ensure
         item_set: item = other
      end

   set_byte0 (v: CHARACTER) is
         -- Set `byte0' to `v'
      do
         byte0 := v
      ensure
         byte0_set: byte0 = v
      end

   set_byte1 (v: CHARACTER) is
         -- Set `byte1' to `v'
      do
         byte1 := v
      ensure
         byte1_set: byte1 = v
      end

   from_integer (v: INTEGER) is
         -- Set the value to `v'
      require
         non_negative: v >= 0
         not_too_large: v <= 65535
      do
         byte0.from_integer (v \\ 256)
         byte1.from_integer (v // 256)
      ensure
         value_set: to_integer = v
      end

feature -- Conversion

   to_integer: INTEGER is
      do
         Result := byte1.code * 256 + byte0.code
      ensure
         non_negative_Result: Result >= 0
         not_too_large_Result: Result <= 65535
      end

end