indexing

   title:       "Exception facilities support";
   cluster:     "pool";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:16 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class EXCEPTION

feature -- Access

   catch_signal (sigcode: INTEGER) is
         -- Catch signal 'sigcode' - do not raise an exception
      external "C"
         alias "catchSignal"
      end

   raise_on_signal (sigcode: INTEGER) is
         -- Raise exception, if signal 'sigcode' occurs
      external "C"
         alias "raiseOnSignal"
      end

   last_signal: INTEGER is
         -- Code of most recent signal
      external "C"
         alias "lastSignal"
      end

   reset_signal: INTEGER is
         -- Reset 'last_signal' to SIG_NONE
      external "C"
         alias "resetSignal"
      end

   raise (rout_name, msg: STRING; code: INTEGER; object: ANY) is
      external "C"
      alias "_eiffel_raise"
      end

   last_ecall: STRING is
      external "C"
         alias "c_last_ecall"
      end

   last_etext: STRING is
      external "C"
         alias "c_last_etext"
      end

   last_ecode: INTEGER is
      external "C"
         alias "c_last_ecode"
      end

   last_eobj: ANY is
      external "C"
         alias "c_last_eobj"
      end

feature
   -- Predefined exception codes
   -- User defined codes should use the range 1 ... 9999

   INTERRUPT               : INTEGER is 10000
   PRECONDITION            : INTEGER is 10001
   POSTCONDITION           : INTEGER is 10002
   CLASS_INVARIANT         : INTEGER is 10003
   LOOP_VARIANT            : INTEGER is 10004
   LOOP_INVARIANT          : INTEGER is 10005
   CHECK_INSTRUCTION       : INTEGER is 10006
   INVALID_INSPECT_VALUE   : INTEGER is 10007
   NO_MORE_MEMORY          : INTEGER is 10008
   VOID_CALL_TARGET        : INTEGER is 10009
   ARITH_DOMAIN            : INTEGER is 10010
   ARITH_SINGULAR          : INTEGER is 10011
   ARITH_OVERFLOW          : INTEGER is 10012
   ARITH_UNDERFLOW         : INTEGER is 10013
   ARITH_TOTAL_LOSS        : INTEGER is 10014
   ARITH_PARTIAL_LOSS      : INTEGER is 10015
   ARITH_ERROR             : INTEGER is 10016
   SIGNAL                  : INTEGER is 10017
   ILLEGAL_FREE            : INTEGER is 10018
   INTERNAL                : INTEGER is 10019
   NO_PERMISSION           : INTEGER is 10020
   INVALID_PATH            : INTEGER is 10021
   INTERRUPTED             : INTEGER is 10022
   PHYSICAL_IO_ERROR       : INTEGER is 10023
   DRIVE_NOT_READY         : INTEGER is 10024
   BAD_FILE_DESCRIPTOR     : INTEGER is 10025
   NOT_A_DIRECTORY         : INTEGER is 10026
   IS_A_DIRECTORY          : INTEGER is 10027
   FILE_TOO_LARGE          : INTEGER is 10028
   NO_MORE_SPACE           : INTEGER is 10029
   OS_ERROR                : INTEGER is 10030
   ILLEGAL_HOOK            : INTEGER is 10031
   VOID_ASSIGNED_TO_EXP    : INTEGER is 10032
   TYPE_MISMATCH           : INTEGER is 10033
   NOT_IN_UNIVERSE         : INTEGER is 10034
   SIG_NONE                : INTEGER is 0 -- No signal occured
   SIG_HANGUP              : INTEGER is 10036
   SIG_INTERRUPT           : INTEGER is 10037
   SIG_QUIT                : INTEGER is 10038
   SIG_FLOAT               : INTEGER is 10039
   SIG_SYSTEM              : INTEGER is 10040
   SIG_PIPE                : INTEGER is 10041
   SIG_ALARM               : INTEGER is 10042
   SIG_OTHER               : INTEGER is 10043
   SIG_BUS                 : INTEGER is 10044
   SIG_SEGMENTATION        : INTEGER is 10045
   SYSTEM_VALIDITY         : INTEGER is 10046
   RUNTIMESTACKOVERFLOW    : INTEGER is 10047
   EVALUATIONSTACKOVERFLOW : INTEGER is 10048
   INTERNALERROR           : INTEGER is 10049
   PROG_ARG_ERR            : INTEGER is 10050
   ENVIRONMENT_ERR         : INTEGER is 10051
   BASIC_IO_ERR            : INTEGER is 10052
   CECIL_ERROR             : INTEGER is 10053
   CALLBACK_ERROR          : INTEGER is 10054
   READ_ACCESS_VIOLATION   : INTEGER is 10055
   WRITE_ACCESS_VIOLATION  : INTEGER is 10056
   INVALID_INDEX           : INTEGER is 10057
   VOID_ACCESS_VIOLATION   : INTEGER is 10058
   DIFFERENT_TYPE          : INTEGER is 10059
   DONT_OBJECT_FILE        : INTEGER is 10060
   DONT_LIBRARY_FILE       : INTEGER is 10061
   LIBRARY_CORRUPTED       : INTEGER is 10062
   ROUTINE_FAILURE         : INTEGER is 10063

end -- class EXCEPTION
