indexing

   title:       "Memory area attached to another memory area";
   cluster:     "pool";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:17 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class RTS_ATTACHED_MEMORY

inherit

   RTS_MEMORY

creation

   attach

feature -- Creation

   attach (other: like attached_to) is
         -- Attach `Current' to `other'
      require
         valid_other: other /= Void
      do
         attached_to := other
      ensure
         is_attached: is_attached
      end

feature -- Access

   area: POINTER is
         -- Pointer to memory data
      do
         if is_attached then
            Result := attached_to.area
         end
      end

feature -- Measurement

   size: INTEGER is
         -- Size of data in bytes
      do
         if is_attached then
            Result := attached_to.size
         end
      end

feature -- Queries

   is_attached: BOOLEAN is
      do
         Result := attached_to /= Void
      end

feature -- Operations

   detach is
      do
         attached_to := Void
      ensure
         is_detached: not is_attached
      end

feature {NONE} -- Implementation

   attached_to: RTS_MEMORY

end