indexing
   title:       "The class to store objects in the file",
                "Simplifies the work with class STORABLE";
   cluster:     "pool";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/01 10:20:16 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class PERSISTENCY [G -> STORABLE]

inherit

   STORABLE
      export
         { NONE } all
      undefine
         copy
      end

   FILE
      end

creation

   make_create_read_write, -- If file exists truncate it
   make_open_read,         -- If no file exception
   make_open_read_write    -- If no file exception

feature -- Access to persistent data

   item: G is
         -- Retrieved object structure, from external
         -- representation previously stored in the file
      do
         Result ?= retrieved (Current)
      end

   put (data: G) is
         -- Produce on the file an external representation of the
         -- entire object structure reachable from current object
         -- Retrievable within current system only
      require
         non_void_data: data /= Void
      do
         data.basic_store (Current)
      end

   general_put (data: G) is
         -- Produce on the file an external representation of the
         -- entire object structure reachable from current object
         -- Retrievable from other systems for same platform
         -- (machine architecture)
      require
         non_void_data: data /= Void
      do
         data.general_store (Current)
      end

end -- class PERSISTENCY
