indexing
   description: "Platform-independent universal properties                   ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class ISE_GENERAL

feature -- Status report

   consistent (other: like Current): BOOLEAN is
         -- Is current object in a consistent state so that `other'
         -- may be copied onto it? (Default answer: yes).
      do
         Result := True
      end;

feature -- Comparison

   setup (other: like Current) is
         -- Assuming current object has just been created, perform
         -- actions necessary to ensure that contents of `other'
         -- can be safely copied onto it.
      do
      ensure
         consistent (other)
      end;

feature -- Basic operations

   die (code: INTEGER) is obsolete "Use ``new_die'' from ``EXCEPTIONS''"
         -- Terminate execution with exit status `code',
         -- without triggering an exception.
   local
      except : expanded EXCEPTIONS
   do
      except.die( code )
   end;

end -- class ISE_GENERAL
