indexing
   description: "Active structures, which always have a current position     ",
                "accessible through a cursor.                                ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : cursor_structure, access;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class CURSOR_STRUCTURE [G] inherit

   ACTIVE [G]

feature -- Access

   cursor: CURSOR is
         -- Current cursor position
      deferred
      end;

feature -- Status report

   valid_cursor (p: CURSOR): BOOLEAN is
         -- Can the cursor be moved to position `p'?
      deferred
      end;

feature -- Cursor movement

   go_to (p: CURSOR) is
         -- Move cursor to position `p'.
      require
         cursor_position_valid: valid_cursor (p)
      deferred
      end;

end -- class CURSOR_STRUCTURE
