indexing
   description: "Tables whose keys are integers or equivalent                ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : indexable, access;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class INDEXABLE [G, H -> INTEGER] inherit

   TABLE [G, H]
      rename
         valid_key as valid_index
      redefine
         put
      end

feature -- Element change

   put (v: G; k: H) is
         -- Associate value `v' with key `k'.
      deferred
      ensure then
         insertion_done: item (k) = v
      end;

end -- class INDEXABLE
