indexing
   description: "Containers whose items are accessible through keys          ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : table, access;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class TABLE [G, H] inherit

   BAG [G]
      rename
         put as bag_put
      end;

feature -- Access

   item, infix "@" (k: H): G is
         -- Entry of key `k'.
      require
         valid_key: valid_key (k)
      deferred
      end;

feature -- Status report

   valid_key (k: H): BOOLEAN is
         -- Is `k' a valid key?
      deferred
      end;

feature -- Element change

   put (v: G; k: H) is
         -- Associate value `v' with key `k'.
      require
         valid_key: valid_key (k)
      deferred
      end;

feature {NONE} -- Inapplicable

   bag_put (v: G) is
      do
      end

end -- class TABLE
