indexing
   description: "Cursors for circular lists";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : circular_cursor, cursor;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class CIRCULAR_CURSOR

 inherit
   CURSOR

creation

   make

feature {LINKED_LIST} -- Initialization

   make (curs: like cursor; int: BOOLEAN; start : INTEGER) is
         -- Create a cursor and set it up on `active_element'.
      do
         cursor := curs
         internal_exhausted := int
         starter := start
      end;

feature {CIRCULAR} -- Implementation

   cursor: CURSOR;
         -- Current element in implementation

   internal_exhausted : BOOLEAN;
         -- Has traversal passsed the start?

   starter : INTEGER
         -- Index of start position

end -- class CIRCULAR_CURSOR
