indexing
   description: "Cursors for compact trees";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : compact_tree_cursor, cursor;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class COMPACT_TREE_CURSOR inherit

   CURSOR

creation

   make

feature {COMPACT_CURSOR_TREE} -- Initialization

   make (i: INTEGER; aft, bef, bel, abv: BOOLEAN) is
         -- Create a cursor and set it up on `i'.
      do
         active := i;
         after := aft;
         below := bel;
         before := bef;
         above := abv
      end;

feature {COMPACT_CURSOR_TREE} -- Access

   active: INTEGER;
         -- Index of current item



feature {COMPACT_CURSOR_TREE} -- Status report

   after: BOOLEAN;
      -- Is there no valid cursor position to the right of cursor?

   before: BOOLEAN;
      -- Is there no valid cursor position to the left of cursor?

   below: BOOLEAN;
      -- Is there no valid cursor position below cursor?

   above: BOOLEAN;
      -- Is there no valid cursor position above cursor?

end -- class COMPACT_TREE_CURSOR
