indexing
   description: "Cursors for linked lists";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : linked_list_cursor, cursor;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class LINKED_LIST_CURSOR [G] inherit

   CURSOR

creation

   make

feature {LINKED_LIST} -- Initialization

   make (active_element: like active; aft, bef: BOOLEAN) is
         -- Create a cursor and set it up on `active_element'.
      do
         active := active_element;
         after := aft;
         before := bef
      end;

feature {LINKED_LIST} -- Implementation

   active: LINKABLE [G];
         -- Current element in linked list

   after: BOOLEAN;
         -- Is there no valid cursor position to the right of cursor?

   before: BOOLEAN;
         -- Is there no valid cursor position to the right of cursor?

invariant
   not_both: not (before and after);
   no_active_not_on: active = Void implies (before or after)

end -- class LINKED_LIST_CURSOR
