indexing
   description: "Cursors for multi-array trees";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : cursor;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class MULTAR_LIST_CURSOR [G] inherit

   CURSOR

creation

   make

feature {MULTI_ARRAY_LIST} -- Initialization

   make (active_element: like active; current_active_index, current_index: INTEGER) is
         -- Create a cursor and set it up on `active_element'.
      do
         active := active_element;
         active_index := current_active_index
         index := current_index
      end;

feature {MULTI_ARRAY_LIST} -- Implementation

   active: BI_LINKABLE [ARRAYED_LIST [G]];
      -- Current element in array_sequence list

   active_index: INTEGER;
      -- Index relative to `active.item'

   index: INTEGER
      -- Index in array_sequence list

end -- class MULTAR_LIST_CURSOR
