indexing
   description: "Cursors for recursive trees";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : recursive_tree_cursor, cursor;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class RECURSIVE_TREE_CURSOR [G] inherit

   CURSOR

creation {RECURSIVE_CURSOR_TREE}

   make

feature {RECURSIVE_CURSOR_TREE} -- Initialization

   make (active_node, parent_of_active: like active;
         aft, bef, bel: BOOLEAN) is
         -- Create a cursor and set it up on `active_node'.
      do
         active := active_node;
         active_parent := parent_of_active;
         after := aft;
         before := bef;
         below := bel
      end;

feature {RECURSIVE_CURSOR_TREE} -- Access

   active: DYNAMIC_TREE [G];
         -- Current node

   active_parent: like active;
         -- Parent of current node

feature {RECURSIVE_CURSOR_TREE} -- Status report

   after: BOOLEAN;
         -- Is there no valid cursor position to the right of cursor?

   before: BOOLEAN;
         -- Is there no valid cursor position to the left of cursor?

   below: BOOLEAN;
         -- Is there no valid cursor position below cursor?

end -- class RECURSIVE_TREE_CURSOR
