indexing
   description: "Dispensers: containers for which clients have no say        ",
                "as to what item they can access at a given time.            ",
                "Examples include stacks and queues.                         ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : dispenser, active;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class DISPENSER [G] inherit

        ACTIVE [G]
                redefine
                        extend,
                        put
        end

        FINITE [G]

feature -- Status report

        readable: BOOLEAN is
                        -- Is there a current item that may be read?
                do
                        Result := not empty
                end;

        writable: BOOLEAN is
                        -- Is there a current item that may be modified?
                do
                        Result := not empty
                end;

feature -- Element change

        append (s: SEQUENCE [G]) is
                        -- Append a copy of `s'.
                        -- (Synonym for `fill')
                do
                        fill (s)
                end;

        extend, force, put (v: G) is
                        -- Add item `v'.
                deferred
                end;

invariant

        readable_definition: readable = not empty;
        writable_definition: writable = not empty;

end -- class DISPENSER
