indexing
   description: "Priority queues implemented as sorted lists";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : priority_queue, queue;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class LINKED_PRIORITY_QUEUE [G -> COMPARABLE]

inherit
        PRIORITY_QUEUE [G]
                undefine
                        copy, is_equal,
                        prune_all, append, readable, writable
                select
                        put, remove, item
                end

        SORTED_TWO_WAY_LIST [G]
                rename
                        make as sl_make,
                        remove as sl_remove,
                        put as sl_put,
                        item as sl_item
                export
                        {NONE}
                                all
                end

creation
        make

feature -- Initialization

        make is
                        -- Allocate heap space.
                do
                        sl_make ;
                end;

feature -- Access

        item: G is
                        -- Entry at top of heap.
                do
                        Result := i_th (count)
                end;

feature -- Removal

        remove is
                        -- Remove item of highest value.
                do
                        go_i_th (count)
                        sl_remove
                        go_i_th (count)
                end;

feature -- Element change

        put (v: G) is
                        -- Insert item `v' at its proper position.
                do
                        extend (v)
                end;


end -- class LINKED_PRIORITY_QUEUE
