indexing
   description: "Dynamically modifiable circular chains";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : dynamic_circular, ring, sequence;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class DYNAMIC_CIRCULAR [G] inherit

        CIRCULAR [G]
                undefine
                        prune, prune_all
                end;

        DYNAMIC_CHAIN [G]
                undefine
                        valid_cursor_index,
                        search, first, last,
                        finish, start, move, go_i_th,
                        off, exhausted
                redefine
                        duplicate
                end;

feature -- Duplication

        duplicate (n: INTEGER): like Current is
                        -- Copy of sub-chain beginning at current position
                        -- and having min (`n', `count') items.
                local
                        pos: CURSOR;
                        to_be_removed, counter: INTEGER
                do
                        from
                                Result := new_chain;
                                pos := cursor;
                                to_be_removed := count.min (n)
                        until
                                counter = to_be_removed
                        loop
                                Result.extend (item);
                                forth;
                                counter := counter + 1
                        end;
                        go_to (pos)
                end;

end -- class DYNAMIC_CIRCULAR
