indexing
   description: "Linkable cells containing a reference to their right        ",
                "neighbor                                                    ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : linkable, cell;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

class LINKABLE [G] inherit

   CELL [G]
      export
         {CELL, CHAIN}
            put;
         {ANY}
            item
      end

feature -- Access

   right: like Current;
         -- Right neighbor

feature {CELL, CHAIN} -- Implementation

   put_right (other: like Current) is
         -- Put `other' to the right of current cell.
      do
         right := other
      ensure
         chained: right = other
      end;

   forget_right is
         -- Remove right link.
      do
         right := Void
      ensure
         not_chained: right = Void
      end;

end -- class LINKABLE
