indexing
   description: "Sequential lists, without commitment to a particular        ",
                "representation                                              ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : list, sequence;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class LIST [G] inherit

   CHAIN [G]
      redefine
         forth
      end;
feature -- Cursor movement

   forth is
         -- Move to next position; if no next position,
         -- ensure that `exhausted' will be true.
      deferred
      ensure then
         moved_forth: index = old index + 1
      end;

feature -- Status report

   after: BOOLEAN is
         -- Is there no valid cursor position to the right of cursor?
      do
         Result := (index = count + 1)
      end;

   before: BOOLEAN is
         -- Is there no valid cursor position to the left of cursor?
      do
         Result := (index = 0)
      end;

invariant

   before_definition: before = (index = 0);
   after_definition: after = (index = count + 1);

end -- class LIST
