indexing
   description: "Sequential lists where the cells are sorted in ascending    ",
                "order according to the relational operators of              ",
                "PART_COMPARABLE                                             ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : sorted_list, sorted_struct, sequence;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class SORTED_LIST [G -> COMPARABLE] inherit

   PART_SORTED_LIST [G]

feature -- Measurement

   min: G is
         -- Minimum item
      require
         not_empty: not empty
      do
         Result := first
      ensure
         min_is_first: Result = first;
         -- smallest: For every item `it' in list, `Result' <= `it'
      end;

   max: G is
         -- Maximum item
      require
         not_empty: not empty
      do
         Result := last
      ensure
         max_is_last: Result = last;
         -- largest: For every item `it' in list, `it' <= `Result'
      end;

   median: G is
         -- Median item
      require
         not_empty: not empty
      do
         Result := i_th ((count + 1) // 2)
      ensure
         median_definition: Result = i_th ((count + 1) // 2)
      end;


end -- class SORTED_LIST
