indexing
   description: "Sets whose items may be compared according to a total order ",
                "relation                                                    ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : comparable_set, comparable_struct;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class COMPARABLE_SET [G -> COMPARABLE] inherit

   SUBSET [G];

   COMPARABLE_STRUCT [G]
      rename
         min as cs_min,
         max as cs_max
      export
         {NONE}
            all
      undefine
         changeable_comparison_criterion
      end

feature -- Measurement

   min: G is
         -- Minimum item
      require
         not_empty: not empty
      do
         Result := cs_min
      ensure
         -- smallest: For every item `it' in set, `Result' <= `it'
      end;

   max: G is
         -- Maximum item
      require
         not_empty: not empty
      do
         Result := cs_max
      ensure
         -- largest: For every item `it' in set, `element' <= `it'
      end;

end -- class COMPARABLE_SET
