indexing
   description: "Collection, where each element must be unique";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : set;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class SET [G] inherit

        COLLECTION [G]
                redefine
                        extend,
                        prune,
                        put,
                        changeable_comparison_criterion
                end

feature -- Measurement

        count: INTEGER is
                -- Number of items
                deferred
                end

feature -- Element change

        extend, put (v: G) is
                        -- Ensure that set includes `v'.
                deferred
                ensure then
                        in_set_already: old has (v) implies (count = old count);
                        added_to_set: not old has (v) implies (count = old count + 1)
                end;

feature -- Removal

        prune (v: G) is
                        -- Remove `v' if present.
                deferred
                ensure then
                        removed_count_change: old has (v) implies (count = old count - 1);
                        not_removed_no_count_change: not old has (v) implies (count = old count);
                        item_deleted: not has (v)
                end;

        changeable_comparison_criterion: BOOLEAN is
                        -- May `object_comparison' be changed?
                        -- (Answer: only if set empty; otherwise insertions might
                        -- introduce duplicates, destroying the set property.)
                do
                        Result := empty
                ensure then
                        only_on_empty: Result = empty
                end

end -- class SET
