indexing
   description: "Data structures whose items may be compared                 ",
                "according to a partial order relation                       ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : comparable_struct;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class COMPARABLE_STRUCT [G -> COMPARABLE] inherit

   BILINEAR [G]

feature -- Measurement

   min: G is
         -- Minimum item
      require
         min_max_available

      do
         from
            start;
            Result := item;
            forth
         until
            off
         loop
            if item < Result then
               Result := item
            end;
            forth
         end
      ensure
      --   smallest: For every item `it' in structure, `Result' <= `it'
      end;

   max: G is
         -- Maximum item
      require
         min_max_available

      do
         from
            start;
            Result := item;
            forth
         until
            off
         loop
            if item > Result then
               Result := item
            end;
            forth
         end
      ensure
      --   largest: For every item `it' in structure, `it' <= `Result'
      end;

   min_max_available: BOOLEAN is
         -- Can min and max be computed?
      do
         Result := not empty
      ensure
         Result implies not empty
      end;

feature {NONE} -- Inapplicable

   index: INTEGER is
      do
      end

invariant

   empty_constraint: min_max_available implies not empty

end -- class COMPARABLE_STRUCT
