indexing
   description: "Bounded data structures, with a notion of capacity";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : bounded, storage;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class BOUNDED [G] inherit

   FINITE [G]

feature -- Measurement

   capacity: INTEGER is
         -- Number of items that may be stored
      deferred
      end;

feature -- Status report

   full: BOOLEAN is
         -- Is structure full?
      do
         Result := (count = capacity)
      end;

   resizable: BOOLEAN is
         -- May `capacity' be changed?
      deferred
      end;

invariant

   valid_count: count <= capacity;
   full_definition: full = (count = capacity)

end -- class BOUNDED
