indexing
   description: "Structures with a finite item count";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : finite, storage;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class FINITE [G] inherit

   BOX [G]

feature -- Measurement

   count: INTEGER is
         -- Number of items
      deferred
      end;

feature -- Status report

   empty: BOOLEAN is
         -- Is structure empty?
      do
         Result := (count = 0)
      end;

invariant

   empty_definition: empty = (count = 0);
   non_negative_count: count >= 0

end -- class FINITE
