indexing
   description: "Hierarchical structures in which each item has zero or      ",
                "one immediate predecessor, and zero or more successors.     ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : hierarchical, traversing;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class HIERARCHICAL [G] inherit

   TRAVERSABLE [G]

feature -- Access

   successor_count: INTEGER is
         -- Number of successors of current element
      require
         not_off: not off
      deferred
      end;

feature -- Cursor movement

   up is
         -- Move to predecessor.
      require
         not_off: not off
      deferred
      end;

   down (i: INTEGER) is
         -- Move to `i'-th successor.
      require
         not_off: not off;
          argument_within_bounds: i >= 1 and i <= successor_count
      deferred
      end;

invariant

   non_negative_successor_count: successor_count >= 0

end -- class HIERARCHICAL
