indexing
   description: "Structures for which there exists a traversal policy        ",
                "that will visit every element exactly once.                 ";
   title      : "EiffelBase: library of reusable components for Eiffel.      ",
                "Based on EiffelBase library for ISE Eiffel,                 ",
                "used with permission.                                       ";
   cluster    : EiffelBase;
   project    : "EiffelBase Library";
   copyright  : "(c) 1986-1997 Interactive Software Engineering Inc.         ",
                "Modifications and extensions:                               ",
                "(c) 1997 Object Tools                                       ",
                "All rights reserved. Duplication and distribution prohibited",
                "May be used only with Visual Eiffel under terms of user     ",
                "license                                                     ";
   key        : traversable, traversing;
   address    : "mail_to:support@object-tools.com                            ",
                "http://www.object-tools.com                                 ";

deferred class
   TRAVERSABLE [G]

inherit

   CONTAINER [G]

feature -- Access

   item: G is
         -- Item at current position
      require
         not_off: not off
      deferred
      end;

feature -- Status report

   off: BOOLEAN is
         -- Is there no current item?
      deferred
      end

feature -- Cursor movement

   start is
         -- Move to first position if any.
      deferred
      end;

invariant

   empty_constraint: empty implies off;

end -- class TRAVERSABLE
