-----------------------------------------------------------------------------
indexing
	description: "Memory Block implementation using array";
	copyright:   "Copyright 1999 Douglas L. Pardee and others,",
						"see file 'forum.txt'";
-----------------------------------------------------------------------------
class ARRAY_MEMORY_BLOCK[G]
		-- memory block implementation, using array
-----------------------------------------------------------------------------
inherit

	MEMORY_BLOCK
		redefine
			default_rescue
	end

	ARRAY[G]
		rename
			make as array_make
		export
      	{NONE} all
      	{ANY} to_c, count
		redefine
			default_rescue
	end
-----------------------------------------------------------------------------
creation
	make
-----------------------------------------------------------------------------

feature { NONE } -- Creation

	make(blocksize: INTEGER) is
		require
			nonnegative_blocksize: blocksize >= 0
  		do
     		array_make(1, blocksize)
		ensure
			count_set: (count = blocksize)
      end

-----------------------------------------------------------------------------

feature {ANY} -- Redefinition

	default_rescue is
		-- assure that the class invariants are okay
	do
		-- both classes require count >= 0
		if (count < 0) then
			count := 0
		end
		-- ARRAY requires count = (upper-lower+1), but that's currently
		-- a given, because upper is computed as (lower+count-1)
	end

-----------------------------------------------------------------------------

end -- class ARRAY_MEMORY_BLOCK
