-----------------------------------------------------------------------------
indexing
	description: "Memory Block Interface, shared between C and Eiffel";
	copyright:   "Copyright 1999 Douglas L. Pardee and others,",
						"see file 'forum.txt'";
-----------------------------------------------------------------------------
deferred class MEMORY_BLOCK
		-- memory block interface definition
-----------------------------------------------------------------------------
inherit

	ANY
		export
			{NONE} all
		undefine
			copy, is_equal
	end
-----------------------------------------------------------------------------

feature { ANY } -- Queries

	to_c: POINTER
			-- memory pointer to the memory block
		is
			deferred
			ensure
				pointer_if_count: (count>0) implies (Result /= default_pointer)
		end

	count: INTEGER
			-- number of items in the memory block
		is
			deferred
		end

-----------------------------------------------------------------------------
invariant
	nonnegative_count: count >= 0
-----------------------------------------------------------------------------

end -- class MEMORY_BLOCK
