indexing

	description:
		"Compilation error constants for regular expression matcher"

class REGEXP_ERRORS

feature -- Compile error constants

	Re_unmatched_parenthesis: INTEGER is 1

	Re_unmatched_brackets:	INTEGER is 2

	Re_invalid_range: INTEGER is 3

	Re_unmatched_braces: INTEGER is 4

	Re_invalid_char_class: INTEGER is 5

	Re_possibly_empty: INTEGER is 6

	Re_empty_repeat: INTEGER is 7

	Re_nested_repeat: INTEGER is 8

	Re_trailing_backslash: INTEGER is 9

	default_error_text(errno: INTEGER): STRING is
			-- Return corresponding error text to `errno'
		do
			inspect
				errno
			when Re_unmatched_parenthesis then
				Result := "unmatched %'()%'"
			when Re_unmatched_brackets then
				Result := "unmatched %'[]%'"
			when Re_invalid_range then
				Result := "invalid %'[]%' range"
			when Re_unmatched_braces then
				Result := "unmatched %'{}%'"
			when Re_invalid_char_class then
				Result := "%'{x}%' denotes no valid class"
			when Re_possibly_empty then
				Result := "operand of %'*%' or %'+%' could be empty"
			when Re_empty_repeat then
				Result := "%'*%', %'+%' or %'?%' follows nothing"
			when Re_nested_repeat then
				Result := "nested %'*%', %'+%' or %'?%'"
			when Re_trailing_backslash then
				Result := "trailing %'\%'"
			else
				Result := "unknown error code"
			end
		end

end -- class REGEXP_ERRORS
