indexing

	description: 
		"Regular expression matcher which can extract a found pattern",
		"from a text source."
	
class REGEXP_EXTRACTOR

inherit
	REGEXP
		rename
			search_forward as matcher_search_forward,
			search_backward as matcher_search_backward,
			match as matcher_match,
			match_prefix as matcher_match_prefix,
			match_suffix as matcher_match_suffix,
			match_left_part as matcher_match_left_part,
			match_right_part as matcher_match_right_part
		end

	EXTRACTOR

creation
	make, make_sensitive, make_insensitive

feature -- Matching questions

	matched_substring (i: INTEGER): STRING is
			-- Matched part of the `i'th subexpression. `Void', if `i'th
			-- subexpression was not part of the match.
		require
			successful_search: found
			not_released: not released
			valid_index: i >= 1 and i <= number_of_subexpr
		local
			s,e: INTEGER
		do
			s := start_of_subexpr(i)
			e := end_of_subexpr(i)
			if s > 0 then
				Result := search_string.substring(s, e)
			end
		end

end -- class REGEXP_EXTRACTOR
