indexing

   title:       "Java Native Interface environment";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_JAVA_NATIVE_INTERFACE_ENV

inherit

   ARRAY [POINTER]
      rename
         count as array_count,
         make  as array_make
      export
         {NONE} all
         {ANY } to_c
   end

creation
   make

feature {NONE} -- Creation

   make is
   do
      array_make (1, count)
   end

feature -- Measurement

   count: INTEGER is 220

feature -- Access: see JDK 1.1 JNI documentation for details

   reserved0: POINTER is do Result := item (reserved0_item                   ); end
   reserved1: POINTER is do Result := item (reserved1_item                   ); end
   reserved2: POINTER is do Result := item (reserved2_item                   ); end
   reserved3: POINTER is do Result := item (reserved3_item                   ); end
   GetVersion: POINTER is do Result := item (GetVersion_item                  ); end
   DefineClass: POINTER is do Result := item (DefineClass_item                 ); end
   FindClass: POINTER is do Result := item (FindClass_item                   ); end
   reserved4: POINTER is do Result := item (reserved4_item                   ); end
   reserved5: POINTER is do Result := item (reserved5_item                   ); end
   reserved6: POINTER is do Result := item (reserved6_item                   ); end
   GetSuperclass: POINTER is do Result := item (GetSuperclass_item               ); end
   IsAssignableFrom: POINTER is do Result := item (IsAssignableFrom_item            ); end
   reserved7: POINTER is do Result := item (reserved7_item                   ); end
   Throw: POINTER is do Result := item (Throw_item                       ); end
   ThrowNew: POINTER is do Result := item (ThrowNew_item                    ); end
   ExceptionOccurred: POINTER is do Result := item (ExceptionOccurred_item           ); end
   ExceptionDescribe: POINTER is do Result := item (ExceptionDescribe_item           ); end
   ExceptionClear: POINTER is do Result := item (ExceptionClear_item              ); end
   FatalError: POINTER is do Result := item (FatalError_item                  ); end
   reserved8: POINTER is do Result := item (reserved8_item                   ); end
   reserved9: POINTER is do Result := item (reserved9_item                   ); end
   NewGlobalRef: POINTER is do Result := item (NewGlobalRef_item                ); end
   DeleteGlobalRef: POINTER is do Result := item (DeleteGlobalRef_item             ); end
   DeleteLocalRef: POINTER is do Result := item (DeleteLocalRef_item              ); end
   IsSameObject: POINTER is do Result := item (IsSameObject_item                ); end
   reserved10: POINTER is do Result := item (reserved10_item                  ); end
   reserved11: POINTER is do Result := item (reserved11_item                  ); end
   AllocObject: POINTER is do Result := item (AllocObject_item                 ); end
   NewObject: POINTER is do Result := item (NewObject_item                   ); end
   NewObjectV: POINTER is do Result := item (NewObjectV_item                  ); end
   NewObjectA: POINTER is do Result := item (NewObjectA_item                  ); end
   GetObjectClass: POINTER is do Result := item (GetObjectClass_item              ); end
   IsInstanceOf: POINTER is do Result := item (IsInstanceOf_item                ); end
   GetMethodID: POINTER is do Result := item (GetMethodID_item                 ); end
   CallObjectMethod: POINTER is do Result := item (CallObjectMethod_item            ); end
   CallObjectMethodV: POINTER is do Result := item (CallObjectMethodV_item           ); end
   CallObjectMethodA: POINTER is do Result := item (CallObjectMethodA_item           ); end
   CallBooleanMethod: POINTER is do Result := item (CallBooleanMethod_item           ); end
   CallBooleanMethodV: POINTER is do Result := item (CallBooleanMethodV_item          ); end
   CallBooleanMethodA: POINTER is do Result := item (CallBooleanMethodA_item          ); end
   CallByteMethod: POINTER is do Result := item (CallByteMethod_item              ); end
   CallByteMethodV: POINTER is do Result := item (CallByteMethodV_item             ); end
   CallByteMethodA: POINTER is do Result := item (CallByteMethodA_item             ); end
   CallCharMethod: POINTER is do Result := item (CallCharMethod_item              ); end
   CallCharMethodV: POINTER is do Result := item (CallCharMethodV_item             ); end
   CallCharMethodA: POINTER is do Result := item (CallCharMethodA_item             ); end
   CallShortMethod: POINTER is do Result := item (CallShortMethod_item             ); end
   CallShortMethodV: POINTER is do Result := item (CallShortMethodV_item            ); end
   CallShortMethodA: POINTER is do Result := item (CallShortMethodA_item            ); end
   CallIntMethod: POINTER is do Result := item (CallIntMethod_item               ); end
   CallIntMethodV: POINTER is do Result := item (CallIntMethodV_item              ); end
   CallIntMethodA: POINTER is do Result := item (CallIntMethodA_item              ); end
   CallLongMethod: POINTER is do Result := item (CallLongMethod_item              ); end
   CallLongMethodV: POINTER is do Result := item (CallLongMethodV_item             ); end
   CallLongMethodA: POINTER is do Result := item (CallLongMethodA_item             ); end
   CallFloatMethod: POINTER is do Result := item (CallFloatMethod_item             ); end
   CallFloatMethodV: POINTER is do Result := item (CallFloatMethodV_item            ); end
   CallFloatMethodA: POINTER is do Result := item (CallFloatMethodA_item            ); end
   CallDoubleMethod: POINTER is do Result := item (CallDoubleMethod_item            ); end
   CallDoubleMethodV: POINTER is do Result := item (CallDoubleMethodV_item           ); end
   CallDoubleMethodA: POINTER is do Result := item (CallDoubleMethodA_item           ); end
   CallVoidMethod: POINTER is do Result := item (CallVoidMethod_item              ); end
   CallVoidMethodV: POINTER is do Result := item (CallVoidMethodV_item             ); end
   CallVoidMethodA: POINTER is do Result := item (CallVoidMethodA_item             ); end
   CallNonvirtualObjectMethod: POINTER is do Result := item (CallNonvirtualObjectMethod_item  ); end
   CallNonvirtualObjectMethodV: POINTER is do Result := item (CallNonvirtualObjectMethodV_item ); end
   CallNonvirtualObjectMethodA: POINTER is do Result := item (CallNonvirtualObjectMethodA_item ); end
   CallNonvirtualBooleanMethod: POINTER is do Result := item (CallNonvirtualBooleanMethod_item ); end
   CallNonvirtualBooleanMethodV: POINTER is do Result := item (CallNonvirtualBooleanMethodV_item); end
   CallNonvirtualBooleanMethodA: POINTER is do Result := item (CallNonvirtualBooleanMethodA_item); end
   CallNonvirtualByteMethod: POINTER is do Result := item (CallNonvirtualByteMethod_item    ); end
   CallNonvirtualByteMethodV: POINTER is do Result := item (CallNonvirtualByteMethodV_item   ); end
   CallNonvirtualByteMethodA: POINTER is do Result := item (CallNonvirtualByteMethodA_item   ); end
   CallNonvirtualCharMethod: POINTER is do Result := item (CallNonvirtualCharMethod_item    ); end
   CallNonvirtualCharMethodV: POINTER is do Result := item (CallNonvirtualCharMethodV_item   ); end
   CallNonvirtualCharMethodA: POINTER is do Result := item (CallNonvirtualCharMethodA_item   ); end
   CallNonvirtualShortMethod: POINTER is do Result := item (CallNonvirtualShortMethod_item   ); end
   CallNonvirtualShortMethodV: POINTER is do Result := item (CallNonvirtualShortMethodV_item  ); end
   CallNonvirtualShortMethodA: POINTER is do Result := item (CallNonvirtualShortMethodA_item  ); end
   CallNonvirtualIntMethod: POINTER is do Result := item (CallNonvirtualIntMethod_item     ); end
   CallNonvirtualIntMethodV: POINTER is do Result := item (CallNonvirtualIntMethodV_item    ); end
   CallNonvirtualIntMethodA: POINTER is do Result := item (CallNonvirtualIntMethodA_item    ); end
   CallNonvirtualLongMethod: POINTER is do Result := item (CallNonvirtualLongMethod_item    ); end
   CallNonvirtualLongMethodV: POINTER is do Result := item (CallNonvirtualLongMethodV_item   ); end
   CallNonvirtualLongMethodA: POINTER is do Result := item (CallNonvirtualLongMethodA_item   ); end
   CallNonvirtualFloatMethod: POINTER is do Result := item (CallNonvirtualFloatMethod_item   ); end
   CallNonvirtualFloatMethodV: POINTER is do Result := item (CallNonvirtualFloatMethodV_item  ); end
   CallNonvirtualFloatMethodA: POINTER is do Result := item (CallNonvirtualFloatMethodA_item  ); end
   CallNonvirtualDoubleMethod: POINTER is do Result := item (CallNonvirtualDoubleMethod_item  ); end
   CallNonvirtualDoubleMethodV: POINTER is do Result := item (CallNonvirtualDoubleMethodV_item ); end
   CallNonvirtualDoubleMethodA: POINTER is do Result := item (CallNonvirtualDoubleMethodA_item ); end
   CallNonvirtualVoidMethod: POINTER is do Result := item (CallNonvirtualVoidMethod_item    ); end
   CallNonvirtualVoidMethodV: POINTER is do Result := item (CallNonvirtualVoidMethodV_item   ); end
   CallNonvirtualVoidMethodA: POINTER is do Result := item (CallNonvirtualVoidMethodA_item   ); end
   GetFieldID: POINTER is do Result := item (GetFieldID_item                  ); end
   GetObjectField: POINTER is do Result := item (GetObjectField_item              ); end
   GetBooleanField: POINTER is do Result := item (GetBooleanField_item             ); end
   GetByteField: POINTER is do Result := item (GetByteField_item                ); end
   GetCharField: POINTER is do Result := item (GetCharField_item                ); end
   GetShortField: POINTER is do Result := item (GetShortField_item               ); end
   GetIntField: POINTER is do Result := item (GetIntField_item                 ); end
   GetLongField: POINTER is do Result := item (GetLongField_item                ); end
   GetFloatField: POINTER is do Result := item (GetFloatField_item               ); end
   GetDoubleField: POINTER is do Result := item (GetDoubleField_item              ); end
   SetObjectField: POINTER is do Result := item (SetObjectField_item              ); end
   SetBooleanField: POINTER is do Result := item (SetBooleanField_item             ); end
   SetByteField: POINTER is do Result := item (SetByteField_item                ); end
   SetCharField: POINTER is do Result := item (SetCharField_item                ); end
   SetShortField: POINTER is do Result := item (SetShortField_item               ); end
   SetIntField: POINTER is do Result := item (SetIntField_item                 ); end
   SetLongField: POINTER is do Result := item (SetLongField_item                ); end
   SetFloatField: POINTER is do Result := item (SetFloatField_item               ); end
   SetDoubleField: POINTER is do Result := item (SetDoubleField_item              ); end
   GetStaticMethodID: POINTER is do Result := item (GetStaticMethodID_item           ); end
   CallStaticObjectMethod: POINTER is do Result := item (CallStaticObjectMethod_item      ); end
   CallStaticObjectMethodV: POINTER is do Result := item (CallStaticObjectMethodV_item     ); end
   CallStaticObjectMethodA: POINTER is do Result := item (CallStaticObjectMethodA_item     ); end
   CallStaticBooleanMethod: POINTER is do Result := item (CallStaticBooleanMethod_item     ); end
   CallStaticBooleanMethodV: POINTER is do Result := item (CallStaticBooleanMethodV_item    ); end
   CallStaticBooleanMethodA: POINTER is do Result := item (CallStaticBooleanMethodA_item    ); end
   CallStaticByteMethod: POINTER is do Result := item (CallStaticByteMethod_item        ); end
   CallStaticByteMethodV: POINTER is do Result := item (CallStaticByteMethodV_item       ); end
   CallStaticByteMethodA: POINTER is do Result := item (CallStaticByteMethodA_item       ); end
   CallStaticCharMethod: POINTER is do Result := item (CallStaticCharMethod_item        ); end
   CallStaticCharMethodV: POINTER is do Result := item (CallStaticCharMethodV_item       ); end
   CallStaticCharMethodA: POINTER is do Result := item (CallStaticCharMethodA_item       ); end
   CallStaticShortMethod: POINTER is do Result := item (CallStaticShortMethod_item       ); end
   CallStaticShortMethodV: POINTER is do Result := item (CallStaticShortMethodV_item      ); end
   CallStaticShortMethodA: POINTER is do Result := item (CallStaticShortMethodA_item      ); end
   CallStaticIntMethod: POINTER is do Result := item (CallStaticIntMethod_item         ); end
   CallStaticIntMethodV: POINTER is do Result := item (CallStaticIntMethodV_item        ); end
   CallStaticIntMethodA: POINTER is do Result := item (CallStaticIntMethodA_item        ); end
   CallStaticLongMethod: POINTER is do Result := item (CallStaticLongMethod_item        ); end
   CallStaticLongMethodV: POINTER is do Result := item (CallStaticLongMethodV_item       ); end
   CallStaticLongMethodA: POINTER is do Result := item (CallStaticLongMethodA_item       ); end
   CallStaticFloatMethod: POINTER is do Result := item (CallStaticFloatMethod_item       ); end
   CallStaticFloatMethodV: POINTER is do Result := item (CallStaticFloatMethodV_item      ); end
   CallStaticFloatMethodA: POINTER is do Result := item (CallStaticFloatMethodA_item      ); end
   CallStaticDoubleMethod: POINTER is do Result := item (CallStaticDoubleMethod_item      ); end
   CallStaticDoubleMethodV: POINTER is do Result := item (CallStaticDoubleMethodV_item     ); end
   CallStaticDoubleMethodA: POINTER is do Result := item (CallStaticDoubleMethodA_item     ); end
   CallStaticVoidMethod: POINTER is do Result := item (CallStaticVoidMethod_item        ); end
   CallStaticVoidMethodV: POINTER is do Result := item (CallStaticVoidMethodV_item       ); end
   CallStaticVoidMethodA: POINTER is do Result := item (CallStaticVoidMethodA_item       ); end
   GetStaticFieldID: POINTER is do Result := item (GetStaticFieldID_item            ); end
   GetStaticObjectField: POINTER is do Result := item (GetStaticObjectField_item        ); end
   GetStaticBooleanField: POINTER is do Result := item (GetStaticBooleanField_item       ); end
   GetStaticByteField: POINTER is do Result := item (GetStaticByteField_item          ); end
   GetStaticCharField: POINTER is do Result := item (GetStaticCharField_item          ); end
   GetStaticShortField: POINTER is do Result := item (GetStaticShortField_item         ); end
   GetStaticIntField: POINTER is do Result := item (GetStaticIntField_item           ); end
   GetStaticLongField: POINTER is do Result := item (GetStaticLongField_item          ); end
   GetStaticFloatField: POINTER is do Result := item (GetStaticFloatField_item         ); end
   GetStaticDoubleField: POINTER is do Result := item (GetStaticDoubleField_item        ); end
   SetStaticObjectField: POINTER is do Result := item (SetStaticObjectField_item        ); end
   SetStaticBooleanField: POINTER is do Result := item (SetStaticBooleanField_item       ); end
   SetStaticByteField: POINTER is do Result := item (SetStaticByteField_item          ); end
   SetStaticCharField: POINTER is do Result := item (SetStaticCharField_item          ); end
   SetStaticShortField: POINTER is do Result := item (SetStaticShortField_item         ); end
   SetStaticIntField: POINTER is do Result := item (SetStaticIntField_item           ); end
   SetStaticLongField: POINTER is do Result := item (SetStaticLongField_item          ); end
   SetStaticFloatField: POINTER is do Result := item (SetStaticFloatField_item         ); end
   SetStaticDoubleField: POINTER is do Result := item (SetStaticDoubleField_item        ); end
   NewString: POINTER is do Result := item (NewString_item                   ); end
   GetStringLength: POINTER is do Result := item (GetStringLength_item             ); end
   GetStringChars: POINTER is do Result := item (GetStringChars_item              ); end
   ReleaseStringChars: POINTER is do Result := item (ReleaseStringChars_item          ); end
   NewStringUTF: POINTER is do Result := item (NewStringUTF_item                ); end
   GetStringUTFLength: POINTER is do Result := item (GetStringUTFLength_item          ); end
   GetStringUTFChars: POINTER is do Result := item (GetStringUTFChars_item           ); end
   ReleaseStringUTFChars: POINTER is do Result := item (ReleaseStringUTFChars_item       ); end
   GetArrayLength: POINTER is do Result := item (GetArrayLength_item              ); end
   NewObjectArray: POINTER is do Result := item (NewObjectArray_item              ); end
   GetObjectArrayElement: POINTER is do Result := item (GetObjectArrayElement_item       ); end
   SetObjectArrayElement: POINTER is do Result := item (SetObjectArrayElement_item       ); end
   NewBooleanArray: POINTER is do Result := item (NewBooleanArray_item             ); end
   NewByteArray: POINTER is do Result := item (NewByteArray_item                ); end
   NewCharArray: POINTER is do Result := item (NewCharArray_item                ); end
   NewShortArray: POINTER is do Result := item (NewShortArray_item               ); end
   NewIntArray: POINTER is do Result := item (NewIntArray_item                 ); end
   NewLongArray: POINTER is do Result := item (NewLongArray_item                ); end
   NewFloatArray: POINTER is do Result := item (NewFloatArray_item               ); end
   NewDoubleArray: POINTER is do Result := item (NewDoubleArray_item              ); end
   GetBooleanArrayElements: POINTER is do Result := item (GetBooleanArrayElements_item     ); end
   GetByteArrayElements: POINTER is do Result := item (GetByteArrayElements_item        ); end
   GetCharArrayElements: POINTER is do Result := item (GetCharArrayElements_item        ); end
   GetShortArrayElements: POINTER is do Result := item (GetShortArrayElements_item       ); end
   GetIntArrayElements: POINTER is do Result := item (GetIntArrayElements_item         ); end
   GetLongArrayElements: POINTER is do Result := item (GetLongArrayElements_item        ); end
   GetFloatArrayElements: POINTER is do Result := item (GetFloatArrayElements_item       ); end
   GetDoubleArrayElements: POINTER is do Result := item (GetDoubleArrayElements_item      ); end
   ReleaseBooleanArrayElements: POINTER is do Result := item (ReleaseBooleanArrayElements_item ); end
   ReleaseByteArrayElements: POINTER is do Result := item (ReleaseByteArrayElements_item    ); end
   ReleaseCharArrayElements: POINTER is do Result := item (ReleaseCharArrayElements_item    ); end
   ReleaseShortArrayElements: POINTER is do Result := item (ReleaseShortArrayElements_item   ); end
   ReleaseIntArrayElements: POINTER is do Result := item (ReleaseIntArrayElements_item     ); end
   ReleaseLongArrayElements: POINTER is do Result := item (ReleaseLongArrayElements_item    ); end
   ReleaseFloatArrayElements: POINTER is do Result := item (ReleaseFloatArrayElements_item   ); end
   ReleaseDoubleArrayElements: POINTER is do Result := item (ReleaseDoubleArrayElements_item  ); end
   GetBooleanArrayRegion: POINTER is do Result := item (GetBooleanArrayRegion_item       ); end
   GetByteArrayRegion: POINTER is do Result := item (GetByteArrayRegion_item          ); end
   GetCharArrayRegion: POINTER is do Result := item (GetCharArrayRegion_item          ); end
   GetShortArrayRegion: POINTER is do Result := item (GetShortArrayRegion_item         ); end
   GetIntArrayRegion: POINTER is do Result := item (GetIntArrayRegion_item           ); end
   GetLongArrayRegion: POINTER is do Result := item (GetLongArrayRegion_item          ); end
   GetFloatArrayRegion: POINTER is do Result := item (GetFloatArrayRegion_item         ); end
   GetDoubleArrayRegion: POINTER is do Result := item (GetDoubleArrayRegion_item        ); end
   SetBooleanArrayRegion: POINTER is do Result := item (SetBooleanArrayRegion_item       ); end
   SetByteArrayRegion: POINTER is do Result := item (SetByteArrayRegion_item          ); end
   SetCharArrayRegion: POINTER is do Result := item (SetCharArrayRegion_item          ); end
   SetShortArrayRegion: POINTER is do Result := item (SetShortArrayRegion_item         ); end
   SetIntArrayRegion: POINTER is do Result := item (SetIntArrayRegion_item           ); end
   SetLongArrayRegion: POINTER is do Result := item (SetLongArrayRegion_item          ); end
   SetFloatArrayRegion: POINTER is do Result := item (SetFloatArrayRegion_item         ); end
   SetDoubleArrayRegion: POINTER is do Result := item (SetDoubleArrayRegion_item        ); end
   RegisterNatives: POINTER is do Result := item (RegisterNatives_item             ); end
   UnregisterNatives: POINTER is do Result := item (UnregisterNatives_item           ); end
   MonitorEnter: POINTER is do Result := item (MonitorEnter_item                ); end
   MonitorExit: POINTER is do Result := item (MonitorExit_item                 ); end
   GetJavaVM: POINTER is do Result := item (GetJavaVM_item                   ); end

feature {NONE} -- Implementation

   reserved0_item: INTEGER is 001
   reserved1_item: INTEGER is 002
   reserved2_item: INTEGER is 003
   reserved3_item: INTEGER is 004
   GetVersion_item: INTEGER is 005
   DefineClass_item: INTEGER is 006
   FindClass_item: INTEGER is 007
   reserved4_item: INTEGER is 008
   reserved5_item: INTEGER is 009
   reserved6_item: INTEGER is 010
   GetSuperclass_item: INTEGER is 011
   IsAssignableFrom_item: INTEGER is 012
   reserved7_item: INTEGER is 013
   Throw_item: INTEGER is 014
   ThrowNew_item: INTEGER is 015
   ExceptionOccurred_item: INTEGER is 016
   ExceptionDescribe_item: INTEGER is 017
   ExceptionClear_item: INTEGER is 018
   FatalError_item: INTEGER is 019
   reserved8_item: INTEGER is 020
   reserved9_item: INTEGER is 021
   NewGlobalRef_item: INTEGER is 022
   DeleteGlobalRef_item: INTEGER is 023
   DeleteLocalRef_item: INTEGER is 024
   IsSameObject_item: INTEGER is 025
   reserved10_item: INTEGER is 026
   reserved11_item: INTEGER is 027
   AllocObject_item: INTEGER is 028
   NewObject_item: INTEGER is 029
   NewObjectV_item: INTEGER is 030
   NewObjectA_item: INTEGER is 031
   GetObjectClass_item: INTEGER is 032
   IsInstanceOf_item: INTEGER is 033
   GetMethodID_item: INTEGER is 034
   CallObjectMethod_item: INTEGER is 035
   CallObjectMethodV_item: INTEGER is 036
   CallObjectMethodA_item: INTEGER is 037
   CallBooleanMethod_item: INTEGER is 038
   CallBooleanMethodV_item: INTEGER is 039
   CallBooleanMethodA_item: INTEGER is 040
   CallByteMethod_item: INTEGER is 041
   CallByteMethodV_item: INTEGER is 042
   CallByteMethodA_item: INTEGER is 043
   CallCharMethod_item: INTEGER is 044
   CallCharMethodV_item: INTEGER is 045
   CallCharMethodA_item: INTEGER is 046
   CallShortMethod_item: INTEGER is 047
   CallShortMethodV_item: INTEGER is 048
   CallShortMethodA_item: INTEGER is 049
   CallIntMethod_item: INTEGER is 050
   CallIntMethodV_item: INTEGER is 051
   CallIntMethodA_item: INTEGER is 052
   CallLongMethod_item: INTEGER is 053
   CallLongMethodV_item: INTEGER is 054
   CallLongMethodA_item: INTEGER is 055
   CallFloatMethod_item: INTEGER is 056
   CallFloatMethodV_item: INTEGER is 057
   CallFloatMethodA_item: INTEGER is 058
   CallDoubleMethod_item: INTEGER is 059
   CallDoubleMethodV_item: INTEGER is 060
   CallDoubleMethodA_item: INTEGER is 061
   CallVoidMethod_item: INTEGER is 062
   CallVoidMethodV_item: INTEGER is 063
   CallVoidMethodA_item: INTEGER is 064
   CallNonvirtualObjectMethod_item: INTEGER is 065
   CallNonvirtualObjectMethodV_item: INTEGER is 066
   CallNonvirtualObjectMethodA_item: INTEGER is 067
   CallNonvirtualBooleanMethod_item: INTEGER is 068
   CallNonvirtualBooleanMethodV_item: INTEGER is 069
   CallNonvirtualBooleanMethodA_item: INTEGER is 070
   CallNonvirtualByteMethod_item: INTEGER is 071
   CallNonvirtualByteMethodV_item: INTEGER is 072
   CallNonvirtualByteMethodA_item: INTEGER is 073
   CallNonvirtualCharMethod_item: INTEGER is 074
   CallNonvirtualCharMethodV_item: INTEGER is 075
   CallNonvirtualCharMethodA_item: INTEGER is 076
   CallNonvirtualShortMethod_item: INTEGER is 077
   CallNonvirtualShortMethodV_item: INTEGER is 078
   CallNonvirtualShortMethodA_item: INTEGER is 079
   CallNonvirtualIntMethod_item: INTEGER is 080
   CallNonvirtualIntMethodV_item: INTEGER is 081
   CallNonvirtualIntMethodA_item: INTEGER is 082
   CallNonvirtualLongMethod_item: INTEGER is 083
   CallNonvirtualLongMethodV_item: INTEGER is 084
   CallNonvirtualLongMethodA_item: INTEGER is 085
   CallNonvirtualFloatMethod_item: INTEGER is 086
   CallNonvirtualFloatMethodV_item: INTEGER is 087
   CallNonvirtualFloatMethodA_item: INTEGER is 088
   CallNonvirtualDoubleMethod_item: INTEGER is 089
   CallNonvirtualDoubleMethodV_item: INTEGER is 090
   CallNonvirtualDoubleMethodA_item: INTEGER is 091
   CallNonvirtualVoidMethod_item: INTEGER is 092
   CallNonvirtualVoidMethodV_item: INTEGER is 093
   CallNonvirtualVoidMethodA_item: INTEGER is 094
   GetFieldID_item: INTEGER is 095
   GetObjectField_item: INTEGER is 096
   GetBooleanField_item: INTEGER is 097
   GetByteField_item: INTEGER is 098
   GetCharField_item: INTEGER is 099
   GetShortField_item: INTEGER is 100
   GetIntField_item: INTEGER is 101
   GetLongField_item: INTEGER is 102
   GetFloatField_item: INTEGER is 103
   GetDoubleField_item: INTEGER is 104
   SetObjectField_item: INTEGER is 105
   SetBooleanField_item: INTEGER is 106
   SetByteField_item: INTEGER is 107
   SetCharField_item: INTEGER is 108
   SetShortField_item: INTEGER is 119
   SetIntField_item: INTEGER is 110
   SetLongField_item: INTEGER is 111
   SetFloatField_item: INTEGER is 112
   SetDoubleField_item: INTEGER is 113
   GetStaticMethodID_item: INTEGER is 114
   CallStaticObjectMethod_item: INTEGER is 115
   CallStaticObjectMethodV_item: INTEGER is 116
   CallStaticObjectMethodA_item: INTEGER is 117
   CallStaticBooleanMethod_item: INTEGER is 118
   CallStaticBooleanMethodV_item: INTEGER is 129
   CallStaticBooleanMethodA_item: INTEGER is 120
   CallStaticByteMethod_item: INTEGER is 121
   CallStaticByteMethodV_item: INTEGER is 122
   CallStaticByteMethodA_item: INTEGER is 123
   CallStaticCharMethod_item: INTEGER is 124
   CallStaticCharMethodV_item: INTEGER is 125
   CallStaticCharMethodA_item: INTEGER is 126
   CallStaticShortMethod_item: INTEGER is 127
   CallStaticShortMethodV_item: INTEGER is 128
   CallStaticShortMethodA_item: INTEGER is 139
   CallStaticIntMethod_item: INTEGER is 130
   CallStaticIntMethodV_item: INTEGER is 131
   CallStaticIntMethodA_item: INTEGER is 132
   CallStaticLongMethod_item: INTEGER is 133
   CallStaticLongMethodV_item: INTEGER is 134
   CallStaticLongMethodA_item: INTEGER is 135
   CallStaticFloatMethod_item: INTEGER is 136
   CallStaticFloatMethodV_item: INTEGER is 137
   CallStaticFloatMethodA_item: INTEGER is 138
   CallStaticDoubleMethod_item: INTEGER is 149
   CallStaticDoubleMethodV_item: INTEGER is 140
   CallStaticDoubleMethodA_item: INTEGER is 141
   CallStaticVoidMethod_item: INTEGER is 142
   CallStaticVoidMethodV_item: INTEGER is 143
   CallStaticVoidMethodA_item: INTEGER is 144
   GetStaticFieldID_item: INTEGER is 145
   GetStaticObjectField_item: INTEGER is 146
   GetStaticBooleanField_item: INTEGER is 147
   GetStaticByteField_item: INTEGER is 148
   GetStaticCharField_item: INTEGER is 159
   GetStaticShortField_item: INTEGER is 150
   GetStaticIntField_item: INTEGER is 151
   GetStaticLongField_item: INTEGER is 152
   GetStaticFloatField_item: INTEGER is 153
   GetStaticDoubleField_item: INTEGER is 154
   SetStaticObjectField_item: INTEGER is 155
   SetStaticBooleanField_item: INTEGER is 156
   SetStaticByteField_item: INTEGER is 157
   SetStaticCharField_item: INTEGER is 158
   SetStaticShortField_item: INTEGER is 169
   SetStaticIntField_item: INTEGER is 160
   SetStaticLongField_item: INTEGER is 161
   SetStaticFloatField_item: INTEGER is 162
   SetStaticDoubleField_item: INTEGER is 163
   NewString_item: INTEGER is 164
   GetStringLength_item: INTEGER is 165
   GetStringChars_item: INTEGER is 166
   ReleaseStringChars_item: INTEGER is 167
   NewStringUTF_item: INTEGER is 168
   GetStringUTFLength_item: INTEGER is 179
   GetStringUTFChars_item: INTEGER is 170
   ReleaseStringUTFChars_item: INTEGER is 171
   GetArrayLength_item: INTEGER is 172
   NewObjectArray_item: INTEGER is 173
   GetObjectArrayElement_item: INTEGER is 174
   SetObjectArrayElement_item: INTEGER is 175
   NewBooleanArray_item: INTEGER is 176
   NewByteArray_item: INTEGER is 177
   NewCharArray_item: INTEGER is 178
   NewShortArray_item: INTEGER is 189
   NewIntArray_item: INTEGER is 180
   NewLongArray_item: INTEGER is 181
   NewFloatArray_item: INTEGER is 182
   NewDoubleArray_item: INTEGER is 183
   GetBooleanArrayElements_item: INTEGER is 184
   GetByteArrayElements_item: INTEGER is 185
   GetCharArrayElements_item: INTEGER is 186
   GetShortArrayElements_item: INTEGER is 187
   GetIntArrayElements_item: INTEGER is 188
   GetLongArrayElements_item: INTEGER is 199
   GetFloatArrayElements_item: INTEGER is 190
   GetDoubleArrayElements_item: INTEGER is 191
   ReleaseBooleanArrayElements_item: INTEGER is 192
   ReleaseByteArrayElements_item: INTEGER is 193
   ReleaseCharArrayElements_item: INTEGER is 194
   ReleaseShortArrayElements_item: INTEGER is 195
   ReleaseIntArrayElements_item: INTEGER is 196
   ReleaseLongArrayElements_item: INTEGER is 197
   ReleaseFloatArrayElements_item: INTEGER is 198
   ReleaseDoubleArrayElements_item: INTEGER is 199
   GetBooleanArrayRegion_item: INTEGER is 200
   GetByteArrayRegion_item: INTEGER is 201
   GetCharArrayRegion_item: INTEGER is 202
   GetShortArrayRegion_item: INTEGER is 203
   GetIntArrayRegion_item: INTEGER is 204
   GetLongArrayRegion_item: INTEGER is 205
   GetFloatArrayRegion_item: INTEGER is 206
   GetDoubleArrayRegion_item: INTEGER is 207
   SetBooleanArrayRegion_item: INTEGER is 208
   SetByteArrayRegion_item: INTEGER is 209
   SetCharArrayRegion_item: INTEGER is 210
   SetShortArrayRegion_item: INTEGER is 211
   SetIntArrayRegion_item: INTEGER is 212
   SetLongArrayRegion_item: INTEGER is 213
   SetFloatArrayRegion_item: INTEGER is 214
   SetDoubleArrayRegion_item: INTEGER is 215
   RegisterNatives_item: INTEGER is 216
   UnregisterNatives_item: INTEGER is 217
   MonitorEnter_item: INTEGER is 218
   MonitorExit_item: INTEGER is 219
   GetJavaVM_item: INTEGER is 220

end