indexing

   title:       "JNI JavaVMInitArgs (since JDK 1.2)";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_JavaVMInitArgs

inherit

   JNI_JavaVMInitArgs_Header
      redefine
         out
      end

creation

   make

feature {NONE} -- Creation

   make is
         -- Create arguments object
      local
         classpath: JNI_JavaVMOption
      do
         !!classpath.make ("-Djava.class.path=" + default_classpath, default_pointer)
         options := << classpath >>
      end

feature -- Status

   version: INTEGER is 65538
        -- Java VM version: jni_version_1_2

   options: ARRAY [JNI_JavaVMOption]
         -- JVM options

   ignoreUnrecognized: BOOLEAN
         -- Should JVM ignore all unrecognized option strings
         -- that begin with "-X" or "_"?

feature -- Status setting

   set_options (value: ARRAY [JNI_JavaVMOption]) is
      do
         options := value
      ensure
         options_set: options = value
      end

   set_ignoreUnrecognized (value: BOOLEAN) is
      do
         ignoreUnrecognized := ignoreUnrecognized
      ensure
         ignoreUnrecognized_set: ignoreUnrecognized = value
      end

feature -- Output

   out: STRING is
      local
         nOptions: INTEGER
         i: INTEGER
      do
         Result := "version: "
         Result.append_integer (version // 0x00010000)
         Result.append_character ('.')
         Result.append_integer (version \\ 0x00010000)
         if options /= Void then
            nOptions := options.count
         end
         Result.append_string ("%NnOptions: ")
         Result.append_integer (nOptions)
         if nOptions > 0 then
            from
               Result.append_string ("%Noptions:")
            variant
               nOptions - i
            until
               i >= nOptions
            loop
               i := i + 1
               Result.append_string ("%N%T")
               Result.append_string (options.item (i).out)
            end
         end
         Result.append_string ("%NignoreUnrecognized: ")
         Result.append_boolean (ignoreUnrecognized)
      end

feature {JNI_JAVA_VIRTUAL_MACHINE} -- Implementation: raw arguments

   raw_data: JNI_RAW_JavaVMInitArgs is
      do
         !!Result.make (Current)
      end

end