indexing

   title:       "Common part of JavaVMInitArgs";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class JNI_JavaVMInitArgs_Header

inherit

   JNI_CONSTANTS
      end

   MEMORY
      end

feature

   version: INTEGER is
         -- Java VM version
      deferred
      ensure
         valid_version: Result = jni_version_1_1 or else
                        Result = jni_version_1_2
      end

feature {JNI_JAVA_VIRTUAL_MACHINE} -- Implementation: raw arguments

   raw_data: JNI_RAW_JavaVMInitArgs_Header is
         -- Binary data to be passed to the JVM
      require
         not collecting
      deferred
      ensure
         not collecting
      end

feature {NONE} -- Implementation: CLASSPATH

   default_classpath: STRING is
         -- CLASSPATH taken from process environment
      local
         process_env: ENVIRONMENT
      once
         !!process_env
         Result := process_env.env_item( "CLASSPATH" )
         if Result = Void then
            Result := "."
         end
      end

end