indexing

   title:       "JNI JavaVMOption (since JDK 1.2)";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_JavaVMOption

inherit

   ANY
      redefine
         out
      end

creation

   make

feature {NONE} -- Creation

   make (value: STRING; extra: POINTER) is
      do
         optionString := value
         extraInfo := extra
      ensure
         optionString_set: optionString = value
         extraInfo_set: extraInfo = extra
      end

feature -- Status

   optionString: STRING

   extraInfo: POINTER

feature -- Output

   out: STRING is
      do
         Result := "optionString: "
         if optionString = Void then
            Result := "N/A"
         else
            Result.append_character ('%"')
            Result.append_string (optionString)
            Result.append_character ('%"')
         end
         Result.append_string (" extraInfo: ")
         Result.append_string (extraInfo.out)
      end

end