indexing

   title:       "Java object representation";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   copyright:   "Object Tools, 1997-2003";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_jobject

inherit

   MEMORY
      export
         {NONE} copy
      redefine
         dispose
      end

creation {JNI_JAVA_NATIVE_INTERFACE}

   make

creation

   make_from_jni_argument

feature {NONE} -- Creation

   make (jjni: JNI_JAVA_NATIVE_INTERFACE; jobj: POINTER) is
         -- Create an object from the corresponding Java object
         -- which was obtained from the call via JNI
      require
         non_void_jjni: jjni /= Void
         valid_jobj: jobj /= default_pointer
      do
         jni := jjni
         obj := jjni.NewGlobalRefP (jobj)
         jjni.DeleteLocalRefP (jobj)
      end

   make_from_jni_argument (jjni: JNI_JAVA_NATIVE_INTERFACE; jobj: POINTER) is
         -- Create an object from the corresponding Java object
         -- which was obtained as an argument of call from the Java
         -- to the native method
      require
         non_void_jjni: jjni /= Void
         valid_jobj: jobj /= default_pointer
      do
         jni := jjni
         obj := jjni.NewGlobalRefP (jobj)
      end

feature -- Disposal

   dispose is
      do
         if obj /= default_pointer then
            jni.DeleteGlobalRef (Current)
            jni := Void
            obj := default_pointer
         end
      end

feature -- Implementation

   obj: POINTER
         -- Java handle for the object

feature {JNI_JAVA_NATIVE_INTERFACE, JNI_JAVA_VALUE} -- Implementation

   jni: JNI_JAVA_NATIVE_INTERFACE

end