indexing

   title:       "JNI binary representation of JavaVMInitArgs (since JDK 1.2)";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   copyright:   "Object Tools, 1999-2003";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_RAW_JavaVMInitArgs

inherit

   JNI_RAW_JavaVMInitArgs_Header
      redefine
         make
      end

creation {JNI_JavaVMInitArgs}

   make

feature {NONE} -- Creation

   make (peer: JNI_JavaVMInitArgs) is
      local
         i: INTEGER
         j: INTEGER
         raw_options: ARRAY [POINTER]
         option: JNI_JavaVMOption
      do
         Precursor (peer)
         if peer.options /= Void and then peer.options.count > 0 then
            nOptions := peer.options.count
            from
               i := nOptions * 2
               !!raw_options.make (1, i)
               j := peer.options.upper
            invariant
               even_i: i \\ 2 = 0
               i_j: j = peer.options.lower + i // 2 - 1
            variant
               i
            until
               i <= 0
            loop
               option := peer.options.item (j)
               raw_options.put (option.extraInfo, i)
               i := i - 1
               raw_options.put (option.optionString.to_c, i)
               i := i - 1
               j := j - 1
            end
            options := raw_options.to_c
         end
         if peer.ignoreUnrecognized then
            ignoreUnrecognized := 1
         end
      end

feature {NONE} -- Binary data

   nOptions: INTEGER
         -- Number of options

   options: POINTER
         -- JVM options

   ignoreUnrecognized: INTEGER
         -- Should JVM ignore all unrecognized option strings
         -- that begin with "-X" or "_"?

end