indexing

   title:       "JNI JDK1_1InitArgs (since JDK 1.1)";
   cluster:     "jni";
   project:     "Java Native Interface Library";
   date:        "$Date: 2005/02/01 10:20:41 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class JNI_RAW_JDK1_1InitArgs

inherit

    JNI_RAW_JavaVMInitArgs_Header
       redefine
          make
       end

    JNI_CONSTANTS
       end

creation {JNI_JAVA_VIRTUAL_MACHINE}

   make_default

creation {JNI_JDK1_1InitArgs}

   make

feature {NONE} -- Creation

   make_default is
         -- Create empty binary area to be filled by the JVM
      do
         version := Jni_version_1_1
      end

   make (peer: JNI_JDK1_1InitArgs) is
      local
         raw_properties: ARRAY [POINTER]
         i: INTEGER
      do
         Precursor (peer)
         if peer.properties /= Void then
            !!raw_properties.make (peer.properties.lower, peer.properties.upper)
            from
               i := raw_properties.lower
            until
               i > raw_properties.upper
            loop
               raw_properties.put (peer.properties.item (i).to_c, i)
               i := i + 1
            end
            properties := raw_properties.to_c
         end
         if peer.checkSource then
            checkSource := 1
         end
         nativeStackSize := peer.nativeStackSize
         javaStackSize := peer.javaStackSize
         minHeapSize := peer.minHeapSize
         maxHeapSize := peer.maxHeapSize
         verifyMode := peer.verifyMode
         classpath := peer.classpath.to_c
         vfprintf := peer.vfprintf
         exit := peer.exit
         abort := peer.abort
         if peer.enableClassGC then
            enableClassGC := 1
         end
         if peer.enableVerboseGC then
            enableVerboseGC := 1
         end
         if peer.disableAsyncGC then
            disableAsyncGC := 1
         end
         reserved0 := peer.reserved0
         reserved1 := peer.reserved1
         reserved2 := peer.reserved2
      end

feature {JNI_JDK1_1InitArgs} -- Binary data

   properties: POINTER
         -- System properties

   checkSource: INTEGER
         -- Whether to check the Java source files are newer than
         -- compiled class files

   nativeStackSize: INTEGER
         -- Maximum native stack size of Java-created threads

   javaStackSize: INTEGER
         -- Maximum Java stack size

   minHeapSize: INTEGER
         -- Initial heap size

   maxHeapSize: INTEGER
         -- Maximum heap size

   verifyMode: INTEGER
         -- Controls whether Java byte code should be verified:
         -- 0 -- none, 1 -- remotely loaded code, 2 -- all code

   classpath: POINTER
         -- The local directory path for class loading

   vfprintf: POINTER
         -- A hook for a function that redirects all VM messages
         -- jint (*vfprintf)(FILE *fp, const char *format, va_list args)

   exit: POINTER
         -- A VM exit hook
         -- void (*exit)(jint code)

   abort: POINTER
         -- A VM abort hook
         -- void (*abort)()

   enableClassGC: INTEGER
         -- Whether to enable class GC

   enableVerboseGC: INTEGER
         -- Whether GC messages will appear

   disableAsyncGC: INTEGER
         -- Whether asynchronous GC is allowed

   reserved0: INTEGER
         -- Reserved field

   reserved1: INTEGER
         -- Reserved field

   reserved2: INTEGER
         -- Reserved field

end