/*
   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/01 10:20:43 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

*/

#include <stdlib.h>
#include <sys/stat.h>

void* VELIBC_stat_struct_new()
{
  return malloc(sizeof(struct stat));
}

int VELIBC_stat_struct_st_uid(struct stat* ptr)
{
  return ptr->st_uid;
}

int VELIBC_stat_struct_st_gid(struct stat* ptr)
{
  return ptr->st_gid;
}

int VELIBC_stat_struct_st_size(struct stat* ptr)
{
  return ptr->st_size;
}

int VELIBC_stat_struct_st_atime(struct stat* ptr)
{
  return ptr->st_atime;
}

int VELIBC_stat_struct_st_mtime(struct stat* ptr)
{
  return ptr->st_mtime;
}

int VELIBC_stat_struct_st_ctime(struct stat* ptr)
{
  return ptr->st_ctime;
}

int VELIBC_stat_struct_S_ISLNK(struct stat* ptr)
{
  return S_ISLNK(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISREG(struct stat* ptr)
{
  return S_ISREG(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISDIR(struct stat* ptr)
{
  return S_ISDIR(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISCHR(struct stat* ptr)
{
  return S_ISCHR(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISBLK(struct stat* ptr)
{
  return S_ISBLK(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISFIFO(struct stat* ptr)
{
  return S_ISFIFO(ptr->st_mode);
}

int VELIBC_stat_struct_S_ISSOCK(struct stat* ptr)
{
  return S_ISSOCK(ptr->st_mode);
}
