/*
   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/01 10:20:43 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

*/

#include <stdio.h>

int VELIBC_rename (char *oldpath,char *newpath)
{
  return rename(oldpath,newpath);
}

int VELIBC_remove (char* pathname)
{
  return remove(pathname);
}

void* VELIBC_tmpnam()
{
  return tmpnam(0);
}

FILE* VELIBC_fopen (char* pathname,char* mode)
{
  return fopen(pathname,mode);
}

FILE* VELIBC_fdopen (int fd,char* mode)
{
  return fdopen(fd,mode);
}

FILE *VELIBC_freopen(char* pathname,char* mode,FILE *stream)
{
  return freopen(pathname,mode,stream);
}

void VELIBC_clearerr(FILE* stream)
{
  clearerr(stream);
}

int VELIBC_fclose(FILE* stream)
{
  return fclose(stream);
}

int VELIBC_feof(FILE* stream)
{
  return feof(stream);
}

int VELIBC_ferror(FILE* stream)
{
  return ferror(stream);
}

int VELIBC_fflush(FILE* stream)
{
  return fflush(stream);
}

int VELIBC_fgetc(FILE* stream)
{
  return fgetc(stream);
}

void* VELIBC_fgets(void *s,int n,FILE* stream)
{
  return fgets (s,n,stream);
}

int VELIBC_fgetpos(FILE* stream,fpos_t* pos)
{
  return fgetpos(stream,pos);
}

int VELIBC_fputc(int c,FILE* stream)
{
  return fputc(c,stream);
}

int VELIBC_fputs(void* s,FILE* stream)
{
  return fputs(s,stream);
}

int VELIBC_fread (void *ptr,int size,int nmemb,FILE* stream)
{
  return fread(ptr,size,nmemb,stream);
}

int VELIBC_fseek(FILE* stream,int offset,int whence)
{
  return fseek(stream,offset,whence);
}

int VELIBC_fsetpos(FILE* stream,fpos_t* pos)
{
  return fsetpos(stream,pos);
}

int VELIBC_ftell(FILE* stream)
{
  return ftell(stream);
}

int VELIBC_fwrite(void *ptr,int size,int nmemb,FILE* stream)
{
  return fwrite(ptr,size,nmemb,stream);
}

void VELIBC_rewind(FILE* stream)
{
  rewind(stream);
}

void VELIBC_setbuf(FILE* stream,void* buf)
{
  setbuf(stream,buf);
}

int VELIBC_setvbuf(FILE* stream,void* buf,int mode,int size)
{
  return setvbuf(stream,buf,mode,size);
}

int VELIBC_ungetc(int c,FILE* stream)
{
  return ungetc (c,stream);
}

FILE* VELIBC_stdin()
{
  return stdin;
}

FILE* VELIBC_stdout()
{
  return stdout;
}

FILE* VELIBC_stderr()
{
  return stderr;
}

int VELIBC_fileno(FILE* stream)
{
  return fileno(stream);
}

FILE* VELIBC_tmpfile()
{
  return tmpfile();
}
