/*
   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/01 10:20:43 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

*/

#include <stdlib.h>

void* VELIBC_calloc(int nmemb, int size)
{
  return calloc(nmemb, size);
}

void VELIBC_free(void* ptr)
{
  free(ptr);
}

void* VELIBC_malloc(int size)
{
  return malloc(size);
}

void* VELIBC_realloc(void* ptr, int size)
{
  return realloc(ptr, size);
}

void VELIBC_abort()
{
  abort();
}

void VELIBC_exit(int status)
{
  exit(status);
}

void* VELIBC_getenv(void* name)
{
  return getenv(name);
}

int VELIBC_setenv(void* name,void* value, int overwrite)
{
  return setenv(name,value,overwrite);
}

void VELIBC_unsetenv(void* name)
{
  unsetenv(name);
}

int VELIBC_system(char* command)
{
  return system(command);
}
void* VELIBC_canonicalize_file_name(const char * name)
{
   return canonicalize_file_name(name);
}
