/*
   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/01 10:20:43 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

*/

#include <unistd.h>
#include <stdlib.h>

int VELIBC_alarm(int seconds)
{
  return alarm(seconds);
}

int VELIBC_execv(void* file,void* argv)
{
  return execv(file,argv);
}

int VELIBC_execvp(void* file,void* argv)
{
  return execvp(file,argv);
}

int VELIBC_fork()
{
  return fork();
}

void* VELIBC_getlogin()
{
  return getlogin();
}

int VELIBC_pause()
{
  return pause();
}

int VELIBC_sleep(int seconds)
{
  return sleep(seconds);
}

int VELIBC_sysconf(int name)
{
  return sysconf(name);
}

int VELIBC_access(char* path,int amode)
{
  return access(path,amode);
}

int VELIBC_chdir(char* path)
{
  return chdir(path);
}

int VELIBC_chown(char* path,int owner,int group)
{
  return chown(path,owner,group);
}

void* VELIBC_getcwd(void* buf,int size)
{
  return getcwd(buf,size);
}

int VELIBC_link(void* existing,void* new)
{
  return link(existing,new);
}

void VELIBC__exit(int result)
{
  _exit(result);
}

int VELIBC_pathconf(char* path,int name)
{
  return pathconf(path,name);
}

int VELIBC_rmdir(char* path)
{
  return rmdir(path);
}

int VELIBC_unlink(char* path)
{
  return unlink(path);
}

int VELIBC_close(int fd)
{
  return close(fd);
}

int VELIBC_dup(int fd)
{
  return dup(fd);
}

int VELIBC_dup2(int fd,int fd2)
{
  return dup2(fd,fd2);
}

int VELIBC_fdatasync(int fd)
{
#ifdef __FreeBSD__
  return fsync(fd);
#else
  return fdatasync(fd);
#endif
}

int VELIBC_fpathconf(int fd,int name)
{
  return fpathconf(fd,name);
}

int VELIBC_fsync(int fd)
{
  return fsync(fd);
}

int VELIBC_isatty(int fd)
{
  return isatty(fd);
}

int VELIBC_lseek(int fd,int offset,int whence)
{
  return lseek(fd,offset,whence);
}

int VELIBC_pipe(void* fd)
{
  return pipe(fd);
}

int VELIBC_read(int fd,void* buf,int nbyte)
{
  return read(fd,buf,nbyte);
}

void* VELIBC_ttyname(int fd)
{
  return ttyname(fd);
}

int VELIBC_write(int fd,void* buf,int nbyte)
{
  return write(fd,buf,nbyte);
} 

int VELIBC_getpid()
{
  return getpid();
}

int VELIBC_getppid()
{
  return getppid();
}

int VELIBC_getegid()
{
  return getegid();
}

int VELIBC_geteuid()
{
  return geteuid();
}

int VELIBC_getgid()
{
  return getgid();
}

int VELIBC_getgroups(int gidsetsize,void* grouplist)
{
  return getgroups(gidsetsize,grouplist);
}

int VELIBC_getpgrp()
{
  return getpgrp();
}

int VELIBC_getuid()
{
  return getuid();
}

int VELIBC_setgid(int gid)
{
  return setgid(gid);
}

int VELIBC_setpgid(int pid,int pgid)
{
  return setpgid(pid,pgid);
}

int VELIBC_setsid()
{
  return setsid();
}

int VELIBC_setuid(int uid)
{
  return setuid(uid);
}

int VELIBC_seteuid(int uid)
{
  return seteuid(uid);
}

int VELIBC_setegid(int gid)
{
  return setegid(gid);
}

void * VELIBC_readlink(char* path)
{
  char * buf = malloc(2049);
  int n;
  if (buf!= 0)
  {
    n = readlink(path,buf,2048);
    if (n>0)
    {
      buf[n] = 0;
    }
    else
    {
      free(buf);
      buf = 0;
    }
  }
  return buf;
}
