indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:08 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_DIRENT

inherit

   VELIBC_BASE

   VELIBC_DIRENT_EXTERNALS

feature

   opendir (pathname: STRING): POINTER is
         -- open a directory
      require
         valid_pathname: pathname /= Void and then not pathname.is_empty
      do
         mem.collection_off;
         Result := ext_opendir (sh.to_c(pathname));
         mem.collection_on;
      end

   readdir (dir: POINTER): VELIBC_DIRENT_STRUCT is
         -- read a directory
      require
         valid_dir: dir /= default_pointer
      local
         p: POINTER;
      do
         p := ext_readdir (dir);
         if p /= default_pointer then
            !!Result.from_c (p);
         end
      end

   closedir (dir: POINTER): INTEGER is
         -- close the directory stream
      require
         valid_dir: dir /= default_pointer
      external "C"
      alias "VELIBC_closedir"
      end

   rewinddir (dir: POINTER) is
         -- reset the directory stream
      require
         valid_dirt: dir /= default_pointer
      external "C"
      alias "VELIBC_rewinddir"
      end

end
