indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:09 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_ERROR_SERVER

feature

   raise_last_error is
      local
         msg: STRING;
      do
         msg := last_error_description;
         if msg /= Void then
            excepts.raise(msg);
         end
      end

   raise_last_file_error (stream: POINTER) is
      local
         msg: STRING;
      do
         if fn_stdio.ferror(stream) then
            msg := last_error_description;
            if msg /= Void then
               excepts.raise(msg);
            end
         end 
      end

   last_error_description: STRING is
      do
         if last_error /=0 then
            Result := fn_string.strerror (last_error);
         end            
      end

   last_error: INTEGER is
      do
         Result := fn_errno.errno;
      end

feature {NONE}

   fn_string: expanded VELIBC_STRING;
   fn_errno: expanded VELIBC_ERRNO;
   fn_stdio: expanded VELIBC_STDIO;
   excepts: expanded EXCEPTIONS;

end
