indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:10 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_STAT_CONSTANTS

feature

   S_IRWXU: BIT 32 is
      once 
         result := ext_S_IRWXU;
      end

   S_IRUSR: BIT 32 is
      once 
         result := ext_S_IRUSR;
      end

   S_IWUSR: BIT 32 is
      once 
         result := ext_S_IWUSR;
      end

   S_IXUSR: BIT 32 is
      once 
         result := ext_S_IXUSR;
      end

   S_IRWXG: BIT 32 is
      once 
         result := ext_S_IRWXG;
      end

   S_IRGRP: BIT 32 is
      once 
         result := ext_S_IRGRP;
      end

   S_IWGRP: BIT 32 is
      once 
         result := ext_S_IWGRP;
      end

   S_IXGRP: BIT 32 is
      once 
         result := ext_S_IXGRP;
      end

   S_IRWXO: BIT 32 is
      once 
         result := ext_S_IRWXO;
      end

   S_IROTH: BIT 32 is
      once 
         result := ext_S_IROTH;
      end

   S_IWOTH: BIT 32 is
      once 
         result := ext_S_IWOTH;
      end

   S_IXOTH: BIT 32 is
      once 
         result := ext_S_IXOTH;
      end
   S_IFMT: BIT 32 is
      once
         Result := ext_S_IFMT;
      end
   
   S_IFSOCK: BOOLEAN is
      once
         Result := ext_S_IFSOCK;
      end
   
   S_IFLNK: BOOLEAN is
      once
         Result := ext_S_IFLNK;
      end
   
   S_IFREG: BOOLEAN is
      once
         Result := ext_S_IFREG;
      end
   
   S_IFBLK: BOOLEAN is
      once
         Result := ext_S_IFBLK;
      end

   S_IFDIR: BOOLEAN is
      once
         Result := ext_S_IFDIR;
      end
   
   S_IFCHR: BOOLEAN is
      once
         Result := ext_S_IFCHR;
      end
   
   S_IFIFO: BOOLEAN is
      once
         Result := ext_S_IFIFO;
      end
   
   S_ISUID: BOOLEAN is
      once
         Result := ext_S_ISUID;
      end
   
   S_ISGID: BOOLEAN is
      once
         Result := ext_S_ISGID;
      end
   
   S_ISVTX: BOOLEAN is
      once
         Result := ext_S_ISVTX;
      end

feature {NONE}
   ext_S_IRWXU: BIT 32 is
      external "C"
      alias "VELIBC_S_IRWXU"
      end

   ext_S_IRUSR: BIT 32 is
      external "C"
      alias "VELIBC_S_IRUSR"
      end

   ext_S_IWUSR: BIT 32 is
      external "C"
      alias "VELIBC_S_IWUSR"
      end

   ext_S_IXUSR: BIT 32 is
      external "C"
      alias "VELIBC_S_IXUSR"
      end

   ext_S_IRWXG: BIT 32 is
      external "C"
      alias "VELIBC_S_IRWXG"
      end

   ext_S_IRGRP: BIT 32 is
      external "C"
      alias "VELIBC_S_IRGRP"
      end

   ext_S_IWGRP: BIT 32 is
      external "C"
      alias "VELIBC_S_IWGRP"
      end

   ext_S_IXGRP: BIT 32 is
      external "C"
      alias "VELIBC_S_IXGRP"
      end

   ext_S_IRWXO: BIT 32 is
      external "C"
      alias "VELIBC_S_IRWXO"
      end

   ext_S_IROTH: BIT 32 is
      external "C"
      alias "VELIBC_S_IROTH"
      end

   ext_S_IWOTH: BIT 32 is
      external "C"
      alias "VELIBC_S_IWOTH"
      end

   ext_S_IXOTH: BIT 32 is
      external "C"
      alias "VELIBC_S_IXOTH"
      end

   ext_S_IFMT: BIT 32 is
      external "C"
      alias "VELIBC_S_IFMT"
      end

   ext_S_IFSOCK: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFSOCK"
      end

   ext_S_IFLNK: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFLNK"
      end

   ext_S_IFREG: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFREG"
      end

   ext_S_IFBLK: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFBLK"
      end

   ext_S_IFDIR: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFDIR"
      end

   ext_S_IFCHR: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFCHR"
      end

   ext_S_IFIFO: BOOLEAN is
      external "C"
      alias "VELIBC_S_IFIFO"
      end

   ext_S_ISUID: BOOLEAN is
      external "C"
      alias "VELIBC_S_ISUID"
      end

   ext_S_ISGID: BOOLEAN is
      external "C"
      alias "VELIBC_S_ISGID"
      end

   ext_S_ISVTX: BOOLEAN is
      external "C"
      alias "VELIBC_S_ISVTX"
      end

end
