indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:10 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_STRING

inherit 

   VELIBC_BASE

   VELIBC_STRING_EXTERNALS

feature
   
   memcpy (dst, src: POINTER; size: INTEGER) is
         -- The  memcpy() function copies n bytes from memory area src
         -- to memory area dest.  The memory areas  may  not  overlap.
         -- Use memmove(3) if the memory areas do overlap.
      require
         valid_pointers: dst /= default_pointer and src /= default_pointer
      external "C"
      alias "VELIBC_memcpy"
      end

   memmove (dest, src: POINTER; size: INTEGER): POINTER is
         -- The memmove() function copies n bytes from memory area src
         -- to memory area dest.  The memory areas may overlap.
      require
         valid_pointers: dest /= default_pointer and src /= default_pointer
      external "C"
      alias "VELIBC_memmove"
      end

   strdup (src: POINTER): POINTER is
         -- Duplicate a string
      require
         valid_source: src /= default_pointer
      external "C"
      alias "VELIBC_strdup"
      end

   strerror (errnum: INTEGER): STRING is
         -- Converts an error number to a string
      do
         Result := sh.from_c(ext_strerror(errnum));
      end
end
