indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:11 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_DIRENT_STRUCT

inherit

   VELIBC_EXTERNAL_STRUCT
   end

creation

   from_c

feature -- 

   d_name: STRING is
         -- filename
      require
         valid_entry: to_c /= default_pointer;
      local
         res: POINTER;
      do
         res := ext_d_name (to_c)
         if res /= default_pointer then
            !!Result.make_empty;
            Result.from_c(res);
         end
      end

   d_type: INTEGER is
         -- type of file
      require
         valid_entry: to_c /= default_pointer;
      do
         Result := ext_d_type (to_c);
      end

feature {NONE}

   ext_d_name (entry: POINTER): POINTER is
      external "C"
      alias "VELIBC_dirent_struct_d_name"
      end

   ext_d_type (entry: POINTER): INTEGER is
      external "C"
      alias "VELIBC_dirent_struct_d_type"
      end

   on_dispose is
      do
      end
end

