indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:11 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class VELIBC_EXTERNAL_INTERNAL_STRUCT

inherit

   VELIBC_EXTERNAL_STRUCT
      rename
         on_dispose as on_external_dispose
      end

feature

   make is
      do
         external_object := create_external_object;
         made_in_eiffel := True;
      ensure
         external_object /= default_pointer;
      end

feature {NONE}

   on_external_dispose is
      do
         --print("external_internal struct::on_external_dispose%N");
         if made_in_eiffel then
            ext_free(external_object);
         else
            on_dispose;
         end
      end

   create_external_object: POINTER is
      deferred
      end
   on_dispose is
      deferred
      end
   ext_free (obj: POINTER) is
      external "C"
      alias "VELIBC_free"
      end

   made_in_eiffel: BOOLEAN;
end
