indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:11 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class VELIBC_EXTERNAL_STRUCT

inherit
   MEMORY
      redefine dispose
      end
feature

   from_c (ext_pointer: POINTER) is
      require
         non_void_external: ext_pointer /= Void;
      do
         external_object := ext_pointer;
      end

   to_c: POINTER is
      do
         Result := external_object;
      end

feature {NONE}

   external_object: POINTER;
   
   dispose is
      do
         if external_object /= default_pointer then
            on_dispose;
            external_object := default_pointer;
         end
      end

   on_dispose is
      deferred
      end
end

