indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:11 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_STAT_STRUCT

inherit

   VELIBC_EXTERNAL_INTERNAL_STRUCT
      end

creation

   from_c, make

feature

   st_uid: INTEGER is
         -- user ID of owner
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_uid(to_c);
      end
   
   st_gid: INTEGER is
         -- group ID of owner
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_gid(to_c);
      end

   st_size: INTEGER is
         -- total size, in bytes
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_size(to_c);
      end

   st_atime: INTEGER is
         -- time of last access
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_atime(to_c);
      end

   st_mtime: INTEGER is
         -- time of last modification
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_mtime(to_c);
      end

   st_ctime: INTEGER is
         -- time of last change
      require
         valid_struct: to_c /= default_pointer;
      do
         Result := ext_st_ctime(to_c);
      end

   S_ISLNK: BOOLEAN is
      do
         Result := ext_S_ISLNK (to_c);
      end

   S_ISREG: BOOLEAN is
      do
         Result := ext_S_ISREG (to_c);
      end

   S_ISDIR: BOOLEAN is
      do
         Result := ext_S_ISDIR (to_c);
      end

   S_ISCHR: BOOLEAN is
      do
         Result := ext_S_ISCHR (to_c);
      end

   S_ISBLKS: BOOLEAN is
      do
         Result := ext_S_ISBLK (to_c);
      end
   
   S_ISFIFO: BOOLEAN is
      do
         Result := ext_S_ISFIFO (to_c);
      end
   
   S_ISSOCK: BOOLEAN is
      do
         Result := ext_S_ISSOCK (to_c);
      end

feature {NONE}

   create_external_object: POINTER is
      do
         Result := ext_new_stat_struct;
      end

   on_dispose is
      do
      end

   ext_new_stat_struct: POINTER is
      external "C"
      alias "VELIBC_stat_struct_new"
      end

   ext_st_uid(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_uid"
      end

   ext_st_gid(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_gid"
      end

   ext_st_size(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_size"
      end

   ext_st_atime(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_atime"
      end

   ext_st_mtime(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_mtime"
      end

   ext_st_ctime(struct: POINTER): INTEGER is
      external "C"
      alias "VELIBC_stat_struct_st_ctime"
      end

   ext_S_ISLNK (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISLNK"
      end
   
   ext_S_ISREG (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISREG"
      end

   ext_S_ISDIR (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISDIR"
      end

   ext_S_ISCHR (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISCHR"
      end

   ext_S_ISBLK (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISBLK"
      end

   ext_S_ISFIFO (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISFIFO"
      end

   ext_S_ISSOCK (entry: POINTER): BOOLEAN is
      external "C"
      alias "VELIBC_stat_struct_S_ISSOCK"
      end
            
end
