indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/01 10:20:44 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_EXTERNAL_STRING_ARRAY

inherit

   VELIBC_EXTERNAL_ARRAY
   MEMORY
      redefine
         dispose
      end

creation

   make

feature -- Creation

   make (array : ARRAY[STRING]) is
      local
         i: INTEGER
         mem: expanded MEMORY
         fn_string: expanded VELIBC_string;
      do
         mem.collection_off;
         count := array.count+1
         from_external(make_array_of_pointers(array.count+1))
         from
            i := array.lower
         until
            i > array.upper
         loop
            put_pointer(to_external, i-array.lower, fn_string.strdup(array.item(i).to_external))
            i := i+1
         end -- loop
         -- NULL terminate.
         put_pointer(to_external, i-array.lower, default_pointer)
         mem.collection_on;
      end

feature -- memory managment

   dispose is
      do
         if to_external /= default_pointer then
            free_pointers_and_array(to_external, count)
            from_external(default_pointer)
         end
      end

feature {NONE}

   count : INTEGER

end -- class VELIBC_EXTERNAL_STRING_ARRAY
