indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:25 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_STRING_HELPER

feature

   from_c (p : POINTER) : STRING is
      do
         if p = default_pointer then
            Result := Void
         else
            !!Result.make_empty
            Result.from_c(p)
         end
      end

   from_c_with_free(p : POINTER) : STRING is
      do
         if p = default_pointer then
            Result := Void
         else
            !!Result.make_empty
            Result.from_c(p)
            ext_free(p)
         end
      end

   to_c (s: STRING): POINTER is
     do
        if s /= Void then
           Result := s.to_c
        else
           Result := default_pointer;
        end
     end

feature {NONE} -- C externals

   ext_free(p : POINTER) is
      external "C"
      alias "VELIBC_free"
      end

end
