indexing

   cluster:     "velibc";
   project:     "Visual Eiffel libc Library";
   date:        "$Date: 2005/02/15 16:22:10 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class VELIBC_WAIT

inherit

   VELIBC_BASE

   VELIBC_WAIT_CONSTANTS

feature   

   wait (status: POINTER): INTEGER is
         -- The  wait  function suspends execution of the current 
         -- process until a child has exited, or until a signal is delivered 
         -- whose  action is to terminate the current process or to call a  
         -- signal handling  function.   If  a  child  has already  exited 
         -- by the time of the call (a so-called "zombie" process), the function 
         -- returns immediately.  Any system resources used by the child are freed.  
      external "C"
      alias "VELIBC_wait"
      end
   
   waitpid (pid: INTEGER; status: POINTER; options: BIT 32): INTEGER is
         -- The  waitpid  function  suspends  execution of the current 
         -- process until a child as specified by the pid argument has exited,  
         -- or until a signal is delivered whose action is to terminate 
         -- the current process or to call a signal handling function. If a child as  
         -- requested by pid has already exited by the time of the call (a so-called 
         -- "zombie"  process), the  function returns immediately. Any system 
         -- resources used by the child are freed.
      external "C"
      alias "VELIBC_waitpid"
      end


   WIFEXITED (status: INTEGER): BOOLEAN is
      -- True if the child exited normally.
      external "C"
      alias "VELIBC_WIFEXITED"
      end

   WEXITSTATUS (status: INTEGER): INTEGER is
      -- evaluates to the least significant  eight  bits  of the  return
      -- code of the child which terminated, which may have been set as 
      -- the argument to a call to exit() or as the argument for a return 
      -- statement in the main program. This function can only be evaluated 
      -- if WIFEXITED returned true.
      external "C"
      alias "VELIBC_WEXITSTATUS"
      end

   WIFSIGNALED (status: INTEGER): BOOLEAN is
      -- returns true if the child process exited because of a signal 
      -- which was not caught.
      external "C"
      alias "VELIBC_WIFSIGNALED"
      end

   WTERMSIG (status: INTEGER): INTEGER is
      -- returns the number of the signal that caused the child  process 
      -- to terminate. This function can only be evaluated if WIFSIGNALED
      -- returned true.
      external "C"
      alias "VELIBC_WTERMSIG"
      end

   WIFSTOPPED (status: INTEGER): BOOLEAN is
      -- returns true if the child process which caused  the return is 
      -- currently stopped; this is only possible if the call was done 
      -- using WUNTRACED.
      external "C"
      alias "VELIBC_WTERMSIG"
      end						 

   WSTOPSIG (status: INTEGER): INTEGER is
      -- returns the number of the signal which caused the child to stop.
      -- This macro can only be evaluated if WIFSTOPPED returned true.
      external "C"
      alias "VELIBC_WSTOPSIG"
      end

end
