indexing

   title:       "The time zone information";
   cluster:     "timedate";
   project:     "The Universal Time & Date UTDC";
   date:        "$Date: 2005/02/01 10:21:56 $";
   revision:    "$Revision: 1.1 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class TIME_ZONE

inherit

	ANY
		redefine
			out
		end

creation

	make

feature {NONE} -- Creation

	make is
			-- Create an object for the current time zone
		do
			offset := TIME_DATE_offset
		end

feature -- Time zone properties

	offset: INTEGER
			-- An offset of the local time from
			-- the coordinated universal time (UTC) in seconds
			-- local_time = UTC + offset

-- TODO: provide implementation and support ANY.out
--
--	daylight_name: STRING is
--			-- The daylight saving time zone name or Void
--			-- if daylight saving time is not used in the time zone
--		do
--		end
--
--	standard_name: STRING is
--			-- The standard time zone name
--		do
--		end

feature -- Time queries

	is_daylight_saving_time: BOOLEAN is
			-- Is the current time in a daylight saving time?
		external "C"
			alias "TIME_DATE_dst"
		end

	out: STRING is
			-- New string containing printable representation of
			-- current object, each field preceded by its attribute name,
			-- a colon and a space
		local
			o: INTEGER
		do
			Result := "GMT"
			o := offset
			if o /= 0 then
				if o > 0 then
					Result.append_character ('+')
				else
					Result.append_character ('-')
					o := - o
				end
				Result.append_integer (o // 3600 // 10)
				Result.append_integer (o // 3600 \\ 10)
				Result.append_character (':')
				o := o // 60 \\ 60
				Result.append_integer (o // 10)
				Result.append_integer (o \\ 10)
			end
   		end

feature {NONE} -- Implementation

	TIME_DATE_offset: INTEGER is
			-- An offset of the local time from
			-- the coordinated universal time (UTC) in seconds
			-- local_time = UTC + offset
		external "C"
			alias "TIME_DATE_offset"
		end

end