indexing

   title:       "Message codes, generated by the tool";
   cluster:     "gmsgs";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/15 16:22:42 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

deferred class GENERATED_MESSAGE_CODES

inherit

   ABSTRACT_MESSAGE_CODES
      end

feature {ABSTRACT_MESSAGE_CODES, MESSAGE} -- Access

   is_valid_message_id (id: INTEGER): BOOLEAN is
      do
         Result := id >= codes.lower and then id <= codes.upper
      end

   message_code (id: INTEGER): STRING is
      do
         if is_valid_message_id (id) then
            Result := codes.item (id)
         else
            create Result.make_empty
         end
      end

   message_type (id: INTEGER): CHARACTER is
      do
         if is_valid_message_id (id) then
            Result := types.item (id)
         end
      end

   codes: ARRAY [STRING] is
         -- Messages codes
      deferred
      ensure
         Result /= Void
      end

   types: ARRAY [CHARACTER] is
         -- Messages types
      deferred
      ensure
         Result /= Void
      end

end