indexing

   title:       "XTEXT";
   cluster:     "gmsgs";
   project:     "Visual Eiffel Library";
   date:        "$Date: 2005/02/15 16:22:42 $";
   revision:    "$Revision: 1.2 $";
   copyright:   "Copyright (C) 1996-2005 Object Tools Group";
   license:     "http://visual-eiffel.com/license";
   disclaimer:  "[
      This program is free software; you can redistribute it and/or modify it 
      under the terms of the GNU General Public License as published by the 
      Free Software Foundation; either version 2 of the License, or (at your 
      option) any later version. This program is distributed in the hope that 
      it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
      See the GNU General Public License for more details. 
      You should have received a copy of the GNU General Public License along 
      with this program; if not, write to the Free Software Foundation, Inc., 
      59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
   ]";
   restrictions: "[
      if you want to use this program under a different license type, contact 
      Object Tools http://www.object-tools.com
   ]";

class XTEXT

creation

   make

feature

   make (file_name: STRING) is
      require
         Non_void_file_name: file_name /= Void
      do
         create file.make_create_read_write (file_name)
         create output.make (file)
      end

   close is
      do
         if output.is_open then
            file.close
            file := Void
         end
         output := Void
      end

   put_character (ch: CHARACTER) is
      do
         if output.is_open then
            output.put_character (ch)
         end
      end

   put_char (ch: CHARACTER) is
      obsolete "Use 'put_character' instead."
      do
         put_character (ch)
      end

   put_newline is
      do
         put_character ('%N')
      end

   put (str: STRING) is
      require
         Non_void_string: str /= Void
      do
         if output.is_open then
            output.put_string (str)
         end
      end

feature {NONE}

   file: FILE_STREAM
   output: TEXT_OUTPUT_STREAM

invariant

   output /= Void

end